(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                 // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              // 2
// All rights reserved.                                                                                               // 3
//                                                                                                                    // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                    // 5
// you may not use this file except in compliance with the License.                                                   // 6
// You may obtain a copy of the License at                                                                            // 7
//                                                                                                                    // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       // 9
//                                                                                                                    // 10
// Unless required by applicable law or agreed to in writing, software                                                // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                  // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           // 13
// See the License for the specific language governing permissions and                                                // 14
// limitations under the License.                                                                                     // 15
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Capnp = Npm.require("capnp");                                                                                     // 18
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 19
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                              // 20
                                                                                                                      //
// TODO(cleanup): lift this out of a package so it can share with async-helpers.js                                    // 22
var Future = Npm.require("fibers/future");                                                                            // 23
var promiseToFuture = function promiseToFuture(promise) {                                                             // 24
  var result = new Future();                                                                                          // 25
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                          // 26
  return result;                                                                                                      // 27
};                                                                                                                    // 28
                                                                                                                      //
var waitPromise = function waitPromise(promise) {                                                                     // 30
  return promiseToFuture(promise).wait();                                                                             // 31
};                                                                                                                    // 32
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 34
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 39
                                                                                                                      //
Meteor.methods({                                                                                                      // 41
  newFrontendRef: function () {                                                                                       // 42
    function newFrontendRef(sessionId, frontendRefRequest) {                                                          // 41
      // Completes a powerbox request for a frontendRef capability.                                                   // 43
      check(sessionId, String);                                                                                       // 44
      // frontendRefRequest is type-checked by frontendRefRegistry.validate(), below.                                 // 45
                                                                                                                      //
      var db = this.connection.sandstormDb;                                                                           // 47
      var frontendRefRegistry = this.connection.frontendRefRegistry;                                                  // 48
                                                                                                                      //
      var session = db.collections.sessions.findOne({ _id: sessionId, userId: this.userId || { $exists: false } });   // 50
      if (!session) {                                                                                                 // 52
        throw new Meteor.Error(403, "Invalid session ID");                                                            // 53
      }                                                                                                               // 54
                                                                                                                      //
      var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRefRequest);                      // 42
                                                                                                                      //
      var descriptor = _frontendRefRegistry$.descriptor;                                                              // 42
      var requirements = _frontendRefRegistry$.requirements;                                                          // 42
      var frontendRef = _frontendRefRegistry$.frontendRef;                                                            // 42
                                                                                                                      //
      descriptor = encodePowerboxDescriptor(descriptor);                                                              // 58
                                                                                                                      //
      var grainId = session.grainId;                                                                                  // 60
      var apiTokenOwner = {                                                                                           // 61
        clientPowerboxRequest: {                                                                                      // 62
          grainId: grainId,                                                                                           // 63
          sessionId: session._id                                                                                      // 64
        }                                                                                                             // 62
      };                                                                                                              // 61
                                                                                                                      //
      var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                            // 68
      var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                      // 69
      cap.close();                                                                                                    // 70
      return { sturdyRef: sturdyRef, descriptor: descriptor };                                                        // 71
    }                                                                                                                 // 72
                                                                                                                      //
    return newFrontendRef;                                                                                            // 41
  }(),                                                                                                                // 41
  fulfillUiViewRequest: function () {                                                                                 // 74
    function fulfillUiViewRequest(sessionId, identityId, grainId, petname, roleAssignment, ownerGrainId) {            // 41
      var db = this.connection.sandstormDb;                                                                           // 75
      check(sessionId, String);                                                                                       // 76
      check(identityId, String);                                                                                      // 77
      check(grainId, String);                                                                                         // 78
      check(roleAssignment, db.roleAssignmentPattern);                                                                // 79
      check(petname, String);                                                                                         // 80
      check(ownerGrainId, String);                                                                                    // 81
                                                                                                                      //
      if (!this.userId || !db.userHasIdentity(this.userId, identityId)) {                                             // 83
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                            // 84
      }                                                                                                               // 85
                                                                                                                      //
      var provider = {                                                                                                // 87
        identityId: identityId,                                                                                       // 88
        accountId: this.userId                                                                                        // 89
      };                                                                                                              // 87
                                                                                                                      //
      var title = db.userGrainTitle(grainId, this.userId, identityId);                                                // 92
                                                                                                                      //
      var descriptor = encodePowerboxDescriptor({                                                                     // 94
        tags: [{ id: Grain.UiView.typeId,                                                                             // 95
          value: Capnp.serialize(Grain.UiView.PowerboxTag, { title: title })                                          // 97
        }]                                                                                                            // 96
      });                                                                                                             // 94
                                                                                                                      //
      var owner = {                                                                                                   // 102
        clientPowerboxRequest: {                                                                                      // 103
          grainId: ownerGrainId,                                                                                      // 104
          sessionId: sessionId                                                                                        // 105
        }                                                                                                             // 103
      };                                                                                                              // 102
                                                                                                                      //
      var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);     // 109
                                                                                                                      //
      return {                                                                                                        // 112
        sturdyRef: result.token,                                                                                      // 113
        descriptor: descriptor                                                                                        // 114
      };                                                                                                              // 112
    }                                                                                                                 // 116
                                                                                                                      //
    return fulfillUiViewRequest;                                                                                      // 41
  }()                                                                                                                 // 41
});                                                                                                                   // 41
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 120
    _classCallCheck(this, PowerboxOption);                                                                            // 120
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 121
  }                                                                                                                   // 122
                                                                                                                      //
  PowerboxOption.prototype.intersect = function () {                                                                  //
    function intersect(other) {                                                                                       //
      // Intersect two options with the same ID. Used when combining matches from multiple tags                       // 125
      // in the same descriptor. The tags are a conjunction.                                                          // 126
      //                                                                                                              // 127
      // Returns true if there was any overlap, or false if there was no overlap and therefore the                    // 128
      // option should be dropped.                                                                                    // 129
      //                                                                                                              // 130
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 131
                                                                                                                      //
      if (other._id != this._id) {                                                                                    // 133
        throw new Error("can only merge options with the same ID");                                                   // 134
      }                                                                                                               // 135
                                                                                                                      //
      if (other.grainId) {                                                                                            // 137
        if (this.uiView && !other.uiView) delete this.uiView;                                                         // 138
        if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                       // 139
        return !!(this.uiView || this.hostedObject);                                                                  // 140
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 141
        // Try to hint which verifierId matched.                                                                      // 142
        if (this.frontendRef.verifiedEmail.verifierId) {                                                              // 143
          if (other.frontendRef.verifiedEmail.verifierId) {                                                           // 144
            // Can't match multiple verifiers at once.                                                                // 145
            return false;                                                                                             // 146
          }                                                                                                           // 147
        } else if (other.frontendRef.verifiedEmail.verifierId) {                                                      // 148
          // One request did not specify any verifierId, the other did, and both matched, so use                      // 149
          // the verifierId.                                                                                          // 150
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 151
        }                                                                                                             // 152
                                                                                                                      //
        return true;                                                                                                  // 154
      } else {                                                                                                        // 155
        // No intersection logic needed for other types.                                                              // 156
        return true;                                                                                                  // 157
      }                                                                                                               // 158
    }                                                                                                                 // 159
                                                                                                                      //
    return intersect;                                                                                                 //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.union = function () {                                                                      //
    function union(other) {                                                                                           //
      // Union two options with the same ID. Used when combining matches from multiple descriptors.                   // 162
      // The descriptors are a disjunction.                                                                           // 163
      //                                                                                                              // 164
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 165
                                                                                                                      //
      if (other._id != this._id) {                                                                                    // 167
        throw new Error("can only merge options with the same ID");                                                   // 168
      }                                                                                                               // 169
                                                                                                                      //
      if (other.grainId) {                                                                                            // 171
        if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                 // 172
        if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                         // 173
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 174
        // If this doesn't have a verifierId but other does, copy it over.                                            // 175
        if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {               // 176
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 178
        }                                                                                                             // 179
      }                                                                                                               // 180
    }                                                                                                                 // 181
                                                                                                                      //
    return union;                                                                                                     //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.subtract = function () {                                                                   //
    function subtract(other) {                                                                                        //
      // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                     // 184
      // if there's anything left, false otherwise.                                                                   // 185
                                                                                                                      //
      if (other._id != this._id) {                                                                                    // 187
        throw new Error("can only merge options with the same ID");                                                   // 188
      }                                                                                                               // 189
                                                                                                                      //
      if (other.grainId) {                                                                                            // 191
        if (this.uiView && other.uiView) delete this.uiView;                                                          // 192
        if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                        // 193
        return !!(this.uiView || this.hostedObject);                                                                  // 194
      } else {                                                                                                        // 195
        return false;                                                                                                 // 196
      }                                                                                                               // 197
    }                                                                                                                 // 198
                                                                                                                      //
    return subtract;                                                                                                  //
  }();                                                                                                                //
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 201
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                // 202
                                                                                                                      //
  frontendRefRegistry.register({                                                                                      // 204
    typeId: Grain.UiView.typeId,                                                                                      // 205
                                                                                                                      //
    query: function () {                                                                                              // 207
      function query(db, userId, value) {                                                                             // 204
        if (!userId) return [];                                                                                       // 208
                                                                                                                      //
        // TODO(someday): Allow `value` to specify app IDs to filter for.                                             // 210
                                                                                                                      //
        var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                          // 212
          return token.grainId;                                                                                       // 212
        });                                                                                                           // 212
        var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                              // 213
          return grain._id;                                                                                           // 213
        });                                                                                                           // 213
                                                                                                                      //
        return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                  // 215
          return new PowerboxOption({                                                                                 // 216
            _id: "grain-" + grainId,                                                                                  // 217
            grainId: grainId,                                                                                         // 218
            uiView: {},                                                                                               // 219
            cardTemplate: "grainPowerboxCard",                                                                        // 220
            configureTemplate: "uiViewPowerboxConfiguration"                                                          // 221
          });                                                                                                         // 216
        });                                                                                                           // 223
      }                                                                                                               // 224
                                                                                                                      //
      return query;                                                                                                   // 204
    }()                                                                                                               // 204
  });                                                                                                                 // 204
}                                                                                                                     // 226
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 228
  var _this = this;                                                                                                   // 228
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             // 229
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           // 230
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               // 231
  // `powerboxOptions`. Each item has the following fields:                                                           // 232
  //                                                                                                                  // 233
  //   _id: Unique identifier string.                                                                                 // 234
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    // 235
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     // 236
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  // 237
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               // 238
  //        to be either a string or an `ObjectID`.                                                                   // 239
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       // 240
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            // 241
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        // 242
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      // 243
  //       of the field is the same as ApiTokens.frontendRef.                                                         // 244
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        // 245
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        // 246
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     // 247
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     // 248
  //       object with the fields:                                                                                    // 249
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     // 250
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      // 251
  //         permissions when requesting a plain UiView.                                                              // 252
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      // 253
  //       match the query. If selected, a request session to the grain embedded should be shown                      // 254
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    // 255
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     // 256
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       // 257
  //       template's data context will be a "card" object as returned by                                             // 258
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      // 259
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       // 260
  //       and returns the URL of the icon to display next to the option.                                             // 261
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       // 262
  //       client-side template for that dialog.                                                                      // 263
  //   ...: Other fields may be added for consumption by the client-side template.                                    // 264
                                                                                                                      //
  check(requestId, String);                                                                                           // 266
  check(descriptorList, [String]);                                                                                    // 267
                                                                                                                      //
  var results = {};                                                                                                   // 269
  var db = this.connection.sandstormDb;                                                                               // 270
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 271
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 273
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 274
      // Decode the descriptor.                                                                                       // 275
      // TODO(now): Also single-segment? Canonical?                                                                   // 276
                                                                                                                      //
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           // 278
      var queryDescriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });
                                                                                                                      //
      if (!queryDescriptor.tags || queryDescriptor.tags.length === 0) return {};                                      // 284
                                                                                                                      //
      // Expand each tag into a match map.                                                                            // 286
      var tagMatches = queryDescriptor.tags.map(function (tag) {                                                      // 287
        var result = {};                                                                                              // 288
                                                                                                                      //
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 290
          result[option._id] = new PowerboxOption(option);                                                            // 291
        });                                                                                                           // 292
                                                                                                                      //
        return result;                                                                                                // 294
      });                                                                                                             // 295
                                                                                                                      //
      // Intersect two tags' matches.                                                                                 // 297
      var matches = tagMatches.reduce(function (a, b) {                                                               // 298
        for (var id in meteorBabelHelpers.sanitizeForInObject(a)) {                                                   // 299
          if (id in b) {                                                                                              // 300
            if (!a[id].intersect(b[id])) {                                                                            // 301
              // Empty intersection.                                                                                  // 302
              delete a[id];                                                                                           // 303
            }                                                                                                         // 304
          } else {                                                                                                    // 305
            // This match only exists in a, not b, so delete it.                                                      // 306
            delete a[id];                                                                                             // 307
          }                                                                                                           // 308
        }                                                                                                             // 309
                                                                                                                      //
        return a;                                                                                                     // 311
      });                                                                                                             // 312
                                                                                                                      //
      // Search among the user's grains for hosted objects that match.                                                // 314
                                                                                                                      //
      if (_this.userId) {                                                                                             // 316
        var user = Meteor.users.findOne(_this.userId);                                                                // 317
                                                                                                                      //
        // Find all grains shared to this user.                                                                       // 319
        var sharedGrainIds = db.userApiTokens(_this.userId).map(function (token) {                                    // 320
          return token.grainId;                                                                                       // 320
        });                                                                                                           // 320
                                                                                                                      //
        // Among all grains owned by the user or shared with the user, search for grains having                       // 322
        // any powerbox tag IDs matching the tag IDs in the query.                                                    // 323
        db.collections.grains.find({                                                                                  // 324
          $or: [{ userId: _this.userId }, { _id: { $in: sharedGrainIds } }],                                          // 326
          "cachedViewInfo.matchRequests.tags.id": { $in: queryDescriptor.tags.map(function (tag) {                    // 327
              return tag.id;                                                                                          // 328
            }) }                                                                                                      // 328
        }, { fields: { "cachedViewInfo.matchRequests": 1 } }).forEach(function (grain) {                              // 325
          // Filter down to grains that actually have a matching descriptor.                                          // 331
          var alreadyMatched = false;                                                                                 // 332
          grain.cachedViewInfo.matchRequests.forEach(function (grainDescriptor) {                                     // 333
            if (alreadyMatched) return;                                                                               // 334
                                                                                                                      //
            // Build map of descriptor tags by ID.                                                                    // 336
            var grainTagsById = {};                                                                                   // 337
            grainDescriptor.tags.forEach(function (tag) {                                                             // 338
              grainTagsById[tag.id] = tag.value;                                                                      // 339
            });                                                                                                       // 340
                                                                                                                      //
            var allMatched = true;                                                                                    // 342
            queryDescriptor.tags.forEach(function (queryTag) {                                                        // 343
              if (!allMatched) return;                                                                                // 344
                                                                                                                      //
              if (queryTag.id in grainTagsById) {                                                                     // 346
                var value = grainTagsById[queryTag.id];                                                               // 347
                // Null values match everything, so only pay attention if non-null.                                   // 348
                if (value && queryTag.value) {                                                                        // 349
                  if (!Capnp.matchPowerboxQuery(queryTag.value, value)) {                                             // 350
                    allMatched = false;                                                                               // 351
                  }                                                                                                   // 352
                }                                                                                                     // 353
              } else {                                                                                                // 354
                allMatched = false;                                                                                   // 355
              }                                                                                                       // 356
            });                                                                                                       // 357
                                                                                                                      //
            if (allMatched) {                                                                                         // 359
              alreadyMatched = true;                                                                                  // 360
              var option = new PowerboxOption({                                                                       // 361
                _id: "grain-" + grain._id,                                                                            // 362
                grainId: grain._id,                                                                                   // 363
                hostedObject: {},                                                                                     // 364
                cardTemplate: "grainPowerboxCard",                                                                    // 365
                configureTemplate: "uiViewPowerboxConfiguration" });                                                  // 366
              if (option._id in matches) {                                                                            // 368
                matches[option._id].union(option);                                                                    // 369
              } else {                                                                                                // 370
                matches[option._id] = option;                                                                         // 371
              }                                                                                                       // 372
            }                                                                                                         // 373
          });                                                                                                         // 374
        });                                                                                                           // 375
      }                                                                                                               // 376
                                                                                                                      //
      return { descriptor: queryDescriptor, matches: matches };                                                       // 378
    });                                                                                                               // 379
                                                                                                                      //
    // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                    // 381
    //   supposed to compare descriptors to determine which ones are more specific than which                         // 382
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   // 383
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           // 384
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        // 385
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        // 386
    //   list.                                                                                                        // 387
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 389
      if (clause.matchQuality === "unacceptable") {                                                                   // 390
        // Remove b's matches from a.                                                                                 // 391
        for (var id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                      // 392
          if (id in finalMatches) {                                                                                   // 393
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 394
              delete finalMatches[id];                                                                                // 395
            }                                                                                                         // 396
          }                                                                                                           // 397
        }                                                                                                             // 398
                                                                                                                      //
        return finalMatches;                                                                                          // 400
      } else {                                                                                                        // 401
        for (var _id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                     // 402
          if (_id in finalMatches) {                                                                                  // 403
            finalMatches[_id].union(clause.matches[_id]);                                                             // 404
          } else {                                                                                                    // 405
            finalMatches[_id] = clause.matches[_id];                                                                  // 406
          }                                                                                                           // 407
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 409
            finalMatches[_id].matchQuality = "preferred";                                                             // 410
          }                                                                                                           // 411
        }                                                                                                             // 412
                                                                                                                      //
        return finalMatches;                                                                                          // 414
      }                                                                                                               // 415
    }, {});                                                                                                           // 416
                                                                                                                      //
    for (var id in meteorBabelHelpers.sanitizeForInObject(matches)) {                                                 // 418
      if (!matches[id].matchQuality) {                                                                                // 419
        matches[id].matchQuality = "acceptable";                                                                      // 420
      }                                                                                                               // 421
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 423
      this.added("powerboxOptions", id, matches[id]);                                                                 // 424
    }                                                                                                                 // 425
  }                                                                                                                   // 426
                                                                                                                      //
  // TODO(someday): Make reactive? Seems annoying.                                                                    // 428
                                                                                                                      //
  this.ready();                                                                                                       // 430
});                                                                                                                   // 431
                                                                                                                      //
SandstormPowerbox = { registerUiViewQueryHandler: registerUiViewQueryHandler };                                       // 433
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
