var require = meteorInstall({"imports":{"server":{"accounts":{"ldap.js":["babel-runtime/helpers/typeof","ldapjs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/ldap.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({LDAP:function(){return LDAP}});var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var ldapjs;module.import("ldapjs",{"default":function(v){ldapjs=v}});
var Future = Npm.require("fibers/future");                                                                             // 1
                                                                                                                       // 2
                                                                                                                       //
// At a minimum, set up LDAP_DEFAULTS.url and .dn according to                                                         // 4
// your needs. url should appear as 'ldap://your.url.here'                                                             // 5
// dn should appear in normal ldap format of comma separated attribute=value                                           // 6
// e.g. 'uid=someuser,cn=users,dc=somevalue'                                                                           // 7
LDAP_DEFAULTS = {                                                                                                      // 8
  url: false,                                                                                                          // 9
  port: "389",                                                                                                         // 10
  dn: false,                                                                                                           // 11
  searchDN: false,                                                                                                     // 12
  searchCredentials: false,                                                                                            // 13
  createNewUser: true,                                                                                                 // 14
  defaultDomain: false,                                                                                                // 15
  searchResultsProfileMap: false,                                                                                      // 16
  base: null,                                                                                                          // 17
  search: "(objectclass=*)",                                                                                           // 18
  ldapsCertificate: false                                                                                              // 19
};                                                                                                                     // 8
                                                                                                                       //
/**                                                                                                                    // 22
 @class LDAP                                                                                                           //
 @constructor                                                                                                          //
 */                                                                                                                    //
function LDAP() {                                                                                                      // 26
  // Set options                                                                                                       // 27
  this.options = _.clone(LDAP_DEFAULTS);                                                                               // 28
};                                                                                                                     // 29
                                                                                                                       //
/**                                                                                                                    // 31
 * Attempt to bind (authenticate) ldap                                                                                 //
 * and perform a dn search if specified                                                                                //
 *                                                                                                                     //
 * @method ldapCheck                                                                                                   //
 *                                                                                                                     //
 * @param {Object} options  Object with username, ldapPass and overrides for LDAP_DEFAULTS object.                     //
 * Additionally the searchBeforeBind parameter can be specified, which is used to search for the DN                    //
 * if not provided.                                                                                                    //
 */                                                                                                                    //
LDAP.prototype.ldapCheck = function (db, options) {                                                                    // 41
                                                                                                                       //
  var _this = this;                                                                                                    // 43
                                                                                                                       //
  options = options || {};                                                                                             // 45
                                                                                                                       //
  if (options.hasOwnProperty("username") && options.hasOwnProperty("ldapPass") || options.hasOwnProperty("searchUsername")) {
    var _ret = function () {                                                                                           // 48
      _this.options.base = db.getLdapBase();                                                                           // 49
      _this.options.url = db.getLdapUrl();                                                                             // 50
      _this.options.searchBeforeBind = {};                                                                             // 51
      _this.options.searchBeforeBind[options.searchUsernameField || db.getLdapSearchUsername()] = options.searchUsername || options.username;
      _this.options.filter = db.getLdapFilter() || "(objectclass=*)";                                                  // 54
      _this.options.searchBindDn = db.getLdapSearchBindDn();                                                           // 55
      _this.options.searchBindPassword = db.getLdapSearchBindPassword();                                               // 56
                                                                                                                       //
      var resolved = false;                                                                                            // 58
      var ldapAsyncFut = new Future();                                                                                 // 59
                                                                                                                       //
      // Create ldap client                                                                                            // 61
      var fullUrl = db.getLdapUrl();                                                                                   // 62
      var client = null;                                                                                               // 63
                                                                                                                       //
      var errorFunc = function errorFunc(err) {                                                                        // 65
        if (err) {                                                                                                     // 66
          if (resolved) return;                                                                                        // 67
          resolved = true;                                                                                             // 68
          ldapAsyncFut["return"]({                                                                                     // 69
            error: err                                                                                                 // 70
          });                                                                                                          // 69
        }                                                                                                              // 72
      };                                                                                                               // 73
                                                                                                                       //
      if (fullUrl.indexOf("ldaps://") === 0) {                                                                         // 75
        var tlsOptions = {};                                                                                           // 76
        var cert = db.getLdapCaCert();                                                                                 // 77
        if (cert) {                                                                                                    // 78
          tlsOptions.ca = cert;                                                                                        // 79
        }                                                                                                              // 80
                                                                                                                       //
        client = ldapjs.createClient({                                                                                 // 82
          url: fullUrl,                                                                                                // 83
          tlsOptions: tlsOptions                                                                                       // 84
        }, errorFunc);                                                                                                 // 82
      } else {                                                                                                         // 86
        client = ldapjs.createClient({                                                                                 // 87
          url: fullUrl                                                                                                 // 88
        }, errorFunc);                                                                                                 // 87
      }                                                                                                                // 90
                                                                                                                       //
      client.on("error", errorFunc);                                                                                   // 92
                                                                                                                       //
      var username = options.username;                                                                                 // 94
      var domain = _this.options.defaultDomain;                                                                        // 95
                                                                                                                       //
      if (!options.hasOwnProperty("searchUsername")) {                                                                 // 97
        // Slide @xyz.whatever from username if it was passed in                                                       // 98
        // and replace it with the domain specified in defaults                                                        // 99
        var emailSliceIndex = options.username.indexOf("@");                                                           // 100
                                                                                                                       //
        // If user appended email domain, strip it out                                                                 // 102
        // And use the defaults.defaultDomain if set                                                                   // 103
        if (emailSliceIndex !== -1) {                                                                                  // 104
          username = options.username.substring(0, emailSliceIndex);                                                   // 105
          domain = domain || options.username.substring(emailSliceIndex + 1, options.username.length);                 // 106
        } else {                                                                                                       // 107
          username = options.username;                                                                                 // 108
        }                                                                                                              // 109
      }                                                                                                                // 110
                                                                                                                       //
      if (_this.options.searchBindDn) {                                                                                // 112
        var _ret2 = function () {                                                                                      // 112
          var ldapBindFut = new Future();                                                                              // 113
          client.bind(_this.options.searchBindDn, _this.options.searchBindPassword, function (err) {                   // 114
            if (err) {                                                                                                 // 116
              ldapBindFut["throw"](err);                                                                               // 117
            } else {                                                                                                   // 118
              ldapBindFut["return"]();                                                                                 // 119
            }                                                                                                          // 120
          });                                                                                                          // 121
                                                                                                                       //
          try {                                                                                                        // 124
            ldapBindFut.wait();                                                                                        // 125
          } catch (err) {                                                                                              // 126
            return {                                                                                                   // 127
              v: {                                                                                                     // 127
                v: { error: err }                                                                                      // 127
              }                                                                                                        // 127
            };                                                                                                         // 127
          }                                                                                                            // 128
        }();                                                                                                           // 112
                                                                                                                       //
        if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                // 112
      }                                                                                                                // 129
      // initialize result                                                                                             // 130
      var retObject = {                                                                                                // 131
        username: username,                                                                                            // 132
        email: domain ? username + "@" + domain : false,                                                               // 133
        emptySearch: true,                                                                                             // 134
        searchResults: {}                                                                                              // 135
      };                                                                                                               // 131
                                                                                                                       //
      var filter = _this.options.filter;                                                                               // 138
      Object.keys(_this.options.searchBeforeBind).forEach(function (searchKey) {                                       // 139
        filter = "&" + filter + "(" + searchKey + "=" + _this.options.searchBeforeBind[searchKey] + ")";               // 140
      });                                                                                                              // 141
                                                                                                                       //
      var searchOptions = {                                                                                            // 143
        scope: "sub",                                                                                                  // 144
        sizeLimit: 1,                                                                                                  // 145
        filter: filter                                                                                                 // 146
      };                                                                                                               // 143
                                                                                                                       //
      // perform LDAP search to determine DN                                                                           // 149
      client.search(_this.options.base, searchOptions, function (err, res) {                                           // 150
        if (err) {                                                                                                     // 151
          if (resolved) return;                                                                                        // 152
          resolved = true;                                                                                             // 153
          ldapAsyncFut["return"]({                                                                                     // 154
            error: err                                                                                                 // 155
          });                                                                                                          // 154
          return;                                                                                                      // 157
        }                                                                                                              // 158
                                                                                                                       //
        retObject.emptySearch = true;                                                                                  // 160
        res.on("searchEntry", function (entry) {                                                                       // 161
          retObject.dn = entry.objectName;                                                                             // 162
          retObject.username = retObject.dn;                                                                           // 163
          retObject.emptySearch = false;                                                                               // 164
                                                                                                                       //
          retObject.searchResults = _.omit(entry.object, "userPassword");                                              // 166
                                                                                                                       //
          if (options.hasOwnProperty("searchUsername")) {                                                              // 168
            // This was only a search, return immediately                                                              // 169
            resolved = true;                                                                                           // 170
            ldapAsyncFut["return"](retObject);                                                                         // 171
            return;                                                                                                    // 172
          }                                                                                                            // 173
                                                                                                                       //
          // use the determined DN to bind                                                                             // 175
          client.bind(entry.objectName, options.ldapPass, function (err) {                                             // 176
            try {                                                                                                      // 177
              if (err) {                                                                                               // 178
                throw new Meteor.Error(err.code, err.message);                                                         // 179
              } else {                                                                                                 // 180
                resolved = true;                                                                                       // 181
                ldapAsyncFut["return"](retObject);                                                                     // 182
              }                                                                                                        // 183
            } catch (e) {                                                                                              // 184
              if (resolved) return;                                                                                    // 186
              resolved = true;                                                                                         // 187
              ldapAsyncFut["return"]({                                                                                 // 188
                error: e                                                                                               // 189
              });                                                                                                      // 188
            }                                                                                                          // 191
          });                                                                                                          // 192
        });                                                                                                            // 193
                                                                                                                       //
        res.on("error", errorFunc);                                                                                    // 195
                                                                                                                       //
        // If no dn is found, return as is.                                                                            // 197
        res.on("end", function (result) {                                                                              // 198
          if (retObject.dn === undefined) {                                                                            // 199
            resolved = true;                                                                                           // 200
            ldapAsyncFut["return"](retObject);                                                                         // 201
          }                                                                                                            // 202
        });                                                                                                            // 203
      });                                                                                                              // 204
                                                                                                                       //
      return {                                                                                                         // 206
        v: ldapAsyncFut.wait()                                                                                         // 206
      };                                                                                                               // 206
    }();                                                                                                               // 48
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 48
  } else {                                                                                                             // 208
    throw new Meteor.Error(403, "Missing LDAP Auth Parameter");                                                        // 209
  }                                                                                                                    // 210
};                                                                                                                     // 212
                                                                                                                       //
LDAP.prototype.updateUserQuota = function (db, user) {                                                                 // 214
  var fallback = {                                                                                                     // 215
    storage: user.cachedStorageQuota || 0,                                                                             // 216
    grains: Infinity,                                                                                                  // 217
    compute: Infinity                                                                                                  // 218
  };                                                                                                                   // 215
                                                                                                                       //
  var setting = db.collections.settings.findOne({ _id: "quotaLdapAttribute" });                                        // 221
  if (!setting || !setting.value) return fallback;                                                                     // 222
                                                                                                                       //
  // TODO(someday): don't just assume the first login identity is the primary identity?                                // 224
  var email = db.getPrimaryEmail(user._id, user.loginIdentities[0].id);                                                // 225
  if (!email) return fallback;                                                                                         // 226
                                                                                                                       //
  var ldapUser = void 0;                                                                                               // 228
  try {                                                                                                                // 229
    ldapUser = this.ldapCheck(db, { searchUsername: email, searchUsernameField: "mail" });                             // 230
  } catch (err) {                                                                                                      // 231
    console.error("Error looking up quota from LDAP");                                                                 // 232
    return fallback;                                                                                                   // 233
  }                                                                                                                    // 234
                                                                                                                       //
  if (!ldapUser || !ldapUser.searchResults) return fallback;                                                           // 236
                                                                                                                       //
  var newStorageQuota = +ldapUser.searchResults[setting.value];                                                        // 238
  if (newStorageQuota !== user.cachedStorageQuota) {                                                                   // 239
    Meteor.users.update({ _id: user._id }, { $set: { cachedStorageQuota: newStorageQuota } });                         // 240
  }                                                                                                                    // 241
                                                                                                                       //
  // TODO(someday): cache timestamp as well and only check/update if greater than 60s ago                              // 243
  return {                                                                                                             // 244
    storage: newStorageQuota,                                                                                          // 245
    grains: Infinity,                                                                                                  // 246
    compute: Infinity                                                                                                  // 247
  };                                                                                                                   // 244
};                                                                                                                     // 249
                                                                                                                       //
                                                                                                                       // 251
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"picture.js":["meteor/http",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/picture.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({userPictureUrl:function(){return userPictureUrl},fetchPicture:function(){return fetchPicture}});var HTTP;module.import("meteor/http",{"HTTP":function(v){HTTP=v}});
                                                                                                                       //
var userPictureUrl = function userPictureUrl(user) {                                                                   // 3
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 4
    // Try to determine user's avatar URL from login service.                                                          // 5
                                                                                                                       //
    var google = user.services.google;                                                                                 // 7
    if (google && google.picture) {                                                                                    // 8
      return google.picture;                                                                                           // 9
    }                                                                                                                  // 10
                                                                                                                       //
    var github = user.services.github;                                                                                 // 12
    if (github && github.id) {                                                                                         // 13
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 14
    }                                                                                                                  // 15
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      // 17
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          // 18
    // Github are different because they are actually the identity providers, so they already know                     // 19
    // the user logged in.                                                                                             // 20
  }                                                                                                                    // 21
};                                                                                                                     // 22
                                                                                                                       //
var fetchPicture = function fetchPicture(db, url) {                                                                    // 24
  try {                                                                                                                // 25
    var result = HTTP.get(url, {                                                                                       // 26
      npmRequestOptions: { encoding: null },                                                                           // 27
      timeout: 5000                                                                                                    // 28
    });                                                                                                                // 26
                                                                                                                       //
    var metadata = {};                                                                                                 // 31
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 33
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 36
    }                                                                                                                  // 37
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 39
    if (enc && enc !== "identity") {                                                                                   // 40
      metadata.encoding = enc;                                                                                         // 41
    }                                                                                                                  // 42
                                                                                                                       //
    return db.addStaticAsset(metadata, result.content);                                                                // 44
  } catch (err) {                                                                                                      // 45
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 46
  }                                                                                                                    // 47
};                                                                                                                     // 48
                                                                                                                       //
                                                                                                                       // 50
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"saml-utils.js":["crypto","querystring","url","xml2js","xmlbuilder","xml-crypto","xmldom","zlib",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/saml-utils.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SAML:function(){return SAML}});var crypto;module.import("crypto",{"default":function(v){crypto=v}});var querystring;module.import("querystring",{"default":function(v){querystring=v}});var Url;module.import("url",{"default":function(v){Url=v}});var xml2js;module.import("xml2js",{"default":function(v){xml2js=v}});var xmlbuilder;module.import("xmlbuilder",{"default":function(v){xmlbuilder=v}});var xmlCrypto;module.import("xml-crypto",{"default":function(v){xmlCrypto=v}});var xmldom;module.import("xmldom",{"default":function(v){xmldom=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 10
                                                                                                                       //
var SAML = function SAML(options) {                                                                                    // 12
  this.options = this.initialize(options);                                                                             // 13
};                                                                                                                     // 14
                                                                                                                       //
SAML.prototype.initialize = function (options) {                                                                       // 16
  if (!options) {                                                                                                      // 17
    options = {};                                                                                                      // 18
  }                                                                                                                    // 19
                                                                                                                       //
  if (!options.protocol) {                                                                                             // 21
    options.protocol = "https://";                                                                                     // 22
  }                                                                                                                    // 23
                                                                                                                       //
  if (!options.path) {                                                                                                 // 25
    options.path = "/saml/consume";                                                                                    // 26
  }                                                                                                                    // 27
                                                                                                                       //
  if (!options.issuer) {                                                                                               // 29
    options.issuer = "onelogin_saml";                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (options.identifierFormat === undefined) {                                                                        // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return options;                                                                                                      // 37
};                                                                                                                     // 38
                                                                                                                       //
SAML.prototype.generateUniqueID = function () {                                                                        // 40
  var chars = "abcdef0123456789";                                                                                      // 41
  var uniqueID = "";                                                                                                   // 42
  for (var i = 0; i < 20; i++) {                                                                                       // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                       // 44
  }                                                                                                                    // 45
                                                                                                                       //
  return uniqueID;                                                                                                     // 47
};                                                                                                                     // 48
                                                                                                                       //
SAML.prototype.generateInstant = function () {                                                                         // 50
  var date = new Date();                                                                                               // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                     // 53
                                                                                                                       //
SAML.prototype.signRequest = function (xml) {                                                                          // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                          // 56
  signer.update(xml);                                                                                                  // 57
  return signer.sign(this.options.privateCert, "base64");                                                              // 58
};                                                                                                                     // 59
                                                                                                                       //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                             // 61
  var id = "_" + this.generateUniqueID();                                                                              // 62
  var instant = this.generateInstant();                                                                                // 63
                                                                                                                       //
  var callbackUrl = void 0;                                                                                            // 65
  // Post-auth destination                                                                                             // 66
  if (this.options.callbackUrl) {                                                                                      // 67
    callbackUrl = this.options.callbackUrl;                                                                            // 68
  } else {                                                                                                             // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                        // 70
  }                                                                                                                    // 71
                                                                                                                       //
  if (this.options.id) id = this.options.id;                                                                           // 73
                                                                                                                       //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                       //
  if (this.options.identifierFormat) {                                                                                 // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                    // 85
                                                                                                                       //
  request += "</samlp:AuthnRequest>";                                                                                  // 87
                                                                                                                       //
  return request;                                                                                                      // 89
};                                                                                                                     // 90
                                                                                                                       //
SAML.prototype.generateLogoutRequest = function (req) {                                                                // 92
  var id = "_" + this.generateUniqueID();                                                                              // 93
  var instant = this.generateInstant();                                                                                // 94
                                                                                                                       //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                   // 97
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                        // 100
                                                                                                                       //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                      // 108
};                                                                                                                     // 109
                                                                                                                       //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                                // 111
  var _this = this;                                                                                                    // 112
  zlib.deflateRaw(request, function (err, buffer) {                                                                    // 113
    if (err) {                                                                                                         // 114
      return callback(err);                                                                                            // 115
    }                                                                                                                  // 116
                                                                                                                       //
    var base64 = buffer.toString("base64");                                                                            // 118
    var target = _this.options.entryPoint;                                                                             // 119
                                                                                                                       //
    if (operation === "logout") {                                                                                      // 121
      if (_this.options.logoutUrl) {                                                                                   // 122
        target = _this.options.logoutUrl;                                                                              // 123
      }                                                                                                                // 124
    }                                                                                                                  // 125
                                                                                                                       //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                     // 127
                                                                                                                       //
    var samlRequest = {                                                                                                // 132
      SAMLRequest: base64                                                                                              // 133
    };                                                                                                                 // 132
                                                                                                                       //
    if (_this.options.privateCert) {                                                                                   // 136
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                               // 137
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                   // 138
    }                                                                                                                  // 139
                                                                                                                       //
    target += querystring.stringify(samlRequest);                                                                      // 141
                                                                                                                       //
    callback(null, target);                                                                                            // 143
  });                                                                                                                  // 144
};                                                                                                                     // 145
                                                                                                                       //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                            // 147
  var request = this.generateAuthorizeRequest(req);                                                                    // 148
                                                                                                                       //
  this.requestToUrl(request, "authorize", callback);                                                                   // 150
};                                                                                                                     // 151
                                                                                                                       //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                               // 153
  var request = this.generateLogoutRequest(req);                                                                       // 154
                                                                                                                       //
  this.requestToUrl(request, "logout", callback);                                                                      // 156
};                                                                                                                     // 157
                                                                                                                       //
SAML.prototype.certToPEM = function (cert) {                                                                           // 159
  cert = cert.match(/.{1,64}/g).join("\n");                                                                            // 160
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                       // 161
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                       // 162
  return cert;                                                                                                         // 163
};                                                                                                                     // 164
                                                                                                                       //
SAML.prototype.validateSignature = function (xml, cert) {                                                              // 166
  var _this = this;                                                                                                    // 167
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                               // 168
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                                 // 170
  sig.keyInfoProvider = {                                                                                              // 171
    getKeyInfo: function () {                                                                                          // 172
      function getKeyInfo(key) {                                                                                       // 172
        return "<X509Data></X509Data>";                                                                                // 173
      }                                                                                                                // 174
                                                                                                                       //
      return getKeyInfo;                                                                                               // 172
    }(),                                                                                                               // 172
                                                                                                                       //
    getKey: function () {                                                                                              // 176
      function getKey(keyInfo) {                                                                                       // 176
        return _this.certToPEM(cert);                                                                                  // 177
      }                                                                                                                // 178
                                                                                                                       //
      return getKey;                                                                                                   // 176
    }()                                                                                                                // 176
  };                                                                                                                   // 171
  sig.loadSignature(signature.toString());                                                                             // 180
  return sig.checkSignature(xml);                                                                                      // 181
};                                                                                                                     // 182
                                                                                                                       //
SAML.prototype.getElement = function (parentElement, elementName) {                                                    // 184
  if (parentElement["saml:" + elementName]) {                                                                          // 185
    return parentElement["saml:" + elementName];                                                                       // 186
  } else if (parentElement["samlp:" + elementName]) {                                                                  // 187
    return parentElement["samlp:" + elementName];                                                                      // 188
  } else if (parentElement["saml2p:" + elementName]) {                                                                 // 189
    return parentElement["saml2p:" + elementName];                                                                     // 190
  } else if (parentElement["saml2:" + elementName]) {                                                                  // 191
    return parentElement["saml2:" + elementName];                                                                      // 192
  }                                                                                                                    // 193
                                                                                                                       //
  return parentElement[elementName];                                                                                   // 195
};                                                                                                                     // 196
                                                                                                                       //
SAML.prototype.parseLogoutRequest = function (xml, callback) {                                                         // 198
  var _this = this;                                                                                                    // 199
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 200
  parser.parseString(xml, function (err, doc) {                                                                        // 201
    if (err) {                                                                                                         // 202
      callback(err);                                                                                                   // 203
      return;                                                                                                          // 204
    }                                                                                                                  // 205
                                                                                                                       //
    var request = _this.getElement(doc, "LogoutRequest");                                                              // 207
    var nameId = _this.getElement(request, "NameID")[0];                                                               // 208
    callback(null, nameId && nameId._);                                                                                // 209
  });                                                                                                                  // 210
};                                                                                                                     // 211
                                                                                                                       //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                                  // 213
  var _this = this;                                                                                                    // 214
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                       // 215
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 216
  parser.parseString(xml, function (err, doc) {                                                                        // 217
    // Verify signature                                                                                                // 218
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                     // 219
      return callback(new Error("Invalid signature"), null, false, xml);                                               // 220
    }                                                                                                                  // 221
                                                                                                                       //
    var response = _this.getElement(doc, "Response");                                                                  // 223
    if (response) {                                                                                                    // 224
      var assertion = _this.getElement(response, "Assertion");                                                         // 225
      if (!assertion) {                                                                                                // 226
        return callback(new Error("Missing SAML assertion"), null, false, xml);                                        // 227
      }                                                                                                                // 228
                                                                                                                       //
      profile = {};                                                                                                    // 230
                                                                                                                       //
      if (response.$ && response.$.InResponseTo) {                                                                     // 232
        profile.inResponseToId = response.$.InResponseTo;                                                              // 233
      }                                                                                                                // 234
                                                                                                                       //
      if (response.$ && response.$.Destination) {                                                                      // 236
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                                // 237
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination), null, false, xml);
        }                                                                                                              // 240
      }                                                                                                                // 241
                                                                                                                       //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                           // 243
      if (issuer) {                                                                                                    // 244
        profile.issuer = issuer[0];                                                                                    // 245
      }                                                                                                                // 246
                                                                                                                       //
      var subject = _this.getElement(assertion[0], "Subject");                                                         // 248
      if (subject) {                                                                                                   // 249
        var nameID = _this.getElement(subject[0], "NameID");                                                           // 250
        if (nameID) {                                                                                                  // 251
          profile.nameID = nameID[0]._;                                                                                // 252
                                                                                                                       //
          if (nameID[0].$.Format) {                                                                                    // 254
            profile.nameIDFormat = nameID[0].$.Format;                                                                 // 255
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                      // 256
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."), null, false, xml);
            }                                                                                                          // 260
          }                                                                                                            // 261
        }                                                                                                              // 262
                                                                                                                       //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                                 // 264
        if (subjectConfirmation) {                                                                                     // 265
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];        // 266
          if (subjectConfirmationData) {                                                                               // 268
            var recipient = subjectConfirmationData.$.Recipient;                                                       // 269
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                            // 270
              return callback(new Error("SAML sent to wrong recipient"), null, false, xml);                            // 271
            }                                                                                                          // 272
                                                                                                                       //
            var nowMs = Date.now();                                                                                    // 274
            var notBefore = subjectConfirmationData.$.NotBefore;                                                       // 275
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                          // 276
              return callback(new Error("SAML assertion was signed for the future."), null, false, xml);               // 277
            }                                                                                                          // 278
                                                                                                                       //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                                 // 280
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                   // 281
              return callback(new Error("SAML assertion was signed for the past."), null, false, xml);                 // 282
            }                                                                                                          // 283
          }                                                                                                            // 284
        }                                                                                                              // 285
      }                                                                                                                // 286
                                                                                                                       //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                                // 288
      if (conditions) {                                                                                                // 289
        for (var key in meteorBabelHelpers.sanitizeForInObject(conditions)) {                                          // 290
          if (conditions.hasOwnProperty(key)) {                                                                        // 291
            var value = conditions[key];                                                                               // 292
            if (key === "$") {                                                                                         // 293
              var _nowMs = Date.now();                                                                                 // 294
              var _notBefore = value.NotBefore;                                                                        // 295
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                     // 296
                return callback(new Error("SAML condition NotBefore is in the future."), null, false, xml);            // 297
              }                                                                                                        // 299
                                                                                                                       //
              var _notOnOrAfter = value.NotOnOrAfter;                                                                  // 301
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                              // 302
                return callback(new Error("SAML condition notOnOrAfter is in the past."), null, false, xml);           // 303
              }                                                                                                        // 305
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                                // 309
              // Do nothing.                                                                                           // 310
              // We already check both Destination and SubjectConfirmation.Recipient, so                               // 311
              // the Audience constraint isn't as important, and is tricky to handle                                   // 312
              // correctly.                                                                                            // 313
              // OneTimeUse is actually very tricky to get right, and requires a cache of                              // 314
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                           // 315
              // we would probably need to stuff it in Mongo to make it robust across multiple                         // 316
              // front-ends. It is a very rarely used constraint anyways.                                              // 317
              // ProxyRestriction constraints only govern the future use of the assertion by the                       // 318
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                         // 319
              // spec, it is always considered valid.                                                                  // 320
            } else {                                                                                                   // 321
              return callback(new Error("Unrecognized SAML constraint: " + key), null, false, xml);                    // 322
            }                                                                                                          // 323
          }                                                                                                            // 324
        }                                                                                                              // 325
      }                                                                                                                // 326
                                                                                                                       //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                   // 328
      if (attributeStatement) {                                                                                        // 329
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                         // 330
                                                                                                                       //
        if (attributes) {                                                                                              // 332
          attributes.forEach(function (attribute) {                                                                    // 333
            var value = _this.getElement(attribute, "AttributeValue");                                                 // 334
            if (typeof value[0] === "string") {                                                                        // 335
              profile[attribute.$.Name] = value[0];                                                                    // 336
            } else {                                                                                                   // 337
              profile[attribute.$.Name] = value[0]._;                                                                  // 338
            }                                                                                                          // 339
          });                                                                                                          // 340
        }                                                                                                              // 341
                                                                                                                       //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                           // 343
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs              // 344
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                                 // 345
        }                                                                                                              // 346
                                                                                                                       //
        if (!profile.email && profile.mail) {                                                                          // 348
          profile.email = profile.mail;                                                                                // 349
        }                                                                                                              // 350
                                                                                                                       //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];            // 352
        if (!profile.email && microsoftEmail) {                                                                        // 353
          profile.email = microsoftEmail;                                                                              // 354
        }                                                                                                              // 355
                                                                                                                       //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];                // 357
        if (!profile.displayName && microsoftDisplayName) {                                                            // 358
          profile.displayName = microsoftDisplayName;                                                                  // 359
        }                                                                                                              // 360
      }                                                                                                                // 361
                                                                                                                       //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                                // 364
      }                                                                                                                // 365
                                                                                                                       //
      callback(null, profile, false, xml);                                                                             // 367
    } else {                                                                                                           // 368
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                    // 369
                                                                                                                       //
      if (logoutResponse) {                                                                                            // 371
        callback(null, null, true, xml);                                                                               // 372
      } else {                                                                                                         // 373
        return callback(new Error("Unknown SAML response message"), null, false, xml);                                 // 374
      }                                                                                                                // 375
    }                                                                                                                  // 377
  });                                                                                                                  // 379
};                                                                                                                     // 380
                                                                                                                       //
SAML.prototype.generateServiceProviderMetadata = function () {                                                         // 382
  var entityId = this.options.issuer;                                                                                  // 383
  var metadata = {                                                                                                     // 384
    "EntityDescriptor": {                                                                                              // 385
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                                // 386
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                               // 387
      "@entityID": entityId,                                                                                           // 388
      "@ID": entityId.replace(/\W/g, "_"),                                                                             // 389
      "SPSSODescriptor": {                                                                                             // 390
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                          // 391
      }                                                                                                                // 390
    }                                                                                                                  // 385
  };                                                                                                                   // 384
                                                                                                                       //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                             // 396
  if (decryptionCert) {                                                                                                // 397
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                        // 398
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                          // 399
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                            // 400
                                                                                                                       //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                        // 402
      "ds:KeyInfo": {                                                                                                  // 403
        "ds:X509Data": {                                                                                               // 404
          "ds:X509Certificate": {                                                                                      // 405
            "#text": decryptionCert                                                                                    // 406
          }                                                                                                            // 405
        }                                                                                                              // 404
      },                                                                                                               // 403
      "EncryptionMethod": [                                                                                            // 410
      // this should be the set that the xmlenc library supports                                                       // 411
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                                 // 402
  }                                                                                                                    // 417
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                                    // 419
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-Redirect",                                                  // 420
    "@Location": Meteor.absoluteUrl("saml/logout/default")                                                             // 421
  };                                                                                                                   // 419
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                              // 424
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                               // 425
    "@index": "1",                                                                                                     // 426
    "@isDefault": "true",                                                                                              // 427
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                      // 428
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                          // 429
  };                                                                                                                   // 425
                                                                                                                       //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                               // 432
};                                                                                                                     // 433
                                                                                                                       //
                                                                                                                       // 435
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"async-helpers.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/async-helpers.js                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({inMeteor:function(){return inMeteor},promiseToFuture:function(){return promiseToFuture},waitPromise:function(){return waitPromise},onInMeteor:function(){return onInMeteor}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 3
                                                                                                                       //
var inMeteorListener = undefined;                                                                                      // 5
var onInMeteor = function onInMeteor(callback) {                                                                       // 6
  inMeteorListener = callback;                                                                                         // 7
};                                                                                                                     // 8
                                                                                                                       //
// Meteor context <-> Async Node.js context adapters                                                                   // 10
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 11
  callback();                                                                                                          // 12
});                                                                                                                    // 13
                                                                                                                       //
var inMeteor = function inMeteor(callback) {                                                                           // 15
  if (inMeteorListener) {                                                                                              // 16
    inMeteorListener();                                                                                                // 17
  }                                                                                                                    // 18
                                                                                                                       //
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        // 20
  return new Promise(function (resolve, reject) {                                                                      // 21
    inMeteorInternal(function () {                                                                                     // 22
      try {                                                                                                            // 23
        resolve(callback());                                                                                           // 24
      } catch (err) {                                                                                                  // 25
        reject(err);                                                                                                   // 26
      }                                                                                                                // 27
    });                                                                                                                // 28
  });                                                                                                                  // 29
};                                                                                                                     // 30
                                                                                                                       //
var promiseToFuture = function promiseToFuture(promise) {                                                              // 32
  var result = new Future();                                                                                           // 33
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 34
  return result;                                                                                                       // 35
};                                                                                                                     // 36
                                                                                                                       //
var waitPromise = function waitPromise(promise) {                                                                      // 38
  return promiseToFuture(promise).wait();                                                                              // 39
};                                                                                                                     // 40
                                                                                                                       //
                                                                                                                       // 42
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"auth.js":["meteor/meteor","meteor/check","crypto","fs","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var SANDSTORM_VARDIR;module.import("/imports/server/constants.js",{"SANDSTORM_VARDIR":function(v){SANDSTORM_VARDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      // 6
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 60 * 60 * 1000;                                                                      // 8
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 9
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 11
  if (tokenIsSetupSession(token)) {                                                                                    // 12
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 13
    globalDb.collections.setupSession.remove({                                                                         // 14
      _id: "current-session",                                                                                          // 15
      hashedSessionId: hash                                                                                            // 16
    });                                                                                                                // 14
  }                                                                                                                    // 18
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 20
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 21
    console.log("Admin token deleted.");                                                                               // 22
  }                                                                                                                    // 23
}                                                                                                                      // 24
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 26
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 27
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 28
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 29
    if (stats.mtime < expireTime) {                                                                                    // 30
      return false;                                                                                                    // 31
    } else {                                                                                                           // 32
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 33
    }                                                                                                                  // 34
  } else {                                                                                                             // 35
    return false;                                                                                                      // 36
  }                                                                                                                    // 37
}                                                                                                                      // 38
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 40
  if (token) {                                                                                                         // 41
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 42
    if (setupSession) {                                                                                                // 43
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 44
      var now = new Date();                                                                                            // 45
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 46
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 47
        return true;                                                                                                   // 48
      }                                                                                                                // 49
    }                                                                                                                  // 50
  }                                                                                                                    // 51
                                                                                                                       //
  return false;                                                                                                        // 53
}                                                                                                                      // 54
                                                                                                                       //
function checkAuth(token) {                                                                                            // 56
  check(token, Match.OneOf(undefined, null, String));                                                                  // 57
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 58
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 59
  }                                                                                                                    // 60
}                                                                                                                      // 61
                                                                                                                       //
                                                                                                                       // 63
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backend.js":["babel-runtime/helpers/classCallCheck","/imports/server/constants.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/backend.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SandstormBackend:function(){return SandstormBackend},shouldRestartGrain:function(){return shouldRestartGrain}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var inMeteor,promiseToFuture,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"promiseToFuture":function(v){promiseToFuture=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 21
var Crypto = Npm.require("crypto");                                                                                    // 22
                                                                                                                       //
var storageUsageUnimplemented = false;                                                                                 // 24
                                                                                                                       //
function generateSessionId(grainId, userId, packageSalt, clientSalt) {                                                 // 26
  var sessionParts = [grainId, clientSalt];                                                                            // 27
  if (userId) {                                                                                                        // 28
    sessionParts.push(userId);                                                                                         // 29
  }                                                                                                                    // 30
                                                                                                                       //
  if (packageSalt) {                                                                                                   // 32
    sessionParts.push(packageSalt);                                                                                    // 33
  }                                                                                                                    // 34
                                                                                                                       //
  var sessionInput = sessionParts.join(":");                                                                           // 36
  return Crypto.createHash("sha256").update(sessionInput).digest("hex");                                               // 37
}                                                                                                                      // 38
                                                                                                                       //
var shouldRestartGrain = function shouldRestartGrain(error, retryCount) {                                              // 40
  // Given an error thrown by an RPC call to a grain, return whether or not it makes sense to try                      // 41
  // to restart the grain and retry. `retryCount` is the number of times that the request has                          // 42
  // already gone through this cycle (should be zero for the first call).                                              // 43
  return error.kjType === "disconnected" && retryCount < 1;                                                            // 44
};                                                                                                                     // 45
                                                                                                                       //
var SandstormBackend = function () {                                                                                   //
  function SandstormBackend(db, backendCap) {                                                                          // 48
    _classCallCheck(this, SandstormBackend);                                                                           // 48
                                                                                                                       //
    this._db = db;                                                                                                     // 49
    this._backendCap = backendCap;                                                                                     // 50
  }                                                                                                                    // 51
                                                                                                                       //
  SandstormBackend.prototype.cap = function () {                                                                       //
    function cap() {                                                                                                   //
      return this._backendCap;                                                                                         // 54
    }                                                                                                                  // 55
                                                                                                                       //
    return cap;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.deleteUser = function () {                                                                //
    function deleteUser(userId) {                                                                                      //
      return waitPromise(this._backendCap.deleteUser(userId));                                                         // 58
    }                                                                                                                  // 59
                                                                                                                       //
    return deleteUser;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.shutdownGrain = function () {                                                             //
    function shutdownGrain(grainId, ownerId, keepSessions) {                                                           //
      if (!keepSessions) {                                                                                             // 62
        Sessions.remove({ grainId: grainId });                                                                         // 63
      }                                                                                                                // 64
                                                                                                                       //
      var grain = this._backendCap.getGrain(ownerId, grainId).supervisor;                                              // 66
      return grain.shutdown().then(function () {                                                                       // 67
        grain.close();                                                                                                 // 68
        throw new Error("expected shutdown() to throw disconnected");                                                  // 69
      }, function (err) {                                                                                              // 70
                                                                                                                       //
        grain.close();                                                                                                 // 72
        if (err.kjType !== "disconnected") {                                                                           // 73
          throw err;                                                                                                   // 74
        }                                                                                                              // 75
      });                                                                                                              // 76
    }                                                                                                                  // 77
                                                                                                                       //
    return shutdownGrain;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.deleteGrain = function () {                                                               //
    function deleteGrain(grainId, ownerId) {                                                                           //
      // We leave it up to the caller if they want to actually wait, but some don't so we report                       // 80
      // exceptions.                                                                                                   // 81
      return this._backendCap.deleteGrain(ownerId, grainId)["catch"](function (err) {                                  // 82
        console.error("problem deleting grain " + grainId + ":", err.message);                                         // 83
        throw err;                                                                                                     // 84
      });                                                                                                              // 85
    }                                                                                                                  // 86
                                                                                                                       //
    return deleteGrain;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.maybeRetryUseGrain = function () {                                                        //
    function maybeRetryUseGrain(grainId, cb, retryCount, err) {                                                        //
      var _this = this;                                                                                                // 88
                                                                                                                       //
      if (shouldRestartGrain(err, retryCount)) {                                                                       // 89
        return inMeteor(function () {                                                                                  // 90
          return cb(_this.continueGrain(grainId).supervisor)["catch"](_this.maybeRetryUseGrain.bind(_this, grainId, cb, retryCount + 1));
        });                                                                                                            // 93
      } else {                                                                                                         // 94
        throw err;                                                                                                     // 95
      }                                                                                                                // 96
    }                                                                                                                  // 97
                                                                                                                       //
    return maybeRetryUseGrain;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.useGrain = function () {                                                                  //
    function useGrain(grainId, cb) {                                                                                   //
      var _this2 = this;                                                                                               // 99
                                                                                                                       //
      // This will open a grain for you, handling restarts if needed, and call the passed function with                // 100
      // the supervisor capability as the only parameter. The callback must return a promise that used                 // 101
      // the supervisor, so that we can check if a disconnect error occurred, and retry if possible.                   // 102
      // This function returns the same promise that your callback returns.                                            // 103
      //                                                                                                               // 104
      // This function is NOT expected to be run in a meteor context.                                                  // 105
      return inMeteor(function () {                                                                                    // 106
        return cb(_this2.continueGrain(grainId).supervisor)["catch"](_this2.maybeRetryUseGrain.bind(_this2, grainId, cb, 0));
      });                                                                                                              // 109
    }                                                                                                                  // 110
                                                                                                                       //
    return useGrain;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.continueGrain = function () {                                                             //
    function continueGrain(grainId) {                                                                                  //
      var grain = Grains.findOne(grainId);                                                                             // 113
      if (!grain) {                                                                                                    // 114
        throw new Meteor.Error(404, "Grain Not Found", "Grain ID: " + grainId);                                        // 115
      }                                                                                                                // 116
                                                                                                                       //
      // If a DevPackage with the same app ID is currently active, we let it override the installed                    // 118
      // package, so that the grain runs using the dev app.                                                            // 119
      var devPackage = DevPackages.findOne({ appId: grain.appId });                                                    // 120
      var isDev = void 0;                                                                                              // 121
      var mountProc = void 0;                                                                                          // 122
      var pkg = void 0;                                                                                                // 123
      if (devPackage) {                                                                                                // 124
        isDev = true;                                                                                                  // 125
        pkg = devPackage;                                                                                              // 126
        mountProc = pkg.mountProc;                                                                                     // 127
      } else {                                                                                                         // 128
        pkg = Packages.findOne(grain.packageId);                                                                       // 129
        if (!pkg) {                                                                                                    // 130
          throw new Meteor.Error(500, "Grain's package not installed", "Package ID: " + grain.packageId);              // 131
        }                                                                                                              // 133
      }                                                                                                                // 134
                                                                                                                       //
      var manifest = pkg.manifest;                                                                                     // 136
      var packageId = pkg._id;                                                                                         // 137
                                                                                                                       //
      if (!("continueCommand" in manifest)) {                                                                          // 139
        throw new Meteor.Error(500, "Package manifest defines no continueCommand.", "Package ID: " + packageId);       // 140
      }                                                                                                                // 142
                                                                                                                       //
      var result = this.startGrainInternal(packageId, grainId, grain.userId, manifest.continueCommand, false, isDev, mountProc);
      result.packageSalt = isDev ? pkg._id : grain.packageSalt;                                                        // 146
      return result;                                                                                                   // 147
    }                                                                                                                  // 148
                                                                                                                       //
    return continueGrain;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.startGrainInternal = function () {                                                        //
    function startGrainInternal(packageId, grainId, ownerId, command, isNew, isDev, mountProc) {                       //
      // Starts the grain supervisor.  Must be executed in a Meteor context.  Blocks until grain is                    // 151
      // started. Returns a promise for an object containing two fields: `owner` (the ID of the owning                 // 152
      // user) and `supervisor` (the supervisor capability).                                                           // 153
                                                                                                                       //
      if (isUserExcessivelyOverQuota(Meteor.users.findOne(ownerId))) {                                                 // 155
        throw new Meteor.Error(402, "Cannot start grain because owner's storage is exhausted.\n" + "Please ask them to upgrade.");
      }                                                                                                                // 159
                                                                                                                       //
      // Ugly: Stay backwards-compatible with old manifests that had "executablePath" and "args" rather                // 161
      //   than just "argv".                                                                                           // 162
      if ("args" in command) {                                                                                         // 163
        if (!("argv" in command)) {                                                                                    // 164
          command.argv = command.args;                                                                                 // 165
        }                                                                                                              // 166
                                                                                                                       //
        delete command.args;                                                                                           // 168
      }                                                                                                                // 169
                                                                                                                       //
      if ("executablePath" in command) {                                                                               // 171
        if (!("deprecatedExecutablePath" in command)) {                                                                // 172
          command.deprecatedExecutablePath = command.executablePath;                                                   // 173
        }                                                                                                              // 174
                                                                                                                       //
        delete command.executablePath;                                                                                 // 176
      }                                                                                                                // 177
                                                                                                                       //
      return this._backendCap.startGrain(ownerId, grainId, packageId, command, isNew, isDev, mountProc);               // 179
    }                                                                                                                  // 180
                                                                                                                       //
    return startGrainInternal;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.updateLastActive = function () {                                                          //
    function updateLastActive(grainId, userId, identityId) {                                                           //
      // Update the lastActive date on the grain, any relevant API tokens, and the user,                               // 183
      // and also update the user's storage usage.                                                                     // 184
                                                                                                                       //
      var storagePromise = undefined;                                                                                  // 186
      var ownerId = undefined;                                                                                         // 187
      if (this._db.isQuotaEnabled() && !storageUsageUnimplemented) {                                                   // 188
        ownerId = Grains.findOne(grainId).userId;                                                                      // 189
        storagePromise = this._backendCap.getUserStorageUsage(ownerId);                                                // 190
      }                                                                                                                // 191
                                                                                                                       //
      var now = new Date();                                                                                            // 193
      if (Grains.update(grainId, { $set: { lastUsed: now } }) === 0) {                                                 // 194
        // Grain must have been deleted. Ignore.                                                                       // 195
        return;                                                                                                        // 196
      }                                                                                                                // 197
                                                                                                                       //
      if (userId) {                                                                                                    // 199
        Meteor.users.update(userId, { $set: { lastActive: now } });                                                    // 200
      }                                                                                                                // 201
                                                                                                                       //
      if (identityId) {                                                                                                // 203
        Meteor.users.update({ _id: identityId }, { $set: { lastActive: now } });                                       // 204
        // Update any API tokens that match this user/grain pairing as well                                            // 205
        ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: { lastUsed: now } }, { multi: true });
      }                                                                                                                // 209
                                                                                                                       //
      if (storagePromise) {                                                                                            // 211
        try {                                                                                                          // 212
          var size = parseInt(waitPromise(storagePromise).size);                                                       // 213
          Meteor.users.update(ownerId, { $set: { storageUsage: size } });                                              // 214
          // TODO(security): Consider actively killing grains if the user is excessively over quota?                   // 215
          //   Otherwise a constantly-active grain could consume arbitrary space without being stopped.                // 216
        } catch (err) {                                                                                                // 217
          if (err.kjType === "unimplemented") {                                                                        // 218
            storageUsageUnimplemented = true;                                                                          // 219
          } else {                                                                                                     // 220
            console.error("error getting user storage usage:", err.stack);                                             // 221
          }                                                                                                            // 222
        }                                                                                                              // 223
      }                                                                                                                // 224
    }                                                                                                                  // 225
                                                                                                                       //
    return updateLastActive;                                                                                           //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormBackend.prototype.openSessionInternal = function () {                                                       //
    function openSessionInternal(grainId, userId, identityId, title, apiToken, cachedSalt, sessionFields) {            //
      // Start the grain if it is not running. This is an optimization: if we didn't start it here,                    // 228
      // it would start on the first request to the session host, but we'd like to get started before                  // 229
      // the round trip.                                                                                               // 230
      var _continueGrain = this.continueGrain(grainId);                                                                // 227
                                                                                                                       //
      var supervisor = _continueGrain.supervisor;                                                                      // 227
      var packageSalt = _continueGrain.packageSalt;                                                                    // 227
                                                                                                                       //
                                                                                                                       //
      this.updateLastActive(grainId, userId, identityId);                                                              // 233
                                                                                                                       //
      cachedSalt = cachedSalt || Random.id(22);                                                                        // 235
      var sessionId = generateSessionId(grainId, userId, packageSalt, cachedSalt);                                     // 236
      var session = Sessions.findOne({ _id: sessionId });                                                              // 237
      if (session) {                                                                                                   // 238
        // TODO(someday): also do some more checks for anonymous sessions (sessions without a userId).                 // 239
        if (session.identityId && session.identityId !== identityId || session.grainId !== grainId) {                  // 240
          var e = new Meteor.Error(500, "Duplicate SessionId");                                                        // 242
          console.error(e);                                                                                            // 243
          throw e;                                                                                                     // 244
        } else {                                                                                                       // 245
          return {                                                                                                     // 246
            supervisor: supervisor,                                                                                    // 247
            methodResult: {                                                                                            // 248
              sessionId: session._id,                                                                                  // 249
              title: title,                                                                                            // 250
              grainId: grainId,                                                                                        // 251
              hostId: session.hostId,                                                                                  // 252
              tabId: session.tabId,                                                                                    // 253
              salt: cachedSalt                                                                                         // 254
            }                                                                                                          // 248
          };                                                                                                           // 246
        }                                                                                                              // 257
      }                                                                                                                // 258
                                                                                                                       //
      // TODO(someday): Allow caller to specify the parent session from which to inherit the tab ID, or                // 260
      //   something.                                                                                                  // 261
                                                                                                                       //
      session = {                                                                                                      // 263
        _id: sessionId,                                                                                                // 264
        grainId: grainId,                                                                                              // 265
        hostId: Crypto.createHash("sha256").update(sessionId).digest("hex").slice(0, 32),                              // 266
        tabId: Crypto.createHash("sha256").update("tab:").update(sessionId).digest("hex").slice(0, 32),                // 267
        timestamp: new Date().getTime(),                                                                               // 268
        hasLoaded: false                                                                                               // 269
      };                                                                                                               // 263
                                                                                                                       //
      if (userId) {                                                                                                    // 272
        session.userId = userId;                                                                                       // 273
      }                                                                                                                // 274
                                                                                                                       //
      if (identityId) {                                                                                                // 276
        session.identityId = identityId;                                                                               // 277
      }                                                                                                                // 278
                                                                                                                       //
      if (apiToken) {                                                                                                  // 280
        session.hashedToken = apiToken._id;                                                                            // 281
      }                                                                                                                // 282
                                                                                                                       //
      if (sessionFields) {                                                                                             // 284
        _.extend(session, sessionFields);                                                                              // 285
      }                                                                                                                // 286
                                                                                                                       //
      Sessions.insert(session);                                                                                        // 288
                                                                                                                       //
      return {                                                                                                         // 290
        supervisor: supervisor,                                                                                        // 291
        methodResult: {                                                                                                // 292
          sessionId: session._id,                                                                                      // 293
          title: title,                                                                                                // 294
          grainId: grainId,                                                                                            // 295
          hostId: session.hostId,                                                                                      // 296
          tabId: session.tabId,                                                                                        // 297
          salt: cachedSalt                                                                                             // 298
        }                                                                                                              // 292
      };                                                                                                               // 290
    }                                                                                                                  // 301
                                                                                                                       //
    return openSessionInternal;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  return SandstormBackend;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 302
                                                                                                                       //
                                                                                                                       // 304
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"constants.js":["meteor/meteor","url",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/constants.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SANDSTORM_ALTHOME:function(){return SANDSTORM_ALTHOME},SANDSTORM_LOGDIR:function(){return SANDSTORM_LOGDIR},SANDSTORM_VARDIR:function(){return SANDSTORM_VARDIR},staticAssetHost:function(){return staticAssetHost}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Url;module.import("url",{"default":function(v){Url=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      // 17
                                                                                                                       //
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
var SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                       // 22
var SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                         // 23
var SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                   // 24
                                                                                                                       //
// TODO: dedupe this and the equivalent copy in sandstorm-db                                                           // 26
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 27
                                                                                                                       //
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + wildcardHost[0] + "static" + wildcardHost[1];  // 29
                                                                                                                       //
                                                                                                                       // 31
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications.js":["meteor/check",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/desktop-notifications.js                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({createAppActivityDesktopNotification:function(){return createAppActivityDesktopNotification}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var createAppActivityDesktopNotification = function createAppActivityDesktopNotification(options) {                    // 19
  check(options, {                                                                                                     // 20
    userId: String,                                                                                                    // 21
    notificationId: String,                                                                                            // 22
    appActivity: {                                                                                                     // 23
      user: Match.OneOf(undefined, {                                                                                   // 24
        identityId: String,                                                                                            // 27
        name: String,                                                                                                  // 28
        avatarUrl: String                                                                                              // 29
      }, { anonymous: true }),                                                                                         // 26
      grainId: String,                                                                                                 // 33
      path: String,                                                                                                    // 34
      body: Match.ObjectIncluding({                                                                                    // 35
        defaultText: String                                                                                            // 36
      }),                                                                                                              // 35
      actionText: Match.ObjectIncluding({                                                                              // 38
        defaultText: String                                                                                            // 39
      })                                                                                                               // 38
    }                                                                                                                  // 23
  });                                                                                                                  // 20
                                                                                                                       //
  globalDb.collections.desktopNotifications.insert({                                                                   // 44
    userId: options.userId,                                                                                            // 45
    notificationId: options.notificationId,                                                                            // 46
    creationDate: new Date(),                                                                                          // 47
    appActivity: options.appActivity                                                                                   // 48
  });                                                                                                                  // 44
};                                                                                                                     // 50
                                                                                                                       //
                                                                                                                       // 52
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"email.js":["meteor/meteor","nodemailer","nodemailer-smtp-pool",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/email.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({send:function(){return send},rawSend:function(){return rawSend}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var nodemailer;module.import("nodemailer",{"default":function(v){nodemailer=v}});var smtpPool;module.import("nodemailer-smtp-pool",{"default":function(v){smtpPool=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 5
                                                                                                                       //
var getSmtpConfig = function getSmtpConfig() {                                                                         // 7
  var config = Settings.findOne({ _id: "smtpConfig" });                                                                // 8
  return config && config.value;                                                                                       // 9
};                                                                                                                     // 10
                                                                                                                       //
var makePool = function makePool(mailConfig) {                                                                         // 12
  if (!mailConfig.hostname) {                                                                                          // 13
    throw new Error("This Sandstorm server has not been configured to send email.");                                   // 14
  }                                                                                                                    // 15
                                                                                                                       //
  var auth = false;                                                                                                    // 17
  if (mailConfig.auth && (mailConfig.auth.user || mailConfig.auth.pass)) {                                             // 18
    auth = mailConfig.auth;                                                                                            // 19
  }                                                                                                                    // 20
                                                                                                                       //
  var secure = mailConfig.port === 465;                                                                                // 22
  var tlsOptions = {                                                                                                   // 23
    // Previously, node 0.10 did not attempt to validate certificates received when connecting                         // 24
    // with STARTTLS, so to avoid regressing we need to preserve that behavior here for now.                           // 25
    rejectUnauthorized: false                                                                                          // 26
  };                                                                                                                   // 23
                                                                                                                       //
  var pool = nodemailer.createTransport(smtpPool({                                                                     // 29
    host: mailConfig.hostname,                                                                                         // 30
    port: mailConfig.port,                                                                                             // 31
    secure: secure,                                                                                                    // 32
    tls: tlsOptions,                                                                                                   // 33
    auth: auth                                                                                                         // 34
  }));                                                                                                                 // 29
                                                                                                                       //
  pool._futureWrappedSendMail = _.bind(Future.wrap(pool.sendMail), pool);                                              // 38
  return pool;                                                                                                         // 39
};                                                                                                                     // 40
                                                                                                                       //
// We construct the SMTP pool at the first call to Email.send, so that                                                 // 42
// other code like migrations can modify the SMTP configuration.                                                       // 43
var pool = void 0;                                                                                                     // 44
var configured = false;                                                                                                // 45
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 47
  Settings.find({ _id: "smtpConfig" }).observeChanges({                                                                // 48
    removed: function () {                                                                                             // 49
      function removed() {                                                                                             // 49
        configured = false;                                                                                            // 50
      }                                                                                                                // 51
                                                                                                                       //
      return removed;                                                                                                  // 49
    }(),                                                                                                               // 49
                                                                                                                       //
    changed: function () {                                                                                             // 53
      function changed() {                                                                                             // 53
        configured = false;                                                                                            // 54
      }                                                                                                                // 55
                                                                                                                       //
      return changed;                                                                                                  // 53
    }(),                                                                                                               // 53
                                                                                                                       //
    added: function () {                                                                                               // 57
      function added() {                                                                                               // 57
        configured = false;                                                                                            // 58
      }                                                                                                                // 59
                                                                                                                       //
      return added;                                                                                                    // 57
    }()                                                                                                                // 57
  });                                                                                                                  // 48
});                                                                                                                    // 61
                                                                                                                       //
var getPool = function getPool(smtpConfig) {                                                                           // 63
  if (smtpConfig) {                                                                                                    // 64
    return makePool(smtpConfig);                                                                                       // 65
  } else if (!configured) {                                                                                            // 66
    configured = true;                                                                                                 // 67
    var config = getSmtpConfig();                                                                                      // 68
    if (config) {                                                                                                      // 69
      pool = makePool(config);                                                                                         // 70
    }                                                                                                                  // 71
  }                                                                                                                    // 72
                                                                                                                       //
  return pool;                                                                                                         // 74
};                                                                                                                     // 75
                                                                                                                       //
var smtpSend = function smtpSend(pool, mailOptions) {                                                                  // 77
  pool._futureWrappedSendMail(mailOptions).wait();                                                                     // 78
};                                                                                                                     // 79
                                                                                                                       //
var rawSend = function rawSend(mailOptions, smtpConfig) {                                                              // 81
  // Sends an email mailOptions object structured as described in                                                      // 82
  // https://github.com/nodemailer/mailcomposer#e-mail-message-fields                                                  // 83
  // across the transport described by smtpConfig.                                                                     // 84
  var pool = getPool(smtpConfig);                                                                                      // 85
  if (pool) {                                                                                                          // 86
    smtpSend(pool, mailOptions);                                                                                       // 87
  } else {                                                                                                             // 88
    throw new Error("SMTP pool is misconfigured.");                                                                    // 89
  }                                                                                                                    // 90
};                                                                                                                     // 91
                                                                                                                       //
// Old comment below                                                                                                   // 93
/**                                                                                                                    // 94
 * Send an email.                                                                                                      //
 *                                                                                                                     //
 * Connects to the mail server configured via the MAIL_URL environment                                                 //
 * variable. If unset, prints formatted message to stdout. The "from" option                                           //
 * is required, and at least one of "to", "cc", and "bcc" must be provided;                                            //
 * all other options are optional.                                                                                     //
 *                                                                                                                     //
 * @param options                                                                                                      //
 * @param options.from {String} RFC5322 "From:" address                                                                //
 * @param options.to {String|String[]} RFC5322 "To:" address[es]                                                       //
 * @param options.cc {String|String[]} RFC5322 "Cc:" address[es]                                                       //
 * @param options.bcc {String|String[]} RFC5322 "Bcc:" address[es]                                                     //
 * @param options.replyTo {String|String[]} RFC5322 "Reply-To:" address[es]                                            //
 * @param options.subject {String} RFC5322 "Subject:" line                                                             //
 * @param options.text {String} RFC5322 mail body (plain text)                                                         //
 * @param options.html {String} RFC5322 mail body (HTML)                                                               //
 * @param options.headers {Object} custom RFC5322 headers (dictionary)                                                 //
 */                                                                                                                    //
                                                                                                                       //
// New API doc comment below                                                                                           // 114
/**                                                                                                                    // 115
 * @summary Send an email. Throws an `Error` on failure to contact mail server                                         //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} options                                                                                             //
 * @param {String} options.from "From:" address (required)                                                             //
 * @param {String|String[]} options.to,cc,bcc,replyTo                                                                  //
 *   "To:", "Cc:", "Bcc:", and "Reply-To:" addresses                                                                   //
 * @param {String} [options.subject]  "Subject:" line                                                                  //
 * @param {String} [options.text|html] Mail body (in plain text or HTML)                                               //
 * @param {Object} [options.headers] Dictionary of custom headers                                                      //
 * @param {Object} [options.smtpConfig] SMTP server to use. Otherwise defaults to configured one.                      //
 * @param {String} [options.smtpConfig.hostname] SMTP server hostname.                                                 //
 * @param {Number} [options.smtpConfig.port] SMTP server port.                                                         //
 * @param {Object} [options.smtpConfig.auth] SMTP server authentication tokens.  Optional.                             //
 * @param {String} [options.smtpConfig.auth.user] Username of user to log in to SMTP server as.  Optional.             //
 * @param {String} [options.smtpConfig.auth.pass] Password of user to log in to SMTP server as.  Optional.             //
 * @param {Object} [options.attachments] Attachments. See:                                                             //
 *   https://github.com/nodemailer/mailcomposer/tree/v0.1.15#add-attachments                                           //
 * @param {String} [options.envelopeFrom] Envelope sender.                                                             //
 */                                                                                                                    //
var send = function send(options) {                                                                                    // 137
  // Unpack options                                                                                                    // 138
  var from = options.from;                                                                                             // 137
  var to = options.to;                                                                                                 // 137
  var cc = options.cc;                                                                                                 // 137
  var bcc = options.bcc;                                                                                               // 137
  var replyTo = options.replyTo;                                                                                       // 137
  var subject = options.subject;                                                                                       // 137
  var text = options.text;                                                                                             // 137
  var html = options.html;                                                                                             // 137
  var envelopeFrom = options.envelopeFrom;                                                                             // 137
  var headers = options.headers;                                                                                       // 137
  var attachments = options.attachments;                                                                               // 137
  var smtpConfig = options.smtpConfig;                                                                                 // 137
                                                                                                                       //
                                                                                                                       //
  var opts = {                                                                                                         // 154
    from: from,                                                                                                        // 155
    to: to,                                                                                                            // 156
    cc: cc,                                                                                                            // 157
    bcc: bcc,                                                                                                          // 158
    replyTo: replyTo,                                                                                                  // 159
    subject: subject,                                                                                                  // 160
    text: text,                                                                                                        // 161
    html: html,                                                                                                        // 162
    headers: headers,                                                                                                  // 163
    attachments: attachments                                                                                           // 164
  };                                                                                                                   // 154
                                                                                                                       //
  if (envelopeFrom) {                                                                                                  // 167
    opts.envelope = {                                                                                                  // 168
      from: envelopeFrom,                                                                                              // 169
      to: to,                                                                                                          // 170
      cc: cc,                                                                                                          // 171
      bcc: bcc                                                                                                         // 172
    };                                                                                                                 // 168
  }                                                                                                                    // 174
                                                                                                                       //
  rawSend(opts, smtpConfig);                                                                                           // 176
};                                                                                                                     // 177
                                                                                                                       //
                                                                                                                       // 179
                                                                                                                       //
// TODO(cleanup): Remove this once BlackrockPayments code finds a better way to import it.                             // 181
global.SandstormEmail = { send: send };                                                                                // 182
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function () {                                                                 //
    function create(db, frontendRef, requirements) {                                                                   //
      // Construct a fresh capability based on a `frontendRef` value.                                                  // 26
                                                                                                                       //
      checkRequirements(requirements);                                                                                 // 28
                                                                                                                       //
      var saveTemplate = { frontendRef: frontendRef };                                                                 // 30
      if (requirements) {                                                                                              // 31
        saveTemplate.requirements = requirements;                                                                      // 32
      }                                                                                                                // 33
                                                                                                                       //
      return this.restore(db, saveTemplate, frontendRef);                                                              // 35
    }                                                                                                                  // 36
                                                                                                                       //
    return create;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function () {                                                                //
    function restore(db, saveTemplate, frontendRef) {                                                                  //
      // Restores a frontendRef capability using the appropriate registered handler.                                   // 39
                                                                                                                       //
      var keys = Object.keys(frontendRef);                                                                             // 41
      if (keys.length != 1) {                                                                                          // 42
        throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                        // 43
      }                                                                                                                // 44
                                                                                                                       //
      var key = keys[0];                                                                                               // 46
      var handler = this._frontendRefHandlers[key];                                                                    // 47
      if (!handler) {                                                                                                  // 48
        throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                        // 49
      }                                                                                                                // 50
                                                                                                                       //
      return handler.restore(db, saveTemplate, frontendRef[key]);                                                      // 52
    }                                                                                                                  // 53
                                                                                                                       //
    return restore;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function () {                                                                  //
    function query(db, userAccountId, tag) {                                                                           //
      // Performs a powerbox query using the appropriate registered handler.                                           // 56
                                                                                                                       //
      var handler = this._typeIdHandlers[tag.id];                                                                      // 58
      if (handler) {                                                                                                   // 59
        return handler.query(db, userAccountId, tag.value);                                                            // 60
      } else {                                                                                                         // 61
        return []; // no matches                                                                                       // 62
      }                                                                                                                // 63
    }                                                                                                                  // 64
                                                                                                                       //
    return query;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function () {                                                               //
    function validate(db, session, frontendRefRequest) {                                                               //
      // Validates a powerbox request on the given `session` (a record from the Sessions table)                        // 67
      // requesting the creation of the given frontendRef type. `frontendRefRequest` is expected to                    // 68
      // come directly from the client; calling validate() verifies that it is well-formed and                         // 69
      // carries out any type-specific server-side work needed to construct the desired frontendRef.                   // 70
      // `validate()` also returns an array of MembraneRequirements that shall apply to the                            // 71
      // capability. These requirements will not yet have been checked, so the caller should check                     // 72
      // them before proceeding.                                                                                       // 73
                                                                                                                       //
      var keys = Object.keys(frontendRefRequest);                                                                      // 75
      if (keys.length != 1) {                                                                                          // 76
        throw new Error("invalid frontendRefRequest: " + JSON.stringify(frontendRefRequest));                          // 77
      }                                                                                                                // 78
                                                                                                                       //
      var key = keys[0];                                                                                               // 80
      var handler = this._frontendRefHandlers[key];                                                                    // 81
      if (!handler) {                                                                                                  // 82
        throw new Error("invalid frontendRefRequest: " + JSON.stringify(frontendRefRequest));                          // 83
      }                                                                                                                // 84
                                                                                                                       //
      if (!handler.validate) {                                                                                         // 86
        throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(frontendRefRequest));     // 87
      }                                                                                                                // 89
                                                                                                                       //
      var _handler$validate = handler.validate(db, session, frontendRefRequest[key]);                                  // 66
                                                                                                                       //
      var descriptor = _handler$validate.descriptor;                                                                   // 66
      var requirements = _handler$validate.requirements;                                                               // 66
      var frontendRef = _handler$validate.frontendRef;                                                                 // 66
                                                                                                                       //
                                                                                                                       //
      var result = { descriptor: descriptor, requirements: requirements, frontendRef: {} };                            // 94
      result.frontendRef[key] = frontendRef;                                                                           // 95
      return result;                                                                                                   // 96
    }                                                                                                                  // 97
                                                                                                                       //
    return validate;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function () {                                                               //
    function register(object) {                                                                                        //
      // Register callbacks related to a particular frontendRef type. The object has the fields:                       // 100
      //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                      // 101
      //       this type. Only needed if `create` and/or `validate` handlers are defined.                              // 102
      //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                     // 103
      //       64-bit integer. Only needed if `query` is defined.                                                      // 104
      //   `restore`: Callback to construct a capability of this type when restoring a saved                           // 105
      //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                             // 106
      //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                    // 107
      //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                             // 108
      //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                     // 109
      //         with whatever other interfaces are appropriate for the ref type.                                      // 110
      //   `validate`: Callback to validate a powerbox request for a new capability of this type.                      // 111
      //       Has signature `(db, session, request) -> {descriptor, requirements, frontendRef}`,                      // 112
      //       where:                                                                                                  // 113
      //     `request` is type-specific information describing the requested capability. The                           // 114
      //         callback *must* type-check this value, and should throw an exception if it is                         // 115
      //         not valid.                                                                                            // 116
      //     `session` is the record from the Sessions table of the UI session where the powerbox                      // 117
      //         request occurred.                                                                                     // 118
      //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                   // 119
      //         that if the descriptor contains any `tag.value`s, they of course need to be                           // 120
      //         presented as capnp-encoded Buffers.                                                                   // 121
      //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                   // 122
      //         new capability. Note that these requirements will be checked immediately and the                      // 123
      //         powerbox request will fail if they aren't met.                                                        // 124
      //     `frontendRef` (returned) is the value that will be written for the key specified                          // 125
      //         by `frontendRefField` in the single-key object `ApiTokens.frontendRef`.                               // 126
      //    `query`: Callback to populate options for a powerbox request for this type ID. Has                         // 127
      //        signature `(db, userAccountId, tagValue) -> options`, where:                                           // 128
      //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                          // 129
      //      `options` (returned): An array of objects representing the options that should be                        // 130
      //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                      // 131
      //          powerbox-server.js for a full description of the fields of each option.                              // 132
                                                                                                                       //
      if (object.frontendRefField) {                                                                                   // 134
        if (object.frontendRefField in this._frontendRefHandlers) {                                                    // 135
          throw new Error("frontendRef handler already registered: " + object.frontendRefField);                       // 136
        }                                                                                                              // 137
                                                                                                                       //
        this._frontendRefHandlers[object.frontendRefField] = object;                                                   // 139
      }                                                                                                                // 140
                                                                                                                       //
      if (object.typeId) {                                                                                             // 142
        if (object.typeId in this._typeIdHandlers) {                                                                   // 143
          throw new Error("typeId handler already registered: " + object.typeId);                                      // 144
        }                                                                                                              // 145
                                                                                                                       //
        this._typeIdHandlers[object.typeId] = object;                                                                  // 147
      }                                                                                                                // 148
    }                                                                                                                  // 149
                                                                                                                       //
    return register;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 152
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"migrations.js":["meteor/meteor","meteor/underscore","meteor/check","/imports/server/accounts/picture.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/migrations.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({migrateToLatest:function(){return migrateToLatest}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var _;module.import("meteor/underscore",{"_":function(v){_=v}});var Match;module.import("meteor/check",{"Match":function(v){Match=v}});var userPictureUrl,fetchPicture;module.import("/imports/server/accounts/picture.js",{"userPictureUrl":function(v){userPictureUrl=v},"fetchPicture":function(v){fetchPicture=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});// Minimal tooling for doing run-at-least-once, ordered migrations.
//                                                                                                                     // 2
// Because migrations can experience partial failure and likely have                                                   // 3
// side-effects, we should be careful to make sure all migrations are                                                  // 4
// idempotent and safe to accidentally run multiple times.                                                             // 5
                                                                                                                       //
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       // 9
                                                                                                                       // 10
                                                                                                                       // 11
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 13
var Url = Npm.require("url");                                                                                          // 14
var Crypto = Npm.require("crypto");                                                                                    // 15
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect(db, backend) {                                    // 17
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 18
  ["google", "github"].forEach(function (serviceName) {                                                                // 19
    var config = configurations.findOne({ service: serviceName });                                                     // 20
    if (config && config.loginStyle !== "redirect") {                                                                  // 21
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
};                                                                                                                     // 25
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings(db, backend) {      // 27
  // In the before time, Google and Github login were enabled by default.                                              // 28
  //                                                                                                                   // 29
  // This actually didn't make much sense, required the first user to configure                                        // 30
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          // 31
  // secure.                                                                                                           // 32
  //                                                                                                                   // 33
  // Now, we have admin-token, so we wish to disable all logins by default                                             // 34
  // (since they need to be configured anyway) but since users may have never                                          // 35
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          // 36
  // we can't just use the value in the Settings collection, since it might                                            // 37
  // never have been set.                                                                                              // 38
  //                                                                                                                   // 39
  // Thus, if the service is configured but absent from Settings, we should                                            // 40
  // explicitly enable it in Settings, and then the rest of the logic can just                                         // 41
  // depend on what value is in Settings and default to false without breaking                                         // 42
  // user installations.                                                                                               // 43
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 44
  ["google", "github"].forEach(function (serviceName) {                                                                // 45
    var config = configurations.findOne({ service: serviceName });                                                     // 46
    var serviceConfig = db.collections.settings.findOne({ _id: serviceName });                                         // 47
    if (config && !serviceConfig) {                                                                                    // 48
      // Only explicitly enable the login service if:                                                                  // 49
      // 1) the service is already configured                                                                          // 50
      // 2) there is no sandstorm configuration already present (the user was                                          // 51
      //    using the previous default behavior).                                                                      // 52
      db.collections.settings.insert({ _id: serviceName, value: true });                                               // 53
    }                                                                                                                  // 54
  });                                                                                                                  // 55
};                                                                                                                     // 56
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo(db, backend) {                                              // 58
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        // 59
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    // 60
  // which has more information about the key, namely a freeform note entered by the admin when                        // 61
  // they created the key. In the case that the email invite form was used, the note has the form                      // 62
  // "E-mail invite to <address>".                                                                                     // 63
  //                                                                                                                   // 64
  // Later, we decided it was useful to indicate in the users table visible to the admin                               // 65
  // information about the invite terms. Namely, for email invites we want to show the address                         // 66
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          // 67
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        // 68
  // from the SignupKeys table.                                                                                        // 69
                                                                                                                       //
  db.collections.users.find().forEach(function (user) {                                                                // 71
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 72
      var signupInfo = db.collections.signupKeys.findOne(user.signupKey);                                              // 73
      if (signupInfo && signupInfo.note) {                                                                             // 74
        var newFields = { signupNote: signupInfo.note };                                                               // 75
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 77
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 78
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 79
        }                                                                                                              // 80
                                                                                                                       //
        db.collections.users.update(user._id, { $set: newFields });                                                    // 82
      }                                                                                                                // 83
    }                                                                                                                  // 84
  });                                                                                                                  // 85
};                                                                                                                     // 86
                                                                                                                       //
var mergeRoleAssignmentsIntoApiTokens = function mergeRoleAssignmentsIntoApiTokens(db, backend) {                      // 88
  db.collections.roleAssignments.find().forEach(function (roleAssignment) {                                            // 89
    db.collections.apiTokens.insert({                                                                                  // 90
      grainId: roleAssignment.grainId,                                                                                 // 91
      userId: roleAssignment.sharer,                                                                                   // 92
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 93
      petname: roleAssignment.petname,                                                                                 // 94
      created: roleAssignment.created,                                                                                 // 95
      owner: {                                                                                                         // 96
        user: {                                                                                                        // 97
          userId: roleAssignment.recipient,                                                                            // 98
          title: roleAssignment.title                                                                                  // 99
        }                                                                                                              // 97
      }                                                                                                                // 96
    });                                                                                                                // 90
  });                                                                                                                  // 103
};                                                                                                                     // 104
                                                                                                                       //
var fixOasisStorageUsageStats = function fixOasisStorageUsageStats(db, backend) {};                                    // 106
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     // 107
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      // 108
// with a no-op.                                                                                                       // 109
                                                                                                                       //
var fetchProfilePictures = function fetchProfilePictures(db, backend) {                                                // 111
  db.collections.users.find({}).forEach(function (user) {                                                              // 112
    var url = userPictureUrl(user);                                                                                    // 113
    if (url) {                                                                                                         // 114
      console.log("Fetching user picture:", url);                                                                      // 115
      var assetId = fetchPicture(db, url);                                                                             // 116
      if (assetId) {                                                                                                   // 117
        db.collections.users.update(user._id, { $set: { "profile.picture": assetId } });                               // 118
      }                                                                                                                // 119
    }                                                                                                                  // 120
  });                                                                                                                  // 121
};                                                                                                                     // 122
                                                                                                                       //
var assignPlans = function assignPlans(db, backend) {                                                                  // 124
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  // 125
  // It has run, so we only need this stub function here.                                                              // 126
};                                                                                                                     // 127
                                                                                                                       //
var removeKeyrings = function removeKeyrings(db, backend) {                                                            // 129
  // These blobs full of public keys were not intended to find their way into mongo and while                          // 130
  // harmless they slow things down because they're huge. Remove them.                                                 // 131
  db.collections.packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
};                                                                                                                     // 135
                                                                                                                       //
var useLocalizedTextInUserActions = function useLocalizedTextInUserActions(db, backend) {                              // 137
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 138
    if (field in oldObj) {                                                                                             // 139
      if (typeof oldObj[field] === "string") {                                                                         // 140
        newObj[field] = { defaultText: oldObj[field] };                                                                // 141
      } else {                                                                                                         // 142
        newObj[field] = oldObj[field];                                                                                 // 143
      }                                                                                                                // 144
    }                                                                                                                  // 145
  }                                                                                                                    // 146
                                                                                                                       //
  db.collections.userActions.find({}).forEach(function (userAction) {                                                  // 148
    var fields = {};                                                                                                   // 149
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 150
    toLocalizedText(fields, userAction, "title");                                                                      // 151
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 152
    db.collections.userActions.update(userAction._id, { $set: fields });                                               // 153
  });                                                                                                                  // 154
};                                                                                                                     // 155
                                                                                                                       //
var verifyAllPgpSignatures = function verifyAllPgpSignatures(db, backend) {                                            // 157
  db.collections.packages.find({}).forEach(function (pkg) {                                                            // 158
    try {                                                                                                              // 159
      console.log("checking PGP signature for package:", pkg._id);                                                     // 160
      var info = waitPromise(backend.cap().tryGetPackage(pkg._id));                                                    // 161
      if (info.authorPgpKeyFingerprint) {                                                                              // 162
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 163
        db.collections.packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });  // 164
      } else {                                                                                                         // 166
        console.log("  no signature");                                                                                 // 167
      }                                                                                                                // 168
    } catch (err) {                                                                                                    // 169
      console.error(err.stack);                                                                                        // 170
    }                                                                                                                  // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
var splitUserIdsIntoAccountIdsAndIdentityIds = function splitUserIdsIntoAccountIdsAndIdentityIds(db, backend) {        // 175
  db.collections.users.find().forEach(function (user) {                                                                // 176
    var identity = {};                                                                                                 // 177
    var serviceUserId = void 0;                                                                                        // 178
    if ("devName" in user) {                                                                                           // 179
      identity.service = "dev";                                                                                        // 180
      serviceUserId = user.devName;                                                                                    // 181
    } else if ("expires" in user) {                                                                                    // 182
      identity.service = "demo";                                                                                       // 183
      serviceUserId = user._id;                                                                                        // 184
    } else if (user.services && "google" in user.services) {                                                           // 185
      identity.service = "google";                                                                                     // 186
      if (user.services.google.email && user.services.google.verified_email) {                                         // 187
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          // 187
        identity.verifiedEmail = user.services.google.email;                                                           // 188
      }                                                                                                                // 189
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 191
    } else if (user.services && "github" in user.services) {                                                           // 192
      identity.service = "github";                                                                                     // 193
      identity.unverifiedEmail = user.services.github.email;                                                           // 194
      serviceUserId = user.services.github.id;                                                                         // 195
    } else if (user.services && "emailToken" in user.services) {                                                       // 196
      identity.service = "emailToken";                                                                                 // 197
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 198
      serviceUserId = user.services.emailToken.email;                                                                  // 199
    }                                                                                                                  // 200
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 202
                                                                                                                       //
    if (user.profile) {                                                                                                // 205
      if (user.profile.name) {                                                                                         // 206
        identity.name = user.profile.name;                                                                             // 207
      }                                                                                                                // 208
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 210
        identity.handle = user.profile.handle;                                                                         // 211
      }                                                                                                                // 212
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 214
        identity.picture = user.profile.picture;                                                                       // 215
      }                                                                                                                // 216
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 218
        identity.pronoun = user.profile.pronoun;                                                                       // 219
      }                                                                                                                // 220
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 222
        identity.unverifiedEmail = user.profile.email;                                                                 // 223
      }                                                                                                                // 224
    }                                                                                                                  // 225
                                                                                                                       //
    identity.main = true;                                                                                              // 227
                                                                                                                       //
    db.collections.users.update(user._id, { $set: { identities: [identity] } });                                       // 229
                                                                                                                       //
    db.collections.grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });        // 231
    db.collections.sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });      // 232
    db.collections.apiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });     // 233
    db.collections.apiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({                                                                           // 243
      "requirements.permissionsHeld.userId": user._id                                                                  // 244
    }, {                                                                                                               // 243
      $set: { "requirements.$.permissionsHeld.identityId": identity.id },                                              // 246
      $unset: { "requirements.$.permissionsHeld.userId": 1 }                                                           // 247
    }, {                                                                                                               // 245
      multi: true                                                                                                      // 249
    }) > 0) {}                                                                                                         // 248
    // The `$` operator modifies the first element in the array that matches the query. Since                          // 251
    // there may be many matches, we need to repeat until no documents are modified.                                   // 252
  });                                                                                                                  // 254
                                                                                                                       //
  db.collections.apiTokens.remove({ userInfo: { $exists: true } });                                                    // 256
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              // 257
  // that this field could show up in the database was in this deprecated, no-longer-functional                        // 258
  // form of API token.                                                                                                // 259
};                                                                                                                     // 260
                                                                                                                       //
var appUpdateSettings = function appUpdateSettings(db, backend) {                                                      // 262
  db.collections.settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                         // 263
  db.collections.settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                     // 264
  db.collections.settings.insert({ _id: "appUpdatesEnabled", value: true });                                           // 265
};                                                                                                                     // 266
                                                                                                                       //
var moveDevAndEmailLoginDataIntoIdentities = function moveDevAndEmailLoginDataIntoIdentities(db, backend) {            // 268
  db.collections.users.find().forEach(function (user) {                                                                // 269
    if (user.identities.length !== 1) {                                                                                // 270
      throw new Error("User does not have exactly one identity: ", user);                                              // 271
    }                                                                                                                  // 272
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 274
    if (Match.test(identity.service, Object)) {                                                                        // 275
      return;                                                                                                          // 275
    } // Already migrated.                                                                                             // 275
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 277
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 278
                                                                                                                       //
    var serviceObject = {};                                                                                            // 280
    var fieldsToUnset = {};                                                                                            // 281
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 283
      serviceObject.name = user.devName;                                                                               // 284
      fieldsToUnset.devName = 1;                                                                                       // 285
    } else if (identity.service === "emailToken") {                                                                    // 286
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 287
      serviceObject.email = user.services.emailToken.email;                                                            // 288
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 289
    }                                                                                                                  // 290
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 292
    newIdentity.service[identity.service] = serviceObject;                                                             // 293
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 295
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 296
      modifier.$unset = fieldsToUnset;                                                                                 // 297
    }                                                                                                                  // 298
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, modifier);                                                          // 300
  });                                                                                                                  // 301
};                                                                                                                     // 302
                                                                                                                       //
var repairEmailIdentityIds = function repairEmailIdentityIds(db, backend) {                                            // 304
  db.collections.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {             // 305
    if (user.identities.length !== 1) {                                                                                // 306
      throw new Error("User does not have exactly one identity: ", user);                                              // 307
    }                                                                                                                  // 308
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 310
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 311
    newIdentity.service = { email: identity.service.emailToken };                                                      // 313
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 314
                                                                                                                       //
    db.collections.grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    db.collections.apiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (db.collections.apiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    db.collections.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                           // 333
  });                                                                                                                  // 334
};                                                                                                                     // 335
                                                                                                                       //
var splitAccountUsersAndIdentityUsers = function splitAccountUsersAndIdentityUsers(db, backend) {                      // 337
  db.collections.users.find({ identities: { $exists: true } }).forEach(function (user) {                               // 338
    if (user.identities.length !== 1) {                                                                                // 339
      throw new Error("User does not have exactly one identity: ", user);                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 343
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 344
    identityUser._id = identity.id;                                                                                    // 345
    identityUser.profile = identity.profile;                                                                           // 346
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 347
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 348
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        // 350
    // contains subfields that are constrained to be unique by Mongo indices.                                          // 351
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 352
    if (identity.service.dev) {                                                                                        // 353
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 354
    } else if (identity.service.email) {                                                                               // 355
      identityUser.stagedServices.email = identity.service.email;                                                      // 356
    }                                                                                                                  // 357
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 363
    accountUser.nonloginIdentities = [];                                                                               // 364
    if (user.services && user.services.resume) {                                                                       // 365
      accountUser.services = { resume: user.services.resume };                                                         // 366
    }                                                                                                                  // 367
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 369
                                                                                                                       //
    db.collections.apiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });
                                                                                                                       //
    db.collections.users.upsert({ _id: identityUser._id }, identityUser);                                              // 376
    db.collections.users.update({ _id: user._id }, accountUser);                                                       // 377
  });                                                                                                                  // 378
                                                                                                                       //
  db.collections.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                       // 380
    db.collections.users.update({ _id: identity._id }, {                                                               // 381
      $unset: { stagedServices: 1 },                                                                                   // 382
      $set: { services: identity.stagedServices }                                                                      // 383
    });                                                                                                                // 381
  });                                                                                                                  // 385
};                                                                                                                     // 386
                                                                                                                       //
var populateContactsFromApiTokens = function populateContactsFromApiTokens(db, backend) {                              // 388
  db.collections.apiTokens.find({                                                                                      // 389
    "owner.user.identityId": { $exists: 1 },                                                                           // 390
    accountId: { $exists: 1 }                                                                                          // 391
  }).forEach(function (token) {                                                                                        // 389
    var identityId = token.owner.user.identityId;                                                                      // 393
    var identity = db.getIdentity(identityId);                                                                         // 394
    if (identity) {                                                                                                    // 395
      var profile = identity.profile;                                                                                  // 396
      db.collections.contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                           // 397
        ownerId: token.accountId,                                                                                      // 398
        petname: profile && profile.name,                                                                              // 399
        created: new Date(),                                                                                           // 400
        identityId: identityId,                                                                                        // 401
        profile: profile                                                                                               // 402
      });                                                                                                              // 397
    }                                                                                                                  // 404
  });                                                                                                                  // 405
};                                                                                                                     // 406
                                                                                                                       //
var cleanUpApiTokens = function cleanUpApiTokens(db, backend) {                                                        // 408
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       // 409
  // where the user still existed in the database.                                                                     // 410
  db.collections.apiTokens.remove({                                                                                    // 411
    userId: { $exists: true },                                                                                         // 412
    identityId: { $exists: false }                                                                                     // 413
  });                                                                                                                  // 411
  db.collections.apiTokens.remove({                                                                                    // 415
    "owner.user.userId": { $exists: true },                                                                            // 416
    "owner.user.identityId": { $exists: false }                                                                        // 417
  });                                                                                                                  // 415
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             // 420
  db.collections.apiTokens.find({                                                                                      // 421
    "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true }                                                  // 422
  }).forEach(function (apiToken) {                                                                                     // 421
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 424
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 425
      $set: { "owner.user.denormalizedGrainMetadata.icon": icon },                                                     // 426
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true }                                                 // 427
    });                                                                                                                // 425
  });                                                                                                                  // 429
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    // 431
  function repairChain(parentToken) {                                                                                  // 432
    db.collections.apiTokens.find({                                                                                    // 433
      parentToken: parentToken._id,                                                                                    // 434
      grainId: { $exists: true },                                                                                      // 435
      identityId: { $exists: false }                                                                                   // 436
    }).forEach(function (childToken) {                                                                                 // 433
      db.collections.apiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });      // 438
      repairChain(childToken);                                                                                         // 439
    });                                                                                                                // 440
  }                                                                                                                    // 441
                                                                                                                       //
  db.collections.apiTokens.find({                                                                                      // 443
    grainId: { $exists: true },                                                                                        // 444
    identityId: { $exists: true },                                                                                     // 445
    parentToken: { $exists: false }                                                                                    // 446
  }).forEach(repairChain);                                                                                             // 443
};                                                                                                                     // 448
                                                                                                                       //
var initServerTitleAndReturnAddress = function initServerTitleAndReturnAddress(db, backend) {                          // 450
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 451
  db.collections.settings.insert({ _id: "serverTitle", value: hostname });                                             // 452
  db.collections.settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                             // 453
};                                                                                                                     // 454
                                                                                                                       //
var sendReferralNotifications = function sendReferralNotifications(db, backend) {                                      // 456
  if (db.isReferralEnabled()) {                                                                                        // 457
    db.collections.users.find({                                                                                        // 458
      loginIdentities: { $exists: true },                                                                              // 459
      expires: { $exists: false }                                                                                      // 460
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 458
      db.sendReferralProgramNotification(user._id);                                                                    // 462
    });                                                                                                                // 463
  }                                                                                                                    // 464
};                                                                                                                     // 465
                                                                                                                       //
var assignBonuses = function assignBonuses(db, backend) {                                                              // 467
  // This was a one-time migration intended to be applied on Oasis to existing users.                                  // 468
  // It has run, so we only need this stub function here.                                                              // 469
};                                                                                                                     // 470
                                                                                                                       //
var splitSmtpUrl = function splitSmtpUrl(db, backend) {                                                                // 472
  var smtpUrlSetting = db.collections.settings.findOne({ _id: "smtpUrl" });                                            // 473
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 474
  var returnAddress = db.collections.settings.findOne({ _id: "returnAddress" });                                       // 475
                                                                                                                       //
  // Default values.                                                                                                   // 477
  var smtpConfig = {                                                                                                   // 478
    hostname: "localhost",                                                                                             // 479
    port: "25",                                                                                                        // 480
    auth: undefined,                                                                                                   // 481
    returnAddress: returnAddress.value                                                                                 // 482
  };                                                                                                                   // 478
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 485
  try {                                                                                                                // 486
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 487
  } catch (e) {}                                                                                                       // 488
                                                                                                                       //
  if (parsed) {                                                                                                        // 490
    // If there was a SMTP URL previously defined, import its data.                                                    // 491
    var auth = undefined;                                                                                              // 492
    if (parsed.auth) {                                                                                                 // 493
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 494
      var user = undefined;                                                                                            // 495
      var pass = undefined;                                                                                            // 496
      if (colonIndex !== -1) {                                                                                         // 497
        user = parsed.auth.slice(0, colonIndex);                                                                       // 498
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 499
      }                                                                                                                // 500
                                                                                                                       //
      auth = {                                                                                                         // 502
        user: user,                                                                                                    // 503
        pass: pass                                                                                                     // 504
      };                                                                                                               // 502
    }                                                                                                                  // 506
                                                                                                                       //
    // Override defaults with previous config's values.                                                                // 508
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 509
    smtpConfig.port = parsed.port || "25";                                                                             // 510
    smtpConfig.auth = auth;                                                                                            // 511
  }                                                                                                                    // 512
                                                                                                                       //
  db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                        // 514
  db.collections.settings.remove({ _id: "returnAddress" });                                                            // 515
  db.collections.settings.remove({ _id: "smtpUrl" });                                                                  // 516
};                                                                                                                     // 517
                                                                                                                       //
var smtpPortShouldBeNumber = function smtpPortShouldBeNumber(db, backend) {                                            // 519
  var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                  // 520
  if (entry) {                                                                                                         // 521
    var setting = entry.value;                                                                                         // 522
    if (setting.port) {                                                                                                // 523
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 524
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: setting });                                       // 525
    }                                                                                                                  // 526
  }                                                                                                                    // 527
};                                                                                                                     // 528
                                                                                                                       //
var consolidateOrgSettings = function consolidateOrgSettings(db, backend) {                                            // 530
  var settings = db.collections.settings;                                                                              // 531
  var orgGoogleDomain = settings.findOne({ _id: "organizationGoogle" });                                               // 532
  var orgEmailDomain = settings.findOne({ _id: "organizationEmail" });                                                 // 533
  var orgLdap = settings.findOne({ _id: "organizationLdap" });                                                         // 534
  var orgSaml = settings.findOne({ _id: "organizationSaml" });                                                         // 535
                                                                                                                       //
  var orgMembership = {                                                                                                // 537
    google: {                                                                                                          // 538
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 539
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 540
    },                                                                                                                 // 538
    email: {                                                                                                           // 542
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 543
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 544
    },                                                                                                                 // 542
    ldap: {                                                                                                            // 546
      enabled: orgLdap ? orgLdap.value : false                                                                         // 547
    },                                                                                                                 // 546
    saml: {                                                                                                            // 549
      enabled: orgSaml ? orgSaml.value : false                                                                         // 550
    }                                                                                                                  // 549
  };                                                                                                                   // 537
                                                                                                                       //
  settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 554
  settings.remove({ _id: "organizationGoogle" });                                                                      // 555
  settings.remove({ _id: "organizationEmail" });                                                                       // 556
  settings.remove({ _id: "organizationLdap" });                                                                        // 557
  settings.remove({ _id: "organizationSaml" });                                                                        // 558
};                                                                                                                     // 559
                                                                                                                       //
var unsetSmtpDefaultHostnameIfNoUsersExist = function unsetSmtpDefaultHostnameIfNoUsersExist(db, backend) {            // 561
  // We don't actually want to have the default hostname "localhost" set.                                              // 562
  // If the user has already finished configuring their server, then this migration should do                          // 563
  // nothing (since we might break their deployment), but for new installs (which will have no users                   // 564
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     // 565
  // default value.                                                                                                    // 566
  var hasUsers = db.collections.users.findOne();                                                                       // 567
  if (!hasUsers) {                                                                                                     // 568
    var entry = db.collections.settings.findOne({ _id: "smtpConfig" });                                                // 569
    var smtpConfig = entry.value;                                                                                      // 570
    if (smtpConfig.hostname === "localhost") {                                                                         // 571
      smtpConfig.hostname = "";                                                                                        // 572
      db.collections.settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                    // 573
    }                                                                                                                  // 574
  }                                                                                                                    // 575
};                                                                                                                     // 576
                                                                                                                       //
var extractLastUsedFromApiTokenOwner = function extractLastUsedFromApiTokenOwner(db, backend) {                        // 578
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     // 579
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     // 580
  // itself.                                                                                                           // 581
  db.collections.apiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                        // 582
    var lastUsed = token.owner.user.lastUsed;                                                                          // 583
    db.collections.apiTokens.update({ _id: token._id }, {                                                              // 584
      $set: { lastUsed: lastUsed },                                                                                    // 585
      $unset: { "owner.user.lastUsed": true }                                                                          // 586
    });                                                                                                                // 584
  });                                                                                                                  // 588
};                                                                                                                     // 589
                                                                                                                       //
var setUpstreamTitles = function setUpstreamTitles(db, backend) {                                                      // 591
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    // 592
                                                                                                                       //
  var apiTokensRaw = db.collections.apiTokens.rawCollection();                                                         // 594
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 595
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            // 597
  // for each of these, so we'd like to skip those which have nothing to update.                                       // 598
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 602
  });                                                                                                                  // 602
                                                                                                                       //
  var count = 0;                                                                                                       // 604
  db.collections.grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {          // 605
    if (count % 100 == 0) {                                                                                            // 606
      console.log(count + " / " + grainIds.length);                                                                    // 607
    }                                                                                                                  // 608
                                                                                                                       //
    ++count;                                                                                                           // 610
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              // 612
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         // 613
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      // 614
    // copy post-sharaing. We assume it was the owner, because:                                                        // 615
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    // 616
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        // 617
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         // 618
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       // 619
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 // 620
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      // 621
    //    owner who renamed post-sharing.                                                                              // 622
    db.collections.apiTokens.update({                                                                                  // 623
      grainId: grain._id,                                                                                              // 624
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 625
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 623
  });                                                                                                                  // 627
};                                                                                                                     // 628
                                                                                                                       //
var markAllRead = function markAllRead(db, backend) {                                                                  // 630
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             // 631
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           // 632
                                                                                                                       //
  db.collections.grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                         // 634
  db.collections.apiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
};                                                                                                                     // 638
                                                                                                                       //
var clearAppIndex = function clearAppIndex(db, backend) {                                                              // 640
  // Due to a bug in the app update code, some app update notifications that the user accepted                         // 641
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      // 642
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     // 643
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      // 644
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            // 645
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      // 646
  // click "dismiss" again easily enough.                                                                              // 647
                                                                                                                       //
  db.collections.appIndex.remove({});                                                                                  // 649
};                                                                                                                     // 650
                                                                                                                       //
var assignEmailVerifierIds = function assignEmailVerifierIds(db, backend) {                                            // 652
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       // 653
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    // 654
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      // 655
  // to the fact that powerbox selections always involve a restore(), but a different problem                          // 656
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       // 657
  // and restore()ing that capability, the ID would be different, because the new capability would                     // 658
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      // 659
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          // 660
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          // 661
                                                                                                                       //
  db.collections.apiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {         // 663
    db.collections.apiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });               // 664
  });                                                                                                                  // 665
};                                                                                                                     // 666
                                                                                                                       //
var startPreinstallingApps = function startPreinstallingApps(db, backend) {                                            // 668
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        // 669
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 // 670
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 672
    db.updateAppIndex();                                                                                               // 673
                                                                                                                       //
    var preinstalledApps = db.collections.appIndex.find({ _id: {                                                       // 675
        $in: db.getProductivitySuiteAppIds().concat(db.getSystemSuiteAppIds()) }                                       // 676
    }).fetch();                                                                                                        // 675
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 679
      return {                                                                                                         // 680
        appId: app.appId,                                                                                              // 681
        packageId: app.packageId                                                                                       // 682
      };                                                                                                               // 680
    });                                                                                                                // 684
                                                                                                                       //
    db.setPreinstalledApps(appAndPackageIds);                                                                          // 686
  };                                                                                                                   // 687
                                                                                                                       //
  if (!Meteor.settings["public"].isTesting && !db.allowDevAccounts()) {                                                // 689
    // We want preinstalling apps to run async and not block startup.                                                  // 690
    Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                // 691
  }                                                                                                                    // 692
};                                                                                                                     // 693
                                                                                                                       //
var setNewServer = function setNewServer(db, backend) {                                                                // 695
  // This migration only applies to "old" servers. New servers will set                                                // 696
  // new_server_migrations_applied to false before any migrations run.                                                 // 697
  if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" })) {                                  // 698
    db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: true });                           // 699
  }                                                                                                                    // 700
};                                                                                                                     // 701
                                                                                                                       //
var addMembraneRequirementsToIdentities = function addMembraneRequirementsToIdentities(db, backend) {                  // 703
  var query = {                                                                                                        // 704
    "frontendRef.identity": { $exists: true },                                                                         // 705
    "owner.grain.grainId": { $exists: true },                                                                          // 706
    "requirements.0": { $exists: false }                                                                               // 707
  };                                                                                                                   // 704
                                                                                                                       //
  db.collections.apiTokens.find(query).map(function (apiToken) {                                                       // 710
    db.collections.apiTokens.update({ _id: apiToken._id }, {                                                           // 711
      $push: {                                                                                                         // 714
        requirements: {                                                                                                // 715
          permissionsHeld: {                                                                                           // 716
            grainId: apiToken.owner.grain.grainId,                                                                     // 717
            identityId: apiToken.frontendRef.identity,                                                                 // 718
            permissions: []                                                                                            // 719
          }                                                                                                            // 716
        }                                                                                                              // 715
      }                                                                                                                // 714
    });                                                                                                                // 713
  });                                                                                                                  // 725
};                                                                                                                     // 726
                                                                                                                       //
var addEncryptionToFrontendRefIpNetwork = function addEncryptionToFrontendRefIpNetwork(db, backend) {                  // 728
  db.collections.apiTokens.find({ "frontendRef.ipNetwork": true }).map(function (apiToken) {                           // 729
    db.collections.apiTokens.update({ _id: apiToken._id }, { $set: { "frontendRef.ipNetwork": { encryption: { none: null } } } });
  });                                                                                                                  // 733
};                                                                                                                     // 734
                                                                                                                       //
function backgroundFillInGrainSizes(db, backend) {                                                                     // 736
  // Fill in sizes for all grains that don't have them. Since computing a grain size requires a                        // 737
  // directory walk, we don't want to do them all at once. Instead, we compute one a second until                      // 738
  // all grains have sizes.                                                                                            // 739
                                                                                                                       //
  try {                                                                                                                // 741
    var grain = db.collections.grains.findOne({ size: { $exists: false } }, { fields: { _id: 1, userId: 1 } });        // 742
                                                                                                                       //
    if (grain) {                                                                                                       // 744
      // Compute size!                                                                                                 // 745
      try {                                                                                                            // 746
        var result = waitPromise(backend.cap().getGrainStorageUsage(grain.userId, grain._id));                         // 747
        db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: parseInt(result.size) } });
      } catch (err) {                                                                                                  // 751
        if (err.kjType === "failed") {                                                                                 // 752
          // Backend had a problem. Maybe the grain doesn't actually exist on disk and the database                    // 753
          // is messed up. We'll set the size to zero and move on.                                                     // 754
          console.error("Error while backfilling grain size for", grain._id, ":", err.stack);                          // 755
          db.collections.grains.update({ _id: grain._id, size: { $exists: false } }, { $set: { size: 0 } });           // 756
        } else {                                                                                                       // 757
          // Rethrow on disconnected / overloaded / unimplemented.                                                     // 758
          throw err;                                                                                                   // 759
        }                                                                                                              // 760
      }                                                                                                                // 761
                                                                                                                       //
      // Do another one in a second.                                                                                   // 763
      Meteor.setTimeout(backgroundFillInGrainSizes.bind(this, db, backend), 1000);                                     // 764
    }                                                                                                                  // 765
  } catch (err) {                                                                                                      // 766
    // We'll just stop for now, to avoid spamming logs if this error persists. Next time the server                    // 767
    // restarts, the migration will continue.                                                                          // 768
    console.error("Error while backfilling grain sizes:", err.stack);                                                  // 769
  }                                                                                                                    // 770
}                                                                                                                      // 771
                                                                                                                       //
function removeFeatureKeys(db, backend) {                                                                              // 773
  // Remove obsolete data related to the Sandstorm for Work paywall, which was eliminated.                             // 774
                                                                                                                       //
  db.notifications.remove({ "admin.type": "cantRenewFeatureKey" });                                                    // 776
  db.notifications.remove({ "admin.type": "trialFeatureKeyExpired" });                                                 // 777
}                                                                                                                      // 778
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    // 780
// Only append to this list!  Do not modify or remove list entries;                                                    // 781
// doing so is likely change the meaning and semantics of user databases.                                              // 782
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer, addMembraneRequirementsToIdentities, addEncryptionToFrontendRefIpNetwork];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 818
                                                                                                                       //
var migrateToLatest = function migrateToLatest(db, backend) {                                                          // 822
  if (Meteor.settings.replicaNumber) {                                                                                 // 823
    (function () {                                                                                                     // 823
      // This is a replica. Wait for the first replica to perform migrations.                                          // 824
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 826
                                                                                                                       //
      var done = new Future();                                                                                         // 828
      var change = function change(doc) {                                                                              // 829
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 830
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 831
      };                                                                                                               // 832
                                                                                                                       //
      var observer = db.collections.migrations.find({ _id: "migrations_applied" }).observe({                           // 834
        added: change,                                                                                                 // 835
        changed: change                                                                                                // 836
      });                                                                                                              // 834
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 839
      var newServerChange = function newServerChange(doc) {                                                            // 840
        if (doc.value) {                                                                                               // 841
          console.log("New server migrations applied elsewhere");                                                      // 842
          newServerDone["return"]();                                                                                   // 843
        }                                                                                                              // 844
      };                                                                                                               // 845
                                                                                                                       //
      var newServerObserver = db.collections.migrations.find({ _id: "new_server_migrations_applied" }).observe({       // 847
        added: newServerChange,                                                                                        // 848
        changed: newServerChange                                                                                       // 849
      });                                                                                                              // 847
                                                                                                                       //
      done.wait();                                                                                                     // 852
      observer.stop();                                                                                                 // 853
      newServerDone.wait();                                                                                            // 854
      newServerObserver.stop();                                                                                        // 855
      console.log("Migrations have completed on replica zero.");                                                       // 856
    })();                                                                                                              // 823
  } else {                                                                                                             // 857
    var applied = db.collections.migrations.findOne({ _id: "migrations_applied" });                                    // 858
    var start = void 0;                                                                                                // 859
    if (!applied) {                                                                                                    // 860
      // Migrations table is not yet seeded with a value.  This means it has                                           // 861
      // applied 0 migrations.  Persist this.                                                                          // 862
      db.collections.migrations.insert({ _id: "migrations_applied", value: 0 });                                       // 863
      start = 0;                                                                                                       // 864
                                                                                                                       //
      // This also means this is a brand new server                                                                    // 866
      db.collections.migrations.insert({ _id: "new_server_migrations_applied", value: false });                        // 867
    } else {                                                                                                           // 868
      start = applied.value;                                                                                           // 869
    }                                                                                                                  // 870
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 872
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 874
      // Apply migration i, then record that migration i was successfully run.                                         // 875
      console.log("Applying migration " + (i + 1));                                                                    // 876
      MIGRATIONS[i](db, backend);                                                                                      // 877
      db.collections.migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                     // 878
      console.log("Applied migration " + (i + 1));                                                                     // 879
    }                                                                                                                  // 880
                                                                                                                       //
    if (!db.collections.migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                          // 882
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           // 883
      // ensures it.                                                                                                   // 884
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 885
        console.log("Running new server startup function " + (_i + 1));                                                // 886
        NEW_SERVER_STARTUP[_i](db, backend);                                                                           // 887
        console.log("Running new server startup function " + (_i + 1));                                                // 888
      }                                                                                                                // 889
                                                                                                                       //
      db.collections.migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });           // 891
    }                                                                                                                  // 892
                                                                                                                       //
    // Start background migrations.                                                                                    // 894
    backgroundFillInGrainSizes(db, backend);                                                                           // 895
  }                                                                                                                    // 896
};                                                                                                                     // 897
                                                                                                                       //
                                                                                                                       // 899
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"observe-helpers.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/observe-helpers.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({fillUndefinedForChangedDoc:function(){return fillUndefinedForChangedDoc}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
function fillUndefinedForChangedDoc(newDoc, oldDoc) {                                                                  // 17
  // In publishes, setting a field to `undefined` specifies that it is no longer present.                              // 18
  // Annoyingly, in the changed callback of observing a collection, it does not do this for you.                       // 19
  Object.keys(oldDoc).forEach(function (key) {                                                                         // 20
    if (!(key in newDoc)) {                                                                                            // 21
      newDoc[key] = undefined;                                                                                         // 22
    }                                                                                                                  // 23
  });                                                                                                                  // 24
}                                                                                                                      // 25
                                                                                                                       //
                                                                                                                       // 27
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"persistent.js":["babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 19
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 21
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 22
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 23
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 26
    _classCallCheck(this, PersistentImpl);                                                                             // 26
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 27
    this[privateTemplate] = saveTemplate;                                                                              // 28
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      // 30
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           // 31
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     // 32
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             // 33
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function () {                                                                     //
    function isSaved() {                                                                                               //
      // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                  // 38
      // table representing this capability.                                                                           // 39
                                                                                                                       //
      return this[privateIsSaved];                                                                                     // 41
    }                                                                                                                  // 42
                                                                                                                       //
    return isSaved;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  PersistentImpl.prototype.save = function () {                                                                        //
    function save(params) {                                                                                            //
      var _this = this;                                                                                                // 44
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 45
        if (!params.sealFor) {                                                                                         // 46
          throw new Error("must specify 'sealFor'");                                                                   // 47
        }                                                                                                              // 48
                                                                                                                       //
        var db = _this[privateDb];                                                                                     // 50
                                                                                                                       //
        var newToken = _.clone(_this[privateTemplate]);                                                                // 52
        newToken.owner = params.sealFor;                                                                               // 53
        if (newToken.owner.user) {                                                                                     // 54
          if (!newToken.identityId) {                                                                                  // 55
            throw new Error("can't save non-UiView with user as owner");                                               // 56
          }                                                                                                            // 57
                                                                                                                       //
          // Only "identityId" and "title" are allowed to be passed to save().                                         // 59
          var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                          // 60
                                                                                                                       //
          // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                            // 62
          userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                         // 63
                                                                                                                       //
          var grain = db.getGrain(newToken.grainId);                                                                   // 65
          if (grain && grain.title !== userOwner.title) {                                                              // 66
            userOwner.upstreamTitle = grain.title;                                                                     // 67
          }                                                                                                            // 68
                                                                                                                       //
          newToken.owner.user = userOwner;                                                                             // 70
        }                                                                                                              // 71
                                                                                                                       //
        var sturdyRef = generateSturdyRef();                                                                           // 73
        newToken._id = hashSturdyRef(sturdyRef);                                                                       // 74
                                                                                                                       //
        newToken.created = new Date();                                                                                 // 76
                                                                                                                       //
        db.collections.apiTokens.insert(newToken);                                                                     // 78
        _this[privateIsSaved] = true;                                                                                  // 79
        return { sturdyRef: new Buffer(sturdyRef) };                                                                   // 80
      });                                                                                                              // 81
    }                                                                                                                  // 82
                                                                                                                       //
    return save;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      // 84
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 87
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 88
};                                                                                                                     // 89
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 91
  return Random.secret();                                                                                              // 92
}                                                                                                                      // 93
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 95
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      // 96
  // false otherwise.                                                                                                  // 97
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        // 99
  //   Reuse?                                                                                                          // 100
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    // 102
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    // 103
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                // 104
                                                                                                                       //
  if (!requirements) {                                                                                                 // 106
    return true;                                                                                                       // 107
  }                                                                                                                    // 108
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 110
    if (requirement.tokenValid) {                                                                                      // 111
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 115
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 119
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 121
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 123
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 124
      }                                                                                                                // 125
    } else if (requirement.permissionsHeld) {                                                                          // 126
      var p = requirement.permissionsHeld;                                                                             // 127
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 128
      var vertex = void 0;                                                                                             // 130
      if (p.identityId) {                                                                                              // 131
        vertex = { grain: { _id: p.grainId, identityId: p.identityId } };                                              // 132
      } else {                                                                                                         // 133
        vertex = { token: { _id: p.tokenId, grainId: p.grainId } };                                                    // 134
      }                                                                                                                // 135
                                                                                                                       //
      var currentPermissions = SandstormPermissions.grainPermissions(db, vertex, viewInfo || {}).permissions;          // 137
      if (!currentPermissions) {                                                                                       // 139
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 143
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 145
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 146
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 147
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 151
      }                                                                                                                // 152
    } else if (requirement.userIsAdmin) {                                                                              // 153
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 154
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 158
    } else {                                                                                                           // 159
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 160
    }                                                                                                                  // 161
  });                                                                                                                  // 162
};                                                                                                                     // 163
                                                                                                                       //
                                                                                                                       // 165
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"static-asset.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/static-asset.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({StaticAssetImpl:function(){return StaticAssetImpl},IdenticonStaticAssetImpl:function(){return IdenticonStaticAssetImpl}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014-2016 Sandstorm Development Group, Inc. and contributors                                          // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Url = Npm.require("url");                                                                                          // 18
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 19
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 21
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 24
    _classCallCheck(this, StaticAssetImpl);                                                                            // 24
                                                                                                                       //
    check(assetId, String);                                                                                            // 25
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 26
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 27
  }                                                                                                                    // 28
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function () {                                                                     //
    function getUrl() {                                                                                                //
      return { protocol: this._protocol, hostPath: this._hostPath };                                                   // 31
    }                                                                                                                  // 32
                                                                                                                       //
    return getUrl;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 33
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 36
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 36
                                                                                                                       //
    check(hash, String);                                                                                               // 37
    check(size, Match.Integer);                                                                                        // 38
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 39
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 40
  }                                                                                                                    // 41
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function () {                                                            //
    function getUrl() {                                                                                                //
      return { protocol: this._protocol, hostPath: this._hostPath };                                                   // 44
    }                                                                                                                  // 45
                                                                                                                       //
    return getUrl;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 46
                                                                                                                       //
                                                                                                                       // 48
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"constants.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/constants.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({ACCOUNT_DELETION_SUSPENSION_TIME:function(){return ACCOUNT_DELETION_SUSPENSION_TIME}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
module.runModuleSetters(ACCOUNT_DELETION_SUSPENSION_TIME = 7 * 60 * 60 * 24 * 1000); // 7 days in ms                   // 17
                                                                                                                       //
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"db-deprecated.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            // 17
// directly.                                                                                                           // 18
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        // 20
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       // 21
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     // 22
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        // 23
//   passed in, thus allowing mocking the database for unit tests.                                                     // 24
                                                                                                                       //
var quotaManager = void 0;                                                                                             // 26
if (Meteor.isServer) {var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});         // 27
                                                                                                                       // 28
  // Imports are usually not allowed to occur in a block. However, it is the only way to do                            // 29
  // this under Meteor. Using // jscs:disable doesn't work for what it considers syntax violations,                    // 30
  // and so we've added this file to .jscsrc's excludedFiles explicitly.                                               // 31
                                                                                                                       //
  quotaManager = new LDAP();                                                                                           // 33
} else {                                                                                                               // 34
  quotaManager = {                                                                                                     // 35
    updateUserQuota: function () {                                                                                     // 36
      function updateUserQuota(db, user) {                                                                             // 35
        return {                                                                                                       // 37
          storage: user.cachedStorageQuota || 0,                                                                       // 38
          grains: Infinity,                                                                                            // 39
          compute: Infinity                                                                                            // 40
        };                                                                                                             // 37
      }                                                                                                                // 42
                                                                                                                       //
      return updateUserQuota;                                                                                          // 35
    }()                                                                                                                // 35
  };                                                                                                                   // 35
}                                                                                                                      // 44
                                                                                                                       //
globalDb = new SandstormDb(quotaManager);                                                                              // 46
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 48
DevPackages = globalDb.collections.devPackages;                                                                        // 49
UserActions = globalDb.collections.userActions;                                                                        // 50
Grains = globalDb.collections.grains;                                                                                  // 51
Contacts = globalDb.collections.contacts;                                                                              // 52
Sessions = globalDb.collections.sessions;                                                                              // 53
SignupKeys = globalDb.collections.signupKeys;                                                                          // 54
ActivityStats = globalDb.collections.activityStats;                                                                    // 55
DeleteStats = globalDb.collections.deleteStats;                                                                        // 56
FileTokens = globalDb.collections.fileTokens;                                                                          // 57
ApiTokens = globalDb.collections.apiTokens;                                                                            // 58
Notifications = globalDb.collections.notifications;                                                                    // 59
StatsTokens = globalDb.collections.statsTokens;                                                                        // 60
Misc = globalDb.collections.misc;                                                                                      // 61
Settings = globalDb.collections.settings;                                                                              // 62
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 64
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 65
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 66
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 67
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 68
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 69
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 70
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 71
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 72
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 73
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 74
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 75
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 76
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"server":{"accounts":{"email-token":{"token-server.js":["crypto","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/email-token/token-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var crypto;module.import("crypto",{"default":function(v){crypto=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
                                                                                                                       //
                                                                                                                       // 3
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 5
                                                                                                                       //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                      // 7
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                              // 8
var V1_HASHFUNC = "sha512";                                                                                            // 9
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token                    // 10
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                                 // 11
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                      // 12
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly                     // 13
// sufficient to reconstruct the output of pbkdf2().                                                                   // 14
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                          // 15
                                                                                                                       //
var TOKEN_EXPIRATION_MS = 60 * 60 * 1000;                                                                              // 17
                                                                                                                       //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                           // 19
  Meteor.users.update({                                                                                                // 20
    "services.email.tokens.createdAt": {                                                                               // 21
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                                  // 22
    }                                                                                                                  // 21
  }, {                                                                                                                 // 20
    $pull: {                                                                                                           // 25
      "services.email.tokens": {                                                                                       // 26
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                                 // 27
      }                                                                                                                // 26
    }                                                                                                                  // 25
  }, {                                                                                                                 // 24
    multi: true                                                                                                        // 31
  });                                                                                                                  // 30
};                                                                                                                     // 33
                                                                                                                       //
Meteor.startup(cleanupExpiredTokens);                                                                                  // 35
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                              // 36
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                                // 37
                                                                                                                       //
var hashToken = function hashToken(token) {                                                                            // 39
  return {                                                                                                             // 40
    digest: SHA256(token),                                                                                             // 41
    algorithm: "sha-256"                                                                                               // 42
  };                                                                                                                   // 40
};                                                                                                                     // 44
                                                                                                                       //
var checkToken = function checkToken(tokens, token) {                                                                  // 46
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.                   // 47
  // Returns the matching object, if one is found, or undefined if none match.                                         // 48
  var foundToken = undefined;                                                                                          // 49
  tokens.forEach(function (userToken) {                                                                                // 50
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                                // 51
      foundToken = userToken;                                                                                          // 53
    }                                                                                                                  // 54
  });                                                                                                                  // 55
                                                                                                                       //
  return foundToken;                                                                                                   // 57
};                                                                                                                     // 58
                                                                                                                       //
var consumeToken = function consumeToken(user, token) {                                                                // 60
  var hashedToken = hashToken(token);                                                                                  // 61
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                                // 62
                                                                                                                       //
  if (foundToken !== undefined) {                                                                                      // 64
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                       // 65
  }                                                                                                                    // 66
                                                                                                                       //
  return foundToken;                                                                                                   // 68
};                                                                                                                     // 69
                                                                                                                       //
var makeBox = function makeBox(token, plaintext) {                                                                     // 71
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                            // 72
  // ciphertext and associated data needed to decrypt later.                                                           // 73
                                                                                                                       //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                          // 75
  // be used as a key directly, so we need to use a KDF with a strong random salt.                                     // 76
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole                   // 77
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                      // 78
  // This would require lengthening the token, which would make the manual-code-entry workflow                         // 79
  // worse, so I'm punting on that for now.                                                                            // 80
  var salt = Random.secret(16);                                                                                        // 81
  var key = crypto.pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                                        // 82
  var iv = crypto.randomBytes(16);                                                                                     // 83
  var cipher = crypto.createCipheriv(V1_CIPHER, key, iv);                                                              // 84
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                                     // 85
  return {                                                                                                             // 86
    version: 1,                                                                                                        // 87
    salt: salt,                                                                                                        // 88
    iv: iv.toString("base64"),                                                                                         // 89
    boxedValue: ciphertext.toString("base64")                                                                          // 90
  };                                                                                                                   // 86
};                                                                                                                     // 92
                                                                                                                       //
var tryUnbox = function tryUnbox(box, secret) {                                                                        // 94
  if (box) {                                                                                                           // 95
    if (box.version === 1) {                                                                                           // 96
      var key = crypto.pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                               // 97
      var iv = new Buffer(box.iv, "base64");                                                                           // 98
      var cipher = crypto.createDecipheriv(V1_CIPHER, key, iv);                                                        // 99
      var cipherText = new Buffer(box.boxedValue, "base64");                                                           // 100
      var plaintext = cipher.update(cipherText);                                                                       // 101
      return plaintext.toString("binary");                                                                             // 102
    }                                                                                                                  // 103
  }                                                                                                                    // 104
                                                                                                                       //
  // If no box was provided, or it was of an unknown version, return no data.                                          // 106
  return;                                                                                                              // 107
};                                                                                                                     // 108
                                                                                                                       //
// Handler to login with a token.                                                                                      // 110
Accounts.registerLoginHandler("email", function (options) {                                                            // 111
  if (!options.email) {                                                                                                // 112
    return undefined; // don't handle                                                                                  // 113
  }                                                                                                                    // 114
                                                                                                                       //
  if (!Accounts.identityServices.email.isEnabled()) {                                                                  // 116
    throw new Meteor.Error(403, "Email identity service is disabled.");                                                // 117
  }                                                                                                                    // 118
                                                                                                                       //
  options = options.email;                                                                                             // 120
  check(options, {                                                                                                     // 121
    email: String,                                                                                                     // 122
    token: String                                                                                                      // 123
  });                                                                                                                  // 121
                                                                                                                       //
  var user = Meteor.users.findOne({                                                                                    // 126
    "services.email.email": options.email                                                                              // 127
  }, {                                                                                                                 // 126
    fields: {                                                                                                          // 129
      "services.email": 1                                                                                              // 130
    }                                                                                                                  // 129
  });                                                                                                                  // 128
                                                                                                                       //
  if (!user) {                                                                                                         // 134
    console.error("User not found:", options.email);                                                                   // 135
    return {                                                                                                           // 136
      error: new Meteor.Error(403, "User not found")                                                                   // 137
    };                                                                                                                 // 136
  }                                                                                                                    // 139
                                                                                                                       //
  if (!user.services.email.tokens) {                                                                                   // 141
    console.error("User has no token set:", options.email);                                                            // 142
    return {                                                                                                           // 143
      error: new Meteor.Error(403, "User has no token set")                                                            // 144
    };                                                                                                                 // 143
  }                                                                                                                    // 146
                                                                                                                       //
  var tokenString = options.token.trim();                                                                              // 148
  var maybeToken = consumeToken(user, tokenString);                                                                    // 149
  if (!maybeToken) {                                                                                                   // 150
    console.error("Token not found:", options.email);                                                                  // 151
    return {                                                                                                           // 152
      error: new Meteor.Error(403, "Invalid authentication code")                                                      // 153
    };                                                                                                                 // 152
  }                                                                                                                    // 155
                                                                                                                       //
  // Attempt to decrypt the resumePath, if provided.                                                                   // 157
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                        // 158
                                                                                                                       //
  return {                                                                                                             // 160
    userId: user._id,                                                                                                  // 161
    options: {                                                                                                         // 162
      resumePath: resumePath                                                                                           // 163
    }                                                                                                                  // 162
  };                                                                                                                   // 160
});                                                                                                                    // 166
                                                                                                                       //
var makeTokenUrl = function makeTokenUrl(email, token, options) {                                                      // 168
  if (options.linking) {                                                                                               // 169
    return options.rootUrl + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId() + "?allowLogin=" + options.linking.allowLogin;
  } else {                                                                                                             // 173
    return options.rootUrl + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);            // 174
  }                                                                                                                    // 175
};                                                                                                                     // 176
                                                                                                                       //
///                                                                                                                    // 178
/// EMAIL VERIFICATION                                                                                                 // 179
///                                                                                                                    // 180
var sendTokenEmail = function sendTokenEmail(db, email, token, options) {                                              // 181
  var subject = void 0;                                                                                                // 182
  var text = void 0;                                                                                                   // 183
                                                                                                                       //
  var rootHostname = Url.parse(options.rootUrl).hostname;                                                              // 185
                                                                                                                       //
  if (!options.linking) {                                                                                              // 187
    subject = "Log in to " + rootHostname;                                                                             // 188
    text = "To confirm this email address on ";                                                                        // 189
  } else {                                                                                                             // 190
    subject = "Confirm this email address on " + rootHostname;                                                         // 191
    text = "To confirm this email address on ";                                                                        // 192
  }                                                                                                                    // 193
                                                                                                                       //
  text = text + rootHostname + ", click on the following link:\n\n" + makeTokenUrl(email, token, options) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                       //
  var sendOptions = {                                                                                                  // 200
    to: email,                                                                                                         // 201
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                                    // 202
    subject: subject,                                                                                                  // 203
    text: text                                                                                                         // 204
  };                                                                                                                   // 200
                                                                                                                       //
  sendEmail(sendOptions);                                                                                              // 207
};                                                                                                                     // 208
                                                                                                                       //
var parsedRootUrl = Url.parse(process.env.ROOT_URL);                                                                   // 210
///                                                                                                                    // 211
/// CREATING USERS                                                                                                     // 212
///                                                                                                                    // 213
// returns the user id                                                                                                 // 214
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, options) {                           // 215
  check(email, String);                                                                                                // 216
  check(options, {                                                                                                     // 217
    resumePath: String,                                                                                                // 218
    linking: Match.Optional({ allowLogin: Boolean }),                                                                  // 219
    rootUrl: String                                                                                                    // 220
  });                                                                                                                  // 217
                                                                                                                       //
  var parsedUrl = Url.parse(options.rootUrl);                                                                          // 223
  if ((parsedUrl.hostname !== parsedRootUrl.hostname || parsedUrl.protocol !== parsedRootUrl.protocol) && !db.hostIsStandalone(parsedUrl.hostname)) {
    // Ignore port and only check hostname/protocol since IE will differ from other browsers and                       // 227
    // sometimes include port 80/443 and sometimes won't                                                               // 228
    throw new Meteor.Error(400, "rootUrl is not valid");                                                               // 229
  }                                                                                                                    // 230
                                                                                                                       //
  var atIndex = email.indexOf("@");                                                                                    // 232
  if (atIndex === -1) {                                                                                                // 233
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                                // 234
  }                                                                                                                    // 235
                                                                                                                       //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });             // 237
  var userId = void 0;                                                                                                 // 239
                                                                                                                       //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                                 // 241
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                         // 242
  var token = Random.id(12);                                                                                           // 243
  var tokenObj = hashToken(token);                                                                                     // 244
  tokenObj.createdAt = new Date();                                                                                     // 245
  tokenObj.secureBox = makeBox(token, options.resumePath);                                                             // 246
                                                                                                                       //
  if (user) {                                                                                                          // 248
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                         // 249
      throw new Meteor.Error("alreadySentEmailToken", "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again.");
    }                                                                                                                  // 255
                                                                                                                       //
    userId = user._id;                                                                                                 // 257
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                          // 259
  } else {                                                                                                             // 260
    var _options = {};                                                                                                 // 261
    user = {                                                                                                           // 262
      services: {                                                                                                      // 263
        email: {                                                                                                       // 264
          tokens: [tokenObj],                                                                                          // 265
          email: email                                                                                                 // 266
        }                                                                                                              // 264
      }                                                                                                                // 263
    };                                                                                                                 // 262
                                                                                                                       //
    userId = Accounts.insertUserDoc(_options, user);                                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  sendTokenEmail(db, email, token, options);                                                                           // 274
                                                                                                                       //
  return userId;                                                                                                       // 276
};                                                                                                                     // 277
                                                                                                                       //
Meteor.methods({                                                                                                       // 279
  createAndEmailTokenForUser: function () {                                                                            // 280
    function createAndEmailTokenForUser(email, options) {                                                              // 280
      // method for create user. Requests come from the client.                                                        // 281
      // This method will create a user if it doesn't exist, otherwise it will generate a token.                       // 282
      // It will always send an email to the user                                                                      // 283
                                                                                                                       //
      check(email, String);                                                                                            // 285
      check(options, {                                                                                                 // 286
        resumePath: String,                                                                                            // 287
        linking: Match.Optional({ allowLogin: Boolean }),                                                              // 288
        rootUrl: String                                                                                                // 289
      });                                                                                                              // 286
                                                                                                                       //
      if (!Accounts.identityServices.email.isEnabled()) {                                                              // 292
        throw new Meteor.Error(403, "Email identity service is disabled.");                                            // 293
      }                                                                                                                // 294
      // Create user. result contains id and token.                                                                    // 295
      var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, options);                             // 296
    }                                                                                                                  // 297
                                                                                                                       //
    return createAndEmailTokenForUser;                                                                                 // 280
  }(),                                                                                                                 // 280
                                                                                                                       //
  linkEmailIdentityToAccount: function () {                                                                            // 299
    function linkEmailIdentityToAccount(email, token, allowLogin) {                                                    // 299
      // Links the email identity with address `email` and login token `token` to the current account.                 // 300
      check(email, String);                                                                                            // 301
      check(token, String);                                                                                            // 302
      check(allowLogin, Boolean);                                                                                      // 303
      var account = Meteor.user();                                                                                     // 304
      if (!account || !account.loginIdentities) {                                                                      // 305
        throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                     // 306
      }                                                                                                                // 307
                                                                                                                       //
      var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });     // 309
      if (!identity) {                                                                                                 // 311
        throw new Meteor.Error(403, "Invalid authentication code.");                                                   // 312
      }                                                                                                                // 313
                                                                                                                       //
      var maybeToken = consumeToken(identity, token.trim());                                                           // 315
      if (!maybeToken) {                                                                                               // 316
        throw new Meteor.Error(403, "Invalid authentication code.");                                                   // 317
      }                                                                                                                // 318
                                                                                                                       //
      Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id, allowLogin);
                                                                                                                       //
      // Return the resume path, if we have one.                                                                       // 323
      var resumePath = tryUnbox(maybeToken.secureBox, token);                                                          // 324
      return resumePath;                                                                                               // 325
    }                                                                                                                  // 326
                                                                                                                       //
    return linkEmailIdentityToAccount;                                                                                 // 299
  }()                                                                                                                  // 299
});                                                                                                                    // 279
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"identity":{"identity-server.js":["/imports/server/backend.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/identity/identity-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var SandstormBackend;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var linkIdentityToAccountInternal = function linkIdentityToAccountInternal(db, backend, identityId, accountId, allowLogin) {
  // Links the identity to the account. If `allowLogin` is true, grants the identity login access                      // 20
  // if possible. Makes the account durable if it is a demo account.                                                   // 21
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 23
  check(backend, SandstormBackend);                                                                                    // 24
  check(identityId, String);                                                                                           // 25
  check(accountId, String);                                                                                            // 26
                                                                                                                       //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                          // 28
  if (!accountUser) {                                                                                                  // 29
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                              // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (accountUser.profile) {                                                                                           // 33
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                       // 34
  }                                                                                                                    // 35
                                                                                                                       //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");          // 39
  }                                                                                                                    // 41
                                                                                                                       //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                        // 43
                                                                                                                       //
  if (!identityUser) {                                                                                                 // 45
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  if (!identityUser.profile) {                                                                                         // 49
    throw new Meteor.Error(400, "Cannot link an account to another account");                                          // 50
  }                                                                                                                    // 51
                                                                                                                       //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                   // 53
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                              // 54
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                  // 55
  }                                                                                                                    // 57
                                                                                                                       //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                           // 59
                                                                                                                       //
  var pushModifier = alreadyLinked || !allowLogin ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                       //
  var modifier = void 0;                                                                                               // 65
  if (accountUser.expires) {                                                                                           // 66
    if (alreadyLinked) {                                                                                               // 67
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                  // 70
                                                                                                                       //
    modifier = {                                                                                                       // 72
      $push: pushModifier,                                                                                             // 73
      $unset: { expires: 1 },                                                                                          // 74
      $set: { upgradedFromDemo: Date.now() }                                                                           // 75
    };                                                                                                                 // 72
    if (db.isReferralEnabled()) {                                                                                      // 77
      // Demo users never got the referral notification. Send it now:                                                  // 78
      db.sendReferralProgramNotification(accountUser._id);                                                             // 79
    }                                                                                                                  // 80
  } else {                                                                                                             // 82
    modifier = { $push: pushModifier };                                                                                // 83
  }                                                                                                                    // 84
                                                                                                                       //
  // Make sure not to add the same identity twice.                                                                     // 86
  Meteor.users.update({ _id: accountUser._id,                                                                          // 87
    "nonloginIdentities.id": { $ne: identityUser._id },                                                                // 88
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                      // 89
                                                                                                                       //
  if (accountUser.expires) {                                                                                           // 92
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                               // 93
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                             // 94
      $set: { upgradedFromDemo: Date.now() } });                                                                       // 96
                                                                                                                       //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                      // 98
    // but to get that to work we would need to adjust the account creation and first login logic.                     // 99
    Meteor.users.update({ _id: accountUser._id,                                                                        // 100
      "loginIdentities.id": demoIdentityId,                                                                            // 101
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                        // 104
  }                                                                                                                    // 106
};                                                                                                                     // 107
                                                                                                                       //
Meteor.methods({                                                                                                       // 109
  loginWithIdentity: function () {                                                                                     // 110
    function loginWithIdentity(accountUserId) {                                                                        // 110
      // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                     // 111
      // not an identity user listed in the account's `loginIdentities` field. This method is not                      // 112
      // intended to be called directly; client-side code should only invoke it through                                // 113
      // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                    // 114
      // login state.                                                                                                  // 115
                                                                                                                       //
      check(accountUserId, String);                                                                                    // 117
                                                                                                                       //
      var identityUser = Meteor.user();                                                                                // 119
      if (!identityUser || !identityUser.profile) {                                                                    // 120
        throw new Meteor.Error(403, "Must be already logged in as an identity.");                                      // 121
      }                                                                                                                // 122
                                                                                                                       //
      var accountUser = Meteor.users.findOne(accountUserId);                                                           // 124
      if (!accountUser) {                                                                                              // 125
        throw new Meteor.Error(404, "No such user found: " + accountUserId);                                           // 126
      }                                                                                                                // 127
                                                                                                                       //
      var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                         // 129
                                                                                                                       //
      if (!linkedIdentity) {                                                                                           // 131
        throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);          // 132
      }                                                                                                                // 134
                                                                                                                       //
      return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {               // 136
        return { userId: accountUserId };                                                                              // 137
      });                                                                                                              // 137
    }                                                                                                                  // 138
                                                                                                                       //
    return loginWithIdentity;                                                                                          // 110
  }(),                                                                                                                 // 110
                                                                                                                       //
  createAccountForIdentity: function () {                                                                              // 140
    function createAccountForIdentity() {                                                                              // 140
      // Creates a new account for the currently-logged-in identity.                                                   // 141
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 143
      if (!(user && user.profile)) {                                                                                   // 144
        throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");                // 145
      }                                                                                                                // 146
                                                                                                                       //
      if (Meteor.users.findOne({                                                                                       // 148
        $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                               // 149
      })) {                                                                                                            // 148
        throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
      }                                                                                                                // 156
                                                                                                                       //
      var newUser = {                                                                                                  // 158
        loginIdentities: [{ id: user._id }],                                                                           // 159
        nonloginIdentities: []                                                                                         // 160
      };                                                                                                               // 158
      if (user.services.dev) {                                                                                         // 162
        newUser.signupKey = "devAccounts";                                                                             // 163
        if (user.services.dev.isAdmin) {                                                                               // 164
          newUser.isAdmin = true;                                                                                      // 165
        }                                                                                                              // 166
                                                                                                                       //
        if (user.services.dev.hasCompletedSignup) {                                                                    // 168
          newUser.hasCompletedSignup = true;                                                                           // 169
        }                                                                                                              // 170
      } else if (user.expires) {                                                                                       // 171
        // Demo user.                                                                                                  // 172
        newUser.expires = user.expires;                                                                                // 173
        if (!!user.appDemoId) {                                                                                        // 174
          newUser.appDemoId = user.appDemoId;                                                                          // 175
        }                                                                                                              // 176
      }                                                                                                                // 177
                                                                                                                       //
      var options = {};                                                                                                // 179
                                                                                                                       //
      // This will throw an error if the identity has been added as a login identity to some                           // 181
      // other account while we were executing the body of this method.                                                // 182
      return Accounts.insertUserDoc(options, newUser);                                                                 // 183
    }                                                                                                                  // 184
                                                                                                                       //
    return createAccountForIdentity;                                                                                   // 140
  }(),                                                                                                                 // 140
                                                                                                                       //
  linkIdentityToAccount: function () {                                                                                 // 186
    function linkIdentityToAccount(token) {                                                                            // 186
      // Links the identity of the current user to the account that has `token` as a resume token.                     // 187
      // If the account is a demo account, makes the account durable and gives the identity login                      // 188
      // access to it.                                                                                                 // 189
                                                                                                                       //
      check(token, String);                                                                                            // 191
                                                                                                                       //
      if (!this.userId) {                                                                                              // 193
        throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                       // 194
      }                                                                                                                // 195
                                                                                                                       //
      var hashed = Accounts._hashLoginToken(token);                                                                    // 197
      var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                   // 198
                                                                                                                       //
      linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id, true);
    }                                                                                                                  // 202
                                                                                                                       //
    return linkIdentityToAccount;                                                                                      // 186
  }(),                                                                                                                 // 186
                                                                                                                       //
  unlinkIdentity: function () {                                                                                        // 204
    function unlinkIdentity(accountUserId, identityId) {                                                               // 204
      // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                           // 205
                                                                                                                       //
      check(identityId, String);                                                                                       // 207
      check(accountUserId, String);                                                                                    // 208
                                                                                                                       //
      if (!this.userId) {                                                                                              // 210
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 211
      }                                                                                                                // 212
                                                                                                                       //
      if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                     // 214
        throw new Meteor.Error(403, "Current user does not own identity " + identityId);                               // 215
      }                                                                                                                // 216
                                                                                                                       //
      var identityUser = Meteor.users.findOne({ _id: identityId });                                                    // 218
      Meteor.users.update({                                                                                            // 219
        _id: accountUserId                                                                                             // 220
      }, {                                                                                                             // 219
        $pull: {                                                                                                       // 222
          nonloginIdentities: { id: identityId },                                                                      // 223
          loginIdentities: { id: identityId }                                                                          // 224
        }                                                                                                              // 222
      });                                                                                                              // 221
    }                                                                                                                  // 227
                                                                                                                       //
    return unlinkIdentity;                                                                                             // 204
  }(),                                                                                                                 // 204
                                                                                                                       //
  setIdentityAllowsLogin: function () {                                                                                // 229
    function setIdentityAllowsLogin(identityId, allowLogin) {                                                          // 229
      // Sets whether the current account allows the identity with ID `identityId` to log in.                          // 230
                                                                                                                       //
      check(identityId, String);                                                                                       // 232
      check(allowLogin, Boolean);                                                                                      // 233
      if (!this.userId) {                                                                                              // 234
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 235
      }                                                                                                                // 236
                                                                                                                       //
      if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                     // 238
        throw new Meteor.Error(403, "Current user does not own identity " + identityId);                               // 239
      }                                                                                                                // 240
                                                                                                                       //
      if (allowLogin) {                                                                                                // 242
        Meteor.users.update({ _id: this.userId,                                                                        // 243
          "nonloginIdentities.id": identityId,                                                                         // 244
          "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },  // 245
          $push: { loginIdentities: { id: identityId } } });                                                           // 247
      } else {                                                                                                         // 248
        Meteor.users.update({ _id: this.userId,                                                                        // 249
          "loginIdentities.id": identityId,                                                                            // 250
          "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },  // 251
          $push: { nonloginIdentities: { id: identityId } } });                                                        // 253
      }                                                                                                                // 254
    }                                                                                                                  // 255
                                                                                                                       //
    return setIdentityAllowsLogin;                                                                                     // 229
  }(),                                                                                                                 // 229
                                                                                                                       //
  logoutIdentitiesOfCurrentAccount: function () {                                                                      // 257
    function logoutIdentitiesOfCurrentAccount() {                                                                      // 257
      // Logs out all identities that are allowed to log in to the current account.                                    // 258
      var user = Meteor.user();                                                                                        // 259
      if (user && user.loginIdentities) {                                                                              // 260
        user.loginIdentities.forEach(function (identity) {                                                             // 261
          Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                  // 262
        });                                                                                                            // 263
      }                                                                                                                // 264
    }                                                                                                                  // 265
                                                                                                                       //
    return logoutIdentitiesOfCurrentAccount;                                                                           // 257
  }()                                                                                                                  // 257
});                                                                                                                    // 109
                                                                                                                       //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId, allowLogin) {                           // 268
  // Links the identity to the account. If the account is a demo account, makes it durable.                            // 269
  // If `allowLogin` is true, attempts to give the identity login access.                                              // 270
  check(db, SandstormDb);                                                                                              // 271
  check(backend, SandstormBackend);                                                                                    // 272
  check(identityId, String);                                                                                           // 273
  check(accountId, String);                                                                                            // 274
  check(allowLogin, Boolean);                                                                                          // 275
  linkIdentityToAccountInternal(db, backend, identityId, accountId, allowLogin);                                       // 276
};                                                                                                                     // 277
                                                                                                                       //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                           // 279
  check(identityId, String);                                                                                           // 280
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                              // 281
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             // 283
  var loginIdentities = {};                                                                                            // 284
                                                                                                                       //
  var _this = this;                                                                                                    // 286
  function addIdentitiesOfAccount(account) {                                                                           // 287
    account.loginIdentities.forEach(function (identity) {                                                              // 288
      if (!(identity.id in loginIdentities)) {                                                                         // 289
        var user = Meteor.users.findOne({ _id: identity.id });                                                         // 290
        if (user) {                                                                                                    // 291
          SandstormDb.fillInProfileDefaults(user);                                                                     // 292
          SandstormDb.fillInIntrinsicName(user);                                                                       // 293
          SandstormDb.fillInLoginId(user);                                                                             // 294
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                                // 295
          filteredUser.loginAccountId = account._id;                                                                   // 296
          filteredUser.sourceIdentityId = identityId;                                                                  // 297
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                      // 298
        }                                                                                                              // 299
                                                                                                                       //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function () {                                                                                       // 303
            function changed(id, fields) {                                                                             // 303
              _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                            // 304
            }                                                                                                          // 305
                                                                                                                       //
            return changed;                                                                                            // 303
          }()                                                                                                          // 303
        });                                                                                                            // 302
      }                                                                                                                // 307
    });                                                                                                                // 308
  }                                                                                                                    // 309
                                                                                                                       //
  var cursor = Meteor.users.find({                                                                                     // 311
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                               // 312
  });                                                                                                                  // 311
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 318
    added: function () {                                                                                               // 319
      function added(account) {                                                                                        // 319
        addIdentitiesOfAccount(account);                                                                               // 320
      }                                                                                                                // 321
                                                                                                                       //
      return added;                                                                                                    // 319
    }(),                                                                                                               // 319
                                                                                                                       //
    changed: function () {                                                                                             // 323
      function changed(newAccount, oldAccount) {                                                                       // 323
        addIdentitiesOfAccount(newAccount);                                                                            // 324
      }                                                                                                                // 325
                                                                                                                       //
      return changed;                                                                                                  // 323
    }(),                                                                                                               // 323
                                                                                                                       //
    removed: function () {                                                                                             // 327
      function removed(account) {                                                                                      // 327
        account.loginIdentities.forEach(function (identity) {                                                          // 328
          if (identity.id in loginIdentities) {                                                                        // 329
            _this.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                             // 330
            loginIdentities[identity.id].stop();                                                                       // 331
            delete loginIdentities[identity.id];                                                                       // 332
          }                                                                                                            // 333
        });                                                                                                            // 334
      }                                                                                                                // 335
                                                                                                                       //
      return removed;                                                                                                  // 327
    }()                                                                                                                // 327
  });                                                                                                                  // 318
  this.ready();                                                                                                        // 337
                                                                                                                       //
  this.onStop(function () {                                                                                            // 339
    handle.stop();                                                                                                     // 340
    Object.keys(loginIdentities).forEach(function (identityId) {                                                       // 341
      loginIdentities[identityId].stop();                                                                              // 342
      delete loginIdentities[identityId];                                                                              // 343
    });                                                                                                                // 344
  });                                                                                                                  // 345
});                                                                                                                    // 346
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"ldap":{"ldap-server.js":["/imports/server/accounts/ldap.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/ldap/ldap-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var LDAP;module.import("/imports/server/accounts/ldap.js",{"LDAP":function(v){LDAP=v}});                               // 1
                                                                                                                       //
// Register login handler with Meteor                                                                                  // 3
Accounts.registerLoginHandler("ldap", function (loginRequest) {                                                        // 4
  // If 'ldap' isn't set in loginRequest object,                                                                       // 5
  // then this isn't the proper handler (return undefined)                                                             // 6
  if (!loginRequest.ldap) {                                                                                            // 7
    return undefined;                                                                                                  // 8
  }                                                                                                                    // 9
                                                                                                                       //
  if (!Accounts.identityServices.ldap.isEnabled()) {                                                                   // 11
    throw new Meteor.Error(403, "LDAP service is disabled.");                                                          // 12
  }                                                                                                                    // 13
                                                                                                                       //
  check(loginRequest, {                                                                                                // 15
    ldap: true,                                                                                                        // 16
    username: String,                                                                                                  // 17
    ldapPass: String                                                                                                   // 18
  });                                                                                                                  // 15
                                                                                                                       //
  // Instantiate LDAP                                                                                                  // 21
  var ldapObj = new LDAP();                                                                                            // 22
                                                                                                                       //
  // Call ldapCheck and get response                                                                                   // 24
  var ldapResponse = ldapObj.ldapCheck(this.connection.sandstormDb, loginRequest);                                     // 25
                                                                                                                       //
  if (ldapResponse.error) {                                                                                            // 27
    return {                                                                                                           // 28
      userId: null,                                                                                                    // 29
      error: ldapResponse.error                                                                                        // 30
    };                                                                                                                 // 28
  } else if (ldapResponse.emptySearch) {                                                                               // 32
    return {                                                                                                           // 33
      userId: null,                                                                                                    // 34
      error: new Meteor.Error(403, "User not found in LDAP")                                                           // 35
    };                                                                                                                 // 33
  } else {                                                                                                             // 37
    // Set initial userId and token vals                                                                               // 38
    return Accounts.updateOrCreateUserFromExternalService("ldap", { id: ldapResponse.dn, username: loginRequest.username,
      rawAttrs: ldapResponse.searchResults }, {});                                                                     // 41
  }                                                                                                                    // 42
});                                                                                                                    // 44
                                                                                                                       //
Meteor.methods({                                                                                                       // 46
  updateQuota: function () {                                                                                           // 47
    function updateQuota() {                                                                                           // 46
      return this.connection.sandstormDb.updateUserQuota(Meteor.user());                                               // 48
      // This is a no-op if settings aren't enabled                                                                    // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return updateQuota;                                                                                                // 46
  }()                                                                                                                  // 46
});                                                                                                                    // 46
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"saml":{"saml-server.js":["url","zlib","/imports/server/accounts/saml-utils.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/saml/saml-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Url;module.import("url",{"default":function(v){Url=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});var SAML;module.import("/imports/server/accounts/saml-utils.js",{"SAML":function(v){SAML=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var Fiber = Npm.require("fibers");                                                                                     // 5
                                                                                                                       //
if (!Accounts.saml) {                                                                                                  // 7
  Accounts.saml = {};                                                                                                  // 8
}                                                                                                                      // 9
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      // 11
// uses. Fortunately, they let us extract it.                                                                          // 12
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 13
                                                                                                                       //
RoutePolicy.declare("/_saml/", "network");                                                                             // 15
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 17
                                                                                                                       //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                            // 19
//   replicated (but currently SAML is not used on any Blackrock servers).                                             // 20
var _loginResultForCredentialToken = {};                                                                               // 21
                                                                                                                       //
var retrieveCredential = function retrieveCredential(credentialToken) {                                                // 23
  var result = _loginResultForCredentialToken[credentialToken];                                                        // 24
  delete _loginResultForCredentialToken[credentialToken];                                                              // 25
  return result;                                                                                                       // 26
};                                                                                                                     // 27
                                                                                                                       //
Accounts.registerLoginHandler(function (loginRequest) {                                                                // 29
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                           // 30
    return undefined;                                                                                                  // 31
  }                                                                                                                    // 32
                                                                                                                       //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                   // 34
    throw new Meteor.Error(403, "SAML service is disabled.");                                                          // 35
  }                                                                                                                    // 36
                                                                                                                       //
  var loginResult = retrieveCredential(loginRequest.credentialToken);                                                  // 38
  if (!loginResult) {                                                                                                  // 39
    throw new Meteor.Error(500, "SAML login did not complete.");                                                       // 40
  } else if (loginResult.profile && loginResult.profile.email) {                                                       // 41
    var user = _.pick(loginResult.profile, "displayName", "email", "nameIDFormat");                                    // 42
    user.id = loginResult.profile.nameID;                                                                              // 43
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                           // 44
  } else {                                                                                                             // 45
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                      // 46
  }                                                                                                                    // 47
});                                                                                                                    // 48
                                                                                                                       //
var samlUrlToObject = function samlUrlToObject(url) {                                                                  // 50
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                                // 51
  if (!url) return null;                                                                                               // 52
                                                                                                                       //
  var splitPath = url.split("/");                                                                                      // 55
                                                                                                                       //
  // Any non-saml request will continue down the default                                                               // 57
  // middlewares.                                                                                                      // 58
  if (splitPath[1] !== "_saml") return null;                                                                           // 59
                                                                                                                       //
  return {                                                                                                             // 62
    actionName: splitPath[2],                                                                                          // 63
    serviceName: splitPath[3],                                                                                         // 64
    credentialToken: splitPath[4]                                                                                      // 65
  };                                                                                                                   // 62
};                                                                                                                     // 67
                                                                                                                       //
var closePopup = function closePopup(res, err) {                                                                       // 69
  res.writeHead(200, { "Content-Type": "text/html" });                                                                 // 70
  var content = "<html><head><script>window.close()</script></head></html>";                                           // 71
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a> <a href="/admin/status" target="_blank">View system log (admin only)</a></body></html>';
  res.end(content, "utf-8");                                                                                           // 75
};                                                                                                                     // 76
                                                                                                                       //
var generateService = function generateService() {                                                                     // 78
  // TODO(cleanup): Inject the db.                                                                                     // 79
  var db = new SandstormDb();                                                                                          // 80
                                                                                                                       //
  var entityId = db.getSamlEntityId();                                                                                 // 82
  var service = {                                                                                                      // 83
    "provider": "default",                                                                                             // 84
    "entryPoint": db.getSamlEntryPoint(),                                                                              // 85
    "logoutUrl": db.getSamlLogout(),                                                                                   // 86
    // TODO(someday): find a better way to inject the DB                                                               // 87
    "issuer": entityId || HOSTNAME,                                                                                    // 88
    // If the certificate has "-----BEGIN CERTIFICATE-----" markers, automatically remove those.                       // 89
    "cert": db.getSamlPublicCert().replace(/-[^\n]*-/g, "").trim()                                                     // 90
  };                                                                                                                   // 83
  return service;                                                                                                      // 92
};                                                                                                                     // 93
                                                                                                                       //
var middleware = function middleware(req, res, next) {                                                                 // 95
  // Make sure to catch any exceptions because otherwise we'd crash                                                    // 96
  // the runner                                                                                                        // 97
  try {                                                                                                                // 98
    var samlObject = samlUrlToObject(req.url);                                                                         // 99
    if (!samlObject || !samlObject.serviceName) {                                                                      // 100
      next();                                                                                                          // 101
      return;                                                                                                          // 102
    }                                                                                                                  // 103
                                                                                                                       //
    if (samlObject.actionName === "config") {                                                                          // 105
      var _saml = new SAML(generateService());                                                                         // 106
      res.writeHead(200, { "Content-Type": "text/xml" });                                                              // 107
      res.end(_saml.generateServiceProviderMetadata());                                                                // 108
      return;                                                                                                          // 109
    }                                                                                                                  // 110
                                                                                                                       //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                                 // 112
      next();                                                                                                          // 113
      return;                                                                                                          // 114
    }                                                                                                                  // 115
                                                                                                                       //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                                // 117
                                                                                                                       //
    var service = generateService();                                                                                   // 120
                                                                                                                       //
    // Skip everything if there's no service set by the saml middleware                                                // 122
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                       //
    if (samlObject.actionName === "authorize") {                                                                       // 126
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                                  // 127
      service.id = samlObject.credentialToken;                                                                         // 128
      var _saml2 = new SAML(service);                                                                                  // 129
      _saml2.getAuthorizeUrl(req, function (err, url) {                                                                // 130
        if (err) throw new Error("Unable to generate authorize url");                                                  // 131
        res.writeHead(302, { "Location": url });                                                                       // 133
        res.end();                                                                                                     // 134
      });                                                                                                              // 135
    } else if (samlObject.actionName === "validate") {                                                                 // 136
      var _saml3 = new SAML(service);                                                                                  // 137
      _saml3.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut, responseText) {                // 138
        if (err) {                                                                                                     // 140
          console.error("Error validating SAML response:", err.toString(), "\nFull SAML response XML:\n", responseText);
          throw new Error("Unable to validate SAML response.");                                                        // 143
        }                                                                                                              // 144
                                                                                                                       //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                     // 146
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                          // 147
        if (!credentialToken) {                                                                                        // 148
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                              // 153
                                                                                                                       //
        _loginResultForCredentialToken[credentialToken] = {                                                            // 155
          profile: profile                                                                                             // 156
        };                                                                                                             // 155
                                                                                                                       //
        closePopup(res);                                                                                               // 159
      });                                                                                                              // 160
    } else {                                                                                                           // 161
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                              // 162
    }                                                                                                                  // 163
  } catch (err) {                                                                                                      // 164
    console.error(err.stack);                                                                                          // 165
    closePopup(res, err);                                                                                              // 166
  }                                                                                                                    // 167
};                                                                                                                     // 168
                                                                                                                       //
// Listen to incoming OAuth http requests                                                                              // 170
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                       // 171
  // Need to create a Fiber since we're using synchronous http calls and nothing                                       // 172
  // else is wrapping this in a fiber automatically                                                                    // 173
  Fiber(function () {                                                                                                  // 174
    middleware(req, res, next);                                                                                        // 175
  }).run();                                                                                                            // 176
});                                                                                                                    // 177
                                                                                                                       //
Meteor.methods({                                                                                                       // 179
  generateSamlLogout: function () {                                                                                    // 180
    function generateSamlLogout() {                                                                                    // 180
      var service = generateService();                                                                                 // 181
      if (!service.logoutUrl) {                                                                                        // 182
        throw new Meteor.Error(500, "No SAML logout url specified");                                                   // 183
      }                                                                                                                // 184
                                                                                                                       //
      var _saml = new SAML(service);                                                                                   // 186
      var identity = void 0;                                                                                           // 187
      Meteor.user().loginIdentities.forEach(function (_identity) {                                                     // 188
        var currIdentity = Meteor.users.findOne({ _id: _identity.id });                                                // 189
        if (currIdentity.services.saml) {                                                                              // 190
          identity = currIdentity;                                                                                     // 191
        }                                                                                                              // 192
      });                                                                                                              // 193
      // TODO(someday): handle user having more than one SAML identity                                                 // 194
                                                                                                                       //
      return Meteor.wrapAsync(_saml.getLogoutUrl.bind(_saml))({                                                        // 196
        user: {                                                                                                        // 197
          nameID: identity.services.saml.id,                                                                           // 198
          nameIDFormat: identity.services.saml.nameIDFormat || "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent"  // 199
        }                                                                                                              // 197
      });                                                                                                              // 196
    }                                                                                                                  // 203
                                                                                                                       //
    return generateSamlLogout;                                                                                         // 180
  }(),                                                                                                                 // 180
                                                                                                                       //
  validateSamlLogout: function () {                                                                                    // 205
    function validateSamlLogout(samlRequest) {                                                                         // 205
      check(samlRequest, String);                                                                                      // 206
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 208
      var userId = Meteor.userId();                                                                                    // 209
      if (!userId) {                                                                                                   // 210
        return new Meteor.Error(403, "Non-logged in users can't logout.");                                             // 211
      }                                                                                                                // 212
                                                                                                                       //
      var service = generateService();                                                                                 // 214
      var _saml = new SAML(service);                                                                                   // 215
      if (samlRequest) {                                                                                               // 216
        var buf = new Buffer(samlRequest, "base64");                                                                   // 217
        var xml = zlib.inflateRawSync(buf).toString();                                                                 // 218
        _saml.parseLogoutRequest(xml, function (err, nameId) {                                                         // 219
          if (err) {                                                                                                   // 220
            console.error("Error validating SAML logout response:", err.toString(), "\nFull SAML response XML:\n", responseText);
            throw new Error("Unable to validate SAML logout response.");                                               // 223
          }                                                                                                            // 224
                                                                                                                       //
          check(nameId, String);                                                                                       // 226
          var identity = db.collections.users.findOne({ "services.saml.id": nameId }, { fields: { _id: 1 } });         // 227
          if (!identity) {                                                                                             // 229
            return new Meteor.Error(400, "No identity found matching SAML nameID.");                                   // 230
          }                                                                                                            // 231
                                                                                                                       //
          var user = db.collections.users.findOne({ "loginIdentities.id": identity._id }, { fields: { _id: 1 } });     // 233
          if (!user) {                                                                                                 // 235
            return new Meteor.Error(403, "No user found for expected SAML identity.");                                 // 236
          }                                                                                                            // 237
                                                                                                                       //
          if (user._id !== userId) {                                                                                   // 239
            var txt = "SAML logout requested for wrong user: " + nameId + ", " + userId;                               // 240
            console.error(txt);                                                                                        // 241
            throw new Error(txt);                                                                                      // 242
          }                                                                                                            // 243
        });                                                                                                            // 244
      }                                                                                                                // 245
    }                                                                                                                  // 246
                                                                                                                       //
    return validateSamlLogout;                                                                                         // 205
  }()                                                                                                                  // 205
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"accounts-server.js":["meteor/accounts-base","/imports/server/accounts/picture.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Accounts;module.import("meteor/accounts-base",{"Accounts":function(v){Accounts=v}});var fetchPicture,userPictureUrl;module.import("/imports/server/accounts/picture.js",{"fetchPicture":function(v){fetchPicture=v},"userPictureUrl":function(v){userPictureUrl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 20
var Future = Npm.require("fibers/future");                                                                             // 21
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 23
  check(handle, String);                                                                                               // 24
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 25
});                                                                                                                    // 26
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 28
  if (user.loginIdentities) {                                                                                          // 29
    // it's an account                                                                                                 // 30
    check(user, { _id: String,                                                                                         // 31
      createdAt: Date,                                                                                                 // 32
      isAdmin: Match.Optional(Boolean),                                                                                // 33
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 34
      signupKey: Match.Optional(String),                                                                               // 35
      signupNote: Match.Optional(String),                                                                              // 36
      signupEmail: Match.Optional(String),                                                                             // 37
      expires: Match.Optional(Date),                                                                                   // 38
      appDemoId: Match.Optional(String),                                                                               // 39
      loginIdentities: [{ id: String }],                                                                               // 40
      nonloginIdentities: [{ id: String }] });                                                                         // 41
                                                                                                                       //
    if (globalDb.isReferralEnabled()) {                                                                                // 43
      user.experiments = user.experiments || {};                                                                       // 44
      user.experiments = {                                                                                             // 45
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test",                                              // 46
        freeGrainLimit: Math.random() < 0.1 ? 100 : "control"                                                          // 47
      };                                                                                                               // 45
      if (!("expires" in user)) {                                                                                      // 49
        globalDb.sendReferralProgramNotification(user._id);                                                            // 50
      }                                                                                                                // 51
    }                                                                                                                  // 52
                                                                                                                       //
    globalDb.preinstallAppsForUser(user._id);                                                                          // 54
                                                                                                                       //
    return user;                                                                                                       // 56
  }                                                                                                                    // 57
                                                                                                                       //
  if (globalDb.getOrganizationDisallowGuests() && !globalDb.isIdentityInOrganization(user)) {                          // 59
    throw new Meteor.Error(400, "User not in organization.");                                                          // 61
  }                                                                                                                    // 62
                                                                                                                       //
  // Check profile.                                                                                                    // 64
  if (options.profile) {                                                                                               // 65
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               // 66
    check(options.profile, Match.ObjectIncluding({                                                                     // 67
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 68
      handle: Match.Optional(ValidHandle),                                                                             // 69
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 70
    }));                                                                                                               // 67
  }                                                                                                                    // 72
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 74
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 76
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 77
  }                                                                                                                    // 78
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronoun");                                           // 80
                                                                                                                       //
  // Try downloading avatar.                                                                                           // 82
  var url = userPictureUrl(user);                                                                                      // 83
  if (url) {                                                                                                           // 84
    var assetId = fetchPicture(globalDb, url);                                                                         // 85
    if (assetId) {                                                                                                     // 86
      user.profile.picture = assetId;                                                                                  // 87
    }                                                                                                                  // 88
  }                                                                                                                    // 89
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 91
  if (user.services && user.services.dev) {                                                                            // 92
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 93
    serviceUserId = user.services.dev.name;                                                                            // 94
    user.profile.service = "dev";                                                                                      // 95
  } else if ("expires" in user) {                                                                                      // 96
    serviceUserId = user._id;                                                                                          // 97
    user.profile.service = "demo";                                                                                     // 98
  } else if (user.services && user.services.email) {                                                                   // 99
    check(user.services.email, {                                                                                       // 100
      email: String,                                                                                                   // 101
      tokens: [{                                                                                                       // 102
        digest: String,                                                                                                // 104
        algorithm: String,                                                                                             // 105
        createdAt: Date,                                                                                               // 106
        secureBox: Match.Optional({                                                                                    // 107
          version: Number,                                                                                             // 108
          salt: String,                                                                                                // 109
          iv: String,                                                                                                  // 110
          boxedValue: String                                                                                           // 111
        })                                                                                                             // 107
      }]                                                                                                               // 103
    });                                                                                                                // 100
    serviceUserId = user.services.email.email;                                                                         // 116
    user.profile.service = "email";                                                                                    // 117
  } else if (user.services && "google" in user.services) {                                                             // 118
    serviceUserId = user.services.google.id;                                                                           // 119
    user.profile.service = "google";                                                                                   // 120
  } else if (user.services && "github" in user.services) {                                                             // 121
    serviceUserId = user.services.github.id;                                                                           // 122
    user.profile.service = "github";                                                                                   // 123
  } else if (user.services && "ldap" in user.services) {                                                               // 124
    serviceUserId = user.services.ldap.id;                                                                             // 125
    user.profile.service = "ldap";                                                                                     // 126
  } else if (user.services && "saml" in user.services) {                                                               // 127
    serviceUserId = user.services.saml.id;                                                                             // 128
    user.profile.service = "saml";                                                                                     // 129
  } else {                                                                                                             // 130
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 131
  }                                                                                                                    // 133
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 135
                                                                                                                       //
  return user;                                                                                                         // 138
});                                                                                                                    // 139
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 141
  if (!attempt.allowed) {                                                                                              // 142
    return false;                                                                                                      // 143
  }                                                                                                                    // 144
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 146
  var user = attempt.user;                                                                                             // 147
                                                                                                                       //
  if (user.suspended && user.suspended.admin) {                                                                        // 149
    throw new Meteor.Error(403, "User has been suspended. Please contact the administrator " + "of this server if you believe this to be in error.");
  }                                                                                                                    // 152
                                                                                                                       //
  if (user.loginIdentities) {                                                                                          // 154
    // it's an account                                                                                                 // 155
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 156
      throw new Meteor.Error(403, "User not in organization.");                                                        // 158
    }                                                                                                                  // 159
                                                                                                                       //
    db.updateUserQuota(user); // This is a no-op if settings aren't enabled                                            // 161
  } else {                                                                                                             // 162
    if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                    // 163
      throw new Meteor.Error(403, "User not in organization.");                                                        // 165
    }                                                                                                                  // 166
  }                                                                                                                    // 167
                                                                                                                       //
  return true;                                                                                                         // 169
});                                                                                                                    // 170
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         // 17
// client for prediction purposes, on the server for actual execution).                                                // 18
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function () {                                                                                         // 26
    function updateProfile(identityId, profile) {                                                                      // 26
      // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                              // 27
      check(identityId, String);                                                                                       // 28
                                                                                                                       //
      check(profile, {                                                                                                 // 30
        name: String,                                                                                                  // 31
        handle: ValidHandle,                                                                                           // 32
        pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                    // 33
        unverifiedEmail: Match.Optional(String)                                                                        // 34
      });                                                                                                              // 30
                                                                                                                       //
      if (!this.userId) {                                                                                              // 37
        throw new Meteor.Error(403, "not logged in");                                                                  // 38
      }                                                                                                                // 39
                                                                                                                       //
      var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                    // 41
                                                                                                                       //
      if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {               // 43
        throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                          // 45
      }                                                                                                                // 46
                                                                                                                       //
      var newValues = {                                                                                                // 48
        "profile.name": profile.name,                                                                                  // 49
        "profile.handle": profile.handle,                                                                              // 50
        "profile.pronoun": profile.pronoun                                                                             // 51
      };                                                                                                               // 48
                                                                                                                       //
      Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                             // 54
                                                                                                                       //
      if (!Meteor.user().hasCompletedSignup) {                                                                         // 56
        Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                             // 57
      }                                                                                                                // 58
    }                                                                                                                  // 59
                                                                                                                       //
    return updateProfile;                                                                                              // 26
  }(),                                                                                                                 // 26
                                                                                                                       //
  testFirstSignup: function () {                                                                                       // 61
    function testFirstSignup(profile) {                                                                                // 61
      if (!this.userId) {                                                                                              // 62
        throw new Meteor.Error(403, "not logged in");                                                                  // 63
      }                                                                                                                // 64
                                                                                                                       //
      Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                        // 66
    }                                                                                                                  // 67
                                                                                                                       //
    return testFirstSignup;                                                                                            // 61
  }(),                                                                                                                 // 61
                                                                                                                       //
  uploadProfilePicture: function () {                                                                                  // 69
    function uploadProfilePicture(identityId) {                                                                        // 69
      check(identityId, String);                                                                                       // 70
      if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                     // 71
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 72
      }                                                                                                                // 73
                                                                                                                       //
      return this.connection.sandstormDb.newAssetUpload({                                                              // 75
        profilePicture: { userId: this.userId, identityId: identityId }                                                // 76
      });                                                                                                              // 75
    }                                                                                                                  // 78
                                                                                                                       //
    return uploadProfilePicture;                                                                                       // 69
  }(),                                                                                                                 // 69
                                                                                                                       //
  cancelUploadProfilePicture: function () {                                                                            // 80
    function cancelUploadProfilePicture(id) {                                                                          // 80
      check(id, String);                                                                                               // 81
      this.connection.sandstormDb.fulfillAssetUpload(id);                                                              // 82
    }                                                                                                                  // 83
                                                                                                                       //
    return cancelUploadProfilePicture;                                                                                 // 80
  }(),                                                                                                                 // 80
                                                                                                                       //
  setPrimaryEmail: function () {                                                                                       // 85
    function setPrimaryEmail(email) {                                                                                  // 85
      check(email, String);                                                                                            // 86
      if (!this.userId) {                                                                                              // 87
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 88
      }                                                                                                                // 89
                                                                                                                       //
      var emails = SandstormDb.getUserEmails(Meteor.user());                                                           // 91
      if (!_.findWhere(emails, { email: email, verified: true })) {                                                    // 92
        throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                             // 93
      }                                                                                                                // 94
                                                                                                                       //
      Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                    // 96
    }                                                                                                                  // 97
                                                                                                                       //
    return setPrimaryEmail;                                                                                            // 85
  }()                                                                                                                  // 85
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       // 17
Meteor.users.deny({                                                                                                    // 18
  insert: function () {                                                                                                // 19
    function insert() {                                                                                                // 19
      return true;                                                                                                     // 19
    }                                                                                                                  // 19
                                                                                                                       //
    return insert;                                                                                                     // 19
  }(),                                                                                                                 // 19
                                                                                                                       //
  update: function () {                                                                                                // 21
    function update() {                                                                                                // 21
      return true;                                                                                                     // 21
    }                                                                                                                  // 21
                                                                                                                       //
    return update;                                                                                                     // 21
  }(),                                                                                                                 // 21
                                                                                                                       //
  remove: function () {                                                                                                // 23
    function remove() {                                                                                                // 23
      return true;                                                                                                     // 23
    }                                                                                                                  // 23
                                                                                                                       //
    return remove;                                                                                                     // 23
  }(),                                                                                                                 // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              // 31
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function () {                                                                                 // 12
    function setMaintenanceMessage(params) {                                                                           // 11
      checkAuth(undefined);                                                                                            // 13
      check(params, maintenanceMessageShape);                                                                          // 14
      var db = this.connection.sandstormDb;                                                                            // 15
      // TODO(soon): make this a single write to a single settings object                                              // 16
      db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                               // 17
      db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                 // 18
      db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                   // 19
    }                                                                                                                  // 20
                                                                                                                       //
    return setMaintenanceMessage;                                                                                      // 11
  }()                                                                                                                  // 11
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    // 6
  // Otherwise, does nothing.                                                                                          // 7
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     // 26
  // IDs.  Otherwise, does nothing.                                                                                    // 27
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              // 44
  // Otherwise, does nothing.                                                                                          // 45
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whiteLabelHideAbout: Boolean,                                                                                        // 15
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 16
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  setPersonalizationSettings: function () {                                                                            // 20
    function setPersonalizationSettings(params) {                                                                      // 19
      checkAuth(undefined);                                                                                            // 21
      check(params, personalizationMessageShape);                                                                      // 22
      var db = this.connection.sandstormDb;                                                                            // 23
      // TODO(soon): make this a single write to a single settings object                                              // 24
      db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                           // 25
      db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                               // 26
      db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                         // 27
      db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                        // 28
      db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                       // 29
                                                                                                                       //
      db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
      db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
      db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
      db.collections.settings.upsert({ _id: "whiteLabelHideAbout" }, { value: params.whiteLabelHideAbout });           // 37
      db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
    }                                                                                                                  // 41
                                                                                                                       //
    return setPersonalizationSettings;                                                                                 // 19
  }(),                                                                                                                 // 19
  getWhitelabelLogoUploadToken: function () {                                                                          // 43
    function getWhitelabelLogoUploadToken() {                                                                          // 19
      checkAuth(undefined);                                                                                            // 44
      var db = this.connection.sandstormDb;                                                                            // 45
      return db.newAssetUpload({ loginLogo: {} });                                                                     // 46
    }                                                                                                                  // 47
                                                                                                                       //
    return getWhitelabelLogoUploadToken;                                                                               // 19
  }(),                                                                                                                 // 19
  resetWhitelabelLogo: function () {                                                                                   // 49
    function resetWhitelabelLogo() {                                                                                   // 19
      checkAuth(undefined);                                                                                            // 50
      var db = this.connection.sandstormDb;                                                                            // 51
      var result = globalDb.collections.settings.findAndModify({                                                       // 52
        query: { _id: "whitelabelCustomLogoAssetId" },                                                                 // 53
        remove: true,                                                                                                  // 54
        fields: { value: 1 }                                                                                           // 55
      });                                                                                                              // 52
                                                                                                                       //
      if (result.ok) {                                                                                                 // 58
        var old = result.value;                                                                                        // 59
        if (old) {                                                                                                     // 60
          db.unrefStaticAsset(old.value);                                                                              // 61
        }                                                                                                              // 62
      } else {                                                                                                         // 63
        throw new Meteor.Error(500, "Couldn't remove whitelabelCustomLogoAssetId");                                    // 64
      }                                                                                                                // 65
    }                                                                                                                  // 66
                                                                                                                       //
    return resetWhitelabelLogo;                                                                                        // 19
  }()                                                                                                                  // 19
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs","/imports/server/auth.js","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       //
                                                                                                                       // 8
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 10
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 11
};                                                                                                                     // 12
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       // 14
// log.                                                                                                                // 15
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 16
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  adminGetServerLogDownloadToken: function () {                                                                        // 20
    function adminGetServerLogDownloadToken(setupToken) {                                                              // 19
      checkAuth(setupToken);                                                                                           // 21
                                                                                                                       //
      var token = Random.id(22);                                                                                       // 23
      SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                  // 24
      setTimeout(function () {                                                                                         // 25
        if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                       // 26
          delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                    // 27
        }                                                                                                              // 28
      }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                             // 29
      return token;                                                                                                    // 30
    }                                                                                                                  // 31
                                                                                                                       //
    return adminGetServerLogDownloadToken;                                                                             // 19
  }()                                                                                                                  // 19
});                                                                                                                    // 19
                                                                                                                       //
Router.map(function () {                                                                                               // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function () {                                                                                              // 38
      function action() {                                                                                              // 35
        var token = this.params.tokenId;                                                                               // 39
        var response = this.response;                                                                                  // 40
        var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                             // 41
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                           // 42
        if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {         // 43
          // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                         // 45
          // method being called.                                                                                      // 46
          response.writeHead(404, { "Content-Type": "text/plain" });                                                   // 47
          return response.end("Invalid server log download token.");                                                   // 48
        }                                                                                                              // 49
                                                                                                                       //
        var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                         // 51
        var fd = Fs.openSync(logFilePath, "r");                                                                        // 52
        var stats = Fs.fstatSync(fd);                                                                                  // 53
        var initialSize = stats.size;                                                                                  // 54
        var readStream = Fs.createReadStream(undefined, {                                                              // 55
          fd: fd,                                                                                                      // 56
          start: 0,                                                                                                    // 57
          end: initialSize                                                                                             // 58
        });                                                                                                            // 55
                                                                                                                       //
        response.writeHead(200, {                                                                                      // 61
          "Content-Length": initialSize,                                                                               // 62
          "Content-Type": "text/plain",                                                                                // 63
          "content-Disposition": "attachment;filename=\"sandstorm.log\""                                               // 64
        });                                                                                                            // 61
        readStream.pipe(response);                                                                                     // 66
      }                                                                                                                // 67
                                                                                                                       //
      return action;                                                                                                   // 35
    }()                                                                                                                // 35
  });                                                                                                                  // 35
});                                                                                                                    // 69
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      // 72
  // userIds associated with these sessions                                                                            // 73
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 76
  }                                                                                                                    // 77
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 81
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 83
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  // 86
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function () {                                                                                               // 93
      function added(session) {                                                                                        // 92
        var hashedSessionId = hashSessionId(session._id);                                                              // 94
        var changed = {};                                                                                              // 95
                                                                                                                       //
        // Update userId cache.                                                                                        // 97
        if (session.userId) {                                                                                          // 98
          if (userIdToSessionHashes[session.userId] === undefined) {                                                   // 99
            userIdToSessionHashes[session.userId] = [];                                                                // 100
            userIdCount = userIdCount + 1;                                                                             // 101
            changed.activeUsers = userIdCount;                                                                         // 102
          }                                                                                                            // 103
                                                                                                                       //
          userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);   // 105
        }                                                                                                              // 107
                                                                                                                       //
        // Update grainId cache.                                                                                       // 109
        if (grainIdToSessionHashes[session.grainId] === undefined) {                                                   // 110
          grainIdToSessionHashes[session.grainId] = [];                                                                // 111
          grainIdCount = grainIdCount + 1;                                                                             // 112
          changed.activeGrains = grainIdCount;                                                                         // 113
        }                                                                                                              // 114
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 119
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 120
        }                                                                                                              // 121
      }                                                                                                                // 122
                                                                                                                       //
      return added;                                                                                                    // 92
    }(),                                                                                                               // 92
    removed: function () {                                                                                             // 124
      function removed(session) {                                                                                      // 92
        var hashedSessionId = hashSessionId(session._id);                                                              // 125
        var changed = {};                                                                                              // 126
                                                                                                                       //
        if (session.userId) {                                                                                          // 128
          userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);   // 129
                                                                                                                       //
          if (userIdToSessionHashes[session.userId].length === 0) {                                                    // 132
            delete userIdToSessionHashes[session.userId];                                                              // 133
            userIdCount = userIdCount - 1;                                                                             // 134
            changed.activeUsers = userIdCount;                                                                         // 135
          }                                                                                                            // 136
        }                                                                                                              // 137
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);
                                                                                                                       //
        if (grainIdToSessionHashes[session.grainId].length === 0) {                                                    // 142
          delete grainIdToSessionHashes[session.grainId];                                                              // 143
          grainIdCount = grainIdCount - 1;                                                                             // 144
          changed.activeGrains = grainIdCount;                                                                         // 145
        }                                                                                                              // 146
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 148
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 149
        }                                                                                                              // 150
      }                                                                                                                // 151
                                                                                                                       //
      return removed;                                                                                                  // 92
    }()                                                                                                                // 92
  });                                                                                                                  // 92
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  // 156
  this.ready();                                                                                                        // 157
});                                                                                                                    // 158
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          // 161
  // clientside and reactively updated.                                                                                // 162
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 // 169
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  // 172
  }, {                                                                                                                 // 168
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  // 175
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
var Url = Npm.require("url");                                                                                          // 19
var Http = Npm.require("http");                                                                                        // 20
var Https = Npm.require("https");                                                                                      // 21
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 22
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 24
  function ExternalUiView(url, grainId, token) {                                                                       // 25
    _classCallCheck(this, ExternalUiView);                                                                             // 25
                                                                                                                       //
    this.url = url;                                                                                                    // 26
    this.grainId = grainId;                                                                                            // 27
    this.token = token;                                                                                                // 28
  }                                                                                                                    // 29
                                                                                                                       //
  ExternalUiView.prototype.newSession = function () {                                                                  // 24
    function newSession(userInfo, context, sessionType, sessionParams) {                                               // 24
      if (sessionType !== ApiSession.typeId) {                                                                         // 32
        throw new Error("SessionType must be ApiSession.");                                                            // 33
      }                                                                                                                // 34
                                                                                                                       //
      var options = {};                                                                                                // 36
                                                                                                                       //
      if (this.token) {                                                                                                // 38
        options.headers = {                                                                                            // 39
          authorization: "Bearer " + this.token                                                                        // 40
        };                                                                                                             // 39
      }                                                                                                                // 42
                                                                                                                       //
      return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };   // 44
    }                                                                                                                  // 45
                                                                                                                       //
    return newSession;                                                                                                 // 24
  }();                                                                                                                 // 24
                                                                                                                       //
  return ExternalUiView;                                                                                               // 24
}();                                                                                                                   // 24
                                                                                                                       //
var responseCodes = {                                                                                                  // 48
  200: { type: "content", code: "ok" },                                                                                // 49
  201: { type: "content", code: "created" },                                                                           // 50
  202: { type: "content", code: "accepted" },                                                                          // 51
  204: { type: "noContent", shouldResetForm: false },                                                                  // 52
  205: { type: "noContent", shouldResetForm: true },                                                                   // 53
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    // 55
  // 206: {type: 'noContent'},                                                                                         // 56
  // 300: {type: 'redirect'},                                                                                          // 57
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 58
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 59
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 60
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    // 62
  // 304: {type: 'redirect'},                                                                                          // 63
  // 305: {type: 'redirect'},                                                                                          // 64
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 65
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 66
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 67
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 68
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 69
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 70
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 71
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 72
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 73
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 75
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 76
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 77
  500: { type: "serverError" },                                                                                        // 78
  501: { type: "serverError" },                                                                                        // 79
  502: { type: "serverError" },                                                                                        // 80
  503: { type: "serverError" },                                                                                        // 81
  504: { type: "serverError" },                                                                                        // 82
  505: { type: "serverError" }                                                                                         // 83
};                                                                                                                     // 48
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 86
  function ExternalWebSession(url, grainId, options) {                                                                 // 87
    _classCallCheck(this, ExternalWebSession);                                                                         // 87
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 88
    this.host = parsedUrl.hostname;                                                                                    // 89
    this.port = parsedUrl.port;                                                                                        // 90
    this.protocol = parsedUrl.protocol;                                                                                // 91
    this.grainId = grainId;                                                                                            // 92
    this.options = options || {};                                                                                      // 93
  }                                                                                                                    // 94
                                                                                                                       //
  ExternalWebSession.prototype.get = function () {                                                                     // 86
    function get(path, context) {                                                                                      // 86
      return this._requestHelper("GET", path, context);                                                                // 97
    }                                                                                                                  // 98
                                                                                                                       //
    return get;                                                                                                        // 86
  }();                                                                                                                 // 86
                                                                                                                       //
  ExternalWebSession.prototype.post = function () {                                                                    // 86
    function post(path, content, context) {                                                                            // 86
      return this._requestHelper("POST", path, context, content.content, content.mimeType);                            // 101
    }                                                                                                                  // 102
                                                                                                                       //
    return post;                                                                                                       // 86
  }();                                                                                                                 // 86
                                                                                                                       //
  ExternalWebSession.prototype.put = function () {                                                                     // 86
    function put(path, content, context) {                                                                             // 86
      return this._requestHelper("PUT", path, context, content.content, content.mimeType);                             // 105
    }                                                                                                                  // 106
                                                                                                                       //
    return put;                                                                                                        // 86
  }();                                                                                                                 // 86
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function () {                                                               // 86
    function _delete(path, context) {                                                                                  // 86
      return this._requestHelper("DELETE", path, context);                                                             // 109
    }                                                                                                                  // 110
                                                                                                                       //
    return _delete;                                                                                                    // 86
  }();                                                                                                                 // 86
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          // 112
  //postStreaming(path, mimeType, context) {                                                                           // 113
  //}                                                                                                                  // 114
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            // 116
  //}                                                                                                                  // 117
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             // 119
  //}                                                                                                                  // 120
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function () {                                                          // 86
    function _requestHelper(method, path, context, content, contentType) {                                             // 86
      var _this = this;                                                                                                // 123
      var session = _this;                                                                                             // 124
      return new Promise(function (resolve, reject) {                                                                  // 125
        var options = _.clone(session.options);                                                                        // 126
        options.headers = options.headers || {};                                                                       // 127
                                                                                                                       //
        // According to the specification of `WebSession`, `path` should not contain a                                 // 129
        // leading slash, and therefore we need to prepend "/". However, for a long time                               // 130
        // this implementation did not in fact prepend a "/". Since some apps might rely on                            // 131
        // that behavior, we only prepend "/" if the path does not start with "/".                                     // 132
        //                                                                                                             // 133
        // TODO(soon): Once apps have updated, prepend "/" unconditionally.                                            // 134
        options.path = path.startsWith("/") ? path : "/" + path;                                                       // 135
                                                                                                                       //
        options.method = method;                                                                                       // 137
        if (contentType) {                                                                                             // 138
          options.headers["content-type"] = contentType;                                                               // 139
        }                                                                                                              // 140
                                                                                                                       //
        // set accept header                                                                                           // 142
        if ("accept" in context) {                                                                                     // 143
          options.headers.accept = context.accept.map(function (acceptedType) {                                        // 144
            return acceptedType.mimeType + "; " + acceptedType.qValue;                                                 // 145
          }).join(", ");                                                                                               // 146
        } else if (!("accept" in options.headers)) {                                                                   // 147
          options.headers.accept = "*/*";                                                                              // 148
        }                                                                                                              // 149
                                                                                                                       //
        // set cookies                                                                                                 // 151
        if (context.cookies && context.cookies.length > 0) {                                                           // 152
          options.headers.cookies = options.headers.cookies || "";                                                     // 153
          context.cookies.forEach(function (keyVal) {                                                                  // 154
            options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                            // 155
          });                                                                                                          // 156
          options.headers.cookies = options.headers.cookies.slice(0, -1);                                              // 157
        }                                                                                                              // 158
                                                                                                                       //
        options.host = session.host;                                                                                   // 160
        options.port = session.port;                                                                                   // 161
                                                                                                                       //
        var requestMethod = Http.request;                                                                              // 163
        if (session.protocol === "https:") {                                                                           // 164
          requestMethod = Https.request;                                                                               // 165
        }                                                                                                              // 166
                                                                                                                       //
        req = requestMethod(options, function (resp) {                                                                 // 168
          var buffers = [];                                                                                            // 169
          var statusInfo = responseCodes[resp.statusCode];                                                             // 170
                                                                                                                       //
          var rpcResponse = {};                                                                                        // 172
                                                                                                                       //
          switch (statusInfo.type) {                                                                                   // 174
            case "content":                                                                                            // 175
              resp.on("data", function (buf) {                                                                         // 176
                buffers.push(buf);                                                                                     // 177
              });                                                                                                      // 178
                                                                                                                       //
              resp.on("end", function () {                                                                             // 180
                var content = {};                                                                                      // 181
                rpcResponse.content = content;                                                                         // 182
                                                                                                                       //
                content.statusCode = statusInfo.code;                                                                  // 184
                if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];           // 185
                if ("content-language" in resp.headers) content.language = resp.headers["content-language"];           // 186
                if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                   // 187
                if ("content-disposition" in resp.headers) {                                                           // 188
                  var disposition = resp.headers["content-disposition"];                                               // 189
                  var parts = disposition.split(";");                                                                  // 190
                  if (parts[0].toLowerCase().trim() === "attachment") {                                                // 191
                    parts.forEach(function (part) {                                                                    // 192
                      var splitPart = part.split("=");                                                                 // 193
                      if (splitPart[0].toLowerCase().trim() === "filename") {                                          // 194
                        content.disposition = { download: splitPart[1].trim() };                                       // 195
                      }                                                                                                // 196
                    });                                                                                                // 197
                  }                                                                                                    // 198
                }                                                                                                      // 199
                                                                                                                       //
                content.body = {};                                                                                     // 201
                content.body.bytes = Buffer.concat(buffers);                                                           // 202
                                                                                                                       //
                resolve(rpcResponse);                                                                                  // 204
              });                                                                                                      // 205
              break;                                                                                                   // 206
            case "noContent":                                                                                          // 207
              var noContent = {};                                                                                      // 208
              rpcResponse.noContent = noContent;                                                                       // 209
              noContent.setShouldResetForm = statusInfo.shouldResetForm;                                               // 210
              resolve(rpcResponse);                                                                                    // 211
              break;                                                                                                   // 212
            case "redirect":                                                                                           // 213
              var redirect = {};                                                                                       // 214
              rpcResponse.redirect = redirect;                                                                         // 215
              redirect.isPermanent = statusInfo.isPermanent;                                                           // 216
              redirect.switchToGet = statusInfo.switchToGet;                                                           // 217
              if ("location" in resp.headers) redirect.location = resp.headers.location;                               // 218
              resolve(rpcResponse);                                                                                    // 219
              break;                                                                                                   // 220
            case "clientError":                                                                                        // 221
              var clientError = {};                                                                                    // 222
              rpcResponse.clientError = clientError;                                                                   // 223
              clientError.statusCode = statusInfo.clientErrorCode;                                                     // 224
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 225
              resolve(rpcResponse);                                                                                    // 226
              break;                                                                                                   // 227
            case "serverError":                                                                                        // 228
              var serverError = {};                                                                                    // 229
              rpcResponse.serverError = serverError;                                                                   // 230
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 231
              resolve(rpcResponse);                                                                                    // 232
              break;                                                                                                   // 233
            default:                                                                                                   // 234
              // ???                                                                                                   // 234
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 235
              reject(err);                                                                                             // 236
              break;                                                                                                   // 237
          }                                                                                                            // 174
        });                                                                                                            // 239
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 241
          reject(e);                                                                                                   // 242
        });                                                                                                            // 243
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 245
          req.abort();                                                                                                 // 246
          err = new Error("Request timed out.");                                                                       // 247
          err.kjType = "overloaded";                                                                                   // 248
          reject(err);                                                                                                 // 249
        });                                                                                                            // 250
                                                                                                                       //
        if (content) {                                                                                                 // 252
          req.end(content);                                                                                            // 253
        } else {                                                                                                       // 254
          req.end();                                                                                                   // 255
        }                                                                                                              // 256
      });                                                                                                              // 257
    }                                                                                                                  // 258
                                                                                                                       //
    return _requestHelper;                                                                                             // 86
  }();                                                                                                                 // 86
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 86
}();                                                                                                                   // 86
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Tls = Npm.require("tls");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Capnp = Npm.require("capnp");                                                                                      // 23
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 25
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 27
  function ByteStreamConnection(connection) {                                                                          // 28
    _classCallCheck(this, ByteStreamConnection);                                                                       // 28
                                                                                                                       //
    this.connection = connection;                                                                                      // 29
  }                                                                                                                    // 30
                                                                                                                       //
  ByteStreamConnection.prototype.done = function () {                                                                  // 27
    function done() {                                                                                                  // 27
      this.connection.end();                                                                                           // 33
    }                                                                                                                  // 34
                                                                                                                       //
    return done;                                                                                                       // 27
  }();                                                                                                                 // 27
                                                                                                                       //
  ByteStreamConnection.prototype.write = function () {                                                                 // 27
    function write(data) {                                                                                             // 27
      this.connection.write(data);                                                                                     // 37
    }                                                                                                                  // 38
                                                                                                                       //
    return write;                                                                                                      // 27
  }();                                                                                                                 // 27
                                                                                                                       //
  // expectSize not implemented                                                                                        // 40
  // expectSize(size) { }                                                                                              // 41
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 27
}();                                                                                                                   // 27
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 45
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 45
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 45
  }                                                                                                                    // 47
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function () {                                                                  //
    function listenTcp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 50
        var resolved = false;                                                                                          // 51
        var server = Net.createServer(function (connection) {                                                          // 52
          var wrappedConnection = new ByteStreamConnection(connection);                                                // 53
          var upstream = port.connect(wrappedConnection).upstream;                                                     // 54
                                                                                                                       //
          connection.on("data", function (data) {                                                                      // 56
            upstream.write(data);                                                                                      // 57
          });                                                                                                          // 58
                                                                                                                       //
          connection.on("close", function (hadError) {                                                                 // 60
            upstream.done();                                                                                           // 61
          });                                                                                                          // 62
                                                                                                                       //
          connection.on("error", function (err) {                                                                      // 64
            if (resolved) {                                                                                            // 65
              connection.write = errorWrite;                                                                           // 66
            } else {                                                                                                   // 67
              // upstream hasn't been resolved yet, so it's safe to reject                                             // 68
              reject(err);                                                                                             // 69
            }                                                                                                          // 70
          });                                                                                                          // 71
        });                                                                                                            // 72
                                                                                                                       //
        server.listen(portNum, function () {                                                                           // 74
          resolved = true;                                                                                             // 75
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 76
        });                                                                                                            // 77
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 79
          if (!resolved) {                                                                                             // 80
            reject(err);                                                                                               // 81
          }                                                                                                            // 82
        });                                                                                                            // 83
      });                                                                                                              // 84
    }                                                                                                                  // 85
                                                                                                                       //
    return listenTcp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function () {                                                                  //
    function listenUdp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 88
        var portMap = {};                                                                                              // 89
        var resolved = false;                                                                                          // 90
        var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                             // 91
        server.bind(portNum);                                                                                          // 92
                                                                                                                       //
        server.on("listening", function () {                                                                           // 94
          // Although UDP is connectionless, we don't resolve until here so that we can handle bind                    // 95
          // errors such as invalid host                                                                               // 96
          resolved = true;                                                                                             // 97
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 98
        });                                                                                                            // 99
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 101
          // TODO(someday): do something about errors after the promise is resolved                                    // 102
          if (!resolved) {                                                                                             // 103
            reject(err);                                                                                               // 104
          } else {                                                                                                     // 105
            console.error("error in listenUdp: " + err);                                                               // 106
          }                                                                                                            // 107
        });                                                                                                            // 108
                                                                                                                       //
        var returnMap = {};                                                                                            // 110
        server.on("message", function (msg, rinfo) {                                                                   // 111
          var address = rinfo.address + "]:" + rinfo.port;                                                             // 112
          var returnPort = returnMap[address];                                                                         // 113
                                                                                                                       //
          if (!returnPort) {                                                                                           // 115
            returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                 // 116
          }                                                                                                            // 117
                                                                                                                       //
          port.send(msg, returnPort);                                                                                  // 119
        });                                                                                                            // 120
      });                                                                                                              // 121
    }                                                                                                                  // 122
                                                                                                                       //
    return listenUdp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 123
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    // 125
//   (ugh).                                                                                                            // 126
Meteor.startup(function () {                                                                                           // 127
  globalFrontendRefRegistry.register({                                                                                 // 128
    frontendRefField: "ipInterface",                                                                                   // 129
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 130
                                                                                                                       //
    restore: function () {                                                                                             // 132
      function restore(db, saveTemplate) {                                                                             // 128
        return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);               // 133
      }                                                                                                                // 135
                                                                                                                       //
      return restore;                                                                                                  // 128
    }(),                                                                                                               // 128
    validate: function () {                                                                                            // 137
      function validate(db, session, value) {                                                                          // 128
        check(value, true);                                                                                            // 138
                                                                                                                       //
        if (!session.userId) {                                                                                         // 140
          throw new Meteor.Error(403, "Not logged in.");                                                               // 141
        }                                                                                                              // 142
                                                                                                                       //
        return {                                                                                                       // 144
          descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                    // 145
          requirements: [{ userIsAdmin: session.userId }],                                                             // 146
          frontendRef: value                                                                                           // 147
        };                                                                                                             // 144
      }                                                                                                                // 149
                                                                                                                       //
      return validate;                                                                                                 // 128
    }(),                                                                                                               // 128
    query: function () {                                                                                               // 151
      function query(db, userId, value) {                                                                              // 128
        if (userId && Meteor.users.findOne(userId).isAdmin) {                                                          // 152
          return [{                                                                                                    // 153
            _id: "frontendref-ipinterface",                                                                            // 155
            frontendRef: { ipInterface: true },                                                                        // 156
            cardTemplate: "ipInterfacePowerboxCard"                                                                    // 157
          }];                                                                                                          // 154
        } else {                                                                                                       // 160
          return [];                                                                                                   // 161
        }                                                                                                              // 162
      }                                                                                                                // 163
                                                                                                                       //
      return query;                                                                                                    // 128
    }()                                                                                                                // 128
  });                                                                                                                  // 128
});                                                                                                                    // 165
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 167
  function BoundUdpPortImpl(server, address, port) {                                                                   // 168
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 168
                                                                                                                       //
    this.server = server;                                                                                              // 169
    this.address = address;                                                                                            // 170
    this.port = port;                                                                                                  // 171
  }                                                                                                                    // 172
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function () {                                                                      // 167
    function send(message, returnPort) {                                                                               // 167
      // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                         // 175
      // capabilities or build a map with them. What we should be doing is mapping all ports to                        // 176
      // their raw physical address/port, and using that here                                                          // 177
      this.server.send(message, 0, message.length, this.port, this.address);                                           // 178
    }                                                                                                                  // 179
                                                                                                                       //
    return send;                                                                                                       // 167
  }();                                                                                                                 // 167
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 167
}();                                                                                                                   // 167
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 182
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 183
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 185
  var part1 = num & 255;                                                                                               // 186
  var part2 = num >> 8 & 255;                                                                                          // 187
  var part3 = num >> 16 & 255;                                                                                         // 188
  var part4 = num >> 24 & 255;                                                                                         // 189
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 191
};                                                                                                                     // 192
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 194
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 195
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 197
    // this is an ipv4 address, we should return it as such                                                            // 198
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 199
    return intToIpv4(ipv4num);                                                                                         // 200
  }                                                                                                                    // 201
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 203
  var numColons = 0;                                                                                                   // 204
  var out = "";                                                                                                        // 205
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 207
    // start with lower bits of address and build the output in reverse                                                // 208
    // this ensures that we can place a colon every 4 characters                                                       // 209
    out += hex[hex.length - 1 - i];                                                                                    // 210
    if ((i + 1) % 4 === 0) {                                                                                           // 211
      out += ":";                                                                                                      // 212
      ++numColons;                                                                                                     // 213
    }                                                                                                                  // 214
  }                                                                                                                    // 215
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          // 217
  if (numColons < 7) {                                                                                                 // 218
    out += "::";                                                                                                       // 219
  }                                                                                                                    // 220
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 222
};                                                                                                                     // 223
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 225
  var type = "udp4";                                                                                                   // 226
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     // 228
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        // 229
  if (address.indexOf(":") != -1) {                                                                                    // 230
    type = "udp6";                                                                                                     // 231
  }                                                                                                                    // 232
                                                                                                                       //
  return type;                                                                                                         // 234
};                                                                                                                     // 235
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate, tls) {                                                                      // 238
    _classCallCheck(this, IpNetworkImpl);                                                                              // 238
                                                                                                                       //
    var _this3 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 238
                                                                                                                       //
    _this3.tls = tls;                                                                                                  // 240
    return _this3;                                                                                                     // 238
  }                                                                                                                    // 241
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function () {                                                                //
    function getRemoteHost(address) {                                                                                  //
      // Note that TLS typically authenticates hostnames, not raw IP addresses. So if `this.tls`                       // 244
      // is true, then the returned `IpRemoteHost` will likely refuse to make any connections.                         // 245
      // However, we keep that code path active because there is in principle no reason why it                         // 246
      // should always fail, and we wish to allow for a possible future in which we let users                          // 247
      // specify custom certificate authorities, in which case it might be more likely for TLS                         // 248
      // to be expected to authenticate raw IP addresses.                                                              // 249
                                                                                                                       //
      return { host: new IpRemoteHostImpl(addressToString(address), this.tls) };                                       // 251
    }                                                                                                                  // 252
                                                                                                                       //
    return getRemoteHost;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function () {                                                          //
    function getRemoteHostByName(address) {                                                                            //
      return { host: new IpRemoteHostImpl(address, this.tls) };                                                        // 255
    }                                                                                                                  // 256
                                                                                                                       //
    return getRemoteHostByName;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 257
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    // 259
//   (ugh).                                                                                                            // 260
Meteor.startup(function () {                                                                                           // 261
  globalFrontendRefRegistry.register({                                                                                 // 262
    frontendRefField: "ipNetwork",                                                                                     // 263
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 264
                                                                                                                       //
    restore: function () {                                                                                             // 266
      function restore(db, saveTemplate, value) {                                                                      // 262
        return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate, "tls" in value.encryption), IpRpc.PersistentIpNetwork);
      }                                                                                                                // 270
                                                                                                                       //
      return restore;                                                                                                  // 262
    }(),                                                                                                               // 262
    validate: function () {                                                                                            // 272
      function validate(db, session, value) {                                                                          // 262
        check(value, { encryption: Match.OneOf({ none: null }, { tls: null }) });                                      // 273
                                                                                                                       //
        if (!session.userId) {                                                                                         // 275
          throw new Meteor.Error(403, "Not logged in.");                                                               // 276
        }                                                                                                              // 277
                                                                                                                       //
        return {                                                                                                       // 279
          descriptor: {                                                                                                // 280
            tags: [{                                                                                                   // 281
              id: IpRpc.IpNetwork.typeId,                                                                              // 283
              value: Capnp.serialize(IpRpc.IpNetwork.PowerboxTag, value)                                               // 284
            }]                                                                                                         // 282
          },                                                                                                           // 280
          requirements: [{ userIsAdmin: session.userId }],                                                             // 290
          frontendRef: value                                                                                           // 291
        };                                                                                                             // 279
      }                                                                                                                // 293
                                                                                                                       //
      return validate;                                                                                                 // 262
    }(),                                                                                                               // 262
    query: function () {                                                                                               // 295
      function query(db, userId, value) {                                                                              // 262
        var encryption = { none: null };                                                                               // 296
        if (value) {                                                                                                   // 297
          encryption = Capnp.parse(IpRpc.IpNetwork.PowerboxTag, value).encryption || encryption;                       // 298
        }                                                                                                              // 299
                                                                                                                       //
        if (userId && Meteor.users.findOne(userId).isAdmin) {                                                          // 301
          return [{                                                                                                    // 302
            _id: "frontendref-ipnetwork",                                                                              // 304
            frontendRef: { ipNetwork: { encryption: encryption } },                                                    // 305
            cardTemplate: "ipNetworkPowerboxCard"                                                                      // 306
          }];                                                                                                          // 303
        } else {                                                                                                       // 309
          return [];                                                                                                   // 310
        }                                                                                                              // 311
      }                                                                                                                // 312
                                                                                                                       //
      return query;                                                                                                    // 262
    }()                                                                                                                // 262
  });                                                                                                                  // 262
});                                                                                                                    // 314
                                                                                                                       //
var IpRemoteHostImpl = function () {                                                                                   //
  function IpRemoteHostImpl(address, tls) {                                                                            // 317
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 317
                                                                                                                       //
    this.address = address;                                                                                            // 318
    this.tls = tls;                                                                                                    // 319
  }                                                                                                                    // 320
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function () {                                                                //
    function getTcpPort(portNum) {                                                                                     //
      return { port: new TcpPortImpl(this.address, portNum, this.tls) };                                               // 323
    }                                                                                                                  // 324
                                                                                                                       //
    return getTcpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function () {                                                                //
    function getUdpPort(portNum) {                                                                                     //
      if (this.tls) {                                                                                                  // 327
        var error = new Error("Datagram Transport Layer Security is not yet supported");                               // 328
        error.kjType = "unimplemented";                                                                                // 329
        throw error;                                                                                                   // 330
      }                                                                                                                // 331
                                                                                                                       //
      return { port: new UdpPortImpl(this.address, portNum) };                                                         // 333
    }                                                                                                                  // 334
                                                                                                                       //
    return getUdpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 335
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 337
  function TcpPortImpl(address, portNum, tls) {                                                                        // 338
    _classCallCheck(this, TcpPortImpl);                                                                                // 338
                                                                                                                       //
    this.address = address;                                                                                            // 339
    this.port = portNum;                                                                                               // 340
    this.tls = tls;                                                                                                    // 341
  }                                                                                                                    // 342
                                                                                                                       //
  TcpPortImpl.prototype.connect = function () {                                                                        // 337
    function connect(downstream) {                                                                                     // 337
      var _this = this;                                                                                                // 345
      var resolved = false;                                                                                            // 346
      var connectMethod = Net.connect;                                                                                 // 347
      if (this.tls) {                                                                                                  // 348
        connectMethod = Tls.connect;                                                                                   // 349
      }                                                                                                                // 350
                                                                                                                       //
      return new Promise(function (resolve, reject) {                                                                  // 352
        var client = connectMethod({ host: _this.address, port: _this.port }, function () {                            // 353
          resolved = true;                                                                                             // 354
          resolve({ upstream: new ByteStreamConnection(client) });                                                     // 355
        });                                                                                                            // 356
                                                                                                                       //
        client.on("data", function (data) {                                                                            // 358
          downstream.write(data);                                                                                      // 359
        });                                                                                                            // 360
                                                                                                                       //
        client.on("close", function (hadError) {                                                                       // 362
          downstream.done();                                                                                           // 363
        });                                                                                                            // 364
                                                                                                                       //
        client.on("error", function (err) {                                                                            // 366
          if (resolved) {                                                                                              // 367
            client.write = errorWrite;                                                                                 // 368
          } else {                                                                                                     // 369
            // upstream hasn't been resolved yet, so it's safe to reject                                               // 370
            reject(err);                                                                                               // 371
          }                                                                                                            // 372
        });                                                                                                            // 373
      });                                                                                                              // 374
    }                                                                                                                  // 375
                                                                                                                       //
    return connect;                                                                                                    // 337
  }();                                                                                                                 // 337
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 337
}();                                                                                                                   // 337
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 378
  throw new Error("error occurred in connection");                                                                     // 379
};                                                                                                                     // 380
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 382
  function UdpPortImpl(address, portNum) {                                                                             // 383
    _classCallCheck(this, UdpPortImpl);                                                                                // 383
                                                                                                                       //
    this.address = address;                                                                                            // 384
    this.port = portNum;                                                                                               // 385
                                                                                                                       //
    var type = addressType(address);                                                                                   // 387
    this.socket = Dgram.createSocket(type);                                                                            // 388
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 // 390
    // This may be pointless since grains are killed frequently when not in use anyways                                // 391
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       // 393
    // and only send replies here.                                                                                     // 394
    // This will be changed to be correct when equality comparisons are added to capabilities.                         // 395
    this.returnPort = null;                                                                                            // 396
                                                                                                                       //
    var _this = this;                                                                                                  // 398
    this.socket.on("message", function (msg, rinfo) {                                                                  // 399
      if (_this.returnPort) {                                                                                          // 400
        _this.returnPort.send(msg, _this);                                                                             // 401
      }                                                                                                                // 402
    });                                                                                                                // 403
  }                                                                                                                    // 404
                                                                                                                       //
  UdpPortImpl.prototype.send = function () {                                                                           // 382
    function send(message, returnPort) {                                                                               // 382
      this.returnPort = returnPort;                                                                                    // 407
      this.socket.send(message, 0, message.length, this.port, this.address);                                           // 408
                                                                                                                       //
      // TODO(someday): use callback to catch errors and do something with them                                        // 410
    }                                                                                                                  // 411
                                                                                                                       //
    return send;                                                                                                       // 382
  }();                                                                                                                 // 382
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 382
}();                                                                                                                   // 382
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","smtp-server","mailparser","/imports/server/persistent.js","/imports/server/email.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var SMTPServer;module.import("smtp-server",{"SMTPServer":function(v){SMTPServer=v}});var MailParser;module.import("mailparser",{"MailParser":function(v){MailParser=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var rawSend;module.import("/imports/server/email.js",{"rawSend":function(v){rawSend=v}});var shouldRestartGrain;module.import("/imports/server/backend.js",{"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 25
var Future = Npm.require("fibers/future");                                                                             // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 29
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 30
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 37
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 38
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 40
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 42
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  // 44
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         // 45
//   after which their count will reset. We'd only check the timer when that user is trying to                         // 46
//   send a new message. This avoids a global query.                                                                   // 47
if (!Meteor.settings.replicaNumber) {                                                                                  // 48
  // only first replica                                                                                                // 48
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 49
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 53
}                                                                                                                      // 54
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 56
  var server = new SMTPServer({                                                                                        // 57
    banner: "Sandstorm Mail Server",                                                                                   // 58
    authOptional: true,                                                                                                // 59
    disabledCommands: ["STARTTLS", "AUTH"],                                                                            // 60
    onData: function () {                                                                                              // 61
      function onData(req, session, callback) {                                                                        // 61
        var mailparser = new MailParser();                                                                             // 62
        req.pipe(mailparser);                                                                                          // 63
                                                                                                                       //
        mailparser.on("end", function (mail) {                                                                         // 65
          // Wrap in outer promise for easier error handling.                                                          // 66
          Promise.resolve().then(function () {                                                                         // 67
            // Extract the 'from' address.                                                                             // 68
            var from = void 0;                                                                                         // 69
            if (mail.from && mail.from.length > 0) {                                                                   // 70
              // It's theoretically possible for the message to have multiple 'from' headers, but this                 // 71
              // never really happens in legitimate practice so we'll just take the first one.                         // 72
              from = mail.from[0];                                                                                     // 73
            } else {                                                                                                   // 74
              // The mail body is missing a 'From:' header. We'll use the bounce address instead,                      // 75
              // with the caveat that this is sometimes *not* the original sender                                      // 76
              // but rather some intermediate agent (e.g. a mailing list daemon). See:                                 // 77
              //   http://en.wikipedia.org/wiki/Bounce_address                                                         // 78
              // TODO(someday): Is this really right, or should we report a blank address instead?                     // 79
              from = { address: session.envelope.mailFrom, name: false };                                              // 80
            }                                                                                                          // 81
                                                                                                                       //
            var attachments = [];                                                                                      // 83
            if (mail.attachments) {                                                                                    // 84
              attachments = mail.attachments.map(function (attachment) {                                               // 85
                var disposition = attachment.contentDisposition || "attachment";                                       // 86
                disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';        // 87
                return {                                                                                               // 88
                  contentType: attachment.contentType,                                                                 // 89
                  contentDisposition: disposition,                                                                     // 90
                  contentId: attachment.contentId,                                                                     // 91
                  content: attachment.content                                                                          // 92
                };                                                                                                     // 88
              });                                                                                                      // 94
            }                                                                                                          // 95
                                                                                                                       //
            if (mail.replyTo && mail.replyTo.length > 1) {                                                             // 97
              console.error("More than one reply-to address address was received in an email.");                       // 98
            }                                                                                                          // 99
                                                                                                                       //
            var mailMessage = {                                                                                        // 101
              // Note that converting the date to nanoseconds actually goes outside the range of                       // 102
              // integers that Javascript can represent precisely. But this is OK because dates aren't                 // 103
              // precise anyway.                                                                                       // 104
              date: (mail.date || new Date()).getTime() * 1000000,                                                     // 105
              from: from,                                                                                              // 106
              to: mail.to,                                                                                             // 107
              cc: mail.cc || [],                                                                                       // 108
              bcc: mail.bcc || [],                                                                                     // 109
              replyTo: mail.replyTo && mail.replyTo[0] || {},                                                          // 110
              messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                 // 111
              references: mail.references || [],                                                                       // 112
              inReplyTo: mail.inReplyTo || [],                                                                         // 113
              subject: mail.subject || "",                                                                             // 114
              text: mail.text || null,                                                                                 // 115
              html: mail.html || null,                                                                                 // 116
              attachments: attachments                                                                                 // 117
            };                                                                                                         // 101
                                                                                                                       //
            // Get list of grain IDs.                                                                                  // 120
            var grainPublicIds = _.uniq(session.envelope.rcptTo.map(function (deliverTo) {                             // 121
              // smtp-server already validates that the address contains an @.                                         // 122
              // To simplify things, we ignore the hostname part of the address and assume that the                    // 123
              // message would not have been sent here if it weren't intended for our host. Usually                    // 124
              // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                      // 125
              // globally unique anyway, so an e-mail meant for another server presumably won't match                  // 126
              // any ID at this one anyway.                                                                            // 127
              var address = deliverTo.address;                                                                         // 121
                                                                                                                       //
              return address.slice(0, address.indexOf("@"));                                                           // 129
            }));                                                                                                       // 130
                                                                                                                       //
            // Deliver to each grain in parallel.                                                                      // 132
            return Promise.all(grainPublicIds.map(function (publicId) {                                                // 133
              // Wrap in a function so that we can call it recursively to retry.                                       // 134
              var tryDeliver = function () {                                                                           // 135
                function tryDeliver(retryCount) {                                                                      // 135
                  var grainId = void 0;                                                                                // 136
                  return inMeteor(function () {                                                                        // 137
                    var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                // 138
                    if (grain) {                                                                                       // 139
                      grainId = grain._id;                                                                             // 140
                      return globalBackend.continueGrain(grainId, retryCount > 0);                                     // 141
                    } else {                                                                                           // 142
                      // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command            // 143
                      // fails in this case, by adding an onRcptTo() callback.                                         // 144
                      throw new Error("No such grain: " + publicId);                                                   // 145
                    }                                                                                                  // 146
                  }).then(function (grainInfo) {                                                                       // 147
                    var supervisor = grainInfo.supervisor;                                                             // 148
                    var uiView = supervisor.getMainView().view;                                                        // 149
                                                                                                                       //
                    // Create an arbitrary struct to use as the session params. E-mail sessions actually               // 151
                    // require no params, but node-capnp won't let us pass null and we don't have an                   // 152
                    // EmptyStruct type available, so we just use EmailAddress, but any struct type would              // 153
                    // work.                                                                                           // 154
                    // TODO(cleanup): Fix node-capnp to accept null.                                                   // 155
                    var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                      // 156
                                                                                                                       //
                    // Create a new session of type HackEmailSession. This is a short-term hack until                  // 158
                    // persistent capabilities and the Powerbox are implemented. We need to pass along a               // 159
                    // HackSessionContext because old versions of sandstorm-http-bridge always use                     // 160
                    // the context of the most recent session; if an old RoundCube grain has a                         // 161
                    // WebSession open, receives an email, and then tries to send an email, the request                // 162
                    // will go out on the SessionContext associated with the HackEmailSession that                     // 163
                    // delivered the email.                                                                            // 164
                    var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
                    return session.send(mailMessage);                                                                  // 169
                  })["catch"](function (err) {                                                                         // 170
                    if (shouldRestartGrain(err, retryCount)) {                                                         // 171
                      return tryDeliver(retryCount + 1);                                                               // 172
                    } else {                                                                                           // 173
                      throw err;                                                                                       // 174
                    }                                                                                                  // 175
                  });                                                                                                  // 176
                }                                                                                                      // 177
                                                                                                                       //
                return tryDeliver;                                                                                     // 135
              }();                                                                                                     // 135
                                                                                                                       //
              return tryDeliver(0);                                                                                    // 179
            }));                                                                                                       // 180
          }).then(function () {                                                                                        // 181
            callback(null, "Message delivered");                                                                       // 182
          }, function (err) {                                                                                          // 183
            console.error("E-mail delivery failure:", err.stack);                                                      // 184
            var mailErr = new Error(err.message);                                                                      // 185
            err.responseCode = 451;                                                                                    // 186
            callback(err.message);                                                                                     // 187
          });                                                                                                          // 188
        });                                                                                                            // 189
      }                                                                                                                // 190
                                                                                                                       //
      return onData;                                                                                                   // 61
    }()                                                                                                                // 61
  });                                                                                                                  // 57
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 193
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 194
  } else {                                                                                                             // 195
    // We must be running `run-dev.sh`.                                                                                // 196
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 197
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 198
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 199
  }                                                                                                                    // 200
});                                                                                                                    // 201
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 203
  return inMeteor(function () {                                                                                        // 204
    var recipientCount = 0;                                                                                            // 205
    recipientCount += email.to ? email.to.length : 0;                                                                  // 206
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 207
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 208
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 209
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 214
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 216
    var userAddress = session._getUserAddress();                                                                       // 217
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          // 219
    if (!email.from) {                                                                                                 // 220
      email.from = {                                                                                                   // 221
        address: grainAddress                                                                                          // 222
      };                                                                                                               // 221
    }                                                                                                                  // 224
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 226
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 230
                                                                                                                       //
    // Unpack fields                                                                                                   // 232
    var from = email.from;                                                                                             // 204
    var to = email.to;                                                                                                 // 204
    var cc = email.cc;                                                                                                 // 204
    var bcc = email.bcc;                                                                                               // 204
    var replyTo = email.replyTo;                                                                                       // 204
    var subject = email.subject;                                                                                       // 204
    var text = email.text;                                                                                             // 204
    var html = email.html;                                                                                             // 204
                                                                                                                       //
                                                                                                                       //
    var options = {                                                                                                    // 235
      from: from,                                                                                                      // 236
      to: to,                                                                                                          // 237
      cc: cc,                                                                                                          // 238
      bcc: bcc,                                                                                                        // 239
      replyTo: replyTo,                                                                                                // 240
      subject: subject,                                                                                                // 241
      text: text,                                                                                                      // 242
      html: html,                                                                                                      // 243
      envelope: {                                                                                                      // 244
        from: grainAddress,                                                                                            // 245
        to: to,                                                                                                        // 246
        cc: cc,                                                                                                        // 247
        bcc: bcc                                                                                                       // 248
      }                                                                                                                // 244
    };                                                                                                                 // 235
                                                                                                                       //
    var headers = {};                                                                                                  // 252
    if (email.messageId) {                                                                                             // 253
      headers["message-id"] = email.messageId;                                                                         // 254
    }                                                                                                                  // 255
                                                                                                                       //
    if (email.references) {                                                                                            // 257
      headers["references"] = email.references; // jscs:ignore requireDotNotation                                      // 258
    }                                                                                                                  // 259
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 261
      headers["in-reply-to"] = email.inReplyTo;                                                                        // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (email.date) {                                                                                                  // 265
      var date = new Date(email.date / 1000000);                                                                       // 266
      if (!isNaN(date.getTime())) {                                                                                    // 267
        // Check to make sure date is valid                                                                            // 267
        headers["date"] = date.toUTCString(); // jscs:ignore requireDotNotation                                        // 268
      }                                                                                                                // 269
    }                                                                                                                  // 270
                                                                                                                       //
    options.headers = headers;                                                                                         // 272
                                                                                                                       //
    if (email.attachments) {                                                                                           // 274
      (function () {                                                                                                   // 274
        var attachments = [];                                                                                          // 275
        email.attachments.forEach(function (attachment) {                                                              // 276
          attachments.push({                                                                                           // 277
            filename: false, // Tell nodemailer not to generate a new filename.                                        // 278
            cid: attachment.contentId,                                                                                 // 279
            contentType: attachment.contentType,                                                                       // 280
            contentDisposition: attachment.contentDisposition,                                                         // 281
            content: attachment.content                                                                                // 282
          });                                                                                                          // 277
        });                                                                                                            // 284
        options.attachments = attachments;                                                                             // 285
      })();                                                                                                            // 274
    }                                                                                                                  // 286
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 288
    if (!grain) throw new Error("Grain does not exist.");                                                              // 289
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 290
                                                                                                                       //
    rawSend(options);                                                                                                  // 292
  }.bind(_this))["catch"](function (err) {                                                                             // 293
    console.error("Error sending e-mail:", err.stack);                                                                 // 294
    throw err;                                                                                                         // 295
  });                                                                                                                  // 296
};                                                                                                                     // 297
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 300
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 300
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 300
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 302
    _this2._services = params.services;                                                                                // 303
    return _this2;                                                                                                     // 300
  }                                                                                                                    // 304
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function () {                                                                    //
    function getId() {                                                                                                 //
      return { id: new Buffer(this._id, "base64") };                                                                   // 307
    }                                                                                                                  // 308
                                                                                                                       //
    return getId;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function () {                                                              //
    function verifyEmail(tabId, verification) {                                                                        //
      var _this3 = this;                                                                                               // 310
                                                                                                                       //
      return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                // 311
        if (verification.tabId !== tabId.toString("hex")) {                                                            // 312
          throw new Error("VerifiedEmail is from a different tab");                                                    // 313
        }                                                                                                              // 314
                                                                                                                       //
        if (_this3._services) {                                                                                        // 316
          // Since this verifier is restricted to specific services, only indicate a match if the                      // 317
          // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                         // 318
          // match all services, and therefore all VerifiedEmails.)                                                    // 319
          if (verification.verifierId !== _this3._id) {                                                                // 320
            throw new Error("VerifierEmail is for a different EmailVerifier.");                                        // 321
          }                                                                                                            // 322
        }                                                                                                              // 323
                                                                                                                       //
        return verification.address;                                                                                   // 325
      });                                                                                                              // 326
    }                                                                                                                  // 327
                                                                                                                       //
    return verifyEmail;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 328
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 331
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 331
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 331
  }                                                                                                                    // 333
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 336
  // Get all of the email addresses verified as belonging to the given user using the given                            // 337
  // verifier.                                                                                                         // 338
                                                                                                                       //
  var services = null;                                                                                                 // 340
  var couldAddAnother = true;                                                                                          // 341
                                                                                                                       //
  if (verifierId) {                                                                                                    // 343
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 344
    if (!verifier) return []; // invalid verifier                                                                      // 346
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 347
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 349
      // Limit to the listed services.                                                                                 // 350
      services = {};                                                                                                   // 351
      verifierInfo.services.forEach(function (service) {                                                               // 352
        return services[service] = true;                                                                               // 352
      });                                                                                                              // 352
      couldAddAnother = !!services.email;                                                                              // 353
    }                                                                                                                  // 354
  }                                                                                                                    // 355
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 357
  var emails = {}; // map address -> true, for uniquification                                                          // 358
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 359
    if (!services || services[identity.profile.service]) {                                                             // 360
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 361
        emails[email.email] = true;                                                                                    // 361
      });                                                                                                              // 361
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  return { emails: Object.keys(emails), couldAddAnother: couldAddAnother };                                            // 365
}                                                                                                                      // 366
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    // 368
//   (ugh).                                                                                                            // 369
Meteor.startup(function () {                                                                                           // 370
  globalFrontendRefRegistry.register({                                                                                 // 371
    frontendRefField: "emailVerifier",                                                                                 // 372
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 373
                                                                                                                       //
    restore: function () {                                                                                             // 375
      function restore(db, saveTemplate, params) {                                                                     // 371
        return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
      }                                                                                                                // 378
                                                                                                                       //
      return restore;                                                                                                  // 371
    }(),                                                                                                               // 371
    validate: function () {                                                                                            // 380
      function validate(db, session, value) {                                                                          // 371
        check(value, { services: Match.Optional([String]) });                                                          // 381
                                                                                                                       //
        var services = value.services;                                                                                 // 383
        if (services) {                                                                                                // 384
          services.forEach(function (service) {                                                                        // 385
            if (!Accounts.identityServices[service]) {                                                                 // 386
              throw new Error("No such identity service: " + service);                                                 // 387
            }                                                                                                          // 388
          });                                                                                                          // 389
        }                                                                                                              // 390
                                                                                                                       //
        value.id = Crypto.randomBytes(16).toString("base64");                                                          // 392
                                                                                                                       //
        return {                                                                                                       // 394
          descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                               // 395
          requirements: [],                                                                                            // 396
          frontendRef: value                                                                                           // 397
        };                                                                                                             // 394
      }                                                                                                                // 399
                                                                                                                       //
      return validate;                                                                                                 // 371
    }(),                                                                                                               // 371
    query: function () {                                                                                               // 401
      function query(db, userId, value) {                                                                              // 371
        var results = [];                                                                                              // 402
                                                                                                                       //
        results.push({                                                                                                 // 404
          _id: "emailverifier-all",                                                                                    // 405
          frontendRef: { emailVerifier: {} },                                                                          // 406
          cardTemplate: "emailVerifierPowerboxCard"                                                                    // 407
        });                                                                                                            // 404
                                                                                                                       //
        for (var name in meteorBabelHelpers.sanitizeForInObject(Accounts.identityServices)) {                          // 410
          if (Accounts.identityServices[name].isEnabled()) {                                                           // 411
            results.push({                                                                                             // 412
              _id: "emailverifier-" + name,                                                                            // 413
              frontendRef: { emailVerifier: { services: [name] } },                                                    // 414
              cardTemplate: "emailVerifierPowerboxCard"                                                                // 415
            });                                                                                                        // 412
          }                                                                                                            // 417
        };                                                                                                             // 418
                                                                                                                       //
        return results;                                                                                                // 420
      }                                                                                                                // 421
                                                                                                                       //
      return query;                                                                                                    // 371
    }()                                                                                                                // 371
  });                                                                                                                  // 371
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 424
    frontendRefField: "verifiedEmail",                                                                                 // 425
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 426
                                                                                                                       //
    restore: function () {                                                                                             // 428
      function restore(db, saveTemplate) {                                                                             // 424
        return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);       // 429
      }                                                                                                                // 431
                                                                                                                       //
      return restore;                                                                                                  // 424
    }(),                                                                                                               // 424
    validate: function () {                                                                                            // 433
      function validate(db, session, value) {                                                                          // 424
        check(value, { verifierId: Match.Optional(String), address: String });                                         // 434
                                                                                                                       //
        if (!session.userId) {                                                                                         // 436
          throw new Meteor.Error(403, "Not logged in.");                                                               // 437
        }                                                                                                              // 438
                                                                                                                       //
        // Verify that the address actually belongs to the user.                                                       // 440
                                                                                                                       //
        if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId).emails, value.address)) {              // 442
          throw new Meteor.Error(403, "User has no such verified address");                                            // 444
        }                                                                                                              // 445
                                                                                                                       //
        // Add the session's tabId.                                                                                    // 447
        value.tabId = session.tabId;                                                                                   // 448
                                                                                                                       //
        // Build the descriptor, which contains the verifier ID.                                                       // 450
        var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
        return {                                                                                                       // 455
          descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                              // 456
          requirements: [],                                                                                            // 457
          frontendRef: value                                                                                           // 458
        };                                                                                                             // 455
      }                                                                                                                // 460
                                                                                                                       //
      return validate;                                                                                                 // 424
    }(),                                                                                                               // 424
    query: function () {                                                                                               // 462
      function query(db, userId, value) {                                                                              // 424
        var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");
        var verified = getVerifiedEmails(db, userId, verifierId);                                                      // 465
        var result = verified.emails.map(function (address) {                                                          // 466
          return {                                                                                                     // 466
            _id: "email-" + address,                                                                                   // 467
            frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                              // 468
            cardTemplate: "verifiedEmailPowerboxCard",                                                                 // 469
            searchTerms: [address]                                                                                     // 470
          };                                                                                                           // 466
        });                                                                                                            // 466
                                                                                                                       //
        if (verified.couldAddAnother) {                                                                                // 473
          result.push({                                                                                                // 474
            _id: "email-add-a-new-one",                                                                                // 475
            frontendRef: { verifiedEmail: { verifierId: verifierId } },                                                // 476
            cardTemplate: "addNewVerifiedEmailPowerboxCard",                                                           // 477
            configureTemplate: "addNewVerifiedEmailPowerboxConfiguration"                                              // 478
          });                                                                                                          // 474
        }                                                                                                              // 480
                                                                                                                       //
        return result;                                                                                                 // 482
      }                                                                                                                // 483
                                                                                                                       //
      return query;                                                                                                    // 424
    }()                                                                                                                // 424
  });                                                                                                                  // 424
});                                                                                                                    // 485
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js","/imports/server/migrations.js","/imports/constants.js","/imports/server/async-helpers.js","fibers","url","capnp",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var migrateToLatest;module.import("/imports/server/migrations.js",{"migrateToLatest":function(v){migrateToLatest=v}});var ACCOUNT_DELETION_SUSPENSION_TIME;module.import("/imports/constants.js",{"ACCOUNT_DELETION_SUSPENSION_TIME":function(v){ACCOUNT_DELETION_SUSPENSION_TIME=v}});var onInMeteor;module.import("/imports/server/async-helpers.js",{"onInMeteor":function(v){onInMeteor=v}});var Fiber;module.import("fibers",{"default":function(v){Fiber=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
var url = require("url");                                                                                              // 23
var Capnp = require("capnp");                                                                                          // 24
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 26
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 28
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 30
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     // 31
  //   first runs. Move it into an import.                                                                             // 32
  Meteor.startup(function () {                                                                                         // 33
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 34
  });                                                                                                                  // 36
}                                                                                                                      // 37
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 39
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 41
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           // 42
  //   packages to actually use the DB, but it's pretty sad.                                                           // 43
  connection.sandstormDb = globalDb;                                                                                   // 44
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 45
});                                                                                                                    // 46
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 47
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxTokens(globalDb));               // 48
SandstormDb.periodicCleanup(60 * 60 * 1000, function () {                                                              // 50
  globalDb.cleanupExpiredAssetUploads();                                                                               // 51
});                                                                                                                    // 52
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 53
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 54
});                                                                                                                    // 55
var deleteAccount = global.BlackrockPayments && global.BlackrockPayments.deleteAccount;                                // 56
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 57
  globalDb.deletePendingAccounts(ACCOUNT_DELETION_SUSPENSION_TIME, globalBackend, deleteAccount);                      // 58
});                                                                                                                    // 60
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 62
  migrateToLatest(globalDb, globalBackend);                                                                            // 62
});                                                                                                                    // 62
                                                                                                                       //
// If there are multiple replicas, prefix every log message with our replica number.                                   // 64
if ("replicaNumber" in Meteor.settings) {                                                                              // 65
  (function () {                                                                                                       // 65
    var patchConsole = function patchConsole(name) {                                                                   // 65
      var old = console[name];                                                                                         // 69
      console[name] = function () {                                                                                    // 70
        // Meteor in dev mode writes "LISTENING" to tell the dev runner that it's ready to accept                      // 71
        // connections.                                                                                                // 72
        if (arguments.length == 1 && arguments[0] == "LISTENING") {                                                    // 73
          old.apply(this, arguments);                                                                                  // 74
        } else {                                                                                                       // 75
          old.apply(this, [prefix].concat(Array.prototype.slice.call(arguments)));                                     // 76
        }                                                                                                              // 77
      };                                                                                                               // 78
    };                                                                                                                 // 79
                                                                                                                       //
    var prefix = "replica" + Meteor.settings.replicaNumber.toString() + ":";                                           // 66
                                                                                                                       //
    patchConsole("log");                                                                                               // 81
    patchConsole("info");                                                                                              // 82
    patchConsole("warn");                                                                                              // 83
    patchConsole("error");                                                                                             // 84
  })();                                                                                                                // 65
}                                                                                                                      // 85
                                                                                                                       //
// Make the fiber pool size infinite(ish)!                                                                             // 87
//                                                                                                                     // 88
// Each fiber created adds an entry to `v8::Isolate::ThreadDataTable`. Unfortunatley, items are                        // 89
// never deleted from this table. So if we create and delete a lot of fibers, then we leak memory.                     // 90
// Worse yet, the table is represented as a linked list, and v8 performs a linear scan of this                         // 91
// linked list every time we switch fibers. We've seen cases where Sandstorm was spending 65% of                       // 92
// its CPU time just scanning this list! The v8 people say this is "working as intended".                              // 93
//                                                                                                                     // 94
// The fibers package has implemented a work-around by maintaining a fiber pool. Fibers are not                        // 95
// deleted; they are returned to the pool. Unfortunately the pool has a default size of 120. So                        // 96
// if we pass 120 simultaneous fibers, we start leaking and slowing down. It's very easy to hit                        // 97
// this number with a few dozen users present.                                                                         // 98
//                                                                                                                     // 99
// Up until it hits the limit, the fibers module will grow the pool dynamically, starting with an                      // 100
// empty pool and adding each new fiber to it. Therefore, if we set the pool size to an impossibly                     // 101
// large number, we effectively get a pool size equal to the maximum number of simultaneous fibers                     // 102
// seen. This is exactly what we want! Now no fibers are ever deleted, so we never leak. A                             // 103
// Sandstorm server that sees a brief surge of traffic may end up holding on to unused RAM                             // 104
// long-term, but this is a relatively obscure problem.                                                                // 105
//                                                                                                                     // 106
// I initially tried to use the value `Infinity` here, but somehow when this made its way down into                    // 107
// the C++ code and was converted to an integer, that integer ended up being zero. So instead we                       // 108
// use 1e9 (1 billion), which ought to be enough for anyone.                                                           // 109
//                                                                                                                     // 110
// Third-party issues, for reference:                                                                                  // 111
//                                                                                                                     // 112
//    https://bugs.chromium.org/p/v8/issues/detail?id=5338                                                             // 113
//    https://bugs.chromium.org/p/v8/issues/detail?id=3777                                                             // 114
//    https://github.com/laverdet/node-fibers/issues/305                                                               // 115
                                                                                                                       // 116
Fiber.poolSize = 1e9;                                                                                                  // 117
                                                                                                                       //
// Special debugging enabled on Blackrock only.                                                                        // 119
if ("replicaNumber" in Meteor.settings) {                                                                              // 120
  (function () {                                                                                                       // 120
    var sampleStackIfTooManyFibers = function sampleStackIfTooManyFibers() {                                           // 120
      if (Fiber.fibersCreated > TOO_MANY_FIBERS && sampleCounter++ % FIBER_SAMPLING_PERIOD == 0) {                     // 145
        var stack = new Error().stack;                                                                                 // 146
        console.warn("There are too many fibers!", stack);                                                             // 147
      }                                                                                                                // 148
    };                                                                                                                 // 149
                                                                                                                       //
    // Sample calls to inMeteor().                                                                                     // 151
                                                                                                                       //
                                                                                                                       //
    // Also take samples from various Meteor infrastructure that schedules fibers.                                     // 154
    var addFiberSampling = function addFiberSampling(prototype, functionName) {                                        // 120
      var old = prototype[functionName];                                                                               // 156
      prototype[functionName] = function () {                                                                          // 157
        sampleStackIfTooManyFibers();                                                                                  // 158
        return old.apply(this, arguments);                                                                             // 159
      };                                                                                                               // 160
    };                                                                                                                 // 161
                                                                                                                       //
    console.warn("Fiber bomb defense enabled.");                                                                       // 121
                                                                                                                       //
    // TEMPORARY: Monitor the number of fibers created and kill the process any time it goes over                      // 123
    //   2000. Unfortunately, due to the aforementioned linked list in ThreadDataTable, the process                    // 124
    //   will become unreasonably slow once the list gets this big. It's better to kill the process                    // 125
    //   so that it restarts fresh rather than to let the Sandstorm server become unresponsive.                        // 126
    // TODO(soon): Remove this when the bug is fixed.                                                                  // 127
    setInterval(function () {                                                                                          // 128
      if (Fiber.fibersCreated > 2000) {                                                                                // 129
        console.error("Process has allocated more than 2000 concurrent fibers. Due to " + "https://bugs.chromium.org/p/v8/issues/detail?id=5338 it will become extremely slow " + "unless we restart it. ABORTING");
        process.abort();                                                                                               // 134
      }                                                                                                                // 135
    }, 5000);                                                                                                          // 136
                                                                                                                       //
    // Let's also log some stack traces when fiber count gets high so we can find out what's                           // 138
    // happening.                                                                                                      // 139
    var TOO_MANY_FIBERS = 1000; // Start sampling when we have more than this many fibers.                             // 140
    var FIBER_SAMPLING_PERIOD = 100; // Sample one stack per this many fibers created.                                 // 141
                                                                                                                       //
    var sampleCounter = 0;                                                                                             // 143
    onInMeteor(sampleStackIfTooManyFibers);                                                                            // 152
                                                                                                                       //
    addFiberSampling(Meteor._SynchronousQueue.prototype, "runTask");                                                   // 163
    addFiberSampling(Meteor._SynchronousQueue.prototype, "queueTask");                                                 // 164
    addFiberSampling(Meteor, "bindEnvironment");                                                                       // 165
  })();                                                                                                                // 120
}                                                                                                                      // 166
                                                                                                                       //
if ("replicaNumber" in Meteor.settings) {                                                                              // 168
  // On Blackrock, dump debug info about local capability counts every minute.                                         // 169
  Meteor.setInterval(Capnp.dumpLocalCapTypeCounts, 60000);                                                             // 170
}                                                                                                                      // 171
                                                                                                                       //
OAuth._checkRedirectUrlOrigin = function (redirectUrl) {                                                               // 173
  // Mostly copied from meteor/packages/oauth/oauth_server.js                                                          // 174
  // We override this method in order to support login from stand-alone grain domains.                                 // 175
  var appHost = Meteor.absoluteUrl();                                                                                  // 176
  var appHostReplacedLocalhost = Meteor.absoluteUrl(undefined, {                                                       // 177
    replaceLocalhost: true                                                                                             // 178
  });                                                                                                                  // 177
                                                                                                                       //
  var redirectParsed = url.parse(redirectUrl);                                                                         // 181
                                                                                                                       //
  return !(redirectUrl.substr(0, appHost.length) === appHost || redirectUrl.substr(0, appHostReplacedLocalhost.length) === appHostReplacedLocalhost || globalDb.hostIsStandalone(redirectParsed.hostname));
};                                                                                                                     // 188
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"account-suspension.js":["/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/account-suspension.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var send;module.import("/imports/server/email.js",{"send":function(v){send=v}});// Sandstorm - Personal Cloud Sandbox  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
function sendDeletionEmails(db, deletedUserId, byAdminUserId, feedback) {                                              // 19
  var deletedUser = db.getUser(deletedUserId);                                                                         // 20
                                                                                                                       //
  var userEmail = _.findWhere(SandstormDb.getUserEmails(deletedUser), { primary: true });                              // 22
  if (!byAdminUserId) {                                                                                                // 23
    // This was initiated by the user, send them an email                                                              // 23
    if (!userEmail) {                                                                                                  // 24
      console.error("Couldn't send deletion email. No address found for user with userId:", deletedUser._id);          // 25
    } else {                                                                                                           // 27
      var _emailOptions = {                                                                                            // 28
        from: db.getReturnAddress(),                                                                                   // 29
        subject: "Your account on " + db.getServerTitle() + " will be deleted in 7 days.",                             // 30
        text: "You have requested that your Sandstorm account on " + db.getServerTitle() + " be deleted. Your account has been suspended and will be fully deleted in seven days. If you change your mind, log into " + process.env.ROOT_URL + " to cancel the process.\n\nIf you did not request this deletion, please contact the server administrator immediately."
      };                                                                                                               // 28
      try {                                                                                                            // 35
        _emailOptions.to = userEmail.email;                                                                            // 36
        send(_emailOptions);                                                                                           // 37
      } catch (err) {                                                                                                  // 38
        console.error("Failed to send deletion email to user (id=" + deletedUser._id + ") with error: " + err);        // 39
      }                                                                                                                // 41
    }                                                                                                                  // 42
  }                                                                                                                    // 43
                                                                                                                       //
  var deleteUserString = userEmail && userEmail.email || "userId=" + deletedUser._id;                                  // 45
  var emailOptions = {                                                                                                 // 46
    from: db.getReturnAddress(),                                                                                       // 47
    subject: "Account for " + deleteUserString + " on " + db.getServerTitle() + " will be deleted in 7 days"           // 48
  };                                                                                                                   // 46
                                                                                                                       //
  if (byAdminUserId) {                                                                                                 // 51
    var initiatingAdmin = db.getUser(byAdminUserId);                                                                   // 52
    var adminName = db.getIdentity(initiatingAdmin.loginIdentities[0].id).profile.name;                                // 53
    emailOptions.text = adminName + " has requested that the Sandstorm account held by " + deleteUserString + " on " + db.getServerTitle() + " be deleted. The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
  } else {                                                                                                             // 55
    emailOptions.text = deleteUserString + " has requested that their account be deleted on " + db.getServerTitle() + ". The account has been suspended and will be fully deleted in seven days. To cancel the deletion, go to: " + process.env.ROOT_URL + "/admin/users/" + deletedUser._id;
    if (feedback) {                                                                                                    // 57
      emailOptions.text += "\nUser gave the following feedback: " + feedback;                                          // 58
    }                                                                                                                  // 59
  }                                                                                                                    // 60
                                                                                                                       //
  Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                                       // 62
    var email = _.findWhere(SandstormDb.getUserEmails(user), { primary: true });                                       // 63
    if (!email) {                                                                                                      // 64
      console.error("No email found for admin with userId:", user._id);                                                // 65
      return;                                                                                                          // 66
    }                                                                                                                  // 67
                                                                                                                       //
    try {                                                                                                              // 69
      emailOptions.to = email.email;                                                                                   // 70
      send(emailOptions);                                                                                              // 71
    } catch (err) {                                                                                                    // 72
      console.error("Failed to send deletion email to admin (id=" + user._id + ") with error: " + err);                // 73
    }                                                                                                                  // 75
  });                                                                                                                  // 76
}                                                                                                                      // 77
                                                                                                                       //
Meteor.methods({                                                                                                       // 79
  suspendAccount: function () {                                                                                        // 80
    function suspendAccount(userId, willDelete) {                                                                      // 79
      check(userId, String);                                                                                           // 81
      check(willDelete, Boolean);                                                                                      // 82
                                                                                                                       //
      if (!isAdmin()) {                                                                                                // 84
        throw new Meteor.Error(403, "Only admins can suspend other users.");                                           // 85
      }                                                                                                                // 86
                                                                                                                       //
      if (userId === Meteor.userId()) {                                                                                // 88
        throw new Meteor.Error(400, "Admins cannot suspend their own accounts from the admin page. Please go to your account setttings.");
      }                                                                                                                // 90
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 92
                                                                                                                       //
      if (global.BlackrockPayments) {                                                                                  // 94
        BlackrockPayments.suspendAccount(db, userId);                                                                  // 95
      }                                                                                                                // 96
                                                                                                                       //
      db.suspendAccount(userId, Meteor.userId(), willDelete);                                                          // 98
                                                                                                                       //
      if (willDelete) {                                                                                                // 100
        sendDeletionEmails(db, userId, Meteor.userId());                                                               // 101
      }                                                                                                                // 102
    }                                                                                                                  // 103
                                                                                                                       //
    return suspendAccount;                                                                                             // 79
  }(),                                                                                                                 // 79
  deleteOwnAccount: function () {                                                                                      // 105
    function deleteOwnAccount(feedback) {                                                                              // 79
      var db = this.connection.sandstormDb;                                                                            // 106
      if (!Meteor.userId()) {                                                                                          // 107
        throw new Meteor.Error(403, "Must be logged in to delete an account");                                         // 108
      }                                                                                                                // 109
                                                                                                                       //
      if (db.isUserInOrganization(Meteor.user())) {                                                                    // 111
        throw new Meteor.Error(403, "Users in an organization cannot delete their own account. " + "Please ask your admin to do it for you.");
      }                                                                                                                // 114
                                                                                                                       //
      if (global.BlackrockPayments) {                                                                                  // 116
        BlackrockPayments.suspendAccount(db, Meteor.userId());                                                         // 117
      }                                                                                                                // 118
                                                                                                                       //
      db.suspendAccount(Meteor.userId(), null, true);                                                                  // 120
                                                                                                                       //
      sendDeletionEmails(db, Meteor.userId(), null, feedback);                                                         // 122
    }                                                                                                                  // 123
                                                                                                                       //
    return deleteOwnAccount;                                                                                           // 79
  }(),                                                                                                                 // 79
  unsuspendAccount: function () {                                                                                      // 125
    function unsuspendAccount(userId) {                                                                                // 79
      check(userId, String);                                                                                           // 126
                                                                                                                       //
      if (!isAdmin()) {                                                                                                // 128
        throw new Meteor.Error(403, "Only admins can unsuspend other users.");                                         // 129
      }                                                                                                                // 130
                                                                                                                       //
      this.connection.sandstormDb.unsuspendAccount(userId, Meteor.userId());                                           // 132
    }                                                                                                                  // 133
                                                                                                                       //
    return unsuspendAccount;                                                                                           // 79
  }(),                                                                                                                 // 79
  unsuspendOwnAccount: function () {                                                                                   // 135
    function unsuspendOwnAccount() {                                                                                   // 79
      if (!Meteor.userId()) {                                                                                          // 136
        throw new Meteor.Error(403, "Must be logged in to unsuspend an account");                                      // 137
      }                                                                                                                // 138
                                                                                                                       //
      this.connection.sandstormDb.unsuspendAccount(Meteor.userId());                                                   // 140
    }                                                                                                                  // 141
                                                                                                                       //
    return unsuspendOwnAccount;                                                                                        // 79
  }()                                                                                                                  // 79
});                                                                                                                    // 79
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","heapdump","/imports/server/constants.js","/imports/server/auth.js","/imports/server/email.js","/imports/server/observe-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});var SANDSTORM_LOGDIR;module.import("/imports/server/constants.js",{"SANDSTORM_LOGDIR":function(v){SANDSTORM_LOGDIR=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});var fillUndefinedForChangedDoc;module.import("/imports/server/observe-helpers.js",{"fillUndefinedForChangedDoc":function(v){fillUndefinedForChangedDoc=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whiteLabelHideAbout", "whitelabelUseServerTitleForHomeText", "quotaEnabled", "quotaLdapEnabled", "billingPromptUrl"];
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 43
  hostname: String,                                                                                                    // 44
  port: Number,                                                                                                        // 45
  auth: {                                                                                                              // 46
    user: String,                                                                                                      // 47
    pass: String                                                                                                       // 48
  },                                                                                                                   // 46
  returnAddress: String                                                                                                // 50
};                                                                                                                     // 43
                                                                                                                       //
Meteor.methods({                                                                                                       // 53
  setAccountSetting: function () {                                                                                     // 54
    function setAccountSetting(token, serviceName, value) {                                                            // 54
      checkAuth(token);                                                                                                // 55
      check(serviceName, String);                                                                                      // 56
      check(value, Boolean);                                                                                           // 57
                                                                                                                       //
      // TODO(someday): currently this relies on the fact that an account is tied to a single                          // 59
      // identity, and thus has only that entry in "services". This will need to be looked at when                     // 60
      // multiple login methods/identities are allowed for a single account.                                           // 61
      if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {    // 62
        throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                  // 63
      }                                                                                                                // 65
                                                                                                                       //
      // Only check configurations for OAuth services.                                                                 // 67
      var oauthServices = ["google", "github"];                                                                        // 68
      if (value && oauthServices.indexOf(serviceName) != -1) {                                                         // 69
        var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                              // 70
        var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                            // 71
        if (!config) {                                                                                                 // 72
          throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              // 75
                                                                                                                       //
        if (!config.clientId || !config.secret) {                                                                      // 77
          throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              // 80
      }                                                                                                                // 81
                                                                                                                       //
      Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                               // 83
      if (value) {                                                                                                     // 84
        Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                  // 85
      }                                                                                                                // 86
    }                                                                                                                  // 87
                                                                                                                       //
    return setAccountSetting;                                                                                          // 54
  }(),                                                                                                                 // 54
                                                                                                                       //
  setSmtpConfig: function () {                                                                                         // 89
    function setSmtpConfig(token, config) {                                                                            // 89
      checkAuth(token);                                                                                                // 90
      check(config, smtpConfigShape);                                                                                  // 91
                                                                                                                       //
      Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                             // 93
    }                                                                                                                  // 94
                                                                                                                       //
    return setSmtpConfig;                                                                                              // 89
  }(),                                                                                                                 // 89
                                                                                                                       //
  disableEmail: function () {                                                                                          // 96
    function disableEmail(token) {                                                                                     // 96
      checkAuth(token);                                                                                                // 97
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 99
      db.collections.settings.update({ _id: "smtpConfig" }, { $set: { "value.hostname": "" } });                       // 100
    }                                                                                                                  // 101
                                                                                                                       //
    return disableEmail;                                                                                               // 96
  }(),                                                                                                                 // 96
                                                                                                                       //
  setSetting: function () {                                                                                            // 103
    function setSetting(token, name, value) {                                                                          // 103
      checkAuth(token);                                                                                                // 104
      check(name, String);                                                                                             // 105
      check(value, Match.OneOf(null, String, Date, Boolean));                                                          // 106
                                                                                                                       //
      Settings.upsert({ _id: name }, { $set: { value: value } });                                                      // 108
    }                                                                                                                  // 109
                                                                                                                       //
    return setSetting;                                                                                                 // 103
  }(),                                                                                                                 // 103
                                                                                                                       //
  saveOrganizationSettings: function () {                                                                              // 111
    function saveOrganizationSettings(token, params) {                                                                 // 53
      checkAuth(token);                                                                                                // 112
      check(params, {                                                                                                  // 113
        membership: {                                                                                                  // 114
          emailToken: {                                                                                                // 115
            enabled: Boolean,                                                                                          // 116
            domain: String                                                                                             // 117
          },                                                                                                           // 115
          google: {                                                                                                    // 119
            enabled: Boolean,                                                                                          // 120
            domain: String                                                                                             // 121
          },                                                                                                           // 119
          ldap: {                                                                                                      // 123
            enabled: Boolean                                                                                           // 124
          },                                                                                                           // 123
          saml: {                                                                                                      // 126
            enabled: Boolean                                                                                           // 127
          }                                                                                                            // 126
        },                                                                                                             // 114
        settings: {                                                                                                    // 130
          disallowGuests: Boolean,                                                                                     // 131
          shareContacts: Boolean                                                                                       // 132
        }                                                                                                              // 130
      });                                                                                                              // 113
                                                                                                                       //
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
    }                                                                                                                  // 138
                                                                                                                       //
    return saveOrganizationSettings;                                                                                   // 53
  }(),                                                                                                                 // 53
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function () {                                                                            // 140
    function adminConfigureLoginService(token, options) {                                                              // 140
      checkAuth(token);                                                                                                // 141
      check(options, Match.ObjectIncluding({ service: String }));                                                      // 142
                                                                                                                       //
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 144
                                                                                                                       //
      ServiceConfiguration.configurations.upsert({ service: options.service }, options);                               // 146
    }                                                                                                                  // 147
                                                                                                                       //
    return adminConfigureLoginService;                                                                                 // 140
  }(),                                                                                                                 // 140
                                                                                                                       //
  clearResumeTokensForService: function () {                                                                           // 149
    function clearResumeTokensForService(token, serviceName) {                                                         // 149
      checkAuth(token);                                                                                                // 150
      check(serviceName, String);                                                                                      // 151
                                                                                                                       //
      var query = {};                                                                                                  // 153
      query["services." + serviceName] = { $exists: true };                                                            // 154
      Meteor.users.find(query).forEach(function (identity) {                                                           // 155
        if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
          Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                 // 158
        }                                                                                                              // 159
                                                                                                                       //
        Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });  // 161
      });                                                                                                              // 163
    }                                                                                                                  // 164
                                                                                                                       //
    return clearResumeTokensForService;                                                                                // 149
  }(),                                                                                                                 // 149
                                                                                                                       //
  adminUpdateUser: function () {                                                                                       // 166
    function adminUpdateUser(token, userInfo) {                                                                        // 166
      checkAuth(token);                                                                                                // 167
      check(userInfo, {                                                                                                // 168
        userId: String,                                                                                                // 169
        signupKey: Boolean,                                                                                            // 170
        isAdmin: Boolean                                                                                               // 171
      });                                                                                                              // 168
                                                                                                                       //
      var userId = userInfo.userId;                                                                                    // 174
      if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                           // 175
        throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                              // 176
      }                                                                                                                // 177
                                                                                                                       //
      Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                             // 179
    }                                                                                                                  // 180
                                                                                                                       //
    return adminUpdateUser;                                                                                            // 166
  }(),                                                                                                                 // 166
                                                                                                                       //
  testSend: function () {                                                                                              // 182
    function testSend(token, smtpConfig, to) {                                                                         // 182
      checkAuth(token);                                                                                                // 183
      check(smtpConfig, smtpConfigShape);                                                                              // 184
      check(to, String);                                                                                               // 185
      var returnAddress = smtpConfig.returnAddress;                                                                    // 182
                                                                                                                       //
      var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                        // 182
                                                                                                                       //
      try {                                                                                                            // 188
        sendEmail({                                                                                                    // 189
          to: to,                                                                                                      // 190
          from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                // 191
          subject: "Testing your Sandstorm's SMTP setting",                                                            // 192
          text: "Success! Your outgoing SMTP is working.",                                                             // 193
          smtpConfig: restConfig                                                                                       // 194
        });                                                                                                            // 189
      } catch (e) {                                                                                                    // 196
        // Attempt to give more accurate error messages for a variety of known failure modes,                          // 197
        // and the actual exception data in the event a user hits a new failure mode.                                  // 198
        if (e.syscall === "getaddrinfo") {                                                                             // 199
          if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                            // 200
            throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
          }                                                                                                            // 202
        } else if (e.syscall === "connect") {                                                                          // 203
          if (e.code === "ECONNREFUSED") {                                                                             // 204
            throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
          }                                                                                                            // 206
        } else if (e.name === "AuthError") {                                                                           // 207
          throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
        }                                                                                                              // 210
                                                                                                                       //
        throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
      }                                                                                                                // 213
    }                                                                                                                  // 214
                                                                                                                       //
    return testSend;                                                                                                   // 182
  }(),                                                                                                                 // 182
                                                                                                                       //
  createSignupKey: function () {                                                                                       // 216
    function createSignupKey(token, note, quota) {                                                                     // 216
      checkAuth(token);                                                                                                // 217
      check(note, String);                                                                                             // 218
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 219
                                                                                                                       //
      var key = Random.id();                                                                                           // 221
      var content = { _id: key, used: false, note: note };                                                             // 222
      if (typeof quota === "number") content.quota = quota;                                                            // 223
      SignupKeys.insert(content);                                                                                      // 224
      return key;                                                                                                      // 225
    }                                                                                                                  // 226
                                                                                                                       //
    return createSignupKey;                                                                                            // 216
  }(),                                                                                                                 // 216
                                                                                                                       //
  sendInvites: function () {                                                                                           // 228
    function sendInvites(token, origin, from, list, subject, message, quota) {                                         // 228
      checkAuth(token);                                                                                                // 229
      check([origin, from, list, subject, message], [String]);                                                         // 230
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 231
                                                                                                                       //
      if (!from.trim()) {                                                                                              // 233
        throw new Meteor.Error(403, "Must enter 'from' address.");                                                     // 234
      }                                                                                                                // 235
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 237
        throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                     // 238
      }                                                                                                                // 239
                                                                                                                       //
      this.unblock();                                                                                                  // 241
                                                                                                                       //
      list = list.split("\n");                                                                                         // 243
      for (var i in meteorBabelHelpers.sanitizeForInObject(list)) {                                                    // 244
        var email = list[i].trim();                                                                                    // 245
                                                                                                                       //
        if (email) {                                                                                                   // 247
          var key = Random.id();                                                                                       // 248
                                                                                                                       //
          var content = {                                                                                              // 250
            _id: key,                                                                                                  // 251
            used: false,                                                                                               // 252
            note: "E-mail invite to " + email,                                                                         // 253
            email: email,                                                                                              // 254
            definitelySent: false                                                                                      // 255
          };                                                                                                           // 250
          if (typeof quota === "number") content.quota = quota;                                                        // 257
          SignupKeys.insert(content);                                                                                  // 258
          sendEmail({                                                                                                  // 259
            to: email,                                                                                                 // 260
            from: from,                                                                                                // 261
            envelopeFrom: globalDb.getReturnAddress(),                                                                 // 262
            subject: subject,                                                                                          // 263
            text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                 // 264
          });                                                                                                          // 259
          SignupKeys.update(key, { $set: { definitelySent: true } });                                                  // 266
        }                                                                                                              // 267
      }                                                                                                                // 268
                                                                                                                       //
      return { sent: true };                                                                                           // 270
    }                                                                                                                  // 271
                                                                                                                       //
    return sendInvites;                                                                                                // 228
  }(),                                                                                                                 // 228
                                                                                                                       //
  adminToggleDisableCap: function () {                                                                                 // 273
    function adminToggleDisableCap(token, capId, value) {                                                              // 273
      checkAuth(token);                                                                                                // 274
      check(capId, String);                                                                                            // 275
      check(value, Boolean);                                                                                           // 276
                                                                                                                       //
      if (value) {                                                                                                     // 278
        ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                 // 279
      } else {                                                                                                         // 280
        ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                // 281
      }                                                                                                                // 282
    }                                                                                                                  // 283
                                                                                                                       //
    return adminToggleDisableCap;                                                                                      // 273
  }(),                                                                                                                 // 273
                                                                                                                       //
  updateQuotas: function () {                                                                                          // 285
    function updateQuotas(token, list, quota) {                                                                        // 285
      checkAuth(token);                                                                                                // 286
      check(list, String);                                                                                             // 287
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 288
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 290
        throw new Meteor.Error(400, "Must enter addresses.");                                                          // 291
      }                                                                                                                // 292
                                                                                                                       //
      var items = list.split("\n");                                                                                    // 294
      var invalid = [];                                                                                                // 295
      for (var i in meteorBabelHelpers.sanitizeForInObject(items)) {                                                   // 296
        var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };             // 297
        var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                     // 299
        n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                // 300
                                                                                                                       //
        if (n < 1) invalid.push(items[i]);                                                                             // 302
      }                                                                                                                // 303
                                                                                                                       //
      if (invalid.length > 0) {                                                                                        // 305
        throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));      // 306
      }                                                                                                                // 308
    }                                                                                                                  // 309
                                                                                                                       //
    return updateQuotas;                                                                                               // 285
  }(),                                                                                                                 // 285
                                                                                                                       //
  dismissAdminStatsNotifications: function () {                                                                        // 311
    function dismissAdminStatsNotifications(token) {                                                                   // 311
      checkAuth(token);                                                                                                // 312
      globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                      // 313
    }                                                                                                                  // 314
                                                                                                                       //
    return dismissAdminStatsNotifications;                                                                             // 311
  }(),                                                                                                                 // 311
                                                                                                                       //
  signUpAsAdmin: function () {                                                                                         // 316
    function signUpAsAdmin(token) {                                                                                    // 316
      check(token, String);                                                                                            // 317
      checkAuth(token);                                                                                                // 318
      if (!this.userId) {                                                                                              // 319
        throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                         // 320
      }                                                                                                                // 321
                                                                                                                       //
      if (!Meteor.user().loginIdentities) {                                                                            // 323
        throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                            // 324
      }                                                                                                                // 325
                                                                                                                       //
      Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                      // 327
      clearAdminToken(token);                                                                                          // 328
    }                                                                                                                  // 329
                                                                                                                       //
    return signUpAsAdmin;                                                                                              // 316
  }(),                                                                                                                 // 316
                                                                                                                       //
  redeemSetupToken: function () {                                                                                      // 331
    function redeemSetupToken(token) {                                                                                 // 53
      // Redeem an admin token into a setup session.                                                                   // 332
      check(token, String);                                                                                            // 333
      if (tokenIsValid(token)) {                                                                                       // 334
        var sessId = Random.secret();                                                                                  // 335
        var creationDate = new Date();                                                                                 // 336
        var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                             // 337
        this.connection.sandstormDb.collections.setupSession.upsert({                                                  // 338
          _id: "current-session"                                                                                       // 339
        }, {                                                                                                           // 338
          creationDate: creationDate,                                                                                  // 341
          hashedSessionId: hashedSessionId                                                                             // 342
        });                                                                                                            // 340
        // Then, invalidate the token, so one one else can use it.                                                     // 344
        clearAdminToken(token);                                                                                        // 345
        return sessId;                                                                                                 // 346
      } else {                                                                                                         // 347
        throw new Meteor.Error(401, "Invalid setup token");                                                            // 348
      }                                                                                                                // 349
    }                                                                                                                  // 350
                                                                                                                       //
    return redeemSetupToken;                                                                                           // 53
  }(),                                                                                                                 // 53
  heapdump: function () {                                                                                              // 352
    function heapdump() {                                                                                              // 53
      // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                               // 353
      //                                                                                                               // 354
      // Call this from the JS console like:                                                                           // 355
      //   Meteor.call("heapdump");                                                                                    // 356
                                                                                                                       //
      checkAuth();                                                                                                     // 358
                                                                                                                       //
      // We use /var/log because it's a location in the container to which the front-end is allowed                    // 360
      // to write.                                                                                                     // 361
      var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                           // 362
      Heapdump.writeSnapshot(name);                                                                                    // 363
      console.log("Wrote heapdump: /opt/sandstorm" + name);                                                            // 364
      return name;                                                                                                     // 365
    }                                                                                                                  // 366
                                                                                                                       //
    return heapdump;                                                                                                   // 53
  }(),                                                                                                                 // 53
                                                                                                                       //
                                                                                                                       //
  setPreinstalledApps: function () {                                                                                   // 368
    function setPreinstalledApps(appAndPackageIds) {                                                                   // 368
      checkAuth();                                                                                                     // 369
      check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                 // 370
                                                                                                                       //
      this.connection.sandstormDb.setPreinstalledApps(appAndPackageIds);                                               // 372
    }                                                                                                                  // 373
                                                                                                                       //
    return setPreinstalledApps;                                                                                        // 368
  }()                                                                                                                  // 368
});                                                                                                                    // 53
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 376
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 379
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 381
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 382
  return Settings.find();                                                                                              // 383
});                                                                                                                    // 384
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 386
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 387
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 388
});                                                                                                                    // 389
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 391
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 392
});                                                                                                                    // 393
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 395
  check(token, String);                                                                                                // 396
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 397
  this.ready();                                                                                                        // 398
});                                                                                                                    // 399
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 401
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 402
  return Meteor.users.find();                                                                                          // 403
});                                                                                                                    // 404
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 406
  var _this2 = this;                                                                                                   // 406
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 407
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           // 409
  // as well as that user object itself.                                                                               // 410
  var identitySubs = {};                                                                                               // 411
  var accountId = userId;                                                                                              // 412
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 414
    if (!identitySubs[identityId]) {                                                                                   // 415
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     // 416
      // subscription to, then don't crash                                                                             // 417
      console.error("attempted to unref untracked identity id:", identityId);                                          // 418
      return;                                                                                                          // 419
    }                                                                                                                  // 420
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 422
    delete identitySubs[identityId];                                                                                   // 423
    observeHandle.stop();                                                                                              // 424
    _this2.removed("users", identityId);                                                                               // 425
  };                                                                                                                   // 426
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 428
    if (identitySubs[identityId]) {                                                                                    // 429
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         // 430
      // avoid leaking a subscription                                                                                  // 431
      console.error("duplicate identity id:", identityId);                                                             // 432
      return;                                                                                                          // 433
    }                                                                                                                  // 434
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 436
    var observeHandle = cursor.observe({                                                                               // 437
      added: function () {                                                                                             // 438
        function added(doc) {                                                                                          // 438
          _this2.added("users", doc._id, doc);                                                                         // 439
        }                                                                                                              // 440
                                                                                                                       //
        return added;                                                                                                  // 438
      }(),                                                                                                             // 438
                                                                                                                       //
      changed: function () {                                                                                           // 442
        function changed(newDoc, oldDoc) {                                                                             // 442
          fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                  // 443
          _this2.changed("users", newDoc._id, newDoc);                                                                 // 444
        }                                                                                                              // 445
                                                                                                                       //
        return changed;                                                                                                // 442
      }(),                                                                                                             // 442
                                                                                                                       //
      removed: function () {                                                                                           // 447
        function removed(oldDoc) {                                                                                     // 447
          _this2.removed("users", oldDoc._id);                                                                         // 448
        }                                                                                                              // 449
                                                                                                                       //
        return removed;                                                                                                // 447
      }()                                                                                                              // 447
    });                                                                                                                // 437
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 452
  };                                                                                                                   // 453
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 455
  var accountSubHandle = accountCursor.observe({                                                                       // 456
    added: function () {                                                                                               // 457
      function added(newDoc) {                                                                                         // 457
        var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                    // 458
        newIdentities.forEach(function (identityId) {                                                                  // 459
          refIdentity(identityId);                                                                                     // 460
        });                                                                                                            // 461
                                                                                                                       //
        _this2.added("users", newDoc._id, newDoc);                                                                     // 463
      }                                                                                                                // 464
                                                                                                                       //
      return added;                                                                                                    // 457
    }(),                                                                                                               // 457
                                                                                                                       //
    changed: function () {                                                                                             // 466
      function changed(newDoc, oldDoc) {                                                                               // 466
        var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                    // 467
        var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                    // 468
                                                                                                                       //
        // Those in newDoc - oldDoc, ref.                                                                              // 470
        var identitiesAdded = _.difference(newIdentities, oldIdentities);                                              // 471
        identitiesAdded.forEach(function (identityId) {                                                                // 472
          refIdentity(identityId);                                                                                     // 473
        });                                                                                                            // 474
                                                                                                                       //
        // Those in oldDoc - newDoc, unref.                                                                            // 476
        var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                            // 477
        identitiesRemoved.forEach(function (identityId) {                                                              // 478
          unrefIdentity(identityId);                                                                                   // 479
        });                                                                                                            // 480
                                                                                                                       //
        fillUndefinedForChangedDoc(newDoc, oldDoc);                                                                    // 482
                                                                                                                       //
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 484
      }                                                                                                                // 485
                                                                                                                       //
      return changed;                                                                                                  // 466
    }(),                                                                                                               // 466
                                                                                                                       //
    removed: function () {                                                                                             // 487
      function removed(oldDoc) {                                                                                       // 487
        _this2.removed("users", oldDoc._id);                                                                           // 488
        var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                    // 489
        oldIdentities.forEach(function (identityId) {                                                                  // 490
          unrefIdentity(identityId);                                                                                   // 491
        });                                                                                                            // 492
      }                                                                                                                // 493
                                                                                                                       //
      return removed;                                                                                                  // 487
    }()                                                                                                                // 487
  });                                                                                                                  // 456
                                                                                                                       //
  this.onStop(function () {                                                                                            // 496
    accountSubHandle.stop();                                                                                           // 497
    // Also stop all the identity subscriptions.                                                                       // 498
    var subs = _.values(identitySubs);                                                                                 // 499
    subs.forEach(function (sub) {                                                                                      // 500
      sub.stop();                                                                                                      // 501
    });                                                                                                                // 502
  });                                                                                                                  // 503
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   // 505
  // query, so by the time we get here we can report readiness.                                                        // 506
  this.ready();                                                                                                        // 507
});                                                                                                                    // 508
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 510
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 511
  return ActivityStats.find();                                                                                         // 512
});                                                                                                                    // 513
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 515
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 516
  return StatsTokens.find();                                                                                           // 517
});                                                                                                                    // 518
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 520
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 521
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 522
      "manifest.actions": 1, "manifest.appTitle": 1, progress: 1, status: 1 } });                                      // 524
});                                                                                                                    // 525
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 527
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 528
                                                                                                                       //
  // Last five minutes.                                                                                                // 530
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 531
                                                                                                                       //
  // Since last sample.                                                                                                // 533
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 534
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 535
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 536
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          // 538
                                                                                                                       //
  this.ready();                                                                                                        // 540
});                                                                                                                    // 541
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 543
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 544
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 546
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 548
  var startSize = Fs.fstatSync(fd).size;                                                                               // 549
                                                                                                                       //
  // Difference between the current file offset and the subscription offset. Can be non-zero when                      // 551
  // logs have rotated.                                                                                                // 552
  var extraOffset = 0;                                                                                                 // 553
                                                                                                                       //
  if (startSize < 8192) {                                                                                              // 555
    // Log size is less than window size. Check for rotated log and grab its tail.                                     // 556
    var logfile1 = SANDSTORM_LOGDIR + "/sandstorm.log.1";                                                              // 557
    if (Fs.existsSync(logfile1)) {                                                                                     // 558
      var fd1 = Fs.openSync(logfile1, "r");                                                                            // 559
      var startSize1 = Fs.fstatSync(fd1).size;                                                                         // 560
      var amountFromLog1 = Math.min(startSize1, 8192 - startSize);                                                     // 561
      var offset1 = startSize1 - amountFromLog1;                                                                       // 562
      var buf = new Buffer(amountFromLog1);                                                                            // 563
      var n = Fs.readSync(fd1, buf, 0, buf.length, offset);                                                            // 564
      if (n > 0) {                                                                                                     // 565
        this.added("adminLog", 0, { text: buf.toString("utf8", 0, n) });                                               // 566
        extraOffset += n;                                                                                              // 567
      }                                                                                                                // 568
    }                                                                                                                  // 569
  }                                                                                                                    // 570
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        // 572
  var offset = Math.max(0, startSize - 8192);                                                                          // 573
                                                                                                                       //
  var _this = this;                                                                                                    // 575
  function doTail() {                                                                                                  // 576
    if (Fs.fstatSync(fd).size < offset) {                                                                              // 577
      extraOffset += offset;                                                                                           // 578
      offset = 0;                                                                                                      // 579
    }                                                                                                                  // 580
                                                                                                                       //
    for (;;) {                                                                                                         // 582
      var _buf = new Buffer(Math.max(1024, startSize - offset));                                                       // 583
      var _n = Fs.readSync(fd, _buf, 0, _buf.length, offset);                                                          // 584
      if (_n <= 0) break;                                                                                              // 585
      _this.added("adminLog", offset + extraOffset, { text: _buf.toString("utf8", 0, _n) });                           // 586
      offset += _n;                                                                                                    // 587
    }                                                                                                                  // 588
  }                                                                                                                    // 589
                                                                                                                       //
  // Watch the file for changes.                                                                                       // 591
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 592
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              // 594
  this.onStop(function () {                                                                                            // 595
    watcher.close();                                                                                                   // 596
    Fs.closeSync(fd);                                                                                                  // 597
  });                                                                                                                  // 598
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            // 600
  doTail();                                                                                                            // 601
                                                                                                                       //
  // Notify ready.                                                                                                     // 603
  this.ready();                                                                                                        // 604
});                                                                                                                    // 605
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 607
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 608
  return ApiTokens.find({                                                                                              // 609
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 610
  }, {                                                                                                                 // 609
    fields: {                                                                                                          // 615
      frontendRef: 1,                                                                                                  // 616
      created: 1,                                                                                                      // 617
      requirements: 1,                                                                                                 // 618
      revoked: 1,                                                                                                      // 619
      owner: 1                                                                                                         // 620
    }                                                                                                                  // 615
  });                                                                                                                  // 614
});                                                                                                                    // 623
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 625
  var _this3 = this;                                                                                                   // 625
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      // 626
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 627
                                                                                                                       //
  // Query if there are any admin users.                                                                               // 629
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 630
  if (cursor.count() > 0) {                                                                                            // 631
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 632
  } else {                                                                                                             // 633
    (function () {                                                                                                     // 633
      var handle = cursor.observeChanges({                                                                             // 634
        added: function () {                                                                                           // 635
          function added(id) {                                                                                         // 635
            _this3.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                  // 636
            handle.stop();                                                                                             // 637
            handle = null;                                                                                             // 638
          }                                                                                                            // 639
                                                                                                                       //
          return added;                                                                                                // 635
        }()                                                                                                            // 635
      });                                                                                                              // 634
      _this3.onStop(function () {                                                                                      // 641
        if (handle) handle.stop();                                                                                     // 642
      });                                                                                                              // 643
    })();                                                                                                              // 633
  }                                                                                                                    // 644
                                                                                                                       //
  this.ready();                                                                                                        // 646
});                                                                                                                    // 647
                                                                                                                       //
Meteor.publish("appIndexAdmin", function (token) {                                                                     // 649
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 650
  return globalDb.collections.appIndex.find();                                                                         // 651
});                                                                                                                    // 652
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 654
  Settings.find({ _id: name, value: true }).observe({                                                                  // 655
    added: function () {                                                                                               // 656
      function added() {                                                                                               // 656
        // Tell the oauth library it should accept login attempts from this service.                                   // 657
        Accounts.oauth.registerService(name);                                                                          // 658
      }                                                                                                                // 659
                                                                                                                       //
      return added;                                                                                                    // 656
    }(),                                                                                                               // 656
                                                                                                                       //
    removed: function () {                                                                                             // 661
      function removed() {                                                                                             // 661
        // Tell the oauth library it should deny login attempts from this service.                                     // 662
        Accounts.oauth.unregisterService(name);                                                                        // 663
      }                                                                                                                // 664
                                                                                                                       //
      return removed;                                                                                                  // 661
    }()                                                                                                                // 661
  });                                                                                                                  // 655
}                                                                                                                      // 666
                                                                                                                       //
observeOauthService("github");                                                                                         // 668
observeOauthService("google");                                                                                         // 669
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Capnp = Npm.require("capnp");                                                                                      // 21
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 23
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 120; // Give enough time for large uploads on slow connections.                            // 25
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 26
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 28
  check(tokenId, String);                                                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 31
}                                                                                                                      // 32
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 34
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        // 35
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 36
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 37
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 39
      cleanupToken(token._id);                                                                                         // 40
    });                                                                                                                // 41
  });                                                                                                                  // 42
});                                                                                                                    // 43
                                                                                                                       //
Meteor.methods({                                                                                                       // 45
  backupGrain: function () {                                                                                           // 46
    function backupGrain(grainId) {                                                                                    // 45
      check(grainId, String);                                                                                          // 47
      var grain = Grains.findOne(grainId);                                                                             // 48
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 49
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 50
      }                                                                                                                // 51
                                                                                                                       //
      this.unblock();                                                                                                  // 53
                                                                                                                       //
      var token = {                                                                                                    // 55
        _id: Random.id(),                                                                                              // 56
        timestamp: new Date(),                                                                                         // 57
        name: grain.title                                                                                              // 58
      };                                                                                                               // 55
                                                                                                                       //
      // TODO(soon): does the grain need to be offline?                                                                // 61
                                                                                                                       //
      var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                   // 63
                                                                                                                       //
      FileTokens.insert(token);                                                                                        // 65
      waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                        // 66
                                                                                                                       //
      return token._id;                                                                                                // 68
    }                                                                                                                  // 69
                                                                                                                       //
    return backupGrain;                                                                                                // 45
  }(),                                                                                                                 // 45
  newRestoreToken: function () {                                                                                       // 71
    function newRestoreToken() {                                                                                       // 45
      if (!isSignedUpOrDemo()) {                                                                                       // 72
        throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                        // 73
      }                                                                                                                // 74
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 76
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 77
      }                                                                                                                // 79
                                                                                                                       //
      var token = {                                                                                                    // 81
        _id: Random.id(),                                                                                              // 82
        timestamp: new Date()                                                                                          // 83
      };                                                                                                               // 81
                                                                                                                       //
      FileTokens.insert(token);                                                                                        // 86
                                                                                                                       //
      return token._id;                                                                                                // 88
    }                                                                                                                  // 89
                                                                                                                       //
    return newRestoreToken;                                                                                            // 45
  }(),                                                                                                                 // 45
  restoreGrain: function () {                                                                                          // 91
    function restoreGrain(tokenId, identityId) {                                                                       // 45
      check(tokenId, String);                                                                                          // 92
      check(identityId, String);                                                                                       // 93
      var token = FileTokens.findOne(tokenId);                                                                         // 94
      if (!token || !isSignedUpOrDemo()) {                                                                             // 95
        throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");              // 96
      }                                                                                                                // 98
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 100
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 101
      }                                                                                                                // 103
                                                                                                                       //
      this.unblock();                                                                                                  // 105
                                                                                                                       //
      var grainId = Random.id(22);                                                                                     // 107
                                                                                                                       //
      try {                                                                                                            // 109
        var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
          console.error("Unzip failure:", err.message);                                                                // 112
          throw new Meteor.Error(500, "Invalid backup file.");                                                         // 113
        })).info;                                                                                                      // 114
        if (!grainInfo.appId) {                                                                                        // 115
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 116
          throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                              // 117
        }                                                                                                              // 118
                                                                                                                       //
        var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                             // 120
                                                                                                                       //
        // Create variables we'll use for later Mongo query.                                                           // 122
        var packageId = void 0;                                                                                        // 123
        var appVersion = void 0;                                                                                       // 124
                                                                                                                       //
        // DevPackages are system-wide, so we do not check the user ID.                                                // 126
        var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                              // 127
        if (devPackage) {                                                                                              // 128
          // If the dev app package exists, it should override the user action.                                        // 129
          packageId = devPackage.packageId;                                                                            // 130
          appVersion = devPackage.manifest.appVersion;                                                                 // 131
        } else if (action) {                                                                                           // 132
          // The app is installed, so we can continue restoring this                                                   // 133
          // grain.                                                                                                    // 134
          packageId = action.packageId;                                                                                // 135
          appVersion = action.appVersion;                                                                              // 136
        } else {                                                                                                       // 137
          // If the package isn't installed at all, bail out.                                                          // 138
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 139
          throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);        // 140
        }                                                                                                              // 143
                                                                                                                       //
        if (appVersion < grainInfo.appVersion) {                                                                       // 145
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 146
          throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
        }                                                                                                              // 152
                                                                                                                       //
        Grains.insert({                                                                                                // 154
          _id: grainId,                                                                                                // 155
          packageId: packageId,                                                                                        // 156
          appId: grainInfo.appId,                                                                                      // 157
          appVersion: appVersion,                                                                                      // 158
          userId: this.userId,                                                                                         // 159
          identityId: identityId,                                                                                      // 160
          title: grainInfo.title,                                                                                      // 161
          "private": true,                                                                                             // 162
          size: 0                                                                                                      // 163
        });                                                                                                            // 154
      } finally {                                                                                                      // 165
        cleanupToken(tokenId);                                                                                         // 166
      }                                                                                                                // 167
                                                                                                                       //
      return grainId;                                                                                                  // 169
    }                                                                                                                  // 170
                                                                                                                       //
    return restoreGrain;                                                                                               // 45
  }()                                                                                                                  // 45
});                                                                                                                    // 45
                                                                                                                       //
Router.map(function () {                                                                                               // 173
  this.route("downloadBackup", {                                                                                       // 174
    where: "server",                                                                                                   // 175
    path: "/downloadBackup/:tokenId",                                                                                  // 176
    action: function () {                                                                                              // 177
      function action() {                                                                                              // 174
        var token = FileTokens.findOne(this.params.tokenId);                                                           // 178
        var response = this.response;                                                                                  // 179
        if (!token) {                                                                                                  // 180
          response.writeHead(404, { "Content-Type": "text/plain" });                                                   // 181
          return response.end("File does not exist");                                                                  // 182
        }                                                                                                              // 183
                                                                                                                       //
        var started = false;                                                                                           // 185
        var encodedFilename = encodeURIComponent(token.name || "backup") + ".zip";                                     // 186
        var sawEnd = false;                                                                                            // 187
                                                                                                                       //
        var stream = {                                                                                                 // 189
          expectSize: function () {                                                                                    // 190
            function expectSize(size) {                                                                                // 189
              if (!started) {                                                                                          // 191
                started = true;                                                                                        // 192
                response.writeHead(200, {                                                                              // 193
                  "Content-Length": size,                                                                              // 194
                  "Content-Type": "application/zip",                                                                   // 195
                  "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                              // 196
                });                                                                                                    // 193
              }                                                                                                        // 198
            }                                                                                                          // 199
                                                                                                                       //
            return expectSize;                                                                                         // 189
          }(),                                                                                                         // 189
          write: function () {                                                                                         // 201
            function write(data) {                                                                                     // 189
              if (!started) {                                                                                          // 202
                started = true;                                                                                        // 203
                response.writeHead(200, {                                                                              // 204
                  "Content-Type": "application/zip",                                                                   // 205
                  "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                              // 206
                });                                                                                                    // 204
              }                                                                                                        // 208
                                                                                                                       //
              response.write(data);                                                                                    // 210
            }                                                                                                          // 211
                                                                                                                       //
            return write;                                                                                              // 189
          }(),                                                                                                         // 189
          done: function () {                                                                                          // 213
            function done(data) {                                                                                      // 189
              if (!started) {                                                                                          // 214
                started = true;                                                                                        // 215
                response.writeHead(200, {                                                                              // 216
                  "Content-Length": 0,                                                                                 // 217
                  "Content-Type": "application/zip",                                                                   // 218
                  "Content-Disposition": "attachment;filename*=utf-8''" + encodedFilename                              // 219
                });                                                                                                    // 216
              }                                                                                                        // 221
                                                                                                                       //
              sawEnd = true;                                                                                           // 223
              response.end();                                                                                          // 224
            }                                                                                                          // 225
                                                                                                                       //
            return done;                                                                                               // 189
          }()                                                                                                          // 189
        };                                                                                                             // 189
                                                                                                                       //
        waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                  // 228
                                                                                                                       //
        if (!sawEnd) {                                                                                                 // 230
          console.error("backend failed to call done() when downloading backup");                                      // 231
          if (!started) {                                                                                              // 232
            throw new Meteor.Error(500, "backend failed to produce data");                                             // 233
          }                                                                                                            // 234
                                                                                                                       //
          response.end();                                                                                              // 236
        }                                                                                                              // 237
                                                                                                                       //
        cleanupToken(this.params.tokenId);                                                                             // 239
      }                                                                                                                // 240
                                                                                                                       //
      return action;                                                                                                   // 174
    }()                                                                                                                // 174
  });                                                                                                                  // 174
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 243
    where: "server",                                                                                                   // 244
    path: "/uploadBackup/:token",                                                                                      // 245
    action: function () {                                                                                              // 246
      function action() {                                                                                              // 243
        var _this = this;                                                                                              // 246
                                                                                                                       //
        if (this.request.method === "POST") {                                                                          // 247
          var _ret = function () {                                                                                     // 247
            var token = FileTokens.findOne(_this.params.token);                                                        // 248
            if (!_this.params.token || !token) {                                                                       // 249
              _this.response.writeHead(403, {                                                                          // 250
                "Content-Type": "text/plain"                                                                           // 251
              });                                                                                                      // 250
              _this.response.write("Invalid upload token.");                                                           // 253
              _this.response.end();                                                                                    // 254
              return {                                                                                                 // 255
                v: void 0                                                                                              // 255
              };                                                                                                       // 255
            }                                                                                                          // 256
                                                                                                                       //
            var request = _this.request;                                                                               // 258
            try {                                                                                                      // 259
              (function () {                                                                                           // 259
                var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                              // 260
                                                                                                                       //
                waitPromise(new Promise(function (resolve, reject) {                                                   // 262
                  request.on("data", function (data) {                                                                 // 263
                    stream.write(data);                                                                                // 264
                  });                                                                                                  // 265
                  request.on("end", function () {                                                                      // 266
                    resolve(stream.done());                                                                            // 267
                  });                                                                                                  // 268
                  request.on("error", function (err) {                                                                 // 269
                    stream.close();                                                                                    // 270
                  });                                                                                                  // 271
                }));                                                                                                   // 272
                                                                                                                       //
                _this.response.writeHead(204);                                                                         // 274
                _this.response.end();                                                                                  // 275
              })();                                                                                                    // 259
            } catch (error) {                                                                                          // 276
              console.error(error.stack);                                                                              // 277
              _this.response.writeHead(500, {                                                                          // 278
                "Content-Type": "text/plain"                                                                           // 279
              });                                                                                                      // 278
              _this.response.write(error.stack);                                                                       // 281
              _this.response.end();                                                                                    // 282
            }                                                                                                          // 283
          }();                                                                                                         // 247
                                                                                                                       //
          if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                 // 247
        } else {                                                                                                       // 284
          this.response.writeHead(405, {                                                                               // 285
            "Content-Type": "text/plain"                                                                               // 286
          });                                                                                                          // 285
          this.response.write("You can only POST here.");                                                              // 288
          this.response.end();                                                                                         // 289
        }                                                                                                              // 290
      }                                                                                                                // 291
                                                                                                                       //
      return action;                                                                                                   // 243
    }()                                                                                                                // 243
  });                                                                                                                  // 243
});                                                                                                                    // 293
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"contacts-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/contacts-server.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
Meteor.publish("contactProfiles", function (showAll) {                                                                 // 17
  var db = this.connection.sandstormDb;                                                                                // 18
  var _this = this;                                                                                                    // 19
  var userId = this.userId;                                                                                            // 20
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             // 22
  var contactIdentities = {};                                                                                          // 23
  var disallowGuests = db.getOrganizationDisallowGuests();                                                             // 24
                                                                                                                       //
  function addIdentityOfContact(identityId) {                                                                          // 26
    if (!(identityId in contactIdentities)) {                                                                          // 27
      var user = Meteor.users.findOne({ _id: identityId });                                                            // 28
                                                                                                                       //
      if (disallowGuests && !showAll) {                                                                                // 30
        if (!db.isIdentityInOrganization(user)) {                                                                      // 31
          return;                                                                                                      // 32
        }                                                                                                              // 33
      }                                                                                                                // 34
                                                                                                                       //
      if (user) {                                                                                                      // 36
        SandstormDb.fillInProfileDefaults(user);                                                                       // 37
        SandstormDb.fillInIntrinsicName(user);                                                                         // 38
        var filteredUser = _.pick(user, "_id", "profile");                                                             // 39
        _this.added("contactProfiles", user._id, filteredUser);                                                        // 40
      }                                                                                                                // 41
                                                                                                                       //
      contactIdentities[identityId] = Meteor.users.find({ _id: identityId }, { fields: { profile: 1 } }).observeChanges({
        changed: function () {                                                                                         // 45
          function changed(id, fields) {                                                                               // 45
            _this.changed("contactProfiles", id, fields);                                                              // 46
          }                                                                                                            // 47
                                                                                                                       //
          return changed;                                                                                              // 45
        }()                                                                                                            // 45
      });                                                                                                              // 44
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  var cursor = db.collections.contacts.find({ ownerId: userId });                                                      // 52
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 54
    added: function () {                                                                                               // 55
      function added(contact) {                                                                                        // 55
        addIdentityOfContact(contact.identityId);                                                                      // 56
      }                                                                                                                // 57
                                                                                                                       //
      return added;                                                                                                    // 55
    }(),                                                                                                               // 55
                                                                                                                       //
    changed: function () {                                                                                             // 59
      function changed(contact) {                                                                                      // 59
        addIdentityOfContact(contact.identityId);                                                                      // 60
      }                                                                                                                // 61
                                                                                                                       //
      return changed;                                                                                                  // 59
    }(),                                                                                                               // 59
                                                                                                                       //
    removed: function () {                                                                                             // 63
      function removed(contact) {                                                                                      // 63
        _this.removed("contactProfiles", contact.identityId);                                                          // 64
        var contactIdentity = contactIdentities[contact.identityId];                                                   // 65
        if (contactIdentity) contactIdentities[contact.identityId].stop();                                             // 66
        delete contactIdentities[contact.identityId];                                                                  // 67
      }                                                                                                                // 68
                                                                                                                       //
      return removed;                                                                                                  // 63
    }()                                                                                                                // 63
  });                                                                                                                  // 54
                                                                                                                       //
  var orgHandle = void 0;                                                                                              // 71
                                                                                                                       //
  if (db.getOrganizationShareContacts() && db.isUserInOrganization(db.collections.users.findOne({ _id: userId }))) {   // 73
    var orgCursor = db.collections.users.find({ profile: { $exists: 1 } });                                            // 75
    // TODO(perf): make a mongo query that can find all identities in an organization and add                          // 76
    // indices for it. Currently, we do some case insensitive matching which mongo can't                               // 77
    // handle well.                                                                                                    // 78
                                                                                                                       //
    orgHandle = orgCursor.observe({                                                                                    // 80
      added: function () {                                                                                             // 81
        function added(user) {                                                                                         // 81
          if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                            // 82
            addIdentityOfContact(user._id);                                                                            // 83
          }                                                                                                            // 84
        }                                                                                                              // 85
                                                                                                                       //
        return added;                                                                                                  // 81
      }(),                                                                                                             // 81
                                                                                                                       //
      changed: function () {                                                                                           // 87
        function changed(user) {                                                                                       // 87
          if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                            // 88
            addIdentityOfContact(user._id);                                                                            // 89
          }                                                                                                            // 90
        }                                                                                                              // 91
                                                                                                                       //
        return changed;                                                                                                // 87
      }(),                                                                                                             // 87
                                                                                                                       //
      removed: function () {                                                                                           // 93
        function removed(user) {                                                                                       // 93
          if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                            // 94
            _this.removed("contactProfiles", user._id);                                                                // 95
            var contactIdentity = contactIdentities[contact.identityId];                                               // 96
            if (contactIdentity) contactIdentities[contact.identityId].stop();                                         // 97
            delete contactIdentities[user._id];                                                                        // 98
          }                                                                                                            // 99
        }                                                                                                              // 100
                                                                                                                       //
        return removed;                                                                                                // 93
      }()                                                                                                              // 93
    });                                                                                                                // 80
  }                                                                                                                    // 102
                                                                                                                       //
  this.ready();                                                                                                        // 104
                                                                                                                       //
  this.onStop(function () {                                                                                            // 106
    handle.stop();                                                                                                     // 107
    if (orgHandle) {                                                                                                   // 108
      orgHandle.stop();                                                                                                // 109
    }                                                                                                                  // 110
                                                                                                                       //
    Object.keys(contactIdentities).forEach(function (identityId) {                                                     // 112
      contactIdentities[identityId].stop();                                                                            // 113
      delete contactIdentities[identityId];                                                                            // 114
    });                                                                                                                // 115
  });                                                                                                                  // 116
});                                                                                                                    // 117
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/async-helpers.js","/imports/server/static-asset.js","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Crypto = Npm.require("crypto");                                                                                    // 20
                                                                                                                       // 21
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 24
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 25
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 26
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 27
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 28
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 29
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 30
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(db, grainId) {                                                                            // 33
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 33
                                                                                                                       //
    this.db = db;                                                                                                      // 34
    this.grainId = grainId;                                                                                            // 35
  }                                                                                                                    // 36
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function () {                                                                  //
    function restore(sturdyRef) {                                                                                      //
      var _this = this;                                                                                                // 38
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 39
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 40
        var token = _this.db.collections.apiTokens.findOne({                                                           // 41
          _id: hashedSturdyRef,                                                                                        // 42
          "owner.grain.grainId": _this.grainId                                                                         // 43
        });                                                                                                            // 41
                                                                                                                       //
        if (!token) {                                                                                                  // 46
          throw new Error("no such token");                                                                            // 47
        }                                                                                                              // 48
                                                                                                                       //
        if (token.owner.grain.introducerIdentity) {                                                                    // 50
          throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
        }                                                                                                              // 53
                                                                                                                       //
        return restoreInternal(_this.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, [], token);
      });                                                                                                              // 58
    }                                                                                                                  // 59
                                                                                                                       //
    return restore;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function () {                                                                     //
    function drop(sturdyRef) {                                                                                         //
      var _this2 = this;                                                                                               // 61
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 62
        return dropInternal(_this2.db, sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) });      // 63
      });                                                                                                              // 64
    }                                                                                                                  // 65
                                                                                                                       //
    return drop;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function () {                                                                //
    function makeToken(ref, owner, requirements) {                                                                     //
      var _this3 = this;                                                                                               // 67
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 68
        var sturdyRef = new Buffer(generateSturdyRef());                                                               // 69
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 70
        _this3.db.collections.apiTokens.insert({                                                                       // 71
          _id: hashedSturdyRef,                                                                                        // 72
          grainId: _this3.grainId,                                                                                     // 73
          objectId: ref,                                                                                               // 74
          owner: owner,                                                                                                // 75
          created: new Date(),                                                                                         // 76
          requirements: requirements                                                                                   // 77
        });                                                                                                            // 71
                                                                                                                       //
        return {                                                                                                       // 80
          token: sturdyRef                                                                                             // 81
        };                                                                                                             // 80
      });                                                                                                              // 83
    }                                                                                                                  // 84
                                                                                                                       //
    return makeToken;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function () {                                                           //
    function makeChildToken(parent, owner, requirements) {                                                             //
      var _this4 = this;                                                                                               // 86
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 87
        // Compute the save ApiToken template.                                                                         // 88
        return makeSaveTemplateForChild(_this4.db, parent.toString(), requirements);                                   // 89
      }).then(function (saveTemplate) {                                                                                // 90
        // Create a dummy PersistentImpl and invoke its own save() method.                                             // 91
        return new PersistentImpl(_this4.db, saveTemplate).save({ sealFor: owner });                                   // 92
      }).then(function (saveResult) {                                                                                  // 93
        // Transform to expected result structure.                                                                     // 94
        return { token: saveResult.sturdyRef };                                                                        // 95
      });                                                                                                              // 96
    }                                                                                                                  // 97
                                                                                                                       //
    return makeChildToken;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function () {                                               //
    function getOwnerNotificationTarget() {                                                                            //
      var _this5 = this;                                                                                               // 99
                                                                                                                       //
      var grainId = this.grainId;                                                                                      // 100
      return {                                                                                                         // 101
        owner: {                                                                                                       // 102
          addOngoing: function () {                                                                                    // 103
            function addOngoing(displayInfo, notification) {                                                           // 103
              return inMeteor(function () {                                                                            // 104
                var grain = _this5.db.collections.grains.findOne({ _id: grainId });                                    // 105
                if (!grain) {                                                                                          // 106
                  throw new Error("Grain not found.");                                                                 // 107
                }                                                                                                      // 108
                                                                                                                       //
                var castedNotification = notification.castAs(PersistentOngoingNotification);                           // 110
                var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                  // 111
                                                                                                                       //
                // We have to close both the casted cap and the original. Perhaps this should be fixed in              // 113
                // node-capnp?                                                                                         // 114
                castedNotification.close();                                                                            // 115
                notification.close();                                                                                  // 116
                var notificationId = _this5.db.collections.notifications.insert({                                      // 117
                  ongoing: wakelockToken,                                                                              // 118
                  grainId: grainId,                                                                                    // 119
                  userId: grain.userId,                                                                                // 120
                  text: displayInfo.caption,                                                                           // 121
                  timestamp: new Date(),                                                                               // 122
                  isUnread: true                                                                                       // 123
                });                                                                                                    // 117
                                                                                                                       //
                return {                                                                                               // 126
                  handle: globalFrontendRefRegistry.create(_this5.db, { notificationHandle: notificationId })          // 127
                };                                                                                                     // 126
              });                                                                                                      // 130
            }                                                                                                          // 131
                                                                                                                       //
            return addOngoing;                                                                                         // 103
          }()                                                                                                          // 103
        }                                                                                                              // 102
      };                                                                                                               // 101
    }                                                                                                                  // 134
                                                                                                                       //
    return getOwnerNotificationTarget;                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function () {                                                       //
    function backgroundActivity(event) {                                                                               //
      var _this6 = this;                                                                                               // 136
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 137
        logActivity(_this6.grainId, null, event);                                                                      // 138
      });                                                                                                              // 139
    }                                                                                                                  // 140
                                                                                                                       //
    return backgroundActivity;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.reportGrainSize = function () {                                                          //
    function reportGrainSize(bytes) {                                                                                  //
      bytes = parseInt(bytes); // int64s are stringified but precision isn't critical here                             // 143
                                                                                                                       //
      var result = this.db.collections.grains.findAndModify({                                                          // 145
        query: { _id: this.grainId },                                                                                  // 146
        update: { $set: { size: bytes } },                                                                             // 147
        fields: { _id: 1, userId: 1, size: 1 }                                                                         // 148
      });                                                                                                              // 145
                                                                                                                       //
      if (!result.ok) {                                                                                                // 151
        throw new Error("Grain not found.");                                                                           // 152
      }                                                                                                                // 153
                                                                                                                       //
      // If the grain did not have a "size" field before the update, then it is a grain created                        // 155
      // before per-grain size tracking was implemented. In that case, we don't want to update the                     // 156
      // user record because it may already be counting the grain (specifically on Blackrock, where                    // 157
      // whole-user size counting has existed for some time).                                                          // 158
      if (this.db.isQuotaEnabled() && "size" in result.value) {                                                        // 159
        // Update the user record, too. Note that we periodically recompute the user's storage usage                   // 160
        // from scratch as well, so this doesn't have to be perfectly reliable.                                        // 161
        var diff = bytes - (result.value.size || 0);                                                                   // 162
        this.db.collections.users.update(result.value.userId, { $inc: { storageUsage: diff } });                       // 163
      }                                                                                                                // 164
    }                                                                                                                  // 165
                                                                                                                       //
    return reportGrainSize;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.getIdentityId = function () {                                                            //
    function getIdentityId(identity) {                                                                                 //
      return unwrapFrontendCap(identity, "identity", function (identityId) {                                           // 168
        return { id: new Buffer(identityId, "hex") };                                                                  // 169
      });                                                                                                              // 170
    }                                                                                                                  // 171
                                                                                                                       //
    return getIdentityId;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(db, grainId) {                                                      // 174
  return new Capnp.Capability(new SandstormCoreImpl(db, grainId), SandstormCore);                                      // 175
};                                                                                                                     // 176
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          // 179
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 181
    _classCallCheck(this, NotificationHandle);                                                                         // 181
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 181
                                                                                                                       //
    _this7.notificationId = notificationId;                                                                            // 183
    _this7.db = db;                                                                                                    // 184
    return _this7;                                                                                                     // 181
  }                                                                                                                    // 185
                                                                                                                       //
  NotificationHandle.prototype.close = function () {                                                                   //
    function close() {                                                                                                 //
      var _this8 = this;                                                                                               // 187
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 188
        if (!_this8.isSaved()) {                                                                                       // 189
          _dismissNotification(_this8.db, _this8.notificationId);                                                      // 190
        }                                                                                                              // 191
      });                                                                                                              // 192
    }                                                                                                                  // 193
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               // 197
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 199
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 199
                                                                                                                       //
    var _this9 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 199
                                                                                                                       //
    check(grainId, String);                                                                                            // 201
    _this9._db = db;                                                                                                   // 202
    _this9._grainId = grainId;                                                                                         // 203
    return _this9;                                                                                                     // 199
  }                                                                                                                    // 204
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function () {                                                           //
    function getViewInfo() {                                                                                           //
      var _this10 = this;                                                                                              // 206
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 207
        var grain = _this10._db.getGrain(_this10._grainId);                                                            // 208
        if (!grain || grain.trashed) {                                                                                 // 209
          throw new Error("grain no longer exists");                                                                   // 210
        }                                                                                                              // 211
                                                                                                                       //
        var pkg = _this10._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};        // 213
                                                                                                                       //
        var manifest = pkg.manifest || {};                                                                             // 217
                                                                                                                       //
        var viewInfo = grain.cachedViewInfo || {};                                                                     // 219
                                                                                                                       //
        if (!viewInfo.appTitle) {                                                                                      // 221
          viewInfo.appTitle = manifest.appTitle || {};                                                                 // 222
        }                                                                                                              // 223
                                                                                                                       //
        if (!viewInfo.grainIcon) {                                                                                     // 225
          var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                               // 226
          if (grainIcon) {                                                                                             // 227
            viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);            // 228
          } else {                                                                                                     // 230
            var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                     // 231
            viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);            // 232
          }                                                                                                            // 234
        }                                                                                                              // 235
                                                                                                                       //
        return viewInfo;                                                                                               // 237
      });                                                                                                              // 238
    }                                                                                                                  // 239
                                                                                                                       //
    return getViewInfo;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          // 241
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     // 242
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       // 243
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 246
  check(grainId, String);                                                                                              // 247
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             // 249
  var grain = db.getGrain(grainId);                                                                                    // 250
  if (!grain || grain.trashed) {                                                                                       // 251
    throw new Meteor.Error(404, "grain not found");                                                                    // 252
  }                                                                                                                    // 253
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 255
};                                                                                                                     // 257
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 259
  frontendRefField: "notificationHandle",                                                                              // 260
                                                                                                                       //
  restore: function () {                                                                                               // 262
    function restore(db, saveTemplate, notificationId) {                                                               // 259
      return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);         // 263
    }                                                                                                                  // 265
                                                                                                                       //
    return restore;                                                                                                    // 259
  }()                                                                                                                  // 259
});                                                                                                                    // 259
                                                                                                                       //
function _dismissNotification(db, notificationId, callCancel) {                                                        // 268
  var notification = db.collections.notifications.findOne({ _id: notificationId });                                    // 269
  if (notification) {                                                                                                  // 270
    db.collections.notifications.remove({ _id: notificationId });                                                      // 271
    if (notification.ongoing) {                                                                                        // 272
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          // 273
      // Only way to fix seems to be to copy it.                                                                       // 274
      var id = new Buffer(notification.ongoing);                                                                       // 275
                                                                                                                       //
      if (!callCancel) {                                                                                               // 277
        dropInternal(db, id, { frontend: null });                                                                      // 278
      } else {                                                                                                         // 279
        var notificationCap = restoreInternal(db, id, { frontend: null }, []).cap;                                     // 280
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 281
        dropInternal(db, id, { frontend: null });                                                                      // 282
        try {                                                                                                          // 283
          waitPromise(castedNotification.cancel());                                                                    // 284
          castedNotification.close();                                                                                  // 285
          notificationCap.close();                                                                                     // 286
        } catch (err) {                                                                                                // 287
          if (err.kjType !== "disconnected") {                                                                         // 288
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   // 289
            // responds.                                                                                               // 290
            throw err;                                                                                                 // 291
          }                                                                                                            // 292
        }                                                                                                              // 293
      }                                                                                                                // 294
    } else if (notification.appUpdates) {                                                                              // 295
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 296
        db.deleteUnusedPackages(appId);                                                                                // 297
      });                                                                                                              // 298
    }                                                                                                                  // 299
  }                                                                                                                    // 300
}                                                                                                                      // 301
                                                                                                                       //
Meteor.methods({                                                                                                       // 303
  dismissNotification: function () {                                                                                   // 304
    function dismissNotification(notificationId) {                                                                     // 303
      // This will remove notifications from the database and from view of the user.                                   // 305
      // For ongoing notifications, it will begin the process of cancelling and dropping them from                     // 306
      // the app.                                                                                                      // 307
                                                                                                                       //
      check(notificationId, String);                                                                                   // 309
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 311
                                                                                                                       //
      var notification = db.collections.notifications.findOne({ _id: notificationId });                                // 313
      if (!notification) {                                                                                             // 314
        throw new Meteor.Error(404, "Notification id not found.");                                                     // 315
      } else if (notification.userId !== Meteor.userId()) {                                                            // 316
        throw new Meteor.Error(403, "Notification does not belong to current user.");                                  // 317
      } else {                                                                                                         // 318
        _dismissNotification(db, notificationId, true);                                                                // 319
      }                                                                                                                // 320
    }                                                                                                                  // 321
                                                                                                                       //
    return dismissNotification;                                                                                        // 303
  }(),                                                                                                                 // 303
  readAllNotifications: function () {                                                                                  // 323
    function readAllNotifications() {                                                                                  // 303
      // Marks all notifications as read for the current user.                                                         // 324
      if (!Meteor.userId()) {                                                                                          // 325
        throw new Meteor.Error(403, "User not logged in.");                                                            // 326
      }                                                                                                                // 327
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 329
      db.collections.notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });
    }                                                                                                                  // 334
                                                                                                                       //
    return readAllNotifications;                                                                                       // 303
  }(),                                                                                                                 // 303
  acceptPowerboxOffer: function () {                                                                                   // 336
    function acceptPowerboxOffer(sessionId, sturdyRef, sessionToken) {                                                 // 303
      var db = this.connection.sandstormDb;                                                                            // 337
      check(sessionId, String);                                                                                        // 338
      check(sturdyRef, String);                                                                                        // 339
      check(sessionToken, Match.OneOf(String, null, undefined));                                                       // 340
                                                                                                                       //
      var sessionQuery = { _id: sessionId };                                                                           // 342
      if (sessionToken) {                                                                                              // 343
        sessionQuery.hashedToken = hashSturdyRef(sessionToken);                                                        // 344
      } else {                                                                                                         // 345
        sessionQuery.userId = this.userId;                                                                             // 346
      }                                                                                                                // 347
                                                                                                                       //
      var session = db.collections.sessions.findOne(sessionQuery);                                                     // 349
      if (!session) {                                                                                                  // 350
        throw new Meteor.Error(404, "No matching session found.");                                                     // 351
      }                                                                                                                // 352
                                                                                                                       //
      var tokenId = hashSturdyRef(sturdyRef);                                                                          // 354
      var apiToken = db.collections.apiTokens.findOne({                                                                // 355
        _id: tokenId,                                                                                                  // 356
        "owner.clientPowerboxOffer.sessionId": sessionId                                                               // 357
      });                                                                                                              // 355
                                                                                                                       //
      if (!apiToken) {                                                                                                 // 360
        throw new Meteor.Error(404, "No such token.");                                                                 // 361
      }                                                                                                                // 362
                                                                                                                       //
      var newSturdyRef = void 0;                                                                                       // 364
      var hashedNewSturdyRef = void 0;                                                                                 // 365
      if (sessionToken && apiToken.parentToken) {                                                                      // 366
        // An anonymous user is being offered a child token. To avoid bloating the database,                           // 367
        // we deterministically derive the sturdyref from the session token and the hashed parent                      // 368
        // token.                                                                                                      // 369
        //                                                                                                             // 370
        // Note that an attacker with read access to the database might be able to derive                              // 371
        // `newSturdyRef` from `sessionToken` and gain access to the capability without ever having                    // 372
        // been explicitly offered it by the grain. Therefore, grains must assume that offering                        // 373
        // a capability to an anonymous user can possibly make that capability accessible to any                       // 374
        // other anonymous user who has connected through the same URL.                                                // 375
                                                                                                                       //
        newSturdyRef = Crypto.createHash("sha256").update(sessionToken).update(apiToken.parentToken).digest("base64").slice(0, -1) // removing trailing "="
        .replace(/\+/g, "-").replace(/\//g, "_"); // make URL-safe                                                     // 377
                                                                                                                       //
        hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                              // 384
        if (db.collections.apiTokens.findOne({ _id: hashedNewSturdyRef })) {                                           // 385
          // We have already generated this token.                                                                     // 386
          db.removeApiTokens({ _id: tokenId });                                                                        // 387
          return newSturdyRef;                                                                                         // 388
        }                                                                                                              // 389
      } else {                                                                                                         // 390
        newSturdyRef = generateSturdyRef();                                                                            // 391
        hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                              // 392
      }                                                                                                                // 393
                                                                                                                       //
      apiToken._id = hashedNewSturdyRef;                                                                               // 395
      apiToken.owner = { webkey: null };                                                                               // 396
                                                                                                                       //
      db.collections.apiTokens.insert(apiToken);                                                                       // 398
      db.removeApiTokens({ _id: tokenId });                                                                            // 399
      return newSturdyRef;                                                                                             // 400
    }                                                                                                                  // 401
                                                                                                                       //
    return acceptPowerboxOffer;                                                                                        // 303
  }()                                                                                                                  // 303
});                                                                                                                    // 303
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(db, parentToken, requirements, parentTokenInfo) {     // 405
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        // 406
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       // 407
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    // 408
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              // 409
  //                                                                                                                   // 410
  // `parentToken` is the raw SturdyRef of the parent.                                                                 // 411
  //                                                                                                                   // 412
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            // 413
  //                                                                                                                   // 414
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         // 415
  // it handy; if omitted it will be looked up.                                                                        // 416
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || db.collections.apiTokens.findOne(hashSturdyRef(parentToken));                   // 418
  if (!parentTokenInfo) {                                                                                              // 419
    throw new Error("no such token");                                                                                  // 420
  }                                                                                                                    // 421
                                                                                                                       //
  var parentOwner = parentTokenInfo.owner || {};                                                                       // 423
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 425
  if (parentOwner.clientPowerboxRequest || parentOwner.clientPowerboxOffer) {                                          // 426
    // Saving this token should make a copy of the restored token, rather than make a child                            // 427
    // token.                                                                                                          // 428
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 430
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                // 432
    delete saveTemplate._id;                                                                                           // 433
    delete saveTemplate.owner;                                                                                         // 434
    delete saveTemplate.created;                                                                                       // 435
  } else {                                                                                                             // 436
    if (parentTokenInfo.identityId) {                                                                                  // 437
      // A UiView token. Need to denormalize some fields from the parent.                                              // 438
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 439
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         // 441
      // assignment.                                                                                                   // 442
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 443
    } else {                                                                                                           // 444
      // A non-UiView child token.                                                                                     // 445
      saveTemplate = {};                                                                                               // 446
    }                                                                                                                  // 447
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            // 449
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 450
  }                                                                                                                    // 451
                                                                                                                       //
  if (requirements) {                                                                                                  // 453
    // Append additional requirements requested by caller.                                                             // 454
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 455
  }                                                                                                                    // 456
                                                                                                                       //
  return saveTemplate;                                                                                                 // 458
};                                                                                                                     // 459
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 461
  function restoreInternal(_x, _x2, _x3, _x4, _x5, _x6) {                                                              // 461
    return _restoreInternal.apply(this, arguments);                                                                    // 461
  }                                                                                                                    // 461
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 461
    return _restoreInternal.toString();                                                                                // 461
  };                                                                                                                   // 461
                                                                                                                       //
  return restoreInternal;                                                                                              // 461
}(function (db, originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                        // 461
  // Restores the token `originalToken`, which is a Buffer.                                                            // 463
  //                                                                                                                   // 464
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     // 465
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               // 466
  //                                                                                                                   // 467
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    // 468
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           // 469
  //                                                                                                                   // 470
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        // 471
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    // 472
  //                                                                                                                   // 473
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          // 474
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        // 475
  // the top-level token.                                                                                              // 476
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 478
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 480
    originalTokenInfo = db.collections.apiTokens.findOne(hashSturdyRef(originalToken));                                // 481
    if (!originalTokenInfo) {                                                                                          // 482
      throw new Meteor.Error(403, "No token found to restore");                                                        // 483
    }                                                                                                                  // 484
  }                                                                                                                    // 485
                                                                                                                       //
  var token = currentTokenId ? db.collections.apiTokens.findOne(currentTokenId) : originalTokenInfo;                   // 487
  if (!token) {                                                                                                        // 489
    if (!originalTokenInfo) {                                                                                          // 490
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 491
    }                                                                                                                  // 492
  }                                                                                                                    // 493
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 495
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 496
  }                                                                                                                    // 497
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           // 499
  check(token.owner, ownerPattern);                                                                                    // 500
                                                                                                                       //
  // Check requirements on the token.                                                                                  // 502
  checkRequirements(db, token.requirements);                                                                           // 503
                                                                                                                       //
  // Check expiration.                                                                                                 // 505
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 506
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 507
  }                                                                                                                    // 508
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 510
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 511
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 512
    } else {                                                                                                           // 513
      // It's getting used now, so clear the expiresIfUnused field.                                                    // 514
      db.collections.apiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                 // 515
    }                                                                                                                  // 516
  }                                                                                                                    // 517
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       // 519
  if (token.parentToken) {                                                                                             // 520
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    // 521
    // checking requirements on the way up.                                                                            // 522
    return restoreInternal(db, originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);          // 523
  }                                                                                                                    // 525
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               // 527
  checkRequirements(db, requirements);                                                                                 // 528
                                                                                                                       //
  if (token.objectId) {                                                                                                // 530
    // A token which represents a specific capability exported by a grain.                                             // 531
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    // 533
    if (token.objectId.appRef) {                                                                                       // 534
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 535
    }                                                                                                                  // 536
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       // 538
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 539
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        // 540
      // don't generate a saveTemplate here.                                                                           // 541
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 542
    }));                                                                                                               // 543
  } else {                                                                                                             // 544
    // Construct a template ApiToken for use if the restored capability is save()d later.                              // 545
    var saveTemplate = makeSaveTemplateForChild(db, originalToken, requirements, originalTokenInfo);                   // 546
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 548
      // A token which represents a capability implemented by a pseudo-driver.                                         // 549
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(db, saveTemplate, token.frontendRef);                                // 551
      return { cap: cap };                                                                                             // 552
    } else if (token.grainId) {                                                                                        // 553
      // It's a UiView.                                                                                                // 554
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          // 556
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  // 557
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     // 558
      // do some transformation), which will return a different capability.                                            // 559
      return { cap: makePersistentUiView(db, saveTemplate, token.grainId) };                                           // 560
    } else {                                                                                                           // 561
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 562
    }                                                                                                                  // 563
  }                                                                                                                    // 564
});                                                                                                                    // 565
                                                                                                                       //
function dropInternal(db, sturdyRef, ownerPattern) {                                                                   // 567
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          // 568
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 570
  var token = db.collections.apiTokens.findOne({ _id: hashedSturdyRef });                                              // 571
  if (!token) {                                                                                                        // 572
    return;                                                                                                            // 573
  }                                                                                                                    // 574
                                                                                                                       //
  if (!Match.test(token.owner, ownerPattern)) {                                                                        // 576
    // The caller of `drop()` does not own the token. From the caller's perspective, this means                        // 577
    // that there is actually nothing to be dropped. For example, perhaps a grain got backed up                        // 578
    // and restored, and now is trying to drop one of its pre-backup tokens. The call to                               // 579
    // `SandstormApi.drop()` should succeed, behaving exactly as if the token was not found.                           // 580
    return;                                                                                                            // 581
  }                                                                                                                    // 582
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 584
    var notificationId = token.frontendRef.notificationHandle;                                                         // 585
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 586
    var anyToken = db.collections.apiTokens.findOne({ "frontendRef.notificationHandle": notificationId });             // 587
    if (!anyToken) {                                                                                                   // 588
      // No other tokens referencing this notification exist, so dismiss the notification                              // 589
      _dismissNotification(db, notificationId);                                                                        // 590
    }                                                                                                                  // 591
  } else if (token.objectId) {                                                                                         // 592
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 593
      return supervisor.drop(token.objectId);                                                                          // 594
    }));                                                                                                               // 595
                                                                                                                       //
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 597
  } else {                                                                                                             // 598
    db.removeApiTokens({ _id: hashedSturdyRef });                                                                      // 599
  }                                                                                                                    // 600
}                                                                                                                      // 601
                                                                                                                       //
var SandstormCoreFactoryImpl = function () {                                                                           //
  function SandstormCoreFactoryImpl(db) {                                                                              // 604
    _classCallCheck(this, SandstormCoreFactoryImpl);                                                                   // 604
                                                                                                                       //
    this.db = db;                                                                                                      // 605
  }                                                                                                                    // 606
                                                                                                                       //
  SandstormCoreFactoryImpl.prototype.getSandstormCore = function () {                                                  //
    function getSandstormCore(grainId) {                                                                               //
      return { core: makeSandstormCore(this.db, grainId) };                                                            // 609
    }                                                                                                                  // 610
                                                                                                                       //
    return getSandstormCore;                                                                                           //
  }();                                                                                                                 //
                                                                                                                       //
  return SandstormCoreFactoryImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory(db) {                                                     // 613
  return new Capnp.Capability(new SandstormCoreFactoryImpl(db), SandstormCoreFactory);                                 // 614
};                                                                                                                     // 615
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 617
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        // 618
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        // 619
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       // 620
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          // 621
  // anywhere. The function returns a Promise for the result of the callback.                                          // 622
  //                                                                                                                   // 623
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         // 624
  // so that you don't have to do your own inMeteor() dance.)                                                          // 625
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          // 627
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         // 628
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         // 629
  //   there are multiple front-end replicas, since the capability could be on a different                             // 630
  //   replica.                                                                                                        // 631
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 633
    return inMeteor(function () {                                                                                      // 634
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 635
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 636
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   // 638
      ApiTokens.remove(tokenId);                                                                                       // 639
                                                                                                                       //
      for (;;) {                                                                                                       // 641
        if (!tokenInfo) throw new Error("missing token?");                                                             // 642
        if (!tokenInfo.parentToken) break;                                                                             // 643
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 644
      }                                                                                                                // 645
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 647
        throw new Error("not a " + type + " capability");                                                              // 648
      }                                                                                                                // 649
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 651
    });                                                                                                                // 652
  });                                                                                                                  // 653
};                                                                                                                     // 654
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/server/async-helpers.js","/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 20
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 21
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 23
  // Enforce expiration times for demo accounts.                                                                       // 24
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 26
    (function () {                                                                                                     // 26
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 27
      if (expireIn < 0) {                                                                                              // 28
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 29
      }                                                                                                                // 30
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 32
        // An expiration time implies that this is a demo account, but those have been disabled.                       // 33
        // Perhaps the config was just changed.                                                                        // 34
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 35
      }                                                                                                                // 36
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                // 38
      // re-authenticates, which fails.                                                                                // 39
      var connection = attempt.connection;                                                                             // 40
      var handle = Meteor.setTimeout(function () {                                                                     // 41
        connection.close();                                                                                            // 41
      }, expireIn);                                                                                                    // 41
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 43
        Meteor.clearTimeout(handle);                                                                                   // 43
      });                                                                                                              // 43
    })();                                                                                                              // 26
  }                                                                                                                    // 44
                                                                                                                       //
  return true;                                                                                                         // 46
});                                                                                                                    // 47
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 49
  // Delete expired demo accounts and all their grains.                                                                // 50
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 52
  Meteor.users.find({ expires: { $lt: now }, loginIdentities: { $exists: true } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1, experiments: 1 } }).forEach(function (user) {
    console.log("delete demo user: " + user._id);                                                                      // 56
    globalDb.deleteAccount(user._id, globalBackend);                                                                   // 57
                                                                                                                       //
    // Record stats about demo accounts.                                                                               // 59
    var deleteStatsType = "demoUser";                                                                                  // 60
    var isAppDemoUser = !!user.appDemoId;                                                                              // 61
    if (isAppDemoUser) {                                                                                               // 62
      deleteStatsType = "appDemoUser";                                                                                 // 63
    }                                                                                                                  // 64
                                                                                                                       //
    // Intentionally record deleted users at time of deletion to avoid miscounting users that                          // 66
    // were demoing just before the day rolled over.                                                                   // 67
    var record = { type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId };                             // 68
    if (user.experiments) {                                                                                            // 69
      record.experiments = user.experiments;                                                                           // 70
    }                                                                                                                  // 71
                                                                                                                       //
    DeleteStats.insert(record);                                                                                        // 73
  });                                                                                                                  // 74
                                                                                                                       //
  // All demo identities should have been deleted as part of deleting the demo users, but just in                      // 76
  // case, check for them too.                                                                                         // 77
  Meteor.users.find({ expires: { $lt: now }, loginIdentities: { $exists: false } }, { fields: { _id: 1 } }).forEach(function (user) {
    console.log("delete demo identity: " + user._id);                                                                  // 81
    globalDb.deleteIdentity(user._id);                                                                                 // 82
  });                                                                                                                  // 83
}                                                                                                                      // 84
                                                                                                                       //
if (allowDemo) {                                                                                                       // 86
  Meteor.methods({                                                                                                     // 87
    createDemoUser: function () {                                                                                      // 88
      function createDemoUser(displayName, appDemoId) {                                                                // 88
        // This is a login method that creates a new temporary user                                                    // 89
        // every time it is used.                                                                                      // 90
        //                                                                                                             // 91
        // appDemoId is important for stats; see cleanupExpiredUsers().                                                // 92
        check(displayName, String);                                                                                    // 93
        check(appDemoId, Match.OneOf(undefined, null, String));                                                        // 94
                                                                                                                       //
        // Create the new user.                                                                                        // 96
        var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                          // 97
        if (appDemoId) {                                                                                               // 98
          newUser.appDemoId = appDemoId;                                                                               // 99
        }                                                                                                              // 100
                                                                                                                       //
        var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                              // 102
                                                                                                                       //
        // Log them in on this connection.                                                                             // 104
        return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                          // 105
          return { userId: userId };                                                                                   // 106
        });                                                                                                            // 106
      }                                                                                                                // 107
                                                                                                                       //
      return createDemoUser;                                                                                           // 88
    }(),                                                                                                               // 88
                                                                                                                       //
    testExpireDemo: function () {                                                                                      // 109
      function testExpireDemo() {                                                                                      // 109
        if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                             // 110
                                                                                                                       //
        var newExpires = new Date(Date.now() + 15000);                                                                 // 112
        if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                  // 113
          throw new Meteor.Error(403, "can't exend demo");                                                             // 114
        }                                                                                                              // 115
                                                                                                                       //
        Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                           // 117
      }                                                                                                                // 118
                                                                                                                       //
      return testExpireDemo;                                                                                           // 109
    }()                                                                                                                // 109
  });                                                                                                                  // 87
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to information about an app by                         // 121
  // appId. If this were available in non-demo mode, then anonymous users could effectively ask the                    // 122
  // server which apps are installed.                                                                                  // 123
  Meteor.publish("appDemoInfo", function (appId) {                                                                     // 124
    // This publishes info about an app, including the latest version of it. Once you log in, it                       // 125
    // also publishes your list of UserActions.                                                                        // 126
    check(appId, String);                                                                                              // 127
                                                                                                                       //
    // Get data about this app from the app index. Note that the app index cache on this server                        // 129
    // is typically 6-24 hours delayed from reality, so if an app is newly-available                                   // 130
    // in the app market, it won't be in the app index. Therefore we don't bail-out if the app                         // 131
    // is missing from the AppIndex collection.                                                                        // 132
    var appIndexData = globalDb.collections.appIndex.findOne({ appId: appId });                                        // 133
                                                                                                                       //
    // Prepare a helper function we can use to transform a package cursor into an appropriate return                   // 135
    // value for this function.                                                                                        // 136
    var packageCursorAndMaybeUserActions = function packageCursorAndMaybeUserActions(userId, appId, packageCursor) {   // 137
      // This allows us to avoid creating duplicate UserActions.                                                       // 138
      if (userId) {                                                                                                    // 139
        return [packageCursor, UserActions.find({ userId: userId, appId: appId })];                                    // 140
      }                                                                                                                // 144
                                                                                                                       //
      return packageCursor;                                                                                            // 146
    };                                                                                                                 // 147
                                                                                                                       //
    // If the app is in the app index, and the current version is installed, always return that. If                    // 149
    // that package isn't installed, store the version number so we can filter on it later.                            // 150
    var packageQuery = {};                                                                                             // 151
    if (appIndexData) {                                                                                                // 152
      var appIndexPackageQuery = Packages.find({ _id: appIndexData.packageId });                                       // 153
      if (appIndexPackageQuery.count() > 0) {                                                                          // 154
        return packageCursorAndMaybeUserActions(this.userId, appId, appIndexPackageQuery);                             // 155
      }                                                                                                                // 156
                                                                                                                       //
      // If the app index version isn't present, insist on a lower version than the app index                          // 158
      // version. This avoids accidentally catching some development version of the app that has the                   // 159
      // same version number as the app market version but isn't the app market version.                               // 160
      packageQuery["manifest.appVersion"] = { $lt: appIndexData.versionNumber };                                       // 161
    }                                                                                                                  // 162
                                                                                                                       //
    // If the specific package from the app index isn't installed, or the app isn't there at all, do                   // 164
    // our best.                                                                                                       // 165
    packageQuery.appId = appId;                                                                                        // 166
    var packageCursor = Packages.find(packageQuery, { sort: { "manifest.appVersion": -1 },                             // 167
      limit: 1                                                                                                         // 170
    });                                                                                                                // 169
    return packageCursorAndMaybeUserActions(this.userId, appId, packageCursor);                                        // 172
  });                                                                                                                  // 173
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 175
} else {                                                                                                               // 176
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           // 177
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 178
}                                                                                                                      // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        // 20
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       // 21
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   // 37
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function () {                                                                                               // 43
      function added(doc) {                                                                                            // 43
        _this.added("desktopNotifications", doc._id, doc);                                                             // 44
      }                                                                                                                // 45
                                                                                                                       //
      return added;                                                                                                    // 43
    }(),                                                                                                               // 43
                                                                                                                       //
    changed: function () {                                                                                             // 47
      function changed(newDoc, oldDoc) {                                                                               // 47
        _this.changed("desktopNotifications", newDoc._id, newDoc);                                                     // 48
      }                                                                                                                // 49
                                                                                                                       //
      return changed;                                                                                                  // 47
    }(),                                                                                                               // 47
                                                                                                                       //
    removed: function () {                                                                                             // 51
      function removed(doc) {                                                                                          // 51
        _this.removed("desktopNotifications", doc._id);                                                                // 52
      }                                                                                                                // 53
                                                                                                                       //
      return removed;                                                                                                  // 51
    }()                                                                                                                // 51
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function () {                                                                                      // 20
    function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                                        // 20
      // This is a login method that creates or logs in a dev account with the given displayName                       // 21
                                                                                                                       //
      check(displayName, String);                                                                                      // 23
      check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                           // 24
      check(profile, Match.OneOf(undefined, null, Object));                                                            // 25
      check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                    // 26
                                                                                                                       //
      if (!this.connection.sandstormDb.allowDevAccounts()) {                                                           // 28
        throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                    // 29
      }                                                                                                                // 30
                                                                                                                       //
      isAdmin = isAdmin || false;                                                                                      // 32
                                                                                                                       //
      profile = profile || {};                                                                                         // 34
      profile.name = profile.name || displayName;                                                                      // 35
      var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                             // 36
                                                                                                                       //
      var user = Meteor.users.findOne({ "services.dev.name": displayName });                                           // 38
      var userId = void 0;                                                                                             // 39
                                                                                                                       //
      if (user) {                                                                                                      // 41
        userId = user._id;                                                                                             // 42
      } else {                                                                                                         // 43
        userId = Accounts.insertUserDoc({                                                                              // 44
          profile: profile,                                                                                            // 45
          unverifiedEmail: unverifiedEmail                                                                             // 46
        }, {                                                                                                           // 44
          services: {                                                                                                  // 48
            dev: {                                                                                                     // 49
              name: displayName,                                                                                       // 50
              isAdmin: isAdmin,                                                                                        // 51
              hasCompletedSignup: hasCompletedSignup                                                                   // 52
            }                                                                                                          // 49
          }                                                                                                            // 48
        });                                                                                                            // 47
      }                                                                                                                // 56
      // Log them in on this connection.                                                                               // 57
      return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                           // 58
        return { userId: userId };                                                                                     // 59
      });                                                                                                              // 59
    }                                                                                                                  // 60
                                                                                                                       //
    return createDevAccount;                                                                                           // 20
  }()                                                                                                                  // 20
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-server.js":["babel-runtime/helpers/typeof","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       // 18
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 20
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 22
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 27
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 29
  check(grainId, String);                                                                                              // 30
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 32
    _id: grainId,                                                                                                      // 34
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 35
  }, {                                                                                                                 // 33
    fields: {                                                                                                          // 40
      title: 1,                                                                                                        // 41
      userId: 1,                                                                                                       // 42
      identityId: 1,                                                                                                   // 43
      "private": 1                                                                                                     // 44
    }                                                                                                                  // 40
  })];                                                                                                                 // 39
  if (this.userId) {                                                                                                   // 48
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 49
    result.push(ApiTokens.find({                                                                                       // 50
      grainId: grainId,                                                                                                // 51
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 52
    }));                                                                                                               // 50
  }                                                                                                                    // 57
                                                                                                                       //
  return result;                                                                                                       // 59
});                                                                                                                    // 60
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 // 62
// This is used for obtaining icon and app title information for grains                                                // 63
// you own, which is used in the sidebar. It is not a security/privacy                                                 // 64
// risk since it only exposes this information for grains the user owns.                                               // 65
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 66
  check(grainId, String);                                                                                              // 67
  var publishThis = [];                                                                                                // 68
  // We need to publish the packageId so that client-side code can                                                     // 69
  // find the right package.                                                                                           // 70
  var thisGrainCursor = Grains.find({                                                                                  // 71
    _id: grainId,                                                                                                      // 72
    userId: this.userId                                                                                                // 73
  }, {                                                                                                                 // 71
    fields: { packageId: 1 }                                                                                           // 75
  });                                                                                                                  // 74
  publishThis.push(thisGrainCursor);                                                                                   // 77
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 79
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 80
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 81
    publishThis.push(thisPackageCursor);                                                                               // 82
  }                                                                                                                    // 83
                                                                                                                       //
  return publishThis;                                                                                                  // 85
});                                                                                                                    // 86
                                                                                                                       //
Meteor.publish("tokenInfo", function (token, isStandalone) {                                                           // 88
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           // 89
  // metadata that it will need to display the app icon and title.  We do not care about making                        // 90
  // the metadata reactive.                                                                                            // 91
  check(token, String);                                                                                                // 92
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 94
  var apiToken = ApiTokens.findOne({                                                                                   // 95
    _id: hashedToken                                                                                                   // 96
  }, {                                                                                                                 // 95
    fields: {                                                                                                          // 98
      grainId: 1,                                                                                                      // 99
      identityId: 1,                                                                                                   // 100
      owner: 1,                                                                                                        // 101
      revoked: 1                                                                                                       // 102
    }                                                                                                                  // 98
  });                                                                                                                  // 97
  if (!apiToken) {                                                                                                     // 105
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 106
  } else if (apiToken.revoked) {                                                                                       // 107
    this.added("tokenInfo", token, { revoked: true });                                                                 // 108
  } else {                                                                                                             // 109
    var grainId = apiToken.grainId;                                                                                    // 110
    var grain = Grains.findOne({                                                                                       // 111
      _id: grainId                                                                                                     // 112
    }, {                                                                                                               // 111
      fields: {                                                                                                        // 114
        packageId: 1,                                                                                                  // 115
        appId: 1,                                                                                                      // 116
        userId: 1                                                                                                      // 117
      }                                                                                                                // 114
    });                                                                                                                // 113
    if (!grain) {                                                                                                      // 120
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 121
    } else {                                                                                                           // 122
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 123
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 124
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 125
        if (identity && metadata) {                                                                                    // 126
          SandstormDb.fillInLoginId(identity);                                                                         // 127
          this.added("tokenInfo", token, {                                                                             // 128
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 129
            grainId: grainId,                                                                                          // 130
            grainMetadata: metadata                                                                                    // 131
          });                                                                                                          // 128
        } else {                                                                                                       // 133
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 134
        }                                                                                                              // 135
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 136
        if (this.userId && !isStandalone) {                                                                            // 137
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 138
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 139
          var childToken = ApiTokens.findOne({                                                                         // 140
            "owner.user.identityId": { $in: identityIds },                                                             // 141
            parentToken: apiToken._id                                                                                  // 142
          });                                                                                                          // 140
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 144
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 146
            this.ready();                                                                                              // 147
            return;                                                                                                    // 148
          }                                                                                                            // 149
        }                                                                                                              // 150
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 152
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 153
        var appIcon = undefined;                                                                                       // 154
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 155
          var icons = pkg.manifest.metadata.icons;                                                                     // 156
          appIcon = icons.grain || icons.appGrid;                                                                      // 157
        }                                                                                                              // 158
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 160
          appTitle: appTitle,                                                                                          // 161
          icon: appIcon,                                                                                               // 162
          appId: appIcon ? undefined : grain.appId                                                                     // 163
        };                                                                                                             // 160
        this.added("tokenInfo", token, {                                                                               // 165
          webkey: true,                                                                                                // 166
          grainId: grainId,                                                                                            // 167
          grainMetadata: denormalizedGrainMetadata                                                                     // 168
        });                                                                                                            // 165
      } else {                                                                                                         // 170
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 171
      }                                                                                                                // 172
    }                                                                                                                  // 173
  }                                                                                                                    // 174
                                                                                                                       //
  this.ready();                                                                                                        // 176
  return;                                                                                                              // 177
});                                                                                                                    // 178
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 180
  check(grainId, String);                                                                                              // 181
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 183
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 184
  }                                                                                                                    // 185
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 187
  if (!grain) {                                                                                                        // 188
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 189
  }                                                                                                                    // 190
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 192
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 193
  }                                                                                                                    // 195
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 197
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 198
                                                                                                                       //
  var _this = this;                                                                                                    // 201
  var query = ApiTokens.find({                                                                                         // 202
    grainId: grainId,                                                                                                  // 203
    identityId: { $in: ownerIdentityIds },                                                                             // 204
    parentToken: { $exists: false },                                                                                   // 205
    "owner.user.identityId": { $in: identityIds },                                                                     // 206
    revoked: { $ne: true }                                                                                             // 207
  });                                                                                                                  // 202
  var handle = query.observe({                                                                                         // 209
    added: function () {                                                                                               // 210
      function added(apiToken) {                                                                                       // 209
        _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
      }                                                                                                                // 213
                                                                                                                       //
      return added;                                                                                                    // 209
    }()                                                                                                                // 209
  });                                                                                                                  // 209
                                                                                                                       //
  this.onStop(function () {                                                                                            // 216
    return handle.stop();                                                                                              // 216
  });                                                                                                                  // 216
});                                                                                                                    // 217
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 219
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 220
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 221
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 222
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 223
});                                                                                                                    // 224
                                                                                                                       //
Meteor.methods({                                                                                                       // 226
  updateGrainPreferredIdentity: function () {                                                                          // 227
    function updateGrainPreferredIdentity(grainId, identityId) {                                                       // 227
      check(grainId, String);                                                                                          // 228
      check(identityId, String);                                                                                       // 229
      if (!this.userId) {                                                                                              // 230
        throw new Meteor.Error(403, "Must be logged in.");                                                             // 231
      }                                                                                                                // 232
                                                                                                                       //
      var grain = globalDb.getGrain(grainId) || {};                                                                    // 234
      if (!grain.userId === this.userId) {                                                                             // 235
        throw new Meteor.Error(403, "Grain not owned by current user.");                                               // 236
      }                                                                                                                // 237
                                                                                                                       //
      Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                           // 239
    }                                                                                                                  // 240
                                                                                                                       //
    return updateGrainPreferredIdentity;                                                                               // 227
  }(),                                                                                                                 // 227
                                                                                                                       //
  updateGrainTitle: function () {                                                                                      // 242
    function updateGrainTitle(grainId, newTitle, identityId) {                                                         // 242
      check(grainId, String);                                                                                          // 243
      check(newTitle, String);                                                                                         // 244
      check(identityId, String);                                                                                       // 245
      if (this.userId) {                                                                                               // 246
        var grain = Grains.findOne(grainId);                                                                           // 247
        if (grain) {                                                                                                   // 248
          if (grain.userId === this.userId) {                                                                          // 249
            Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                       // 250
                                                                                                                       //
            // Denormalize new title out to all sharing tokens.                                                        // 252
            ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
          } else {                                                                                                     // 256
            if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                  // 257
              throw new Meteor.Error(403, "Current user does not have identity " + identityId);                        // 258
            }                                                                                                          // 259
                                                                                                                       //
            var token = ApiTokens.findOne({                                                                            // 261
              grainId: grainId,                                                                                        // 262
              objectId: { $exists: false },                                                                            // 263
              "owner.user.identityId": identityId                                                                      // 264
            }, {                                                                                                       // 261
              sort: { created: 1 } });                                                                                 // 266
            if (token && token.owner.user.title !== newTitle) {                                                        // 268
              if (token.owner.user.upstreamTitle === newTitle) {                                                       // 269
                // User renamed grain to match upstream title. Act like they never renamed it at                       // 270
                // all.                                                                                                // 271
                ApiTokens.update({                                                                                     // 272
                  grainId: grainId,                                                                                    // 273
                  "owner.user.identityId": identityId                                                                  // 274
                }, {                                                                                                   // 272
                  $set: { "owner.user.title": newTitle },                                                              // 276
                  $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                   // 277
                }, {                                                                                                   // 275
                  multi: true                                                                                          // 279
                });                                                                                                    // 278
              } else {                                                                                                 // 281
                var modification = {                                                                                   // 282
                  "owner.user.title": newTitle,                                                                        // 283
                  "owner.user.renamed": true                                                                           // 284
                };                                                                                                     // 282
                                                                                                                       //
                if (!token.owner.user.upstreamTitle) {                                                                 // 287
                  // If `upstreamTitle` isn't present then it is equal to the old title.                               // 288
                  modification["owner.user.upstreamTitle"] = token.owner.user.title;                                   // 289
                }                                                                                                      // 290
                                                                                                                       //
                ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
              }                                                                                                        // 295
            }                                                                                                          // 296
          }                                                                                                            // 297
        }                                                                                                              // 298
      }                                                                                                                // 299
    }                                                                                                                  // 300
                                                                                                                       //
    return updateGrainTitle;                                                                                           // 242
  }(),                                                                                                                 // 242
                                                                                                                       //
  privatizeGrain: function () {                                                                                        // 302
    function privatizeGrain(grainId) {                                                                                 // 302
      check(grainId, String);                                                                                          // 303
      if (this.userId) {                                                                                               // 304
        Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                           // 305
      }                                                                                                                // 306
    }                                                                                                                  // 307
                                                                                                                       //
    return privatizeGrain;                                                                                             // 302
  }(),                                                                                                                 // 302
                                                                                                                       //
  inviteUsersToGrain: function () {                                                                                    // 309
    function inviteUsersToGrain(_origin, identityId, grainId, title, roleAssignment, contacts, message) {              // 309
      var _this2 = this;                                                                                               // 310
                                                                                                                       //
      if ((typeof message === "undefined" ? "undefined" : _typeof(message)) === "object") {                            // 311
        // Older versions of the client passed an object here, but we only care about the `text`                       // 312
        // parameter. (This block can eventually be removed.)                                                          // 313
        message = message.text;                                                                                        // 314
      }                                                                                                                // 315
                                                                                                                       //
      if (!this.isSimulation) {                                                                                        // 317
        var _ret = function () {                                                                                       // 317
          check(_origin, String);                                                                                      // 318
          check(identityId, String);                                                                                   // 319
          check(grainId, String);                                                                                      // 320
          check(title, String);                                                                                        // 321
          check(roleAssignment, roleAssignmentPattern);                                                                // 322
          check(contacts, [{                                                                                           // 323
            _id: String,                                                                                               // 325
            isDefault: Match.Optional(Boolean),                                                                        // 326
            profile: Match.ObjectIncluding({                                                                           // 327
              service: String,                                                                                         // 328
              name: String,                                                                                            // 329
              intrinsicName: String                                                                                    // 330
            })                                                                                                         // 327
          }]);                                                                                                         // 324
          check(message, String);                                                                                      // 334
          if (!_this2.userId) {                                                                                        // 335
            throw new Meteor.Error(403, "Must be logged in to share by email.");                                       // 336
          }                                                                                                            // 337
                                                                                                                       //
          if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                  // 339
            throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                         // 340
          }                                                                                                            // 341
                                                                                                                       //
          if (contacts.length === 0) {                                                                                 // 343
            throw new Meteor.Error(400, "No contacts were provided.");                                                 // 344
          }                                                                                                            // 345
                                                                                                                       //
          if (globalDb.isDemoUser()) {                                                                                 // 347
            throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                              // 348
          }                                                                                                            // 349
                                                                                                                       //
          var escapedMessage = message.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/\n/g, "<br>");
                                                                                                                       //
          var accountId = _this2.userId;                                                                               // 357
          var outerResult = { successes: [], failures: [] };                                                           // 358
          var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                        // 359
          var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                               // 360
          contacts.forEach(function (contact) {                                                                        // 361
            if (contact.isDefault && contact.profile.service === "email") {                                            // 362
              var emailAddress = contact.profile.intrinsicName;                                                        // 363
              var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
              var url = ROOT_URL + "/shared/" + result.token;                                                          // 368
              var html = escapedMessage + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
              try {                                                                                                    // 374
                globalDb.incrementDailySentMailCount(accountId);                                                       // 375
                sendEmail({                                                                                            // 376
                  to: emailAddress,                                                                                    // 377
                  from: fromEmail,                                                                                     // 378
                  replyTo: replyTo,                                                                                    // 379
                  subject: title + " - Invitation to collaborate",                                                     // 380
                  text: message + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                  html: html                                                                                           // 384
                });                                                                                                    // 376
              } catch (e) {                                                                                            // 386
                outerResult.failures.push({ contact: contact, error: e.toString() });                                  // 387
              }                                                                                                        // 388
            } else {                                                                                                   // 389
              var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
              var _url = ROOT_URL + "/shared/" + _result.token;                                                        // 394
              try {                                                                                                    // 395
                var identity = Meteor.users.findOne({ _id: contact._id });                                             // 396
                var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                   // 397
                if (email) {                                                                                           // 399
                  var intrinsicName = contact.profile.intrinsicName;                                                   // 400
                  var loginNote = void 0;                                                                              // 401
                  if (contact.profile.service === "google") {                                                          // 402
                    loginNote = "Google account with address " + email.email;                                          // 403
                  } else if (contact.profile.service === "github") {                                                   // 404
                    loginNote = "Github account with username " + intrinsicName;                                       // 405
                  } else if (contact.profile.service === "email") {                                                    // 406
                    loginNote = "email address " + intrinsicName;                                                      // 407
                  } else if (contact.profile.service === "ldap") {                                                     // 408
                    loginNote = "LDAP username " + intrinsicName;                                                      // 409
                  } else if (contact.profile.service === "saml") {                                                     // 410
                    loginNote = "SAML ID " + intrinsicName;                                                            // 411
                  } else {                                                                                             // 412
                    throw new Meteor.Error(500, "Unknown service to email share link.");                               // 413
                  }                                                                                                    // 414
                                                                                                                       //
                  var _html = escapedMessage + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                  globalDb.incrementDailySentMailCount(accountId);                                                     // 421
                  sendEmail({                                                                                          // 422
                    to: email.email,                                                                                   // 423
                    from: fromEmail,                                                                                   // 424
                    replyTo: replyTo,                                                                                  // 425
                    subject: title + " - Invitation to collaborate",                                                   // 426
                    text: message + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                    html: _html                                                                                        // 430
                  });                                                                                                  // 422
                } else {                                                                                               // 432
                  outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
                }                                                                                                      // 436
              } catch (e) {                                                                                            // 437
                outerResult.failures.push({ contact: contact, error: e.toString(),                                     // 438
                  warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 441
            }                                                                                                          // 442
          });                                                                                                          // 443
                                                                                                                       //
          return {                                                                                                     // 445
            v: outerResult                                                                                             // 445
          };                                                                                                           // 445
        }();                                                                                                           // 317
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 317
      }                                                                                                                // 446
    }                                                                                                                  // 447
                                                                                                                       //
    return inviteUsersToGrain;                                                                                         // 309
  }(),                                                                                                                 // 309
                                                                                                                       //
  requestAccess: function () {                                                                                         // 449
    function requestAccess(_origin, grainId, identityId) {                                                             // 449
      check(_origin, String);                                                                                          // 450
      check(grainId, String);                                                                                          // 451
      check(identityId, String);                                                                                       // 452
      if (!this.isSimulation) {                                                                                        // 453
        if (!this.userId) {                                                                                            // 454
          throw new Meteor.Error(403, "Must be logged in to request access.");                                         // 455
        }                                                                                                              // 456
                                                                                                                       //
        if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                      // 458
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 459
        }                                                                                                              // 460
                                                                                                                       //
        var grain = Grains.findOne(grainId);                                                                           // 462
        if (!grain) {                                                                                                  // 463
          throw new Meteor.Error(404, "No such grain");                                                                // 464
        }                                                                                                              // 465
                                                                                                                       //
        var grainOwner = globalDb.getUser(grain.userId);                                                               // 467
        var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                             // 468
        if (!email) {                                                                                                  // 469
          throw new Meteor.Error("no email", "Grain owner has no email address.");                                     // 470
        }                                                                                                              // 471
                                                                                                                       //
        var emailAddress = email.email;                                                                                // 473
                                                                                                                       //
        var identity = globalDb.getIdentity(identityId);                                                               // 475
        globalDb.addContact(grainOwner._id, identityId);                                                               // 476
                                                                                                                       //
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 478
        var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                           // 479
                                                                                                                       //
        // TODO(soon): In the HTML version, we should display an identity card.                                        // 481
        var identityNote = "";                                                                                         // 482
        if (identity.profile.service === "google") {                                                                   // 483
          identityNote = " (" + identity.privateIntrinsicName + ")";                                                   // 484
        } else if (identity.profile.service === "github") {                                                            // 485
          identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                        // 486
        } else if (identity.profile.service === "email") {                                                             // 487
          identityNote = " (" + identity.profile.intrinsicName + ")";                                                  // 488
        } else if (identity.profile.service === "ldap") {                                                              // 489
          identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                          // 490
        } else if (identity.profile.service === "saml") {                                                              // 491
          identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                          // 492
        }                                                                                                              // 493
                                                                                                                       //
        var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
        var url = ROOT_URL + "/share/" + grainId + "/" + identityId;                                                   // 498
                                                                                                                       //
        var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                          // 500
                                                                                                                       //
        var user = Meteor.user();                                                                                      // 503
        var ACCESS_REQUEST_LIMIT = 10;                                                                                 // 504
        var resetCount = true;                                                                                         // 505
        if (user.accessRequests) {                                                                                     // 506
          if (user.accessRequests.resetOn < new Date()) {                                                              // 507
            Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                 // 508
          } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                              // 509
            throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
          } else {                                                                                                     // 513
            resetCount = false;                                                                                        // 514
          }                                                                                                            // 515
        }                                                                                                              // 516
                                                                                                                       //
        var modifier = { $inc: { "accessRequests.count": 1 } };                                                        // 518
        if (resetCount) {                                                                                              // 519
          var tomorrow = new Date(Date.now() + 86400000);                                                              // 520
          modifier.$set = { "accessRequests.resetOn": tomorrow };                                                      // 521
        }                                                                                                              // 522
                                                                                                                       //
        Meteor.users.update({ _id: user._id }, modifier);                                                              // 524
                                                                                                                       //
        sendEmail({                                                                                                    // 526
          to: emailAddress,                                                                                            // 527
          from: fromEmail,                                                                                             // 528
          replyTo: replyTo,                                                                                            // 529
          subject: grain.title + " - Request for access",                                                              // 530
          text: message + "\n\nFollow this link to share access:\n\n" + url,                                           // 531
          html: html                                                                                                   // 532
        });                                                                                                            // 526
      }                                                                                                                // 534
    }                                                                                                                  // 535
                                                                                                                       //
    return requestAccess;                                                                                              // 449
  }()                                                                                                                  // 449
});                                                                                                                    // 226
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                         // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 37
HOSTNAME = ROOT_URL.hostname;                                                                                          // 38
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 40
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 41
    _classCallCheck(this, SessionContextImpl);                                                                         // 41
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 42
    this.sessionId = sessionId;                                                                                        // 43
    this.identityId = identityId;                                                                                      // 44
    this.tabId = tabId;                                                                                                // 45
  }                                                                                                                    // 46
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function () {                                                            // 40
    function claimRequest(sturdyRef, requiredPermissions) {                                                            // 40
      var _this2 = this;                                                                                               // 48
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 49
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 50
                                                                                                                       //
        var token = ApiTokens.findOne({                                                                                // 52
          _id: hashedSturdyRef,                                                                                        // 53
          "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                    // 54
        });                                                                                                            // 52
                                                                                                                       //
        if (!token) {                                                                                                  // 57
          throw new Error("no such token");                                                                            // 58
        }                                                                                                              // 59
                                                                                                                       //
        var session = Sessions.findOne({ _id: _this2.sessionId });                                                     // 61
                                                                                                                       //
        if (!session) {                                                                                                // 63
          throw new Error("no such session");                                                                          // 64
        }                                                                                                              // 65
                                                                                                                       //
        // Honor `requiredPermissions`.                                                                                // 67
        var requirements = [];                                                                                         // 68
        if (session.hashedToken) {                                                                                     // 69
          // Session is authorized by token. Note that it's important to check this before identityId                  // 70
          // e.g. in the case of standalone domains.                                                                   // 71
          requirements.push({                                                                                          // 72
            permissionsHeld: {                                                                                         // 73
              permissions: requiredPermissions || [],                                                                  // 74
              tokenId: session.hashedToken,                                                                            // 75
              grainId: _this2.grainId                                                                                  // 76
            }                                                                                                          // 73
          });                                                                                                          // 72
        } else if (session.identityId) {                                                                               // 79
          // Session is authorized by identity.                                                                        // 80
          requirements.push({                                                                                          // 81
            permissionsHeld: {                                                                                         // 82
              permissions: requiredPermissions || [],                                                                  // 83
              identityId: session.identityId,                                                                          // 84
              grainId: _this2.grainId                                                                                  // 85
            }                                                                                                          // 82
          });                                                                                                          // 81
        } else {                                                                                                       // 88
          // This can only happen with old-style sharing which has been deprecated for years. If                       // 89
          // we wanted to support this, I suppose we could do so as long as requiredPermissions is                     // 90
          // all-false? But probably this will never come up.                                                          // 91
          throw new Error("Cannot accept powerbox request from anonymous session that " + "doesn't have a token.");    // 92
        }                                                                                                              // 94
                                                                                                                       //
        return restoreInternal(globalDb, new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ sessionId: _this2.sessionId }) }, requirements, token);
      });                                                                                                              // 101
    }                                                                                                                  // 102
                                                                                                                       //
    return claimRequest;                                                                                               // 40
  }();                                                                                                                 // 40
                                                                                                                       //
  SessionContextImpl.prototype._offerOrFulfill = function () {                                                         // 40
    function _offerOrFulfill(isFulfill, cap, requiredPermissions, descriptor, displayInfo) {                           // 40
      var _this3 = this;                                                                                               // 104
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 105
                                                                                                                       //
        var session = Sessions.findOne({ _id: _this3.sessionId });                                                     // 107
                                                                                                                       //
        if (!session.identityId && !session.hashedToken) {                                                             // 109
          throw new Error("Session has neither an identityId nor a hashedToken.");                                     // 110
        }                                                                                                              // 111
                                                                                                                       //
        if (isFulfill && !session.powerboxRequest) {                                                                   // 113
          // Not a request session, so treat fulfillRequest() same as offer().                                         // 114
          isFulfill = false;                                                                                           // 115
        }                                                                                                              // 116
                                                                                                                       //
        var castedCap = cap.castAs(SystemPersistent);                                                                  // 118
        var apiTokenOwner = { clientPowerboxOffer: { sessionId: _this3.sessionId } };                                  // 119
        var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
        if (isUiView) {                                                                                                // 123
          var tagValue = {};                                                                                           // 124
          if (descriptor.tags[0].value) {                                                                              // 125
            tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                // 126
          }                                                                                                            // 127
                                                                                                                       //
          if (!tagValue.title) {                                                                                       // 129
            throw new Error("No value provided for UiView.PowerboxTag.title.");                                        // 130
          }                                                                                                            // 131
                                                                                                                       //
          if (session.identityId) {                                                                                    // 133
            apiTokenOwner = {                                                                                          // 134
              user: {                                                                                                  // 135
                identityId: _this3.identityId,                                                                         // 136
                title: tagValue.title                                                                                  // 137
              }                                                                                                        // 135
            };                                                                                                         // 134
          }                                                                                                            // 140
        }                                                                                                              // 141
                                                                                                                       //
        if (isFulfill) {                                                                                               // 143
          // The capability will pass directly to the requesting grain.                                                // 144
          apiTokenOwner = {                                                                                            // 145
            clientPowerboxRequest: {                                                                                   // 146
              sessionId: session.powerboxRequest.requestingSession                                                     // 147
            }                                                                                                          // 146
          };                                                                                                           // 145
        }                                                                                                              // 150
                                                                                                                       //
        // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                        // 152
        // are fully implemented for supervisors.                                                                      // 153
        var permissionsHeld = {                                                                                        // 154
          grainId: _this3.grainId,                                                                                     // 155
          permissions: requiredPermissions                                                                             // 156
        };                                                                                                             // 154
                                                                                                                       //
        // Note that if both hashedToken and identityId are present, this indicates that the session                   // 159
        // is authorized by a token which the user has NOT redeemed. Thus the identity does not                        // 160
        // directly have access to the grain; the token does. (This is the case in particular for                      // 161
        // standalone domains.) So clearly we want our requirement to be based on the token, not the                   // 162
        // identity.                                                                                                   // 163
        if (session.hashedToken) {                                                                                     // 164
          permissionsHeld.tokenId = session.hashedToken;                                                               // 165
        } else if (session.identityId) {                                                                               // 166
          permissionsHeld.identityId = session.identityId;                                                             // 167
        } else {                                                                                                       // 168
          throw new Error("Cannot offer to anonymous session that does not have a token.");                            // 169
        }                                                                                                              // 170
                                                                                                                       //
        var requirement = { permissionsHeld: permissionsHeld };                                                        // 172
                                                                                                                       //
        checkRequirements(globalDb, [requirement]);                                                                    // 174
                                                                                                                       //
        var save = castedCap.save(apiTokenOwner);                                                                      // 176
        var sturdyRef = waitPromise(save).sturdyRef;                                                                   // 177
        ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                 // 178
                                                                                                                       //
        var powerboxView = void 0;                                                                                     // 180
        if (isFulfill) {                                                                                               // 181
          powerboxView = {                                                                                             // 182
            fulfill: {                                                                                                 // 183
              token: sturdyRef.toString(),                                                                             // 184
              descriptor: Capnp.serializePacked(Powerbox.PowerboxDescriptor, descriptor).toString("base64")            // 185
            }                                                                                                          // 183
          };                                                                                                           // 182
        } else if (isUiView) {                                                                                         // 189
          if (session.identityId) {                                                                                    // 190
            // Deduplicate.                                                                                            // 191
            var tokenId = hashSturdyRef(sturdyRef.toString());                                                         // 192
            var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                     // 193
            var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
            dupeQuery._id = { $ne: newApiToken._id };                                                                  // 196
            dupeQuery["owner.user.identityId"] = _this3.identityId;                                                    // 197
            dupeQuery.trashed = { $exists: false };                                                                    // 198
            dupeQuery.revoked = { $exists: false };                                                                    // 199
                                                                                                                       //
            var dupeToken = ApiTokens.findOne(dupeQuery);                                                              // 201
            if (dupeToken) {                                                                                           // 202
              globalDb.removeApiTokens({ _id: tokenId });                                                              // 203
              tokenId = dupeToken._id;                                                                                 // 204
            }                                                                                                          // 205
                                                                                                                       //
            powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                // 207
          } else {                                                                                                     // 208
            powerboxView = { offer: { uiView: { token: sturdyRef.toString() } } };                                     // 209
          }                                                                                                            // 210
        } else {                                                                                                       // 211
          powerboxView = {                                                                                             // 212
            offer: {                                                                                                   // 213
              token: sturdyRef.toString()                                                                              // 214
            }                                                                                                          // 213
          };                                                                                                           // 212
        }                                                                                                              // 217
                                                                                                                       //
        Sessions.update({ _id: _this3.sessionId }, {                                                                   // 219
          $set: {                                                                                                      // 221
            powerboxView: powerboxView                                                                                 // 222
          }                                                                                                            // 221
        });                                                                                                            // 220
      });                                                                                                              // 226
    }                                                                                                                  // 227
                                                                                                                       //
    return _offerOrFulfill;                                                                                            // 40
  }();                                                                                                                 // 40
                                                                                                                       //
  SessionContextImpl.prototype.offer = function () {                                                                   // 40
    function offer(cap, requiredPermissions, descriptor, displayInfo) {                                                // 40
      return this._offerOrFulfill(false, cap, requiredPermissions, descriptor, displayInfo);                           // 230
    }                                                                                                                  // 231
                                                                                                                       //
    return offer;                                                                                                      // 40
  }();                                                                                                                 // 40
                                                                                                                       //
  SessionContextImpl.prototype.fulfillRequest = function () {                                                          // 40
    function fulfillRequest(cap, requiredPermissions, descriptor, displayInfo) {                                       // 40
      return this._offerOrFulfill(true, cap, requiredPermissions, descriptor, displayInfo);                            // 234
    }                                                                                                                  // 235
                                                                                                                       //
    return fulfillRequest;                                                                                             // 40
  }();                                                                                                                 // 40
                                                                                                                       //
  SessionContextImpl.prototype.activity = function () {                                                                // 40
    function activity(event) {                                                                                         // 40
      var _this4 = this;                                                                                               // 237
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 238
        logActivity(_this4.grainId, _this4.identityId || "anonymous", event);                                          // 239
      });                                                                                                              // 240
    }                                                                                                                  // 241
                                                                                                                       //
    return activity;                                                                                                   // 40
  }();                                                                                                                 // 40
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 40
}();                                                                                                                   // 40
                                                                                                                       //
Meteor.methods({                                                                                                       // 244
  finishPowerboxRequest: function () {                                                                                 // 245
    function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {                             // 244
      check(sessionId, String);                                                                                        // 246
      check(webkeyUrl, String);                                                                                        // 247
      check(saveLabel, Match.OneOf(undefined, null, String));                                                          // 248
      check(identityId, String);                                                                                       // 249
      check(grainId, String);                                                                                          // 250
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 252
                                                                                                                       //
      var userId = Meteor.userId();                                                                                    // 254
      if (!userId || !db.userHasIdentity(userId, identityId)) {                                                        // 255
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 256
      }                                                                                                                // 257
                                                                                                                       //
      var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                  // 259
      var hostId = matchWildcardHost(parsedWebkey.host);                                                               // 260
      if (!hostId || !db.isApiHostId(hostId)) {                                                                        // 261
        throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
      }                                                                                                                // 264
                                                                                                                       //
      var token = parsedWebkey.hash;                                                                                   // 266
      if (!token) {                                                                                                    // 267
        throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
      }                                                                                                                // 270
                                                                                                                       //
      token = token.slice(1);                                                                                          // 272
      if (db.isTokenSpecificHostId(hostId) && hostId !== db.apiHostIdForToken(token)) {                                // 273
        // Note: This case is not security-sensitive. The client could easily compute the correct                      // 274
        //   host ID for this token. But since they've passed one that doesn't match, we assume                        // 275
        //   something is wrong and stop here.                                                                         // 276
        throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                  // 277
      }                                                                                                                // 278
                                                                                                                       //
      var cap = restoreInternal(db, new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 282
      var owner = {                                                                                                    // 283
        clientPowerboxRequest: {                                                                                       // 284
          grainId: grainId,                                                                                            // 285
          introducerIdentity: identityId,                                                                              // 286
          sessionId: sessionId                                                                                         // 287
        }                                                                                                              // 284
      };                                                                                                               // 283
      if (saveLabel) {                                                                                                 // 290
        grainOwner.saveLabel = {                                                                                       // 291
          defaultText: saveLabel                                                                                       // 292
        };                                                                                                             // 291
      }                                                                                                                // 294
                                                                                                                       //
      var save = castedCap.save(owner);                                                                                // 296
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 297
      return sturdyRef.toString();                                                                                     // 298
    }                                                                                                                  // 299
                                                                                                                       //
    return finishPowerboxRequest;                                                                                      // 244
  }(),                                                                                                                 // 244
  finishPowerboxOffer: function () {                                                                                   // 301
    function finishPowerboxOffer(sessionId) {                                                                          // 244
      check(sessionId, String);                                                                                        // 302
                                                                                                                       //
      Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                         // 304
    }                                                                                                                  // 305
                                                                                                                       //
    return finishPowerboxOffer;                                                                                        // 244
  }(),                                                                                                                 // 244
  getViewInfoForApiToken: function () {                                                                                // 307
    function getViewInfoForApiToken(apiTokenId) {                                                                      // 244
      check(apiTokenId, String);                                                                                       // 308
      var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                  // 309
      if (!token) {                                                                                                    // 310
        throw new Meteor.Error(400, "No such token.");                                                                 // 311
      }                                                                                                                // 312
                                                                                                                       //
      var grain = globalDb.collections.grains.findOne(token.grainId);                                                  // 314
      if (!grain) {                                                                                                    // 315
        throw new Meteor.Error(500, "No grain found for token.");                                                      // 316
      }                                                                                                                // 317
                                                                                                                       //
      return grain.cachedViewInfo;                                                                                     // 319
    }                                                                                                                  // 320
                                                                                                                       //
    return getViewInfoForApiToken;                                                                                     // 244
  }()                                                                                                                  // 244
});                                                                                                                    // 244
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 323
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 323
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 324
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 324
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 324
  }                                                                                                                    // 326
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function () {                                                        // 323
    function _getPublicId() {                                                                                          // 323
      // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                    // 329
      //                                                                                                               // 330
      // Must be called in a Meteor context.                                                                           // 331
                                                                                                                       //
      while (!this.publicId) {                                                                                         // 333
        // We haven't looked up the public ID yet.                                                                     // 334
        var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                         // 335
        if (!grain) throw new Error("Grain does not exist.");                                                          // 336
                                                                                                                       //
        if (grain.publicId) {                                                                                          // 338
          this.publicId = grain.publicId;                                                                              // 339
        } else {                                                                                                       // 340
          // The grain doesn't have a public ID yet. Generate one.                                                     // 341
          var candidate = generateRandomHostname(20);                                                                  // 342
                                                                                                                       //
          if (Grains.findOne({ publicId: candidate })) {                                                               // 344
            // This should never ever happen.                                                                          // 345
            console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");   // 346
            continue;                                                                                                  // 348
          }                                                                                                            // 349
                                                                                                                       //
          // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                  // 351
          // simultaneously.                                                                                           // 352
          if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
            // We won the race.                                                                                        // 355
            this.publicId = candidate;                                                                                 // 356
          }                                                                                                            // 357
        }                                                                                                              // 358
      }                                                                                                                // 359
                                                                                                                       //
      return this.publicId;                                                                                            // 361
    }                                                                                                                  // 362
                                                                                                                       //
    return _getPublicId;                                                                                               // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function () {                                                         // 323
    function _getAddress() {                                                                                           // 323
      // Get the grain's outgoing e-mail address.                                                                      // 365
      //                                                                                                               // 366
      // Must be called in a Meteor context.                                                                           // 367
                                                                                                                       //
      return this._getPublicId() + "@" + HOSTNAME;                                                                     // 369
    }                                                                                                                  // 370
                                                                                                                       //
    return _getAddress;                                                                                                // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function () {                                                     // 323
    function _getUserAddress() {                                                                                       // 323
      // Get the user's e-mail address.                                                                                // 373
      //                                                                                                               // 374
      // Must be called in a Meteor context.                                                                           // 375
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                         // 377
                                                                                                                       //
      var identity = globalDb.getIdentity(grain.identityId);                                                           // 379
                                                                                                                       //
      var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                      // 381
      var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                      // 382
                                                                                                                       //
      var result = {};                                                                                                 // 384
      if (email) {                                                                                                     // 385
        result.address = email;                                                                                        // 386
      }                                                                                                                // 387
                                                                                                                       //
      if (identity.profile.name) {                                                                                     // 389
        result.name = identity.profile.name;                                                                           // 390
      }                                                                                                                // 391
                                                                                                                       //
      return result;                                                                                                   // 393
    }                                                                                                                  // 394
                                                                                                                       //
    return _getUserAddress;                                                                                            // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function () {                                                                // 323
    function send(email) {                                                                                             // 323
      return hackSendEmail(this, email);                                                                               // 397
    }                                                                                                                  // 398
                                                                                                                       //
    return send;                                                                                                       // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function () {                                                         // 323
    function getPublicId() {                                                                                           // 323
      return inMeteor(function () {                                                                                    // 401
        var result = {};                                                                                               // 402
                                                                                                                       //
        result.publicId = this._getPublicId();                                                                         // 404
        result.hostname = HOSTNAME;                                                                                    // 405
        result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                 // 406
                                                                                                                       //
        var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                           // 408
        result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                 // 409
                                                                                                                       //
        return result;                                                                                                 // 411
      }.bind(this));                                                                                                   // 412
    }                                                                                                                  // 413
                                                                                                                       //
    return getPublicId;                                                                                                // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function () {                                                             // 323
    function httpGet(url) {                                                                                            // 323
      var _this = this;                                                                                                // 416
      var session = _this;                                                                                             // 417
                                                                                                                       //
      return new Promise(function (resolve, reject) {                                                                  // 419
        var requestMethod = Http.request;                                                                              // 420
        if (url.indexOf("https://") === 0) {                                                                           // 421
          requestMethod = Https.request;                                                                               // 422
        } else if (url.indexOf("http://") !== 0) {                                                                     // 423
          err = new Error("Protocol not recognized.");                                                                 // 424
          err.nature = "precondition";                                                                                 // 425
          reject(err);                                                                                                 // 426
        }                                                                                                              // 427
                                                                                                                       //
        req = requestMethod(url, function (resp) {                                                                     // 429
          var buffers = [];                                                                                            // 430
          var err = void 0;                                                                                            // 431
                                                                                                                       //
          switch (Math.floor(resp.statusCode / 100)) {                                                                 // 433
            case 2:                                                                                                    // 434
              // 2xx response -- OK.                                                                                   // 434
              resp.on("data", function (buf) {                                                                         // 435
                buffers.push(buf);                                                                                     // 436
              });                                                                                                      // 437
                                                                                                                       //
              resp.on("end", function () {                                                                             // 439
                resolve({                                                                                              // 440
                  content: Buffer.concat(buffers),                                                                     // 441
                  mimeType: resp.headers["content-type"] || null                                                       // 442
                });                                                                                                    // 440
              });                                                                                                      // 444
              break;                                                                                                   // 445
            case 3:                                                                                                    // 446
              // 3xx response -- redirect.                                                                             // 446
              resolve(session.httpGet(resp.headers.location));                                                         // 447
              break;                                                                                                   // 448
            case 4:                                                                                                    // 449
              // 4xx response -- client error.                                                                         // 449
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 450
              err.nature = "precondition";                                                                             // 451
              reject(err);                                                                                             // 452
              break;                                                                                                   // 453
            case 5:                                                                                                    // 454
              // 5xx response -- internal server error.                                                                // 454
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 455
              err.nature = "localBug";                                                                                 // 456
              reject(err);                                                                                             // 457
              break;                                                                                                   // 458
            default:                                                                                                   // 459
              // ???                                                                                                   // 459
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 460
              err.nature = "localBug";                                                                                 // 461
              reject(err);                                                                                             // 462
              break;                                                                                                   // 463
          }                                                                                                            // 433
        });                                                                                                            // 465
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 467
          e.nature = "networkFailure";                                                                                 // 468
          reject(e);                                                                                                   // 469
        });                                                                                                            // 470
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 472
          req.abort();                                                                                                 // 473
          err = new Error("Request timed out.");                                                                       // 474
          err.nature = "localBug";                                                                                     // 475
          err.durability = "overloaded";                                                                               // 476
          reject(err);                                                                                                 // 477
        });                                                                                                            // 478
                                                                                                                       //
        req.end();                                                                                                     // 480
      });                                                                                                              // 481
    }                                                                                                                  // 482
                                                                                                                       //
    return httpGet;                                                                                                    // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function () {                                                      // 323
    function getUserAddress() {                                                                                        // 323
      return inMeteor(function () {                                                                                    // 485
        return this._getUserAddress();                                                                                 // 486
      }.bind(this));                                                                                                   // 487
    }                                                                                                                  // 488
                                                                                                                       //
    return getUserAddress;                                                                                             // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function () {                                            // 323
    function obsoleteGenerateApiToken(petname, userInfo, expires) {                                                    // 323
      throw new Error("generateApiToken() has been removed. Use offer templates instead.");                            // 491
    }                                                                                                                  // 492
                                                                                                                       //
    return obsoleteGenerateApiToken;                                                                                   // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function () {                                               // 323
    function obsoleteListApiTokens() {                                                                                 // 323
      throw new Error("listApiTokens() has been removed. Use offer templates instead.");                               // 495
    }                                                                                                                  // 496
                                                                                                                       //
    return obsoleteListApiTokens;                                                                                      // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function () {                                              // 323
    function obsoleteRevokeApiToken(tokenId) {                                                                         // 323
      throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                              // 499
    }                                                                                                                  // 500
                                                                                                                       //
    return obsoleteRevokeApiToken;                                                                                     // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function () {                                                // 323
    function getUiViewForEndpoint(url) {                                                                               // 323
      var parsedUrl = Url.parse(url);                                                                                  // 503
                                                                                                                       //
      if (parsedUrl.hash) {                                                                                            // 505
        // Assume that anything with a fragment is a webkey                                                            // 505
        if (parsedUrl.pathname && parsedUrl.pathname !== "/") {                                                        // 506
          throw new Error("Webkey urls cannot contain a path.");                                                       // 507
        }                                                                                                              // 508
                                                                                                                       //
        var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                       // 510
        var hostId = matchWildcardHost(parsedUrl.host);                                                                // 511
        // Connecting to a remote server with a bearer token.                                                          // 512
        // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                           // 513
        return { view: new ExternalUiView(url, this.grainId, token) };                                                 // 514
      } else {                                                                                                         // 515
        return { view: new ExternalUiView(url, this.grainId) };                                                        // 516
      }                                                                                                                // 517
    }                                                                                                                  // 518
                                                                                                                       //
    return getUiViewForEndpoint;                                                                                       // 323
  }();                                                                                                                 // 323
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 323
}(SessionContextImpl);                                                                                                 // 323
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 521
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 522
};                                                                                                                     // 524
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 526
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 528
  // Generate a random unique name suitable for use in a hostname.                                                     // 529
                                                                                                                       //
  var digits = [];                                                                                                     // 531
  for (var i = 0; i < length; i++) {                                                                                   // 532
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 533
  }                                                                                                                    // 534
                                                                                                                       //
  return digits.join("");                                                                                              // 536
};                                                                                                                     // 537
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js","/imports/server/static-asset.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var StaticAssetImpl,IdenticonStaticAssetImpl;module.import("/imports/server/static-asset.js",{"StaticAssetImpl":function(v){StaticAssetImpl=v},"IdenticonStaticAssetImpl":function(v){IdenticonStaticAssetImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
var Identity = Capnp.importSystem("sandstorm/identity.capnp").Identity;                                                // 19
                                                                                                                       // 20
                                                                                                                       // 21
var StaticAsset = Capnp.importSystem("sandstorm/util.capnp").StaticAsset;                                              // 22
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 25
    _classCallCheck(this, IdentityImpl);                                                                               // 25
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 25
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 27
    _this.db = db;                                                                                                     // 28
    return _this;                                                                                                      // 25
  }                                                                                                                    // 29
                                                                                                                       //
  IdentityImpl.prototype.getProfile = function () {                                                                    //
    function getProfile() {                                                                                            //
      var identity = this.db.getIdentity(this.identityId);                                                             // 32
                                                                                                                       //
      var profile = {                                                                                                  // 34
        displayName: { defaultText: identity.profile.name },                                                           // 35
        preferredHandle: identity.profile.handle,                                                                      // 36
        pronouns: identity.profile.pronoun                                                                             // 37
      };                                                                                                               // 34
                                                                                                                       //
      if (identity.profile.picture) {                                                                                  // 40
        profile.picture = new Capnp.Capability(new StaticAssetImpl(identity.profile.picture), StaticAsset);            // 41
      } else {                                                                                                         // 43
        var hash = this.identityId.slice(0, 32);                                                                       // 44
        profile.picture = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);                   // 45
      }                                                                                                                // 47
                                                                                                                       //
      return { profile: profile };                                                                                     // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return getProfile;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 51
                                                                                                                       //
// TODO(cleanup): Find a better home for this.                                                                         // 53
var MembraneRequirement = Match.OneOf({ tokenValid: String }, { permissionsHeld: { identityId: String, grainId: String, permissions: Match.Optional([Boolean]) } }, { permissionsHeld: { tokenId: String, grainId: String, permissions: Match.Optional([Boolean]) } }, { userIsAdmin: String });
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requirements) {                                                       // 62
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 63
  if (requirements) {                                                                                                  // 64
    check(requirements, [MembraneRequirement]);                                                                        // 65
    saveTemplate.requirements = requirements;                                                                          // 66
  }                                                                                                                    // 67
                                                                                                                       //
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 69
};                                                                                                                     // 71
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 73
  frontendRefField: "identity",                                                                                        // 74
  typeId: Identity.typeId,                                                                                             // 75
                                                                                                                       //
  restore: function () {                                                                                               // 77
    function restore(db, saveTemplate, identityId) {                                                                   // 73
      return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);     // 78
    }                                                                                                                  // 80
                                                                                                                       //
    return restore;                                                                                                    // 73
  }(),                                                                                                                 // 73
  validate: function () {                                                                                              // 82
    function validate(db, session, value) {                                                                            // 73
      check(value, { id: String, roleAssignment: SandstormDb.prototype.roleAssignmentPattern });                       // 83
                                                                                                                       //
      if (!session.userId) {                                                                                           // 85
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 86
      }                                                                                                                // 87
                                                                                                                       //
      var grain = db.getGrain(session.grainId);                                                                        // 89
      SandstormPermissions.createNewApiToken(db, { identityId: session.identityId,                                     // 90
        accountId: session.userId                                                                                      // 93
      }, session.grainId, "petname", value.roleAssignment, { user: { identityId: value.id, title: grain.title } });    // 92
                                                                                                                       //
      // TODO(soon): Somehow notify this user that they now have access.                                               // 100
                                                                                                                       //
      // TODO(perf): This permissions computation happens once here and then once again when the                       // 102
      //   `permissionsHeld` requirement is checked. Is there a way to avoid the duplicated work?                      // 103
      var permissions = SandstormPermissions.grainPermissions(db, { grain: { _id: session.grainId, identityId: value.id } }, session.viewInfo || {}).permissions;
                                                                                                                       //
      return {                                                                                                         // 108
        descriptor: {                                                                                                  // 109
          tags: [{                                                                                                     // 110
            id: Identity.typeId,                                                                                       // 112
            value: Capnp.serialize(Identity.PowerboxTag, {                                                             // 113
              permissions: permissions                                                                                 // 116
            })                                                                                                         // 115
          }]                                                                                                           // 111
        },                                                                                                             // 109
        requirements: [{                                                                                               // 121
          permissionsHeld: {                                                                                           // 123
            identityId: value.id,                                                                                      // 124
            grainId: session.grainId,                                                                                  // 125
            permissions: []                                                                                            // 126
          }                                                                                                            // 123
        }],                                                                                                            // 122
        frontendRef: value.id                                                                                          // 130
      };                                                                                                               // 108
    }                                                                                                                  // 132
                                                                                                                       //
    return validate;                                                                                                   // 73
  }(),                                                                                                                 // 73
  query: function () {                                                                                                 // 134
    function query(db, userId, value) {                                                                                // 73
      var result = [];                                                                                                 // 135
      var requestedPermissions = [];                                                                                   // 136
      if (value) {                                                                                                     // 137
        requestedPermissions = Capnp.parse(Identity.PowerboxTag, value).permissions || [];                             // 138
      }                                                                                                                // 139
                                                                                                                       //
      db.collections.contacts.find({ ownerId: userId }).forEach(function (contact) {                                   // 141
        var identity = db.getIdentity(contact.identityId);                                                             // 142
        if (identity) {                                                                                                // 143
          result.push({                                                                                                // 144
            _id: "frontendref-identity-" + contact.identityId,                                                         // 145
            frontendRef: { identity: contact.identityId },                                                             // 146
            cardTemplate: "identityPowerboxCard",                                                                      // 147
            configureTemplate: "identityPowerboxConfiguration",                                                        // 148
            profile: identity.profile,                                                                                 // 149
            requestedPermissions: requestedPermissions,                                                                // 150
            searchTerms: [identity.profile.name, identity.profile.handle, identity.profile.intrinsicName]              // 151
          });                                                                                                          // 144
        }                                                                                                              // 157
      });                                                                                                              // 158
                                                                                                                       //
      return result;                                                                                                   // 160
    }                                                                                                                  // 161
                                                                                                                       //
    return query;                                                                                                      // 73
  }()                                                                                                                  // 73
});                                                                                                                    // 73
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});var promiseToFuture;module.import("/imports/server/async-helpers.js",{"promiseToFuture":function(v){promiseToFuture=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 20
  defaultText: String,                                                                                                 // 21
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 22
};                                                                                                                     // 20
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 25
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               // 27
// because Meteor.userId() is not available in server-side routes.                                                     // 28
                                                                                                                       //
Meteor.methods({                                                                                                       // 30
  cancelDownload: function (_cancelDownload) {                                                                         // 31
    function cancelDownload(_x) {                                                                                      // 31
      return _cancelDownload.apply(this, arguments);                                                                   // 31
    }                                                                                                                  // 31
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 31
      return _cancelDownload.toString();                                                                               // 31
    };                                                                                                                 // 31
                                                                                                                       //
    return cancelDownload;                                                                                             // 31
  }(function (packageId) {                                                                                             // 31
    check(packageId, String);                                                                                          // 32
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            // 34
    cancelDownload(packageId);                                                                                         // 35
  }),                                                                                                                  // 36
                                                                                                                       //
  newUploadToken: function () {                                                                                        // 38
    function newUploadToken() {                                                                                        // 38
      if (!isSignedUp()) {                                                                                             // 39
        throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                            // 40
      }                                                                                                                // 41
                                                                                                                       //
      if (globalDb.isUninvitedFreeUser()) {                                                                            // 43
        throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                               // 44
      }                                                                                                                // 45
                                                                                                                       //
      var token = Random.id(22);                                                                                       // 47
      uploadTokens[token] = setTimeout(function () {                                                                   // 48
        delete uploadTokens[token];                                                                                    // 49
      }, 20 * 60 * 1000);                                                                                              // 50
                                                                                                                       //
      return token;                                                                                                    // 52
    }                                                                                                                  // 53
                                                                                                                       //
    return newUploadToken;                                                                                             // 38
  }(),                                                                                                                 // 38
                                                                                                                       //
  upgradeGrains: function () {                                                                                         // 55
    function upgradeGrains(appId, version, packageId) {                                                                // 55
      this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                             // 56
    }                                                                                                                  // 57
                                                                                                                       //
    return upgradeGrains;                                                                                              // 55
  }(),                                                                                                                 // 55
                                                                                                                       //
  ensureInstalled: function () {                                                                                       // 59
    function ensureInstalled(packageId, url, isRetry) {                                                                // 59
      check(packageId, String);                                                                                        // 60
      check(url, Match.OneOf(String, undefined, null));                                                                // 61
      check(isRetry, Boolean);                                                                                         // 62
                                                                                                                       //
      if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                        // 64
        throw new Meteor.Error(400, "The package ID contains illegal characters.");                                    // 65
      }                                                                                                                // 66
                                                                                                                       //
      if (!this.userId) {                                                                                              // 68
        if (allowDemo && isSafeDemoAppUrl(url)) {                                                                      // 69
          // continue on                                                                                               // 70
        } else {                                                                                                       // 71
          // jscs:ignore disallowEmptyBlocks                                                                           // 71
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 72
        }                                                                                                              // 73
      } else if (!isSignedUpOrDemo()) {                                                                                // 74
        throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");    // 75
      }                                                                                                                // 77
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 79
                                                                                                                       //
      if (!pkg || pkg.status !== "ready") {                                                                            // 81
        if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                          // 82
          if (!isSafeDemoAppUrl(url)) {                                                                                // 83
            // TODO(someday): Billing prompt on client side.                                                           // 84
            throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
          }                                                                                                            // 87
        }                                                                                                              // 88
      }                                                                                                                // 89
                                                                                                                       //
      if (!pkg || isRetry) {                                                                                           // 91
        globalDb.startInstall(packageId, url, isRetry);                                                                // 92
      }                                                                                                                // 93
    }                                                                                                                  // 94
                                                                                                                       //
    return ensureInstalled;                                                                                            // 59
  }()                                                                                                                  // 59
});                                                                                                                    // 30
                                                                                                                       //
Meteor.publish("packageInfo", function (packageId) {                                                                   // 97
  check(packageId, String);                                                                                            // 98
  var db = this.connection.sandstormDb;                                                                                // 99
  var pkgCursor = db.collections.packages.find(packageId);                                                             // 100
  var pkg = pkgCursor.fetch()[0];                                                                                      // 101
  if (pkg && this.userId) {                                                                                            // 102
    return [pkgCursor, db.collections.userActions.find({ userId: this.userId, appId: pkg.appId }), db.collections.grains.find({ userId: this.userId, appId: pkg.appId })];
  } else {                                                                                                             // 108
    return pkgCursor;                                                                                                  // 109
  }                                                                                                                    // 110
});                                                                                                                    // 111
                                                                                                                       //
Router.map(function () {                                                                                               // 113
  this.route("upload", {                                                                                               // 114
    where: "server",                                                                                                   // 115
    path: "/upload/:token",                                                                                            // 116
                                                                                                                       //
    action: function () {                                                                                              // 118
      function action() {                                                                                              // 118
        if (!this.params.token || !uploadTokens[this.params.token]) {                                                  // 119
          this.response.writeHead(403, {                                                                               // 120
            "Content-Type": "text/plain"                                                                               // 121
          });                                                                                                          // 120
          this.response.write("Invalid upload token.");                                                                // 123
          this.response.end();                                                                                         // 124
        } else if (this.request.method === "POST") {                                                                   // 125
          try {                                                                                                        // 126
            var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                      // 127
            this.response.writeHead(200, {                                                                             // 128
              "Content-Length": packageId.length,                                                                      // 129
              "Content-Type": "text/plain"                                                                             // 130
            });                                                                                                        // 128
            this.response.write(packageId);                                                                            // 132
            this.response.end();                                                                                       // 133
            clearTimeout(uploadTokens[this.params.token]);                                                             // 134
            delete uploadTokens[this.params.token];                                                                    // 135
          } catch (error) {                                                                                            // 136
            console.error(error.stack);                                                                                // 137
            this.response.writeHead(500, {                                                                             // 138
              "Content-Type": "text/plain"                                                                             // 139
            });                                                                                                        // 138
            this.response.write("Unpacking SPK failed; is it valid?");                                                 // 141
            this.response.end();                                                                                       // 142
          };                                                                                                           // 143
        } else {                                                                                                       // 144
          this.response.writeHead(405, {                                                                               // 145
            "Content-Type": "text/plain"                                                                               // 146
          });                                                                                                          // 145
          this.response.write("You can only POST here.");                                                              // 148
          this.response.end();                                                                                         // 149
        }                                                                                                              // 150
      }                                                                                                                // 151
                                                                                                                       //
      return action;                                                                                                   // 118
    }()                                                                                                                // 118
  });                                                                                                                  // 114
});                                                                                                                    // 153
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
                                                                                                                       // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 28
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 30
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 32
// To protect against race conditions, we require that each row in the Packages                                        // 33
// collection have at most one writer at a time, as tracked by this `installers`                                       // 34
// map. Each key is a package ID and each value is either an AppInstaller object                                       // 35
// or the string 'uninstalling', indicating that some fiber is working on                                              // 36
// uninstalling the package.                                                                                           // 37
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 39
  if (Meteor.settings.replicaNumber) {                                                                                 // 40
    throw new Error("This can only be called on the main front-end replica.");                                         // 41
  }                                                                                                                    // 42
};                                                                                                                     // 43
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 45
  verifyIsMainReplica();                                                                                               // 46
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 48
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 50
    return;                                                                                                            // 51
  }                                                                                                                    // 52
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 54
                                                                                                                       //
  try {                                                                                                                // 56
    var action = UserActions.findOne({ packageId: packageId });                                                        // 57
    var grain = Grains.findOne({ packageId: packageId });                                                              // 58
    var notificationQuery = {};                                                                                        // 59
    notificationQuery["appUpdates." + pkg.appId + ".packageId"] = packageId;                                           // 60
    if (!grain && !action && !Notifications.findOne(notificationQuery) && !globalDb.getAppIdForPreinstalledPackage(packageId)) {
      Packages.update({                                                                                                // 63
        _id: packageId                                                                                                 // 64
      }, {                                                                                                             // 63
        $set: { status: "delete" },                                                                                    // 66
        $unset: { shouldCleanup: "" }                                                                                  // 67
      });                                                                                                              // 65
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 69
      Packages.remove(packageId);                                                                                      // 70
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  // 72
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 73
        globalDb.unrefStaticAsset(assetId);                                                                            // 74
      });                                                                                                              // 75
    } else {                                                                                                           // 76
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 77
    }                                                                                                                  // 78
                                                                                                                       //
    delete installers[packageId];                                                                                      // 80
  } catch (error) {                                                                                                    // 81
    delete installers[packageId];                                                                                      // 82
    throw error;                                                                                                       // 83
  }                                                                                                                    // 84
};                                                                                                                     // 85
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 87
  verifyIsMainReplica();                                                                                               // 88
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 90
    return;                                                                                                            // 91
  }                                                                                                                    // 92
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 94
  installers[pkg._id] = installer;                                                                                     // 95
  installer.start();                                                                                                   // 96
};                                                                                                                     // 97
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 99
  Packages.remove({ _id: packageId, status: "download" });                                                             // 100
};                                                                                                                     // 101
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 103
  verifyIsMainReplica();                                                                                               // 104
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 106
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               // 108
  if (installer && installer.downloadRequest) {                                                                        // 109
    // OK, effect cancellation by faking an error.                                                                     // 110
    installer.wrapCallback(function () {                                                                               // 111
      throw new Error("Canceled");                                                                                     // 112
    })();                                                                                                              // 113
  }                                                                                                                    // 114
};                                                                                                                     // 115
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 117
  installers = {};                                                                                                     // 118
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 120
    // Restart any deletions that were killed while in-progress.                                                       // 121
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 122
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           // 124
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 125
      added: startInstallInternal,                                                                                     // 126
      removed: cancelDownloadInternal                                                                                  // 127
    });                                                                                                                // 125
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                // 130
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 131
      added: deletePackageInternal                                                                                     // 132
    });                                                                                                                // 131
  });                                                                                                                  // 134
}                                                                                                                      // 135
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 137
  return new Promise(function (resolve, reject) {                                                                      // 138
    var id = Random.id();                                                                                              // 139
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 141
    var hasher = Crypto.createHash("sha256");                                                                          // 142
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 144
      try {                                                                                                            // 145
        hasher.update(chunk);                                                                                          // 146
        backendStream.write(chunk);                                                                                    // 147
      } catch (err) {                                                                                                  // 148
        reject(err);                                                                                                   // 149
      }                                                                                                                // 150
    });                                                                                                                // 151
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 153
      try {                                                                                                            // 154
        (function () {                                                                                                 // 154
          backendStream.done();                                                                                        // 155
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 156
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 157
            return packageId;                                                                                          // 158
          }));                                                                                                         // 159
          backendStream.close();                                                                                       // 160
        })();                                                                                                          // 154
      } catch (err) {                                                                                                  // 161
        reject(err);                                                                                                   // 162
      }                                                                                                                // 163
    });                                                                                                                // 164
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 166
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           // 167
      try {                                                                                                            // 168
        backendStream.close();                                                                                         // 169
        reject(err);                                                                                                   // 170
      } catch (err2) {                                                                                                 // 171
        reject(err2);                                                                                                  // 172
      }                                                                                                                // 173
    });                                                                                                                // 174
  });                                                                                                                  // 175
};                                                                                                                     // 176
                                                                                                                       //
AppInstaller = function () {                                                                                           // 178
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 179
    _classCallCheck(this, AppInstaller);                                                                               // 179
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 180
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 182
    this.url = url;                                                                                                    // 183
    this.failed = false;                                                                                               // 184
    this.appId = appId;                                                                                                // 185
    this.isAutoUpdated = isAutoUpdated;                                                                                // 186
                                                                                                                       //
    // Serializes database writes.                                                                                     // 188
    this.writeChain = Promise.resolve();                                                                               // 189
  }                                                                                                                    // 190
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function () {                                                                // 178
    function updateProgress(status, progress, error, manifest) {                                                       // 178
      // TODO(security):  On error, we should actually delete the package from the database and only                   // 193
      //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                     // 194
      //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                        // 195
      //   already-downloading package but specifies a different URL, we really should initiate an                     // 196
      //   entirely separate download...  but cancel it if the first download succeeds.)                               // 197
                                                                                                                       //
      this.status = status;                                                                                            // 199
      this.progress = progress || -1;                                                                                  // 200
      this.error = error;                                                                                              // 201
      this.manifest = manifest || null;                                                                                // 202
                                                                                                                       //
      var _this = this;                                                                                                // 204
                                                                                                                       //
      // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                   // 206
      // occur in exactly the order in which we generate them, so we use a promise chain to serialize                  // 207
      // them.                                                                                                         // 208
      this.writeChain = this.writeChain.then(function () {                                                             // 209
        return inMeteor(function () {                                                                                  // 210
          if (manifest) extractManifestAssets(manifest);                                                               // 211
                                                                                                                       //
          Packages.update(_this.packageId, {                                                                           // 213
            $set: {                                                                                                    // 214
              status: _this.status,                                                                                    // 215
              progress: _this.progress,                                                                                // 216
              error: _this.error ? _this.error.message : null,                                                         // 217
              manifest: _this.manifest,                                                                                // 218
              appId: _this.appId,                                                                                      // 219
              authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                   // 220
            }                                                                                                          // 214
          });                                                                                                          // 213
                                                                                                                       //
          if (_this.authorPgpKeyFingerprint) {                                                                         // 224
            globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                         // 225
          }                                                                                                            // 226
        })["catch"](function (err) {                                                                                   // 227
          console.error(err.stack);                                                                                    // 228
        });                                                                                                            // 229
      });                                                                                                              // 230
    }                                                                                                                  // 231
                                                                                                                       //
    return updateProgress;                                                                                             // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function () {                                                                  // 178
    function wrapCallback(method) {                                                                                    // 178
      // Note that the function below must not be an arrow function, since arrow functions do not have                 // 234
      // access to the context's arguments array.                                                                      // 235
      var _this = this;                                                                                                // 236
      return function () {                                                                                             // 237
        if (_this.failed) return;                                                                                      // 238
        try {                                                                                                          // 239
          return method.apply(_this, _.toArray(arguments));                                                            // 240
        } catch (err) {                                                                                                // 241
          _this.failed = true;                                                                                         // 242
          _this.cleanup();                                                                                             // 243
          _this.updateProgress("failed", 0, err);                                                                      // 244
          _this.writeChain = _this.writeChain.then(function () {                                                       // 245
            delete installers[_this.packageId];                                                                        // 246
          });                                                                                                          // 247
          console.error("Failed to install app:", err.stack);                                                          // 248
        }                                                                                                              // 249
      };                                                                                                               // 250
    }                                                                                                                  // 251
                                                                                                                       //
    return wrapCallback;                                                                                               // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.cleanup = function () {                                                                       // 178
    function cleanup() {                                                                                               // 178
      if (this.uploadStream) {                                                                                         // 254
        try {                                                                                                          // 255
          this.uploadStream.close();                                                                                   // 256
        } catch (err) {}                                                                                               // 257
                                                                                                                       //
        delete this.uploadStream;                                                                                      // 259
      }                                                                                                                // 260
                                                                                                                       //
      if (this.downloadRequest) {                                                                                      // 262
        try {                                                                                                          // 263
          this.downloadRequest.abort();                                                                                // 264
        } catch (err) {}                                                                                               // 265
                                                                                                                       //
        delete this.downloadRequest;                                                                                   // 267
      }                                                                                                                // 268
    }                                                                                                                  // 269
                                                                                                                       //
    return cleanup;                                                                                                    // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.start = function () {                                                                         // 178
    function start() {                                                                                                 // 178
      var _this2 = this;                                                                                               // 271
                                                                                                                       //
      return this.wrapCallback(function () {                                                                           // 272
        _this2.cleanup();                                                                                              // 273
                                                                                                                       //
        globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                 // 275
          if (info.appId) {                                                                                            // 276
            _this2.appId = info.appId;                                                                                 // 277
            _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                             // 278
            _this2.done(info.manifest);                                                                                // 279
          } else {                                                                                                     // 280
            _this2.doDownload();                                                                                       // 281
          }                                                                                                            // 282
        }), _this2.wrapCallback(function (err) {                                                                       // 283
          throw err;                                                                                                   // 284
        }));                                                                                                           // 285
      })();                                                                                                            // 286
    }                                                                                                                  // 287
                                                                                                                       //
    return start;                                                                                                      // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.doDownload = function () {                                                                    // 178
    function doDownload() {                                                                                            // 178
      if (!this.url) {                                                                                                 // 290
        throw new Error("Unknown package ID, and no URL was provided.");                                               // 291
      }                                                                                                                // 292
                                                                                                                       //
      console.log("Downloading app:", this.url);                                                                       // 294
      this.updateProgress("download");                                                                                 // 295
                                                                                                                       //
      this.uploadStream = globalBackend.cap().installPackage().stream;                                                 // 297
      return this.doDownloadTo(this.uploadStream);                                                                     // 298
    }                                                                                                                  // 299
                                                                                                                       //
    return doDownload;                                                                                                 // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function () {                                                                  // 178
    function doDownloadTo(out) {                                                                                       // 178
      var _this3 = this;                                                                                               // 301
                                                                                                                       //
      var url = Url.parse(this.url);                                                                                   // 302
      var options = {                                                                                                  // 303
        hostname: url.hostname,                                                                                        // 304
        port: url.port,                                                                                                // 305
        path: url.path                                                                                                 // 306
      };                                                                                                               // 303
                                                                                                                       //
      var protocol = void 0;                                                                                           // 309
      if (url.protocol === "http:" || url.protocol === "https:") {                                                     // 310
        protocol = Request.defaults({                                                                                  // 311
          maxRedirects: 20,                                                                                            // 312
          // Since we will verify the download against a hash anyway, we don't need to verify the                      // 313
          // server's certificate. In fact, the only reason we support HTTPS at all here is because                    // 314
          // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                 // 315
          // certificate check here is helpful in that it means we don't have to worry about having a                  // 316
          // reasonable list of trusted CAs available to Sandstorm.                                                    // 317
          strictSSL: false                                                                                             // 318
        });                                                                                                            // 311
      } else {                                                                                                         // 320
        throw new Error("Protocol not supported: " + url.protocol);                                                    // 321
      }                                                                                                                // 322
                                                                                                                       //
      // TODO(security):  It could arguably be a security problem that it's possible to probe the                      // 324
      //   server's local network (behind any firewalls) by presenting URLs here.                                      // 325
      var bytesExpected = undefined;                                                                                   // 326
      var bytesReceived = 0;                                                                                           // 327
      var hasher = Crypto.createHash("sha256");                                                                        // 328
      var done = false;                                                                                                // 329
      var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                          // 330
        if (!done) {                                                                                                   // 331
          if (bytesExpected) {                                                                                         // 332
            _this3.updateProgress("download", bytesReceived / bytesExpected);                                          // 333
          } else {                                                                                                     // 334
            _this3.updateProgress("download", bytesReceived);                                                          // 335
          }                                                                                                            // 336
        }                                                                                                              // 337
      }), 500);                                                                                                        // 338
                                                                                                                       //
      var request = protocol.get(this.url);                                                                            // 340
                                                                                                                       //
      request.on("response", this.wrapCallback(function (response) {                                                   // 342
        if ("content-length" in response.headers) {                                                                    // 343
          bytesExpected = parseInt(response.headers["content-length"]);                                                // 344
        }                                                                                                              // 345
      }));                                                                                                             // 346
                                                                                                                       //
      request.on("data", this.wrapCallback(function (chunk) {                                                          // 348
        hasher.update(chunk);                                                                                          // 349
        out.write(chunk);                                                                                              // 350
        bytesReceived += chunk.length;                                                                                 // 351
        updateDownloadProgress();                                                                                      // 352
      }));                                                                                                             // 353
                                                                                                                       //
      request.on("end", this.wrapCallback(function () {                                                                // 355
        out.done();                                                                                                    // 356
                                                                                                                       //
        if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                  // 358
          throw new Error("Package hash did not match.");                                                              // 359
        }                                                                                                              // 360
                                                                                                                       //
        done = true;                                                                                                   // 362
        delete _this3.downloadRequest;                                                                                 // 363
                                                                                                                       //
        _this3.updateProgress("unpack");                                                                               // 365
        out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                        // 366
          _this3.appId = info.appId;                                                                                   // 367
          _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 368
          _this3.done(info.manifest);                                                                                  // 369
        }), _this3.wrapCallback(function (err) {                                                                       // 370
          throw err;                                                                                                   // 371
        }));                                                                                                           // 372
      }));                                                                                                             // 373
                                                                                                                       //
      request.on("error", this.wrapCallback(function (err) {                                                           // 375
        throw err;                                                                                                     // 375
      }));                                                                                                             // 375
                                                                                                                       //
      this.downloadRequest = request;                                                                                  // 377
    }                                                                                                                  // 378
                                                                                                                       //
    return doDownloadTo;                                                                                               // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  AppInstaller.prototype.done = function () {                                                                          // 178
    function done(manifest) {                                                                                          // 178
      console.log("App ready:", this.packageId);                                                                       // 381
      this.updateProgress("ready", 1, undefined, manifest);                                                            // 382
      var _this = this;                                                                                                // 383
      _this.writeChain = _this.writeChain.then(function () {                                                           // 384
        return inMeteor(function () {                                                                                  // 385
          if (_this.isAutoUpdated) {                                                                                   // 386
            globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
          }                                                                                                            // 390
                                                                                                                       //
          if (globalDb.getPackageIdForPreinstalledApp(_this.appId) && globalDb.collections.appIndex.findOne({          // 392
            _id: _this.appId,                                                                                          // 394
            packageId: _this.packageId                                                                                 // 395
          })) {                                                                                                        // 393
            // Only mark app as preinstall ready if its appId is in the preinstalledApps setting                       // 397
            // and if it's the latest package version in the appIndex. The updateAppIndex function                     // 398
            // will always trigger updates of preinstalled apps, even if a concurrent download of                      // 399
            // an older package is going on.                                                                           // 400
            globalDb.setPreinstallAppAsReady(_this.appId, _this.packageId);                                            // 401
          }                                                                                                            // 402
        });                                                                                                            // 403
      }).then(function () {                                                                                            // 404
        delete installers[_this.packageId];                                                                            // 405
      });                                                                                                              // 406
    }                                                                                                                  // 407
                                                                                                                       //
    return done;                                                                                                       // 178
  }();                                                                                                                 // 178
                                                                                                                       //
  return AppInstaller;                                                                                                 // 178
}();                                                                                                                   // 178
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 410
  var metadata = manifest.metadata;                                                                                    // 411
  if (!metadata) return;                                                                                               // 412
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 414
  if (icons) {                                                                                                         // 415
    var handleIcon = function handleIcon(icon) {                                                                       // 416
      if (icon.svg) {                                                                                                  // 417
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 418
        icon.format = "svg";                                                                                           // 419
        delete icon.svg;                                                                                               // 420
        return true;                                                                                                   // 421
      } else if (icon.png) {                                                                                           // 422
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        // 423
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 424
        if (!normalDpi) return false;                                                                                  // 425
        icon.format = "png";                                                                                           // 426
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 427
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 429
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          // 430
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 431
        }                                                                                                              // 432
                                                                                                                       //
        delete icon.png;                                                                                               // 434
        return true;                                                                                                   // 435
      } else {                                                                                                         // 436
        // Unknown icon. Filter it.                                                                                    // 437
        return false;                                                                                                  // 438
      }                                                                                                                // 439
    };                                                                                                                 // 440
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 442
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 443
                                                                                                                       //
    // We don't need the market icons.                                                                                 // 445
    if (icons.market) delete icons.market;                                                                             // 446
    if (icons.marketBig) delete icons.marketBig;                                                                       // 447
  }                                                                                                                    // 448
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 450
    if (text.defaultText) {                                                                                            // 451
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 452
      delete text.defaultText;                                                                                         // 453
    }                                                                                                                  // 454
                                                                                                                       //
    if (text.localizations) {                                                                                          // 456
      text.localizations.forEach(function (localization) {                                                             // 457
        if (localization.text) {                                                                                       // 458
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 459
          delete localization.text;                                                                                    // 461
        }                                                                                                              // 462
      });                                                                                                              // 463
    }                                                                                                                  // 464
  };                                                                                                                   // 465
                                                                                                                       //
  var license = metadata.license;                                                                                      // 467
  if (license) {                                                                                                       // 468
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 469
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 470
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 471
  }                                                                                                                    // 472
                                                                                                                       //
  var author = metadata.author;                                                                                        // 474
  if (author) {                                                                                                        // 475
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     // 476
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 477
  }                                                                                                                    // 478
                                                                                                                       //
  // Don't need the keyring either.                                                                                    // 480
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 481
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 // 483
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 484
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                // 486
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 487
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    // 489
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 490
};                                                                                                                     // 491
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 493
  // Returns a list of all asset IDs in the given manifest.                                                            // 494
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 496
  if (!metadata) return [];                                                                                            // 497
                                                                                                                       //
  var result = [];                                                                                                     // 499
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 501
  if (icons) {                                                                                                         // 502
    var handleIcon = function handleIcon(icon) {                                                                       // 503
      if (icon.assetId) {                                                                                              // 504
        result.push(icon.assetId);                                                                                     // 505
      }                                                                                                                // 506
    };                                                                                                                 // 507
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 509
    if (icons.grain) handleIcon(icons.grain);                                                                          // 510
  }                                                                                                                    // 511
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 513
    if (text.defaultTextAssetId) {                                                                                     // 514
      result.push(defaultTextAssetId);                                                                                 // 515
    }                                                                                                                  // 516
                                                                                                                       //
    if (text.localizations) {                                                                                          // 518
      text.localizations.forEach(function (localization) {                                                             // 519
        if (localization.assetId) {                                                                                    // 520
          result.push(localization.assetId);                                                                           // 521
        }                                                                                                              // 522
      });                                                                                                              // 523
    }                                                                                                                  // 524
  };                                                                                                                   // 525
                                                                                                                       //
  var license = metadata.license;                                                                                      // 527
  if (license) {                                                                                                       // 528
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 529
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 530
    if (license.notices) handleLocalizedText(license.notices);                                                         // 531
  }                                                                                                                    // 532
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 534
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 535
                                                                                                                       //
  return result;                                                                                                       // 537
};                                                                                                                     // 538
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":["/imports/server/async-helpers.js","/imports/server/desktop-notifications.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var waitPromise;module.import("/imports/server/async-helpers.js",{"waitPromise":function(v){waitPromise=v}});var createAppActivityDesktopNotification;module.import("/imports/server/desktop-notifications.js",{"createAppActivityDesktopNotification":function(v){createAppActivityDesktopNotification=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 20
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 21
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 22
                                                                                                                       //
logActivity = function logActivity(grainId, identityIdOrAnonymous, event) {                                            // 24
  // identityIdOrAnonymous is the string "anonymous" for an anonymous user, or is null for a                           // 25
  // non-user-initiated ("background") activity.                                                                       // 26
                                                                                                                       //
  check(grainId, String);                                                                                              // 28
  check(identityIdOrAnonymous, Match.Maybe(String));                                                                   // 29
  // `event` is always an ActivityEvent parsed from Cap'n Proto but that's too complicated to check                    // 30
  // here.                                                                                                             // 31
                                                                                                                       //
  var identityId = identityIdOrAnonymous === "anonymous" ? null : identityIdOrAnonymous;                               // 33
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          // 35
  //   here, rather than looking it up every time.                                                                     // 36
  grain = Grains.findOne(grainId);                                                                                     // 37
  if (!grain) {                                                                                                        // 38
    // Shouldn't be possible since activity events come from the grain.                                                // 39
    throw new Error("no such grain");                                                                                  // 40
  }                                                                                                                    // 41
                                                                                                                       //
  // Look up the event typedef.                                                                                        // 43
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 44
  if (!eventType) {                                                                                                    // 45
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 46
  }                                                                                                                    // 47
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 49
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           // 50
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    // 51
    if (identityId != grain.identityId) {                                                                              // 52
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 53
    }                                                                                                                  // 54
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        // 56
    ApiTokens.update({                                                                                                 // 57
      "grainId": grainId,                                                                                              // 58
      "owner.user.seenAllActivity": true,                                                                              // 59
      "owner.user.identityId": { $ne: identityId }                                                                     // 60
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 57
  }                                                                                                                    // 62
                                                                                                                       //
  if (identityId) {                                                                                                    // 64
    // Apply auto-subscriptions.                                                                                       // 65
    if (eventType.autoSubscribeToGrain) {                                                                              // 66
      globalDb.subscribeToActivity(identityId, grainId);                                                               // 67
    }                                                                                                                  // 68
                                                                                                                       //
    if (event.thread && eventType.autoSubscribeToThread) {                                                             // 70
      globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                      // 71
    }                                                                                                                  // 72
  }                                                                                                                    // 73
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                // 75
  var notifyMap = {};                                                                                                  // 76
  var addRecipient = function addRecipient(recipient) {                                                                // 77
    // Mutes take priority over subscriptions.                                                                         // 78
    if (recipient.mute) {                                                                                              // 79
      notifyMap[recipient.identityId] = false;                                                                         // 80
    } else {                                                                                                           // 81
      if (!(recipient.identityId in notifyMap)) {                                                                      // 82
        notifyMap[recipient.identityId] = true;                                                                        // 83
      }                                                                                                                // 84
    }                                                                                                                  // 85
  };                                                                                                                   // 86
                                                                                                                       //
  if (identityId) {                                                                                                    // 88
    // Don't notify self.                                                                                              // 89
    addRecipient({ identityId: identityId, mute: true });                                                              // 90
  }                                                                                                                    // 91
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   // 93
  if (eventType.notifySubscribers) {                                                                                   // 94
    // The grain owner is implicitly subscribed.                                                                       // 95
    addRecipient({ identityId: grain.identityId });                                                                    // 96
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           // 98
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 99
                                                                                                                       //
    if (event.thread) {                                                                                                // 101
      // Add everyone subscribed to the thread.                                                                        // 102
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 103
    }                                                                                                                  // 104
  }                                                                                                                    // 105
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    // 107
  if (event.users && event.users.length > 0) {                                                                         // 108
    (function () {                                                                                                     // 108
      var promises = [];                                                                                               // 109
      event.users.forEach(function (user) {                                                                            // 110
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 111
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 112
            addRecipient({ identityId: targetId });                                                                    // 113
          }));                                                                                                         // 114
        }                                                                                                              // 115
      });                                                                                                              // 116
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 117
        return undefined;                                                                                              // 117
      }));                                                                                                             // 117
    })();                                                                                                              // 108
  }                                                                                                                    // 118
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                // 120
  var notify = [];                                                                                                     // 121
  for (var _identityId in meteorBabelHelpers.sanitizeForInObject(notifyMap)) {                                         // 122
    if (notifyMap[_identityId]) {                                                                                      // 123
      notify.push(_identityId);                                                                                        // 124
    }                                                                                                                  // 125
  }                                                                                                                    // 126
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 128
    (function () {                                                                                                     // 128
      var notification = {                                                                                             // 129
        grainId: grainId,                                                                                              // 130
        path: event.path || ""                                                                                         // 131
      };                                                                                                               // 129
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  // 134
      var update = {                                                                                                   // 135
        isUnread: true,                                                                                                // 136
        timestamp: new Date()                                                                                          // 137
      };                                                                                                               // 135
                                                                                                                       //
      if (event.thread) {                                                                                              // 140
        notification.threadPath = event.thread.path || "";                                                             // 141
      }                                                                                                                // 142
                                                                                                                       //
      if (identityId) {                                                                                                // 144
        notification.initiatingIdentity = identityId;                                                                  // 145
      } else if (identityIdOrAnonymous) {                                                                              // 146
        notification.initiatorAnonymous = true;                                                                        // 147
      }                                                                                                                // 148
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 150
      update.text = eventType.verbPhrase;                                                                              // 151
                                                                                                                       //
      var body = event.notification && event.notification.caption || { defaultText: "" };                              // 153
                                                                                                                       //
      var appActivity = {                                                                                              // 155
        grainId: notification.grainId,                                                                                 // 156
        path: notification.path,                                                                                       // 157
        body: body,                                                                                                    // 158
        actionText: eventType.verbPhrase                                                                               // 159
      };                                                                                                               // 155
                                                                                                                       //
      if (identityId) {                                                                                                // 162
        // Look up icon urls for the responsible identity and the app                                                  // 163
        var identity = Meteor.users.findOne({ _id: identityId });                                                      // 164
        if (!identity) {                                                                                               // 165
          throw new Error("no such identity");                                                                         // 166
        }                                                                                                              // 167
                                                                                                                       //
        SandstormDb.fillInProfileDefaults(identity);                                                                   // 169
        SandstormDb.fillInPictureUrl(identity);                                                                        // 170
                                                                                                                       //
        appActivity.user = {                                                                                           // 172
          identityId: identity._id,                                                                                    // 173
          name: identity.profile.name,                                                                                 // 174
          avatarUrl: identity.profile.pictureUrl || ""                                                                 // 175
        };                                                                                                             // 172
      } else if (identityIdOrAnonymous) {                                                                              // 177
        appActivity.user = { anonymous: true };                                                                        // 178
      }                                                                                                                // 179
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 181
        // Notify all accounts connected with this identity.                                                           // 182
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          // We need to know the ID of the inserted/updated document so we can embed it in the                         // 187
          // desktop notification to bind them.                                                                        // 188
          var idIfInserted = Random.id(17);                                                                            // 189
          var result = Notifications.findAndModify({                                                                   // 190
            query: _.extend({ userId: account._id }, notification),                                                    // 191
            update: {                                                                                                  // 192
              $set: update,                                                                                            // 193
              $inc: { count: 1 },                                                                                      // 194
              $setOnInsert: {                                                                                          // 195
                _id: idIfInserted                                                                                      // 196
              }                                                                                                        // 195
            },                                                                                                         // 192
            upsert: true                                                                                               // 199
          });                                                                                                          // 190
                                                                                                                       //
          if (!result.ok) {                                                                                            // 202
            console.error("Couldn't create notification!", result.lastErrorObject);                                    // 203
            return;                                                                                                    // 204
          }                                                                                                            // 205
                                                                                                                       //
          var notificationId = result.value._id || idIfInserted;                                                       // 207
                                                                                                                       //
          var desktopNotification = {                                                                                  // 209
            userId: account._id,                                                                                       // 210
            notificationId: notificationId,                                                                            // 211
            appActivity: appActivity                                                                                   // 212
          };                                                                                                           // 209
                                                                                                                       //
          createAppActivityDesktopNotification(desktopNotification);                                                   // 215
        });                                                                                                            // 216
      });                                                                                                              // 217
    })();                                                                                                              // 128
  }                                                                                                                    // 218
};                                                                                                                     // 219
                                                                                                                       //
Meteor.methods({                                                                                                       // 221
  testNotifications: function () {                                                                                     // 222
    function testNotifications() {                                                                                     // 222
      // Deliver a test notification of each non-grain-initiated type to the user.                                     // 223
      if (!this.userId) return;                                                                                        // 224
                                                                                                                       //
      Notifications.insert({                                                                                           // 226
        admin: {                                                                                                       // 227
          action: "/admin/stats",                                                                                      // 228
          type: "reportStats"                                                                                          // 229
        },                                                                                                             // 227
        userId: this.userId,                                                                                           // 231
        timestamp: new Date(),                                                                                         // 232
        isUnread: true                                                                                                 // 233
      });                                                                                                              // 226
                                                                                                                       //
      Notifications.insert({                                                                                           // 236
        userId: this.userId,                                                                                           // 237
        referral: true,                                                                                                // 238
        timestamp: new Date(),                                                                                         // 239
        isUnread: true                                                                                                 // 240
      });                                                                                                              // 236
                                                                                                                       //
      if (global.BlackrockPayments) {                                                                                  // 243
        Notifications.insert({                                                                                         // 244
          userId: this.userId,                                                                                         // 245
          mailingListBonus: true,                                                                                      // 246
          timestamp: new Date(),                                                                                       // 247
          isUnread: true                                                                                               // 248
        });                                                                                                            // 244
      }                                                                                                                // 250
    }                                                                                                                  // 251
                                                                                                                       //
    return testNotifications;                                                                                          // 222
  }()                                                                                                                  // 222
});                                                                                                                    // 221
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 254
  return Notifications.find({ userId: this.userId });                                                                  // 255
});                                                                                                                    // 256
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 258
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 // 259
  // "notifications" and "notificationGrains" reactively.                                                              // 260
  check(notificationIds, [String]);                                                                                    // 261
  var notifications = Notifications.find({                                                                             // 262
    _id: { $in: notificationIds },                                                                                     // 263
    userId: this.userId                                                                                                // 264
  }, {                                                                                                                 // 262
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 266
  });                                                                                                                  // 265
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 269
    return row.grainId;                                                                                                // 270
  }).filter(function (x) {                                                                                             // 271
    return x;                                                                                                          // 271
  });                                                                                                                  // 271
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 273
    return row.initiatingIdentity;                                                                                     // 274
  }).filter(function (x) {                                                                                             // 275
    return x;                                                                                                          // 275
  });                                                                                                                  // 275
                                                                                                                       //
  return [Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];                                // 277
});                                                                                                                    // 280
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   // 17
// including routing of requests to proxies and handling of static web publishing.                                     // 18
                                                                                                                       //
                                                                                                                       // 20
var Url = Npm.require("url");                                                                                          // 21
var Fs = Npm.require("fs");                                                                                            // 22
var Dns = Npm.require("dns");                                                                                          // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 35
// Maps grain public IDs to Connect handlers.                                                                          // 36
// TODO(perf): Garbage-collect this map?                                                                               // 37
                                                                                                                       //
// TODO(perf): Implement a more general cache not just of web publishing handlers but of all sorts                     // 39
//   of hosts, in order to avoid database lookups to determine how to handle requests. Host types                      // 40
//   to distinguish between:                                                                                           // 41
//   - Grain hosts                                                                                                     // 42
//   - Web publishing hosts                                                                                            // 43
//   - Standalone grain hosts                                                                                          // 44
                                                                                                                       //
var dnsCache = {};                                                                                                     // 46
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  // 47
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    // 48
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           // 49
// better caching.                                                                                                     // 50
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 52
  // Is this hostname mapped to the Sandstorm shell?                                                                   // 53
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 55
}                                                                                                                      // 56
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      // 58
// uses. Fortunately, they let us extract it.                                                                          // 59
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 60
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 62
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 64
  return function (request, response) {                                                                                // 65
    var path = request.url;                                                                                            // 66
                                                                                                                       //
    // Strip query.                                                                                                    // 68
    path = path.split("?")[0];                                                                                         // 69
                                                                                                                       //
    // If a directory, open "index.html".                                                                              // 71
    if (path.slice(-1) === "/") {                                                                                      // 72
      path = path + "index.html";                                                                                      // 73
    }                                                                                                                  // 74
                                                                                                                       //
    // Strip leading "/".                                                                                              // 76
    if (path[0] === "/") path = path.slice(1);                                                                         // 77
                                                                                                                       //
    // URI-decode the rest. Note that this allows filenames to contain spaces and question marks.                      // 79
    var encoded = path;                                                                                                // 80
    path = decodeURIComponent(encoded);                                                                                // 81
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 83
    var charset = mime.charsets.lookup(type);                                                                          // 84
    if (charset) {                                                                                                     // 85
      type = type + "; charset=" + charset;                                                                            // 86
    } else if (type === "application/json") {                                                                          // 87
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           // 88
      type = type + "; charset=utf-8";                                                                                 // 89
    }                                                                                                                  // 90
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      // 92
    //   Note that nginx will also auto-compress things...                                                             // 93
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 95
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 96
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     // 102
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    // 103
      //   web publishing is meant to publish public content. There is one case where this is                          // 104
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         // 105
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         // 106
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               // 107
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 108
    }                                                                                                                  // 109
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 111
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         // 113
    // logic to happen if the response has no data.                                                                    // 114
    //                                                                                                                 // 115
    // TODO(cleanup): This is pretty ugly.                                                                             // 116
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 117
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 119
      var tryPath = function tryPath(path) {                                                                           // 120
        return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                     // 120
          // jscs:disable disallowQuotedKeysInObjects                                                                  // 121
          var status = result.status;                                                                                  // 122
          if (status === "file") {                                                                                     // 123
            // Nothing to do.                                                                                          // 124
          } else if (status === "directory") {                                                                         // 125
            stream.sendingDirectResponse();                                                                            // 126
            response.writeHead(303, {                                                                                  // 127
              "Content-Type": "text/plain",                                                                            // 128
              "Location": "/" + path + "/",                                                                            // 129
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 130
            });                                                                                                        // 127
            response.end("redirect: /" + path + "/");                                                                  // 132
          } else if (status === "notFound") {                                                                          // 133
            if (path !== encoded) {                                                                                    // 134
              // Compatibility hack: Try getting the URL-encoded version of the path. We used to not                   // 135
              // URL-decode paths at all, hence the need for this fallback.                                            // 136
              // TODO(apibump): Move this hack to the compat layer.                                                    // 137
              return tryPath(encoded);                                                                                 // 138
            }                                                                                                          // 139
                                                                                                                       //
            stream.sendingDirectResponse();                                                                            // 141
            response.writeHead(404, {                                                                                  // 142
              "Content-Type": "text/plain"                                                                             // 143
            });                                                                                                        // 142
            response.end("404 not found: /" + path);                                                                   // 145
          } else {                                                                                                     // 146
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 147
            stream.sendingDirectResponse();                                                                            // 148
            response.writeHead(500, {                                                                                  // 149
              "Content-Type": "text/plain"                                                                             // 150
            });                                                                                                        // 149
            response.end("Internal server error");                                                                     // 152
          }                                                                                                            // 153
                                                                                                                       //
          streamCap.close();                                                                                           // 155
        });                                                                                                            // 156
      };                                                                                                               // 120
      return tryPath(path);                                                                                            // 157
    })["catch"](function (err) {                                                                                       // 158
      console.error(err.stack);                                                                                        // 159
      streamCap.close();                                                                                               // 160
    });                                                                                                                // 161
  };                                                                                                                   // 162
}                                                                                                                      // 163
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 165
  var status = 500;                                                                                                    // 166
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 167
    status = err.error;                                                                                                // 169
  } else if (err.httpErrorCode) {                                                                                      // 170
    status = err.httpErrorCode;                                                                                        // 171
  }                                                                                                                    // 172
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        // 174
  if (status >= 500) console.error(err.stack);                                                                         // 175
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 177
  res.end(err.htmlMessage || err.message);                                                                             // 178
}                                                                                                                      // 179
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 181
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 182
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 184
  if (buf.length < magic.length) return false;                                                                         // 185
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 187
    if (buf[i] != magic[i]) return false;                                                                              // 188
  }                                                                                                                    // 189
                                                                                                                       //
  return true;                                                                                                         // 191
}                                                                                                                      // 192
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 194
  try {                                                                                                                // 195
    if (req.method === "GET" && req.url === "/") {                                                                     // 196
      var content = new Buffer("Self-test OK.");                                                                       // 198
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     // 200
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 201
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 202
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 203
      }                                                                                                                // 204
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 206
        "Content-Type": "text/plain",                                                                                  // 207
        "Content-Length": content.length,                                                                              // 208
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 209
      });                                                                                                              // 206
      res.end(content);                                                                                                // 211
    } else {                                                                                                           // 212
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 213
      res.end("Bad request to self-test subdomain.");                                                                  // 214
      return;                                                                                                          // 215
    }                                                                                                                  // 216
  } catch (err) {                                                                                                      // 217
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 218
  }                                                                                                                    // 219
}                                                                                                                      // 220
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 222
  inMeteor(function () {                                                                                               // 223
    if (req.method === "GET") {                                                                                        // 224
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 225
      if (req.headers["if-none-match"] === "permanent") {                                                              // 226
        // Cache never invalidates since we use a new URL for every resource.                                          // 227
        res.writeHead(304, {                                                                                           // 228
          "Cache-Control": "public, max-age=31536000",                                                                 // 229
          "ETag": "permanent",                                                                                         // 230
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         // 232
          "Content-Security-Policy": assetCspHeader,                                                                   // 233
          "Access-Control-Allow-Origin": "*",                                                                          // 234
          "X-Content-Type-Options": "nosniff"                                                                          // 235
        });                                                                                                            // 228
        res.end();                                                                                                     // 237
        return;                                                                                                        // 238
      }                                                                                                                // 239
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 241
      var pathname = url.pathname.slice(1);                                                                            // 242
      var asset = void 0;                                                                                              // 243
      if (pathname.startsWith("identicon/")) {                                                                         // 244
        var size = parseInt((url.query || {}).s);                                                                      // 245
        asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                    // 246
      } else if (pathname.indexOf("/") == -1) {                                                                        // 247
        asset = globalDb.getStaticAsset(pathname);                                                                     // 248
      }                                                                                                                // 249
                                                                                                                       //
      if (asset) {                                                                                                     // 251
        var headers = {                                                                                                // 252
          "Content-Type": asset.mimeType,                                                                              // 253
          "Content-Length": asset.content.length,                                                                      // 254
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            // 256
          "Cache-Control": "public, max-age=31536000",                                                                 // 257
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   // 259
          "ETag": "permanent",                                                                                         // 260
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     // 262
          // or doing basically anything when browsed to directly. The static assets host is not                       // 263
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      // 264
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          // 265
          // specifying these scripts in <script> tags.                                                                // 266
          "Content-Security-Policy": assetCspHeader,                                                                   // 267
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        // 269
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         // 270
          // assets you're not supposed to know about.                                                                 // 271
          "Access-Control-Allow-Origin": "*",                                                                          // 272
                                                                                                                       //
          // Extra protection against content type trickery.                                                           // 274
          "X-Content-Type-Options": "nosniff"                                                                          // 275
        };                                                                                                             // 252
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 278
          headers["Content-Encoding"] = asset.encoding;                                                                // 279
        }                                                                                                              // 280
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 282
        res.end(asset.content);                                                                                        // 283
      } else {                                                                                                         // 284
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 285
        res.end("not found");                                                                                          // 286
      }                                                                                                                // 287
    } else if (req.method === "POST") {                                                                                // 288
      var _ret = function () {                                                                                         // 288
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 289
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 291
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 292
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              // 294
        if (!purpose) {                                                                                                // 295
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 296
          res.end("Upload token not found or expired.");                                                               // 297
          return {                                                                                                     // 298
            v: void 0                                                                                                  // 298
          };                                                                                                           // 298
        } else if (purpose.profilePicture) {                                                                           // 299
          var userId = purpose.profilePicture.userId;                                                                  // 300
          var identityId = purpose.profilePicture.identityId;                                                          // 301
          check(userId, String);                                                                                       // 302
          check(identityId, String);                                                                                   // 303
        } else if (purpose.loginLogo) {                                                                                // 304
          // no additional fields for loginLogo                                                                        // 305
        } else {                                                                                                       // 306
          res.writeHead(500, { "Content-Type": "text/plain" });                                                        // 307
          res.end("Found invalid purpose for upload");                                                                 // 308
          return {                                                                                                     // 309
            v: void 0                                                                                                  // 309
          };                                                                                                           // 309
        }                                                                                                              // 310
                                                                                                                       //
        var buffers = [];                                                                                              // 312
        var totalSize = 0;                                                                                             // 313
        var done = new Future();                                                                                       // 314
        req.on("data", function (buf) {                                                                                // 315
          totalSize += buf.length;                                                                                     // 316
          if (totalSize <= 64 * 1024) {                                                                                // 317
            buffers.push(buf);                                                                                         // 318
          }                                                                                                            // 319
        });                                                                                                            // 320
        req.on("end", done["return"].bind(done));                                                                      // 321
        req.on("error", done["throw"].bind(done));                                                                     // 322
        done.wait();                                                                                                   // 323
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 325
          // TODO(soon): Resize the image ourselves.                                                                   // 326
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 327
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 328
          return {                                                                                                     // 329
            v: void 0                                                                                                  // 329
          };                                                                                                           // 329
        }                                                                                                              // 330
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 332
        var type = void 0;                                                                                             // 333
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 334
          type = "image/png";                                                                                          // 335
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 336
          type = "image/jpeg";                                                                                         // 337
        } else {                                                                                                       // 338
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 339
          res.end("Image must be PNG or JPEG.");                                                                       // 340
          return {                                                                                                     // 341
            v: void 0                                                                                                  // 341
          };                                                                                                           // 341
        }                                                                                                              // 342
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 344
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 346
          var _identityId = purpose.profilePicture.identityId;                                                         // 347
          var result = Meteor.users.findAndModify({                                                                    // 348
            query: { _id: _identityId },                                                                               // 349
            update: { $set: { "profile.picture": assetId } },                                                          // 350
            fields: { "profile.picture": 1 }                                                                           // 351
          });                                                                                                          // 348
                                                                                                                       //
          if (result.ok) {                                                                                             // 354
            var old = result.value;                                                                                    // 355
            if (old && old.profile && old.profile.picture) {                                                           // 356
              globalDb.unrefStaticAsset(old.profile.picture);                                                          // 357
            }                                                                                                          // 358
          } else {                                                                                                     // 359
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 360
            res.end("Couldn't update profile picture.");                                                               // 361
            return {                                                                                                   // 362
              v: void 0                                                                                                // 362
            };                                                                                                         // 362
          }                                                                                                            // 363
        } else if (purpose.loginLogo) {                                                                                // 364
          var _result = globalDb.collections.settings.findAndModify({                                                  // 365
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 366
            update: {                                                                                                  // 367
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 368
              $set: { value: assetId }                                                                                 // 369
            },                                                                                                         // 367
            upsert: true,                                                                                              // 371
            fields: { value: 1 }                                                                                       // 372
          });                                                                                                          // 365
                                                                                                                       //
          if (_result.ok) {                                                                                            // 375
            var _old = _result.value;                                                                                  // 376
            if (_old && _old.value) {                                                                                  // 377
              globalDb.unrefStaticAsset(_old.value);                                                                   // 378
            }                                                                                                          // 379
          } else {                                                                                                     // 380
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 381
            res.end("Couldn't update login logo.");                                                                    // 382
            return {                                                                                                   // 383
              v: void 0                                                                                                // 383
            };                                                                                                         // 383
          }                                                                                                            // 384
        }                                                                                                              // 385
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 387
        res.end();                                                                                                     // 388
      }();                                                                                                             // 288
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 288
    } else if (req.method === "OPTIONS") {                                                                             // 389
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 390
      if (requestedHeaders) {                                                                                          // 391
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 392
      }                                                                                                                // 393
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 395
        "Access-Control-Allow-Origin": "*",                                                                            // 396
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 397
        "Access-Control-Max-Age": "3600"                                                                               // 398
      });                                                                                                              // 395
      res.end();                                                                                                       // 400
    } else {                                                                                                           // 401
      res.writeHead(405, "Method Not Allowed", {                                                                       // 402
        "Allow": "GET, POST, OPTIONS",                                                                                 // 403
        "Content-Type": "text/plain"                                                                                   // 404
      });                                                                                                              // 402
      res.end("405 Method Not Allowed: " + req.method);                                                                // 406
    }                                                                                                                  // 407
  })["catch"](function (err) {                                                                                         // 408
    writeErrorResponse(res, err);                                                                                      // 409
  });                                                                                                                  // 410
}                                                                                                                      // 411
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 413
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     // 414
  // redirect.                                                                                                         // 415
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 416
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      // 418
  // hostname.                                                                                                         // 419
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 420
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        // 422
  // string parameters, if provided.                                                                                   // 423
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 424
  return targetUrl;                                                                                                    // 425
};                                                                                                                     // 426
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 428
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       // 429
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       // 430
  // request directly.                                                                                                 // 431
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 433
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 435
  // See if the request was for a host in the wildcard.                                                                // 436
  var id = matchWildcardHost(req.headers.host);                                                                        // 437
  if (id) {                                                                                                            // 438
    // Match!                                                                                                          // 439
    if (redirectIfInWildcard) {                                                                                        // 440
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 441
      res.end();                                                                                                       // 442
      return;                                                                                                          // 443
    }                                                                                                                  // 444
                                                                                                                       //
    if (id === "static") {                                                                                             // 446
      // Static assets domain.                                                                                         // 447
      serveStaticAsset(req, res);                                                                                      // 448
      return;                                                                                                          // 449
    }                                                                                                                  // 450
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 452
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       // 453
      // publishing wildcard hosts.                                                                                    // 454
      serveSelfTest(req, res);                                                                                         // 455
      return;                                                                                                          // 456
    }                                                                                                                  // 457
                                                                                                                       //
    // Try to route the request to a session.                                                                          // 459
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 460
      if (handled) {                                                                                                   // 461
        return null;                                                                                                   // 462
      } else {                                                                                                         // 463
        return id;                                                                                                     // 464
      }                                                                                                                // 465
    });                                                                                                                // 466
  } else {                                                                                                             // 467
    // Not a wildcard host. Perhaps it is a custom host.                                                               // 468
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 469
  }                                                                                                                    // 470
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 472
    if (publicId) {                                                                                                    // 473
      return Promise.resolve(undefined).then(function () {                                                             // 474
        var handler = webPublishingHandlers[publicId];                                                                 // 475
        if (handler) {                                                                                                 // 476
          return handler;                                                                                              // 477
        } else {                                                                                                       // 478
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 // 479
          return inMeteor(function () {                                                                                // 480
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 481
            if (!grain) {                                                                                              // 482
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 483
            }                                                                                                          // 484
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 486
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 487
          });                                                                                                          // 488
        }                                                                                                              // 489
      }).then(function (handler) {                                                                                     // 490
        handler(req, res);                                                                                             // 491
      });                                                                                                              // 492
    } else {                                                                                                           // 493
      // Already handled by tryProxyRequest above, no further action needed.                                           // 494
      return Promise.resolve(undefined);                                                                               // 495
    }                                                                                                                  // 496
  })["catch"](function (err) {                                                                                         // 497
    writeErrorResponse(res, err);                                                                                      // 498
  });                                                                                                                  // 499
};                                                                                                                     // 500
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       // 502
// port.                                                                                                               // 503
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 504
  handleNonMeteorRequest(req, res, next, false);                                                                       // 505
};                                                                                                                     // 506
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 // 508
// They are handled as follows:                                                                                        // 509
//                                                                                                                     // 510
// * Requests to the shell & grains, we redirect to the main port.                                                     // 511
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     // 512
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    // 513
//                                                                                                                     // 514
// Alternate ports are bound to FD #5 and higher.                                                                      // 515
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 516
  var numPorts = process.env.PORT.split(",").length;                                                                   // 517
  var numAlternatePorts = numPorts - 1;                                                                                // 518
  return numAlternatePorts;                                                                                            // 519
};                                                                                                                     // 520
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 522
  try {                                                                                                                // 523
    if (!req.headers.host) {                                                                                           // 524
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 525
      res.end("Missing Host header");                                                                                  // 526
      return;                                                                                                          // 527
    }                                                                                                                  // 528
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 // 530
    var hostname = req.headers.host.split(":")[0];                                                                     // 531
    if (isSandstormShell(hostname)) {                                                                                  // 532
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 533
      res.end();                                                                                                       // 534
      return;                                                                                                          // 535
    }                                                                                                                  // 536
    // TODO(someday): check for standalone hosts and do something reasonable                                           // 537
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 539
  } catch (e) {                                                                                                        // 540
    // This should never be reached, because all the request handlers should be catching                               // 541
    // exceptions, but you can never be too careful in a top-level request handler.                                    // 542
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 543
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 544
    res.end("Unhandled exception: " + e.stack);                                                                        // 545
  }                                                                                                                    // 546
};                                                                                                                     // 547
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 549
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 550
    // Call createServerForSandstorm() to skip our monkey patching.                                                    // 551
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 552
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 553
  }                                                                                                                    // 554
};                                                                                                                     // 555
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 557
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 558
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          // 560
  var nonMeteorRequestHandler = connect();                                                                             // 561
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            // 562
  if (global.BlackrockPayments) {                                                                                      // 563
    // Have to check with global, because it could be undefined.                                                       // 563
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 564
  }                                                                                                                    // 565
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 567
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 569
  WebApp.httpServer.on("request", function (req, res) {                                                                // 570
    Promise.resolve(undefined).then(function () {                                                                      // 571
      if (!req.headers.host) {                                                                                         // 572
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 573
        res.end("Missing Host header");                                                                                // 574
        return;                                                                                                        // 575
      }                                                                                                                // 576
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0]; // strip port if it exists                                        // 578
      if (isSandstormShell(hostname)) {                                                                                // 579
        if (req.url.startsWith("/_oauth/")) {                                                                          // 580
          // Intercept oauth callbacks on the main host to check if the user was actually logging                      // 581
          // into a standalone host, in which case we need to redirect to that host instead.                           // 582
          var parsedUrl = Url.parse(req.url, true);                                                                    // 583
          if (parsedUrl.query && parsedUrl.query.state) {                                                              // 584
            var _ret2 = function () {                                                                                  // 584
              var rawState = new Buffer(parsedUrl.query.state, "base64");                                              // 585
              var state = JSON.parse(rawState.toString());                                                             // 586
              if (state.redirectUrl) {                                                                                 // 587
                var _ret3 = function () {                                                                              // 587
                  var parsedRedirect = Url.parse(state.redirectUrl);                                                   // 588
                  var redirectHostname = parsedRedirect.hostname;                                                      // 589
                  if (redirectHostname !== HOSTNAME) {                                                                 // 590
                    return {                                                                                           // 591
                      v: {                                                                                             // 591
                        v: inMeteor(function () {                                                                      // 591
                          if (globalDb.hostIsStandalone(redirectHostname)) {                                           // 592
                            res.writeHead(302, { "Location": parsedRedirect.protocol + "//" + parsedRedirect.host + req.url });
                            res.end();                                                                                 // 595
                            return;                                                                                    // 596
                          } else {                                                                                     // 597
                            throw new Meteor.Error(400, "redirectUrl in OAuth was for an unknown host: " + state.redirectUrl);
                          }                                                                                            // 600
                        })                                                                                             // 601
                      }                                                                                                // 591
                    };                                                                                                 // 591
                  }                                                                                                    // 602
                }();                                                                                                   // 587
                                                                                                                       //
                if ((typeof _ret3 === "undefined" ? "undefined" : _typeof(_ret3)) === "object") return _ret3.v;        // 587
              }                                                                                                        // 603
            }();                                                                                                       // 584
                                                                                                                       //
            if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;            // 584
          }                                                                                                            // 604
        }                                                                                                              // 605
        // If destined for the DDP host or the main host, pass on to Meteor                                            // 606
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 607
          meteorRequestListeners[i](req, res);                                                                         // 608
        }                                                                                                              // 609
      } else {                                                                                                         // 610
        return inMeteor(function () {                                                                                  // 611
          if (globalDb.hostIsStandalone(hostname)) {                                                                   // 612
            // If it's a standalone host, also pass on to meteor                                                       // 613
            for (var _i = 0; _i < meteorRequestListeners.length; _i++) {                                               // 614
              meteorRequestListeners[_i](req, res);                                                                    // 615
            }                                                                                                          // 616
          } else {                                                                                                     // 617
            // Otherwise, dispatch to our own middleware proxy chain.                                                  // 618
            nonMeteorRequestHandler(req, res);                                                                         // 619
            // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                               // 620
            WebApp._timeoutAdjustmentRequestCallback(req, res);                                                        // 621
          }                                                                                                            // 622
        });                                                                                                            // 623
      }                                                                                                                // 624
    })["catch"](function (e) {                                                                                         // 625
      // This should never be reached, because all the request handlers should be catching                             // 626
      // exceptions, but you can never be too careful in a top-level request handler.                                  // 627
      console.error("Unhandled exception in request handler:", e.stack);                                               // 628
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 629
      res.end("Unhandled exception: " + e.stack);                                                                      // 630
    });                                                                                                                // 631
  });                                                                                                                  // 632
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 634
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 635
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 637
    Promise.resolve(undefined).then(function () {                                                                      // 638
      if (!req.headers.host) {                                                                                         // 639
        throw new Meteor.Error(400, "Missing Host header");                                                            // 640
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 641
        // Go on to Meteor.                                                                                            // 642
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 643
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 644
        }                                                                                                              // 645
                                                                                                                       //
        return true;                                                                                                   // 647
      } else {                                                                                                         // 648
        return inMeteor(function () {                                                                                  // 649
          // TODO(someday): This is slightly sad that some requests will now need a Meteor fiber                       // 650
          // If we disallow standalone domains from being in the wildcard host, then we can move                       // 651
          // this check to the bottom.                                                                                 // 652
          if (globalDb.hostIsStandalone(req.headers.host.split(":")[0])) {                                             // 653
            for (var _ii = 0; _ii < meteorUpgradeListeners.length; ++_ii) {                                            // 654
              meteorUpgradeListeners[_ii](req, socket, head);                                                          // 655
            }                                                                                                          // 656
                                                                                                                       //
            return true;                                                                                               // 658
          } else {                                                                                                     // 659
            var id = matchWildcardHost(req.headers.host);                                                              // 660
            if (id) {                                                                                                  // 661
              return tryProxyUpgrade(id, req, socket, head);                                                           // 662
            } else {                                                                                                   // 663
              return false;                                                                                            // 664
            }                                                                                                          // 665
          }                                                                                                            // 666
        });                                                                                                            // 667
      }                                                                                                                // 668
    }).then(function (handled) {                                                                                       // 669
      if (!handled) socket.destroy();                                                                                  // 670
    })["catch"](function (err) {                                                                                       // 671
      console.error("WebSocket event handler failed:", err.stack);                                                     // 672
      socket.destroy();                                                                                                // 673
    });                                                                                                                // 674
  });                                                                                                                  // 675
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 677
});                                                                                                                    // 678
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 680
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 686
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 693
  // Given a hostname, determine its public ID.                                                                        // 694
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     // 695
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        // 696
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      // 697
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    // 698
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      // 699
  // the TXT record on a subdomain.                                                                                    // 700
  //                                                                                                                   // 701
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   // 702
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         // 703
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      // 704
  // CDN like CloudFlare in front of the site.                                                                         // 705
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 707
  if (cache && Date.now() < cache.expiration) {                                                                        // 708
    return Promise.resolve(cache.value);                                                                               // 709
  }                                                                                                                    // 710
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 712
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 713
      if (err) {                                                                                                       // 714
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 715
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 716
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 737
        reject(error);                                                                                                 // 738
      } else if (records.length !== 1) {                                                                               // 739
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 740
      } else {                                                                                                         // 741
        // Under node 0.12+, `records` is an array-of-arrays. Each sub-array contains "chunks" of a                    // 742
        // record, which should be joined.                                                                             // 743
        var result = records[0].join("");                                                                              // 744
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 745
        resolve(result);                                                                                               // 746
      }                                                                                                                // 747
    });                                                                                                                // 748
  });                                                                                                                  // 749
}                                                                                                                      // 750
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum","/imports/server/constants.js","/imports/server/backend.js","/imports/server/async-helpers.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});var SandstormBackend,shouldRestartGrain;module.import("/imports/server/backend.js",{"SandstormBackend":function(v){SandstormBackend=v},"shouldRestartGrain":function(v){shouldRestartGrain=v}});var inMeteor,waitPromise;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v},"waitPromise":function(v){waitPromise=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
var Crypto = Npm.require("crypto");                                                                                    // 21
var ChildProcess = Npm.require("child_process");                                                                       // 22
var Fs = Npm.require("fs");                                                                                            // 23
var Path = Npm.require("path");                                                                                        // 24
var Http = Npm.require("http");                                                                                        // 25
var Url = Npm.require("url");                                                                                          // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
var Net = Npm.require("net");                                                                                          // 28
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 30
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 31
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 32
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 33
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 34
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 35
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                         // 36
                                                                                                                       //
var PARSED_ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                 // 38
var PROTOCOL = PARSED_ROOT_URL.protocol;                                                                               // 39
var PORT = PARSED_ROOT_URL.port;                                                                                       // 40
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      // 43
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        // 44
  check(accountId, String);                                                                                            // 45
  check(identityId, String);                                                                                           // 46
  check(apiTokenAccountId, String);                                                                                    // 47
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        // 49
  if (!db.isReferralEnabled()) {                                                                                       // 50
    return;                                                                                                            // 51
  }                                                                                                                    // 52
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 54
  var bobAccountId = accountId;                                                                                        // 55
  var bobIdentityId = identityId;                                                                                      // 56
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 58
    _id: bobAccountId,                                                                                                 // 59
    referredByComplete: { $exists: true }                                                                              // 60
  }).count() > 0) {                                                                                                    // 58
    return;                                                                                                            // 62
  }                                                                                                                    // 63
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 // 65
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 69
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 71
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    // 72
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    // 73
  // access' interface. Let's call them Bob.                                                                           // 74
  //                                                                                                                   // 75
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    // 76
  // first referredBy we find -- let's call that Alice.                                                                // 77
  //                                                                                                                   // 78
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           // 79
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         // 80
  // Identity since it has become redundant.                                                                           // 81
  //                                                                                                                   // 82
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       // 83
  // link with Bob, even if Bob already had an account.                                                                // 84
                                                                                                                       //
  // Bail out early if referrals aren't enabled                                                                        // 86
  if (!db.isReferralEnabled()) {                                                                                       // 87
    return;                                                                                                            // 88
  }                                                                                                                    // 89
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         // 91
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 92
    return;                                                                                                            // 93
  }                                                                                                                    // 94
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 // 96
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 97
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 98
    _id: { $in: bobIdentityIds },                                                                                      // 99
    referredBy: { $exists: true }                                                                                      // 100
  });                                                                                                                  // 98
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 103
    return;                                                                                                            // 104
  }                                                                                                                    // 105
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 107
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          // 109
  var now = new Date();                                                                                                // 110
  Meteor.users.update({                                                                                                // 111
    _id: bobAccountId,                                                                                                 // 112
    referredByComplete: { $exists: false }                                                                             // 113
  }, {                                                                                                                 // 111
    $set: {                                                                                                            // 115
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 116
      referredCompleteDate: now                                                                                        // 117
    }                                                                                                                  // 115
  });                                                                                                                  // 114
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       // 121
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 122
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 123
  });                                                                                                                  // 122
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     // 126
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 127
    $unset: { referredBy: true }                                                                                       // 128
  });                                                                                                                  // 127
}                                                                                                                      // 130
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 133
    var _this2 = this;                                                                                                 // 133
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 133
                                                                                                                       //
    this._headers = {};                                                                                                // 134
    this._prefixes = [];                                                                                               // 135
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 137
      if (pattern.endsWith("*")) {                                                                                     // 138
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 139
      } else {                                                                                                         // 140
        _this2._headers[pattern] = true;                                                                               // 141
      }                                                                                                                // 142
    });                                                                                                                // 143
  }                                                                                                                    // 144
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function () {                                                                    //
    function matches(header) {                                                                                         //
      header = header.toLowerCase();                                                                                   // 147
      if (this._headers[header]) return true;                                                                          // 148
                                                                                                                       //
      for (var i in meteorBabelHelpers.sanitizeForInObject(this._prefixes)) {                                          // 150
        if (header.startsWith(this._prefixes[i])) {                                                                    // 151
          return true;                                                                                                 // 152
        }                                                                                                              // 153
      };                                                                                                               // 154
                                                                                                                       //
      return false;                                                                                                    // 156
    }                                                                                                                  // 157
                                                                                                                       //
    return matches;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 160
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 161
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         // 163
// These are regex matches, so ensure they are escaped properly with double                                            // 164
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            // 165
// that may render html and execute embedded scripts.                                                                  // 166
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 176
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 178
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory(globalDb);                                                         // 180
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 181
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 182
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 183
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            // 185
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               // 186
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 187
Meteor.onConnection(function (connection) {                                                                            // 188
  connection.sandstormBackend = globalBackend;                                                                         // 189
});                                                                                                                    // 190
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        // 192
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      // 193
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      // 194
// Restarting the node process (and only the node process) always fixes the problem.                                   // 195
//                                                                                                                     // 196
// Here, I've added some code that attempts to detect the problem by doing a health check                              // 197
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          // 198
var backendHealthy = true;                                                                                             // 199
var disconnectCount = 0;                                                                                               // 200
Meteor.setInterval(function () {                                                                                       // 201
  if (!backendHealthy) {                                                                                               // 202
    if (disconnectCount++ > 2) process.abort();                                                                        // 203
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 204
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 205
    sandstormBackendConnection.close();                                                                                // 206
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 207
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 208
    globalBackend._backendCap = sandstormBackend;                                                                      // 209
  }                                                                                                                    // 210
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 212
  backendHealthy = false;                                                                                              // 213
  var promise = sandstormBackend.ping().then(function () {                                                             // 214
    backendHealthy = true;                                                                                             // 215
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 216
  }, function (err) {                                                                                                  // 217
    console.error("error: Backend ping threw error!", err.stack);                                                      // 218
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        // 219
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         // 220
    // So we don't expect this branch to execute in any case.                                                          // 221
  });                                                                                                                  // 222
                                                                                                                       //
  if (debugLog) {                                                                                                      // 224
    console.log("capnp.js: outer promise:", promise);                                                                  // 225
  }                                                                                                                    // 226
}, 30000);                                                                                                             // 227
                                                                                                                       //
// =======================================================================================                             // 229
// API for creating / starting grains from Meteor methods.                                                             // 230
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 232
                                                                                                                       //
function parsePowerboxDescriptorList(list) {                                                                           // 234
  return list.map(function (packedDescriptor) {                                                                        // 235
    return Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });         // 235
  });                                                                                                                  // 235
}                                                                                                                      // 238
                                                                                                                       //
Meteor.methods({                                                                                                       // 240
  newGrain: function () {                                                                                              // 241
    function newGrain(packageId, command, title, identityId) {                                                         // 240
      // Create and start a new grain.                                                                                 // 242
                                                                                                                       //
      check(packageId, String);                                                                                        // 244
      check(command, Object); // Manifest.Command from package.capnp.                                                  // 245
      check(title, String);                                                                                            // 246
      check(identityId, String);                                                                                       // 247
                                                                                                                       //
      if (!this.userId) {                                                                                              // 249
        throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                            // 250
      }                                                                                                                // 251
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 253
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 254
      }                                                                                                                // 255
                                                                                                                       //
      if (!isSignedUpOrDemo()) {                                                                                       // 257
        throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");            // 258
      }                                                                                                                // 260
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 262
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 263
      }                                                                                                                // 265
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 267
      var isDev = false;                                                                                               // 268
      var mountProc = false;                                                                                           // 269
      if (!pkg) {                                                                                                      // 270
        // Maybe they wanted a dev package.  Check there too.                                                          // 271
        pkg = DevPackages.findOne(packageId);                                                                          // 272
        isDev = true;                                                                                                  // 273
        mountProc = pkg.mountProc;                                                                                     // 274
      }                                                                                                                // 275
                                                                                                                       //
      if (!pkg) {                                                                                                      // 277
        throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                     // 278
      }                                                                                                                // 279
                                                                                                                       //
      var appId = pkg.appId;                                                                                           // 281
      var manifest = pkg.manifest;                                                                                     // 282
      var grainId = Random.id(22); // 128 bits of entropy                                                              // 283
      Grains.insert({                                                                                                  // 284
        _id: grainId,                                                                                                  // 285
        packageId: packageId,                                                                                          // 286
        appId: appId,                                                                                                  // 287
        appVersion: manifest.appVersion,                                                                               // 288
        userId: this.userId,                                                                                           // 289
        identityId: identityId,                                                                                        // 290
        title: title,                                                                                                  // 291
        "private": true,                                                                                               // 292
        size: 0                                                                                                        // 293
      });                                                                                                              // 284
                                                                                                                       //
      globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev, mountProc);              // 296
      globalBackend.updateLastActive(grainId, this.userId, identityId);                                                // 298
      return grainId;                                                                                                  // 299
    }                                                                                                                  // 300
                                                                                                                       //
    return newGrain;                                                                                                   // 240
  }(),                                                                                                                 // 240
  openSession: function () {                                                                                           // 302
    function openSession(grainId, identityId, cachedSalt, options) {                                                   // 240
      // Open a new UI session on an existing grain.  Starts the grain if it is not already                            // 303
      // running.                                                                                                      // 304
                                                                                                                       //
      options = options || {};                                                                                         // 306
                                                                                                                       //
      check(grainId, String);                                                                                          // 308
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 309
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 310
      check(options, {                                                                                                 // 311
        powerboxRequest: Match.Optional({                                                                              // 312
          descriptors: [String],                                                                                       // 313
          requestingSession: String                                                                                    // 314
        })                                                                                                             // 312
      });                                                                                                              // 311
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 318
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 319
      }                                                                                                                // 320
                                                                                                                       //
      var grain = Grains.findOne({ _id: grainId });                                                                    // 322
      if (!grain) {                                                                                                    // 323
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                        // 324
      } else if (grain.trashed) {                                                                                      // 325
        throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                      // 326
      } else if (grain.suspended) {                                                                                    // 327
        throw new Meteor.Error("grain-owner-suspended", "Grain's owner is suspended", "Grain ID: " + grainId);         // 328
      }                                                                                                                // 330
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 332
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 333
      if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {               // 334
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 336
      }                                                                                                                // 337
                                                                                                                       //
      var sessionFields = {};                                                                                          // 339
      if (options.powerboxRequest) {                                                                                   // 340
        sessionFields.powerboxRequest = {                                                                              // 341
          descriptors: parsePowerboxDescriptorList(options.powerboxRequest.descriptors),                               // 342
          requestingSession: options.powerboxRequest.requestingSession                                                 // 343
        };                                                                                                             // 341
      }                                                                                                                // 345
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt, sessionFields);
      var result = opened.methodResult;                                                                                // 349
      var proxy = new Proxy(grain, result.sessionId, result.hostId, result.tabId, identityId, false, null, opened.supervisor);
                                                                                                                       //
      if (sessionFields.powerboxRequest) {                                                                             // 354
        proxy.powerboxRequest = sessionFields.powerboxRequest;                                                         // 355
      }                                                                                                                // 356
                                                                                                                       //
      proxiesByHostId[result.hostId] = proxy;                                                                          // 358
      return result;                                                                                                   // 359
    }                                                                                                                  // 360
                                                                                                                       //
    return openSession;                                                                                                // 240
  }(),                                                                                                                 // 240
  openSessionFromApiToken: function () {                                                                               // 362
    function openSessionFromApiToken(params, identityId, cachedSalt, neverRedeem, parentOrigin, options) {             // 240
      // Given an API token, either opens a new WebSession to the underlying grain or returns a                        // 363
      // path to which the client should redirect in order to open such a session.                                     // 364
      //                                                                                                               // 365
      // `parentOrigin` is the origin of the parent frame of the grain iframe. This may differ from                    // 366
      // ROOT_URL for standalone domains.                                                                              // 367
                                                                                                                       //
      neverRedeem = neverRedeem || false;                                                                              // 369
      parentOrigin = parentOrigin || process.env.ROOT_URL;                                                             // 370
      options = options || {};                                                                                         // 371
                                                                                                                       //
      check(params, {                                                                                                  // 373
        token: String,                                                                                                 // 374
        incognito: Match.Optional(Boolean) });                                                                         // 375
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 377
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 378
      check(neverRedeem, Boolean);                                                                                     // 379
      check(parentOrigin, String);                                                                                     // 380
      check(options, {                                                                                                 // 381
        powerboxRequest: Match.Optional({                                                                              // 382
          descriptors: [String],                                                                                       // 383
          requestingSession: String                                                                                    // 384
        })                                                                                                             // 382
      });                                                                                                              // 381
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 388
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 389
      }                                                                                                                // 390
                                                                                                                       //
      if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                   // 392
        throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
      }                                                                                                                // 395
                                                                                                                       //
      var token = params.token;                                                                                        // 397
      var incognito = !identityId;                                                                                     // 398
      var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                    // 399
      var apiToken = ApiTokens.findOne(hashedToken);                                                                   // 400
      validateWebkey(apiToken);                                                                                        // 401
      var grain = Grains.findOne({ _id: apiToken.grainId });                                                           // 402
      if (!grain) {                                                                                                    // 403
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                               // 404
      }                                                                                                                // 405
                                                                                                                       //
      if (apiToken.accountId) {                                                                                        // 407
        referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                               // 408
      }                                                                                                                // 409
                                                                                                                       //
      var title = void 0;                                                                                              // 411
      if (grain.userId === apiToken.accountId) {                                                                       // 412
        title = grain.title;                                                                                           // 413
      } else {                                                                                                         // 414
        var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                   // 415
          grainId: apiToken.grainId,                                                                                   // 417
          "owner.user.identityId": apiToken.identityId                                                                 // 418
        }, {                                                                                                           // 416
          sort: {                                                                                                      // 420
            lastUsed: -1                                                                                               // 421
          }                                                                                                            // 420
        });                                                                                                            // 419
        if (sharerToken) {                                                                                             // 424
          title = sharerToken.owner.user.title;                                                                        // 425
        } else {                                                                                                       // 426
          title = "shared grain";                                                                                      // 427
        }                                                                                                              // 428
      }                                                                                                                // 429
                                                                                                                       //
      if (this.userId && !incognito && !neverRedeem) {                                                                 // 431
        if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
          var owner = { user: { identityId: identityId, title: title } };                                              // 434
                                                                                                                       //
          // Create a new API token for the identity redeeming this token.                                             // 436
          var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname || "redeemed webkey", { allAccess: null }, owner);
          globalDb.addContact(apiToken.accountId, identityId);                                                         // 441
                                                                                                                       //
          // If the parent API token is forSharing and it has an accountId, then the logged-in user (call              // 443
          // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference              // 444
          // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                      // 445
          // share-by-identity, this happens immediately.)                                                             // 446
          if (result.parentApiToken) {                                                                                 // 447
            var parentApiToken = result.parentApiToken;                                                                // 448
            if (parentApiToken.forSharing && parentApiToken.accountId) {                                               // 449
              storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
            }                                                                                                          // 452
          }                                                                                                            // 453
        }                                                                                                              // 454
                                                                                                                       //
        return { redirectToGrain: apiToken.grainId };                                                                  // 456
      } else {                                                                                                         // 457
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                       // 458
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 459
        }                                                                                                              // 461
                                                                                                                       //
        var sessionFields = {};                                                                                        // 463
        if (options.powerboxRequest) {                                                                                 // 464
          sessionFields.powerboxRequest = {                                                                            // 465
            descriptors: parsePowerboxDescriptorList(options.powerboxRequest.descriptors),                             // 466
            requestingSession: options.powerboxRequest.requestingSession                                               // 467
          };                                                                                                           // 465
        }                                                                                                              // 469
                                                                                                                       //
        // Even in incognito mode, we want to record the user ID on the session. The user ID is not                    // 471
        // leaked to the app in any way -- it is used to decide what options to show in a powerbox                     // 472
        // request. Even if the user is incognito, they should be able to offer their full range of                    // 473
        // capabilities.                                                                                               // 474
        //                                                                                                             // 475
        // The identity ID passed here IS revealed to the app, but for incognito mode it is always                     // 476
        // null/undefined.                                                                                             // 477
        var opened = globalBackend.openSessionInternal(apiToken.grainId, this.userId, identityId, title, apiToken, cachedSalt, sessionFields);
                                                                                                                       //
        var _result = opened.methodResult;                                                                             // 481
        var proxy = new Proxy(grain, _result.sessionId, _result.hostId, _result.tabId, identityId, false, parentOrigin, opened.supervisor);
        proxy.apiToken = apiToken;                                                                                     // 485
        if (sessionFields.powerboxRequest) {                                                                           // 486
          proxy.powerboxRequest = sessionFields.powerboxRequest;                                                       // 487
        }                                                                                                              // 488
                                                                                                                       //
        proxiesByHostId[_result.hostId] = proxy;                                                                       // 490
        return _result;                                                                                                // 491
      }                                                                                                                // 492
    }                                                                                                                  // 493
                                                                                                                       //
    return openSessionFromApiToken;                                                                                    // 240
  }(),                                                                                                                 // 240
  keepSessionAlive: function () {                                                                                      // 495
    function keepSessionAlive(sessionId) {                                                                             // 240
      // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                  // 496
      //   by them.                                                                                                    // 497
      check(sessionId, String);                                                                                        // 498
                                                                                                                       //
      var result = Sessions.findAndModify({                                                                            // 500
        query: { _id: sessionId },                                                                                     // 501
        update: { $set: { timestamp: new Date().getTime() } },                                                         // 502
        fields: { grainId: 1, identityId: 1, hostId: 1 }                                                               // 503
      });                                                                                                              // 500
                                                                                                                       //
      if (!result.ok) {                                                                                                // 506
        return false;                                                                                                  // 507
      }                                                                                                                // 508
                                                                                                                       //
      var session = result.value;                                                                                      // 510
      if (session) {                                                                                                   // 511
        // Session still present in database, so send keep-alive to backend.                                           // 512
        try {                                                                                                          // 513
          var grainId = session.grainId;                                                                               // 514
          var hostId = session.hostId;                                                                                 // 515
          var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                              // 516
          if (!supervisor) {                                                                                           // 517
            supervisor = globalBackend.continueGrain(grainId).supervisor;                                              // 518
          }                                                                                                            // 519
                                                                                                                       //
          waitPromise(supervisor.keepAlive());                                                                         // 521
          globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                    // 522
        } catch (err) {                                                                                                // 523
          // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                  // 524
          // the next request, so whatever.                                                                            // 525
          if (err.kjType !== "disconnected") {                                                                         // 526
            throw err;                                                                                                 // 527
          }                                                                                                            // 528
        }                                                                                                              // 529
                                                                                                                       //
        return true;                                                                                                   // 531
      } else {                                                                                                         // 532
        return false;                                                                                                  // 533
      }                                                                                                                // 534
    }                                                                                                                  // 535
                                                                                                                       //
    return keepSessionAlive;                                                                                           // 240
  }(),                                                                                                                 // 240
  shutdownGrain: function () {                                                                                         // 537
    function shutdownGrain(grainId) {                                                                                  // 240
      check(grainId, String);                                                                                          // 538
      var grain = Grains.findOne(grainId);                                                                             // 539
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 540
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 541
      }                                                                                                                // 542
                                                                                                                       //
      waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                           // 544
    }                                                                                                                  // 545
                                                                                                                       //
    return shutdownGrain;                                                                                              // 240
  }()                                                                                                                  // 240
});                                                                                                                    // 240
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 548
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        // 549
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            // 550
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        // 551
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 553
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 554
  }                                                                                                                    // 555
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 557
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 558
  }                                                                                                                    // 559
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 561
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 562
  }                                                                                                                    // 563
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 565
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 566
  }                                                                                                                    // 567
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 569
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 570
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 571
    } else if (refreshedExpiration) {                                                                                  // 572
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 573
    } else {                                                                                                           // 574
      // It's getting used now, so clear the expiresIfUnused field.                                                    // 575
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 576
    }                                                                                                                  // 577
  }                                                                                                                    // 578
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 580
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 581
  }                                                                                                                    // 582
};                                                                                                                     // 583
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 585
  var shutdownApp = function shutdownApp(appId) {                                                                      // 586
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 587
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 588
    });                                                                                                                // 589
  };                                                                                                                   // 590
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 592
    removed: function () {                                                                                             // 593
      function removed(devPackage) {                                                                                   // 592
        shutdownApp(devPackage.appId);                                                                                 // 593
      }                                                                                                                // 593
                                                                                                                       //
      return removed;                                                                                                  // 592
    }(),                                                                                                               // 592
    changed: function () {                                                                                             // 595
      function changed(newDevPackage, oldDevPackage) {                                                                 // 592
        shutdownApp(oldDevPackage.appId);                                                                              // 596
        if (oldDevPackage.appId !== newDevPackage.appId) {                                                             // 597
          shutdownApp(newDevPackage.appId);                                                                            // 598
        }                                                                                                              // 599
      }                                                                                                                // 600
                                                                                                                       //
      return changed;                                                                                                  // 592
    }(),                                                                                                               // 592
    added: function () {                                                                                               // 602
      function added(devPackage) {                                                                                     // 592
        shutdownApp(devPackage.appId);                                                                                 // 602
      }                                                                                                                // 602
                                                                                                                       //
      return added;                                                                                                    // 592
    }()                                                                                                                // 592
  });                                                                                                                  // 592
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 605
    removed: function () {                                                                                             // 606
      function removed(session) {                                                                                      // 605
        var proxy = proxiesByHostId[session.hostId];                                                                   // 607
        delete proxiesByHostId[session.hostId];                                                                        // 608
        if (proxy) {                                                                                                   // 609
          proxy.close();                                                                                               // 610
        }                                                                                                              // 611
      }                                                                                                                // 612
                                                                                                                       //
      return removed;                                                                                                  // 605
    }()                                                                                                                // 605
  });                                                                                                                  // 605
});                                                                                                                    // 614
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             // 616
var TIMEOUT_MS = 180000;                                                                                               // 617
var gcSessions = function gcSessions() {                                                                               // 618
  var now = new Date().getTime();                                                                                      // 619
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 620
};                                                                                                                     // 621
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 623
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 625
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       // 626
  // doesn't already exist. The first request on the session host will always create a new proxy.                      // 627
  // Later requests may create a proxy if they go to a different front-end replica or if the                           // 628
  // front-end was restarted.                                                                                          // 629
  check(hostId, String);                                                                                               // 630
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 632
    var proxy = proxiesByHostId[hostId];                                                                               // 633
    if (proxy) {                                                                                                       // 634
      return proxy;                                                                                                    // 635
    } else {                                                                                                           // 636
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          // 637
      proxiesByHostId[hostId] = null;                                                                                  // 638
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 640
        var session = Sessions.findOne({ hostId: hostId });                                                            // 641
        if (!session) {                                                                                                // 642
          if (isAlreadyOpened) {                                                                                       // 643
            var _ret = function () {                                                                                   // 643
              var observer = void 0;                                                                                   // 644
              return {                                                                                                 // 645
                v: new Promise(function (resolve, reject) {                                                            // 645
                  var task = Meteor.setTimeout(function () {                                                           // 646
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 652
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 653
                    added: function () {                                                                               // 654
                      function added() {                                                                               // 653
                        Meteor.clearTimeout(task);                                                                     // 655
                        resolve(getProxyForHostId(hostId, false));                                                     // 656
                      }                                                                                                // 657
                                                                                                                       //
                      return added;                                                                                    // 653
                    }()                                                                                                // 653
                  });                                                                                                  // 653
                }).then(function (v) {                                                                                 // 659
                  observer.stop();                                                                                     // 660
                  return v;                                                                                            // 661
                }, function (e) {                                                                                      // 662
                  observer.stop();                                                                                     // 663
                  throw e;                                                                                             // 664
                })                                                                                                     // 665
              };                                                                                                       // 645
            }();                                                                                                       // 643
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 643
          } else {                                                                                                     // 666
            // Does not appear to be a valid session host.                                                             // 667
            return undefined;                                                                                          // 668
          }                                                                                                            // 669
        }                                                                                                              // 670
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 672
        if (session.hashedToken) {                                                                                     // 673
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 674
          // We don't have to fully validate the API token here because if it changed the session                      // 675
          // would have been deleted.                                                                                  // 676
          if (!apiToken) {                                                                                             // 677
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 678
          }                                                                                                            // 679
        }                                                                                                              // 680
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 682
        if (!grain) {                                                                                                  // 683
          // Grain was deleted, I guess.                                                                               // 684
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 685
        }                                                                                                              // 686
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           // 688
        // implies this check was already performed.                                                                   // 689
                                                                                                                       //
        var proxy = new Proxy(grain, session._id, hostId, session.tabId, session.identityId, false);                   // 691
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 693
                                                                                                                       //
        if (session.powerboxRequest) {                                                                                 // 695
          proxy.powerboxRequest = session.powerboxRequest;                                                             // 696
        }                                                                                                              // 697
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      // 699
        // e.g. if the user's access was revoked).                                                                     // 700
        if (hostId in proxiesByHostId) {                                                                               // 701
          proxiesByHostId[hostId] = proxy;                                                                             // 702
        } else {                                                                                                       // 703
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 704
        }                                                                                                              // 705
                                                                                                                       //
        return proxy;                                                                                                  // 707
      });                                                                                                              // 708
    }                                                                                                                  // 709
  });                                                                                                                  // 710
};                                                                                                                     // 711
                                                                                                                       //
// =======================================================================================                             // 713
// API tokens                                                                                                          // 714
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              // 717
  // requests are not associated with any entry in the `Sessions` collection, so we need                               // 718
  // some other means of detecting unused proxies and closing them. This class works by keeping                        // 719
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      // 720
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             // 721
  //                                                                                                                   // 722
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       // 723
  // structs.                                                                                                          // 724
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 726
    var _this3 = this;                                                                                                 // 726
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 726
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 727
    this.newBucket = {};                                                                                               // 728
    this.oldBucket = {};                                                                                               // 729
    this.interval = Meteor.setInterval(function () {                                                                   // 730
      for (var oldHashedToken in meteorBabelHelpers.sanitizeForInObject(_this3.oldBucket)) {                           // 731
        for (var oldHashedParams in meteorBabelHelpers.sanitizeForInObject(_this3.oldBucket[oldHashedToken])) {        // 732
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 733
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 735
          if (oldProxy && !newProxy) {                                                                                 // 736
            if (Object.keys(oldProxy.websockets).length > 0 || Object.keys(oldProxy.streamingRequests).length > 0 || Object.keys(oldProxy.streamingResponses).length > 0) {
              // A client has an open stream. Keep the proxy around.                                                   // 740
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 741
            } else {                                                                                                   // 742
              // We can close this proxy and forget about it.                                                          // 743
              oldProxy.close();                                                                                        // 744
            }                                                                                                          // 745
          }                                                                                                            // 746
        }                                                                                                              // 747
      }                                                                                                                // 748
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 750
      _this3.newBucket = {};                                                                                           // 751
                                                                                                                       //
      var keepAlives = [];                                                                                             // 753
      for (var hashedToken in meteorBabelHelpers.sanitizeForInObject(_this3.oldBucket)) {                              // 754
        for (var hashedParams in meteorBabelHelpers.sanitizeForInObject(_this3.oldBucket[hashedToken])) {              // 755
          var proxy = _this3.oldBucket[hashedToken][hashedParams];                                                     // 756
          keepAlives.push(proxy.supervisor.keepAlive()["catch"](function (e) {                                         // 757
            console.error("supervisor.keepAlive() failed.", e);                                                        // 758
          }));                                                                                                         // 759
        }                                                                                                              // 760
      }                                                                                                                // 761
                                                                                                                       //
      waitPromise(Promise.all(keepAlives));                                                                            // 763
    }, intervalMillis);                                                                                                // 764
  }                                                                                                                    // 765
                                                                                                                       //
  ApiSessionProxies.prototype.get = function () {                                                                      //
    function get(hashedToken, hashedParams) {                                                                          //
      if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                  // 768
        return this.newBucket[hashedToken][hashedParams];                                                              // 769
      } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                           // 770
        var proxy = this.oldBucket[hashedToken][hashedParams];                                                         // 771
        delete this.oldBucket[hashedToken][hashedParams];                                                              // 772
        this.put(hashedToken, hashedParams, proxy);                                                                    // 773
        return proxy;                                                                                                  // 774
      } else {                                                                                                         // 775
        return null;                                                                                                   // 776
      }                                                                                                                // 777
    }                                                                                                                  // 778
                                                                                                                       //
    return get;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.put = function () {                                                                      //
    function put(hashedToken, hashedParams, proxy) {                                                                   //
      if (!this.newBucket[hashedToken]) {                                                                              // 781
        this.newBucket[hashedToken] = {};                                                                              // 782
      }                                                                                                                // 783
                                                                                                                       //
      this.newBucket[hashedToken][hashedParams] = proxy;                                                               // 785
    }                                                                                                                  // 786
                                                                                                                       //
    return put;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function () {                                                     //
    function removeProxiesOfToken(hashedToken) {                                                                       //
      if (hashedToken in this.oldBucket) {                                                                             // 789
        for (var hashedParams in meteorBabelHelpers.sanitizeForInObject(this.oldBucket[hashedToken])) {                // 790
          this.oldBucket[hashedToken][hashedParams].close();                                                           // 791
        }                                                                                                              // 792
                                                                                                                       //
        delete this.oldBucket[hashedToken];                                                                            // 794
      }                                                                                                                // 795
                                                                                                                       //
      if (hashedToken in this.newBucket) {                                                                             // 797
        for (var _hashedParams in meteorBabelHelpers.sanitizeForInObject(this.newBucket[hashedToken])) {               // 798
          this.newBucket[hashedToken][_hashedParams].close();                                                          // 799
        }                                                                                                              // 800
                                                                                                                       //
        delete this.newBucket[hashedToken];                                                                            // 802
      }                                                                                                                // 803
    }                                                                                                                  // 804
                                                                                                                       //
    return removeProxiesOfToken;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
// The interval of 60 seconds here deliberately matches the `keepSessionAlive()` interval                              // 807
// in the case of non-API proxies.                                                                                     // 808
                                                                                                                       //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(60 * 1000);                                                              // 809
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 811
  Grains.find().observe({                                                                                              // 812
    changed: function () {                                                                                             // 813
      function changed(newGrain, oldGrain) {                                                                           // 812
        if (oldGrain["private"] != newGrain["private"]) {                                                              // 814
          Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                        // 815
          ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                      // 816
            apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                      // 817
          });                                                                                                          // 818
        }                                                                                                              // 819
      }                                                                                                                // 820
                                                                                                                       //
      return changed;                                                                                                  // 812
    }()                                                                                                                // 812
  });                                                                                                                  // 812
});                                                                                                                    // 822
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 824
  var params = {};                                                                                                     // 825
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 826
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 827
      return s.trim();                                                                                                 // 829
    });                                                                                                                // 829
    // The only currently supported passthrough value is 'address', but others could be useful in                      // 830
    // the future.                                                                                                     // 831
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 833
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             // 834
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          // 835
      // hackery.                                                                                                      // 836
      var addressToPass = request.socket.remoteAddress;                                                                // 837
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 838
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     // 839
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   // 840
        addressToPass = request.headers["x-real-ip"];                                                                  // 841
      }                                                                                                                // 842
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 844
        // Map IPv4 addresses in IPv6.                                                                                 // 845
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       // 846
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       // 847
        // might otherwise need to precisely represent 64-bit fields.                                                  // 848
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 849
          return parseInt(x, 10);                                                                                      // 850
        }).reduce(function (a, b) {                                                                                    // 850
          return 256 * a + b;                                                                                          // 851
        });                                                                                                            // 851
        params.remoteAddress = {                                                                                       // 852
          lower64: v4Int,                                                                                              // 853
          upper64: 0                                                                                                   // 854
        };                                                                                                             // 852
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 856
        // TODO(test): Unit test this                                                                                  // 857
        // Parse a valid v6 address.                                                                                   // 858
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 // 859
        var groups = addressToPass.split(":");                                                                         // 860
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          // 862
        if (groups[0] === "") {                                                                                        // 863
          groups.shift();                                                                                              // 864
        }                                                                                                              // 865
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 867
          groups.pop();                                                                                                // 868
        }                                                                                                              // 869
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 871
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       // 872
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     // 873
        if (Net.isIPv4(lastGroup)) {                                                                                   // 874
          groups.pop();                                                                                                // 875
          var quad = lastGroup.split(".").map(function (x) {                                                           // 876
            return parseInt(x, 10);                                                                                    // 876
          });                                                                                                          // 876
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 877
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 878
        }                                                                                                              // 879
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 881
        var emptyGroupIndex = groups.indexOf("");                                                                      // 882
        var cleanGroups = void 0;                                                                                      // 883
        if (emptyGroupIndex !== -1) {                                                                                  // 884
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 885
          // groupsToAdd + 1 because we sliced out the empty element                                                   // 886
          var mid = Array(groupsToAdd + 1);                                                                            // 887
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 888
            mid[i] = "0";                                                                                              // 889
          }                                                                                                            // 890
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 892
          cleanGroups = [].concat(head, mid, tail);                                                                    // 893
        } else {                                                                                                       // 894
          cleanGroups = groups;                                                                                        // 895
        }                                                                                                              // 896
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 898
          return parseInt(x, 16);                                                                                      // 898
        });                                                                                                            // 898
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       // 899
        // into 53-bit-mantissa doubles.                                                                               // 900
        params.remoteAddress = {                                                                                       // 901
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 902
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 903
        };                                                                                                             // 901
      }                                                                                                                // 905
    }                                                                                                                  // 906
  }                                                                                                                    // 907
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 909
}                                                                                                                      // 910
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          // 912
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 913
  check(token, String);                                                                                                // 914
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 915
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 916
  var serializedParams = getApiSessionParams(request);                                                                 // 918
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 919
  return Promise.resolve(undefined).then(function () {                                                                 // 920
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 921
    if (proxy) {                                                                                                       // 922
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 923
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 924
      }                                                                                                                // 925
                                                                                                                       //
      return proxy;                                                                                                    // 927
    } else {                                                                                                           // 928
      return inMeteor(function () {                                                                                    // 929
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 930
        validateWebkey(tokenInfo);                                                                                     // 931
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 933
        if (!grain) {                                                                                                  // 934
          // Grain was deleted, I guess.                                                                               // 935
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 936
        }                                                                                                              // 937
                                                                                                                       //
        var proxy = void 0;                                                                                            // 939
        if (tokenInfo.userInfo) {                                                                                      // 940
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 941
        } else {                                                                                                       // 942
          var identityId = null;                                                                                       // 943
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 944
            identityId = tokenInfo.identityId;                                                                         // 945
          }                                                                                                            // 946
                                                                                                                       //
          proxy = new Proxy(grain, null, null, tabId, identityId, true);                                               // 948
          proxy.apiToken = tokenInfo;                                                                                  // 949
          proxy.apiSessionParams = serializedParams;                                                                   // 950
        }                                                                                                              // 951
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 953
          // Note that only public grains may be opened without a user ID.                                             // 954
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 955
        }                                                                                                              // 956
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 958
          proxy.expires = tokenInfo.expires;                                                                           // 959
        }                                                                                                              // 960
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 962
                                                                                                                       //
        return proxy;                                                                                                  // 964
      });                                                                                                              // 965
    }                                                                                                                  // 966
  });                                                                                                                  // 967
};                                                                                                                     // 968
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 970
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       // 971
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       // 972
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         // 973
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         // 974
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       // 975
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       // 976
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       // 977
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 978
    return true;                                                                                                       // 979
  }                                                                                                                    // 980
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       // 982
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        // 983
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    // 984
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         // 985
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       // 986
  // client app.                                                                                                       // 987
  //                                                                                                                   // 988
  // Since many clients in the wild have already been configured to use the shared API host, we                        // 989
  // must continue to support them, so this logic remains.                                                             // 990
  var agent = req.headers["user-agent"];                                                                               // 991
  return agent && agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                           // 992
};                                                                                                                     // 993
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 995
  // Extract the API token from the request.                                                                           // 996
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 998
  var token = void 0;                                                                                                  // 999
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 1000
    token = auth.slice(7).trim();                                                                                      // 1001
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 1002
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 1004
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 1005
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   // 1006
    // Allowing them would be a security problem in browsers that ignore CSP.                                          // 1007
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 1008
    if (parts.length < 2) {                                                                                            // 1009
      token = undefined;                                                                                               // 1010
    } else {                                                                                                           // 1011
      token = parts[1];                                                                                                // 1012
      req.url = "/" + parts.slice(2).join("/");                                                                        // 1013
      // remove .sandstorm-token/$TOKEN from path                                                                      // 1014
    }                                                                                                                  // 1015
  } else {                                                                                                             // 1016
    token = undefined;                                                                                                 // 1017
  }                                                                                                                    // 1018
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 1020
    // Verify that the token matches the specific host.                                                                // 1021
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 1022
      token = undefined;                                                                                               // 1023
    }                                                                                                                  // 1024
  }                                                                                                                    // 1025
                                                                                                                       //
  return token;                                                                                                        // 1027
};                                                                                                                     // 1028
                                                                                                                       //
// =======================================================================================                             // 1030
// Routing to proxies.                                                                                                 // 1031
//                                                                                                                     // 1032
                                                                                                                       //
// pre-meteor.js calls this                                                                                            // 1034
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 1035
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        // 1036
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       // 1037
  // should consider other host types, like static web publishing), or throws an error if the                          // 1038
  // request is definitely invalid.                                                                                    // 1039
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 1041
    var token = apiTokenForRequest(req, hostId);                                                                       // 1042
    if (token) {                                                                                                       // 1043
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 1044
        // Meteor sets the timeout to five seconds. Change that back to two                                            // 1045
        // minutes, which is the default value.                                                                        // 1046
        socket.setTimeout(120000);                                                                                     // 1047
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1049
        return true;                                                                                                   // 1050
      });                                                                                                              // 1051
    } else {                                                                                                           // 1052
      return Promise.resolve(false);                                                                                   // 1053
    }                                                                                                                  // 1054
  } else {                                                                                                             // 1055
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1056
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1057
      if (proxy) {                                                                                                     // 1058
        // Cross-origin requests are not allowed on UI session hosts.                                                  // 1059
        var origin = req.headers.origin;                                                                               // 1060
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 1061
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 1062
        }                                                                                                              // 1063
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            // 1065
        // minutes, which is the default value.                                                                        // 1066
        socket.setTimeout(120000);                                                                                     // 1067
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1069
        return true;                                                                                                   // 1070
      } else {                                                                                                         // 1071
        return false;                                                                                                  // 1072
      }                                                                                                                // 1073
    });                                                                                                                // 1074
  }                                                                                                                    // 1075
};                                                                                                                     // 1076
                                                                                                                       //
// pre-meteor.js calls this                                                                                            // 1078
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1079
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            // 1080
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       // 1081
  // should consider other host types, like static web publishing), or throws an error if the                          // 1082
  // request is definitely invalid.                                                                                    // 1083
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1085
  if (hostIdHash) {                                                                                                    // 1086
    var _ret2 = function () {                                                                                          // 1086
      // This is a request for the API host.                                                                           // 1087
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1089
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1091
        // Reply to CORS preflight request.                                                                            // 1092
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       // 1094
        // must send a valid Authorization header, and since cookies are not used for                                  // 1095
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     // 1096
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       // 1097
        //                                                                                                             // 1098
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       // 1099
        // use cross-origin, as if this is somehow useful for implementing any practical security                      // 1100
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             // 1101
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          // 1102
        //                                                                                                             // 1103
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    // 1104
        // only need to copy those over, rather than create an exhaustive list. But this is still                      // 1105
        // overly complicated.                                                                                         // 1106
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1108
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1109
          "Access-Control-Max-Age": "3600"                                                                             // 1110
        };                                                                                                             // 1108
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     // 1113
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1114
        if (requestedHeaders) {                                                                                        // 1115
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1116
        }                                                                                                              // 1117
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            // 1119
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1120
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1121
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1123
        }                                                                                                              // 1124
                                                                                                                       //
        for (header in meteorBabelHelpers.sanitizeForInObject(accessControlHeaders)) {                                 // 1126
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1127
        }                                                                                                              // 1128
      }                                                                                                                // 1129
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1131
        if (err instanceof Meteor.Error) {                                                                             // 1132
          console.log("error: " + err);                                                                                // 1133
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1134
        } else {                                                                                                       // 1135
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1136
        }                                                                                                              // 1137
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1139
      };                                                                                                               // 1140
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1142
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1143
        inMeteor(function () {                                                                                         // 1144
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1145
          check(keepaliveDuration, Match.Integer);                                                                     // 1146
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1147
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1148
        }).then(function () {                                                                                          // 1149
          res.writeHead(200, {});                                                                                      // 1150
          res.end();                                                                                                   // 1151
        }, errorHandler);                                                                                              // 1152
      } else if (token) {                                                                                              // 1153
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1154
          proxy.requestHandler(req, res);                                                                              // 1155
        }, errorHandler);                                                                                              // 1156
      } else {                                                                                                         // 1157
        // No token. Look up static API host info.                                                                     // 1158
        inMeteor(function () {                                                                                         // 1159
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1160
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1162
            // OPTIONS request with no authorization token.                                                            // 1163
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1165
            if (dav.length > 0) {                                                                                      // 1166
              res.setHeader("DAV", dav.join(", "));                                                                    // 1167
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1168
            }                                                                                                          // 1169
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1171
            res.end();                                                                                                 // 1172
          } else {                                                                                                     // 1173
            var resources = (apiHost || {}).resources || {};                                                           // 1174
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1175
            if (path in resources) {                                                                                   // 1176
              // Serve a static resource.                                                                              // 1177
              var resource = resources[path];                                                                          // 1178
              console.log(path, resources, resource);                                                                  // 1179
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1180
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1181
              res.writeHead(200, {                                                                                     // 1182
                "Content-Type": resource.type                                                                          // 1183
              });                                                                                                      // 1182
              res.end(resource.body);                                                                                  // 1185
            } else {                                                                                                   // 1186
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1187
                res.writeHead(401, {                                                                                   // 1188
                  "Content-Type": "text/plain",                                                                        // 1189
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1190
                });                                                                                                    // 1188
              } else {                                                                                                 // 1192
                // TODO(someday): Display some sort of nifty API browser.                                              // 1193
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1194
              }                                                                                                        // 1195
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1201
          }                                                                                                            // 1202
        }).then(function () {}, errorHandler);                                                                         // 1203
      }                                                                                                                // 1204
                                                                                                                       //
      return {                                                                                                         // 1206
        v: Promise.resolve(true)                                                                                       // 1206
      };                                                                                                               // 1206
    }();                                                                                                               // 1086
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 1086
  } else {                                                                                                             // 1207
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1208
                                                                                                                       //
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1211
      if (proxy) {                                                                                                     // 1212
        // Let's do some CSRF defense.                                                                                 // 1213
        var expectedOrigin = PROTOCOL + "//" + req.headers.host;                                                       // 1214
        var mainUrl = proxy.parentOrigin;                                                                              // 1215
        var origin = req.headers.origin;                                                                               // 1216
        var referer = req.headers.referer;                                                                             // 1217
        if (origin) {                                                                                                  // 1218
          // If an origin header was provided, then it must be accurate. Note that Chrome and                          // 1219
          // Safari always send an Origin header on non-GET requests (even same-origin), and                           // 1220
          // therefore on those browsers this rule will block all CSRF attacks. Unfortunately,                         // 1221
          // a patch to add this behavior to Firefox has stalled:                                                      // 1222
          //     https://bugzilla.mozilla.org/show_bug.cgi?id=446344                                                   // 1223
          // I haven't found any information on IE/Edge's behavior.                                                    // 1224
          if (origin !== expectedOrigin) {                                                                             // 1225
            // TODO(security): Alas, it turns out we have apps that have:                                              // 1226
            //   <meta name="referrer" content="no-referrer">                                                          // 1227
            // as Chrome sends "Origin: null" in these cases. :( These apps need to switch to:                         // 1228
            //   <meta name="referrer" content="same-origin">                                                          // 1229
            // It's important that we don't break apps, so we will accept null origins for now,                        // 1230
            // which of course completely defeats any CSRF protection. We should get the apps to                       // 1231
            // update or apply a whitelist soon.                                                                       // 1232
            if (origin === "null") {                                                                                   // 1233
              if (!proxy.wroteCsrfWarning) {                                                                           // 1234
                console.warn("Note: Observed null Origin header. App needs to be updated so that " + "we can apply automatic CSRF protection. grain ID:", proxy.grainId);
                proxy.wroteCsrfWarning = true;                                                                         // 1238
              }                                                                                                        // 1239
            } else {                                                                                                   // 1240
              throw new Meteor.Error(403, "Blocked illegal cross-origin request from: " + origin);                     // 1241
            }                                                                                                          // 1242
          }                                                                                                            // 1243
        } else if (referer) {                                                                                          // 1244
          // Mark that we've seed a Referer header on this host, which indicates that the user's                       // 1245
          // browser is not suppressing them.                                                                          // 1246
          proxy.seenReferer = true;                                                                                    // 1247
                                                                                                                       //
          // Deny requests coming from an external referer, since there is no legitimate use case                      // 1249
          // for these. Note of course that an attacker can trivially suppress the referer header                      // 1250
          // in practice, so this check alone does not give us any security benefit if we accept                       // 1251
          // requests that lack a referer.                                                                             // 1252
          if (referer != expectedOrigin && !referer.startsWith(expectedOrigin + "/") && referer != mainUrl && !referer.startsWith(mainUrl + "/")) {
            throw new Meteor.Error(403, "Blocked illegal cross-origin referral from: " + referer);                     // 1255
          }                                                                                                            // 1256
        } else {                                                                                                       // 1257
          // We saw neither an Origin nor a Referer header.                                                            // 1258
          if (req.method !== "GET" && req.method !== "HEAD") {                                                         // 1259
            // This is possibly a side-effecting request, meaning we should worry about CSRF.                          // 1260
            //                                                                                                         // 1261
            // Note that we'll never get to this branch for Chrome or Safari since they would have                     // 1262
            // sent an Origin header.                                                                                  // 1263
                                                                                                                       //
            if (!proxy.wroteCsrfWarning) {                                                                             // 1265
              console.warn("Note: Observed session for which auto-CSRF-protection couldn't be applied.", "seenReferer:", !!proxy.seenReferer, "method:", req.method, "path:", req.url, "UA:", req.headers["user-agent"]);
              proxy.wroteCsrfWarning = true;                                                                           // 1270
            }                                                                                                          // 1271
          }                                                                                                            // 1272
        }                                                                                                              // 1273
                                                                                                                       //
        proxy.requestHandler(req, res);                                                                                // 1275
        return true;                                                                                                   // 1276
      } else {                                                                                                         // 1277
        return false;                                                                                                  // 1278
      }                                                                                                                // 1279
    });                                                                                                                // 1280
  }                                                                                                                    // 1281
};                                                                                                                     // 1282
                                                                                                                       //
// =======================================================================================                             // 1284
// Proxy class                                                                                                         // 1285
//                                                                                                                     // 1286
// Connects to a grain and exports it on a wildcard host.                                                              // 1287
//                                                                                                                     // 1288
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grain, sessionId, hostId, tabId, identityId, isApi, parentOrigin, supervisor) {                       // 1291
    var _this4 = this;                                                                                                 // 1291
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1291
                                                                                                                       //
    // `grain` is an entry in the `Grains` collection.                                                                 // 1292
    this.grainId = grain._id;                                                                                          // 1293
    this.ownerId = grain.userId;                                                                                       // 1294
    this.identityId = identityId;                                                                                      // 1295
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1296
    this.sessionId = sessionId;                                                                                        // 1297
    this.tabId = tabId;                                                                                                // 1298
    this.isApi = isApi;                                                                                                // 1299
    this.hasLoaded = false;                                                                                            // 1300
    this.websockets = {};                                                                                              // 1301
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1302
    this.streamingRequests = {};                                                                                       // 1303
    this.streamingRequestCounter = 0; // Used for generating unique request IDs.                                       // 1304
    this.streamingResponses = {};                                                                                      // 1305
    this.streamingResponseCounter = 0; // Used for generating unique response IDs.                                     // 1306
    this.parentOrigin = parentOrigin || process.env.ROOT_URL;                                                          // 1307
                                                                                                                       //
    if (sessionId) {                                                                                                   // 1309
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1310
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1311
      this.hostId = hostId;                                                                                            // 1312
    } else {                                                                                                           // 1313
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1314
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1315
    }                                                                                                                  // 1316
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1318
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1319
      if (!identity) {                                                                                                 // 1320
        throw new Error("identity not found: " + this.identityId);                                                     // 1321
      }                                                                                                                // 1322
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               // 1324
      var idCapRequirement = {                                                                                         // 1325
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1326
      };                                                                                                               // 1325
                                                                                                                       //
      this.userInfo = {                                                                                                // 1329
        displayName: { defaultText: identity.profile.name },                                                           // 1330
        preferredHandle: identity.profile.handle,                                                                      // 1331
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1332
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1333
      };                                                                                                               // 1329
      if (identity.profile.pictureUrl) {                                                                               // 1335
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1336
      } else {                                                                                                         // 1337
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1341
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1343
    } else {                                                                                                           // 1344
      this.userInfo = {                                                                                                // 1345
        displayName: { defaultText: "Anonymous User" },                                                                // 1346
        preferredHandle: "anonymous"                                                                                   // 1347
      };                                                                                                               // 1345
    }                                                                                                                  // 1349
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1351
      if (_this4.sessionId) {                                                                                          // 1352
        // Implement /_sandstorm-init for setting the session cookie.                                                  // 1353
        var url = Url.parse(request.url, true);                                                                        // 1354
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1355
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1356
          return;                                                                                                      // 1357
        }                                                                                                              // 1358
      }                                                                                                                // 1359
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1361
        var contentLength = request.headers["content-length"];                                                         // 1362
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    // 1365
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1366
        } else {                                                                                                       // 1367
          return readAll(request).then(function (data) {                                                               // 1368
            return _this4.handleRequest(request, data, response, 0);                                                   // 1369
          });                                                                                                          // 1370
        }                                                                                                              // 1371
      })["catch"](function (err) {                                                                                     // 1372
        _this4.setHasLoaded();                                                                                         // 1373
                                                                                                                       //
        var body = err.stack;                                                                                          // 1375
        if (err.cppFile) {                                                                                             // 1376
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1377
        }                                                                                                              // 1378
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1380
          body += "\ntype: " + err.kjType;                                                                             // 1381
        }                                                                                                              // 1382
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1384
          // Unfortunately, it's too late to tell the client what happened.                                            // 1385
          console.error("HTTP request failed after response already sent:", body);                                     // 1386
          response.end();                                                                                              // 1387
        } else {                                                                                                       // 1388
          if (err instanceof Meteor.Error) {                                                                           // 1389
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1390
          } else {                                                                                                     // 1391
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1392
          }                                                                                                            // 1393
                                                                                                                       //
          response.end(body);                                                                                          // 1395
        }                                                                                                              // 1396
      });                                                                                                              // 1397
    };                                                                                                                 // 1398
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1400
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1401
        console.error("WebSocket setup failed:", err.stack);                                                           // 1402
        // TODO(cleanup):  Manually send back a 500 response?                                                          // 1403
        socket.destroy();                                                                                              // 1404
      });                                                                                                              // 1405
    };                                                                                                                 // 1406
  }                                                                                                                    // 1407
                                                                                                                       //
  Proxy.prototype.close = function () {                                                                                //
    function close() {                                                                                                 //
      for (var streamingResponseIdx in meteorBabelHelpers.sanitizeForInObject(this.streamingResponses)) {              // 1410
        this.streamingResponses[streamingResponseIdx].abort();                                                         // 1411
      }                                                                                                                // 1412
                                                                                                                       //
      this.streamingResponses = {};                                                                                    // 1414
                                                                                                                       //
      for (var streamingRequestIdx in meteorBabelHelpers.sanitizeForInObject(this.streamingRequests)) {                // 1416
        this.streamingRequests[streamingRequestIdx].destroy();                                                         // 1417
      }                                                                                                                // 1418
                                                                                                                       //
      this.streamingRequests = {};                                                                                     // 1420
                                                                                                                       //
      for (var socketIdx in meteorBabelHelpers.sanitizeForInObject(this.websockets)) {                                 // 1422
        this.websockets[socketIdx].destroy();                                                                          // 1423
      };                                                                                                               // 1424
                                                                                                                       //
      this.websockets = {};                                                                                            // 1426
                                                                                                                       //
      if (this.session) {                                                                                              // 1428
        this.session.close();                                                                                          // 1429
        delete this.session;                                                                                           // 1430
      }                                                                                                                // 1431
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1433
        this.uiView.close();                                                                                           // 1434
        delete this.uiView;                                                                                            // 1435
      }                                                                                                                // 1436
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1438
        this.supervisor.close();                                                                                       // 1439
        delete this.supervisor;                                                                                        // 1440
      }                                                                                                                // 1441
                                                                                                                       //
      if (this.permissionsObserver) {                                                                                  // 1443
        this.permissionsObserver.stop();                                                                               // 1444
        delete this.permissionsObserver;                                                                               // 1445
      }                                                                                                                // 1446
    }                                                                                                                  // 1447
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getConnection = function () {                                                                        //
    function getConnection() {                                                                                         //
      if (!this.supervisor) {                                                                                          // 1450
        this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                         // 1451
        this.uiView = null;                                                                                            // 1452
      }                                                                                                                // 1453
                                                                                                                       //
      if (!this.uiView) {                                                                                              // 1455
        this.uiView = this.supervisor.getMainView().view;                                                              // 1456
      }                                                                                                                // 1457
    }                                                                                                                  // 1458
                                                                                                                       //
    return getConnection;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function () {                                                                   //
    function _callNewWebSession(request, userInfo) {                                                                   //
      var params = Capnp.serialize(WebSession.Params, {                                                                // 1461
        basePath: PROTOCOL + "//" + request.headers.host,                                                              // 1462
        userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",               // 1463
        acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
          return s.trim();                                                                                             // 1467
        }) : ["en-US", "en"]                                                                                           // 1467
      });                                                                                                              // 1461
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
    }                                                                                                                  // 1473
                                                                                                                       //
    return _callNewWebSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function () {                                                                   //
    function _callNewApiSession(request, userInfo) {                                                                   //
      var _this5 = this;                                                                                               // 1475
                                                                                                                       //
      var serializedParams = this.apiSessionParams;                                                                    // 1476
      if (!serializedParams) {                                                                                         // 1477
        throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                 // 1478
      }                                                                                                                // 1479
                                                                                                                       //
      // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                   // 1481
      // calling newSession with an ApiSession._id.                                                                    // 1482
      // Eventually we'll remove this logic once we're sure apps have updated.                                         // 1483
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
        return session.session;                                                                                        // 1488
      }, function (err) {                                                                                              // 1489
        return _this5._callNewWebSession(request, userInfo);                                                           // 1490
      });                                                                                                              // 1491
    }                                                                                                                  // 1492
                                                                                                                       //
    return _callNewApiSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewRequestSession = function () {                                                               //
    function _callNewRequestSession(request, userInfo) {                                                               //
      var params = Capnp.serialize(WebSession.Params, {                                                                // 1495
        basePath: PROTOCOL + "//" + request.headers.host,                                                              // 1496
        userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",               // 1497
        acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
          return s.trim();                                                                                             // 1501
        }) : ["en-US", "en"]                                                                                           // 1501
      });                                                                                                              // 1495
      return this.uiView.newRequestSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, this.powerboxRequest.descriptors, new Buffer(this.tabId, "hex")).session;
    }                                                                                                                  // 1508
                                                                                                                       //
    return _callNewRequestSession;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewSession = function () {                                                                      //
    function _callNewSession(request, viewInfo) {                                                                      //
      var _this6 = this;                                                                                               // 1510
                                                                                                                       //
      var userInfo = _.clone(this.userInfo);                                                                           // 1511
      var promise = inMeteor(function () {                                                                             // 1512
        var vertex = void 0;                                                                                           // 1513
        if (_this6.apiToken) {                                                                                         // 1514
          vertex = { token: _this6.apiToken };                                                                         // 1515
        } else {                                                                                                       // 1516
          // (this.identityId might be null; this is fine)                                                             // 1517
          vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                  // 1518
        }                                                                                                              // 1519
                                                                                                                       //
        var onInvalidated = function () {                                                                              // 1521
          function onInvalidated() {                                                                                   // 1521
            Sessions.remove({ _id: _this6.sessionId });                                                                // 1522
          }                                                                                                            // 1523
                                                                                                                       //
          return onInvalidated;                                                                                        // 1521
        }();                                                                                                           // 1521
                                                                                                                       //
        if (!_this6.sessionId) {                                                                                       // 1525
          onInvalidated = function () {                                                                                // 1526
            function onInvalidated() {                                                                                 // 1526
              apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                             // 1527
            }                                                                                                          // 1528
                                                                                                                       //
            return onInvalidated;                                                                                      // 1526
          }();                                                                                                         // 1526
        }                                                                                                              // 1529
                                                                                                                       //
        var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);            // 1531
                                                                                                                       //
        if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                             // 1534
        _this6.permissionsObserver = permissions.observeHandle;                                                        // 1535
                                                                                                                       //
        if (!permissions.permissions) {                                                                                // 1537
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 1538
        }                                                                                                              // 1539
                                                                                                                       //
        Sessions.update({                                                                                              // 1541
          _id: _this6.sessionId                                                                                        // 1542
        }, {                                                                                                           // 1541
          $set: {                                                                                                      // 1544
            viewInfo: viewInfo,                                                                                        // 1545
            permissions: permissions.permissions                                                                       // 1546
          }                                                                                                            // 1544
        });                                                                                                            // 1543
                                                                                                                       //
        return permissions.permissions;                                                                                // 1550
      });                                                                                                              // 1551
                                                                                                                       //
      return promise.then(function (permissions) {                                                                     // 1553
        userInfo.permissions = permissions;                                                                            // 1554
                                                                                                                       //
        var numBytes = Math.ceil(permissions.length / 8);                                                              // 1556
        var buf = new Buffer(numBytes);                                                                                // 1557
        for (var ii = 0; ii < numBytes; ++ii) {                                                                        // 1558
          buf[ii] = 0;                                                                                                 // 1559
        }                                                                                                              // 1560
                                                                                                                       //
        for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                           // 1562
          var byteNum = Math.floor(_ii / 8);                                                                           // 1563
          var bitNum = _ii % 8;                                                                                        // 1564
          if (permissions[_ii]) {                                                                                      // 1565
            buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                 // 1566
          }                                                                                                            // 1567
        }                                                                                                              // 1568
                                                                                                                       //
        userInfo.deprecatedPermissionsBlob = buf;                                                                      // 1570
                                                                                                                       //
        if (_this6.isApi) {                                                                                            // 1572
          return _this6._callNewApiSession(request, userInfo);                                                         // 1573
        } else if (_this6.powerboxRequest) {                                                                           // 1574
          return _this6._callNewRequestSession(request, userInfo);                                                     // 1575
        } else {                                                                                                       // 1576
          return _this6._callNewWebSession(request, userInfo);                                                         // 1577
        }                                                                                                              // 1578
      });                                                                                                              // 1579
    }                                                                                                                  // 1580
                                                                                                                       //
    return _callNewSession;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getSession = function () {                                                                           //
    function getSession(request) {                                                                                     //
      var _this7 = this;                                                                                               // 1582
                                                                                                                       //
      if (!this.session) {                                                                                             // 1583
        this.getConnection(); // make sure we're connected                                                             // 1584
        var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                             // 1585
          return inMeteor(function () {                                                                                // 1586
            // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                        // 1587
            var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                            // 1588
            Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                               // 1589
          }).then(function () {                                                                                        // 1590
            return _this7._callNewSession(request, viewInfo);                                                          // 1591
          });                                                                                                          // 1592
        }, function (error) {                                                                                          // 1593
          if (error.kjType === "failed" || error.kjType === "unimplemented") {                                         // 1594
            // Method not implemented.                                                                                 // 1595
            // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                   // 1596
            //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                   // 1597
            //   to accept 'failed' here at least until the next API bump.                                             // 1598
            return _this7._callNewSession(request, {});                                                                // 1599
          } else {                                                                                                     // 1600
            return Promise.reject(error);                                                                              // 1601
          }                                                                                                            // 1602
        });                                                                                                            // 1603
        this.session = new Capnp.Capability(promise, WebSession);                                                      // 1604
      }                                                                                                                // 1605
                                                                                                                       //
      return this.session;                                                                                             // 1607
    }                                                                                                                  // 1608
                                                                                                                       //
    return getSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.keepAlive = function () {                                                                            //
    function keepAlive() {                                                                                             //
      this.getConnection();                                                                                            // 1611
      return this.supervisor.keepAlive();                                                                              // 1612
    }                                                                                                                  // 1613
                                                                                                                       //
    return keepAlive;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.resetConnection = function () {                                                                      //
    function resetConnection() {                                                                                       //
      if (this.session) {                                                                                              // 1616
        this.session.close();                                                                                          // 1617
        delete this.session;                                                                                           // 1618
      }                                                                                                                // 1619
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1621
        this.uiView.close();                                                                                           // 1622
        delete this.uiView;                                                                                            // 1623
      }                                                                                                                // 1624
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1626
        this.supervisor.close();                                                                                       // 1627
        delete this.supervisor;                                                                                        // 1628
      }                                                                                                                // 1629
                                                                                                                       //
      if (this.permissionsObserver) {                                                                                  // 1631
        this.permissionsObserver.stop();                                                                               // 1632
        delete this.permissionsObserver;                                                                               // 1633
      }                                                                                                                // 1634
    }                                                                                                                  // 1635
                                                                                                                       //
    return resetConnection;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function () {                                                                 //
    function maybeRetryAfterError(error, retryCount) {                                                                 //
      var _this8 = this;                                                                                               // 1637
                                                                                                                       //
      // If the error may be caused by the grain dying or a network failure, try to restart it,                        // 1638
      // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                          // 1639
      // `retryCount` should be incremented for every successful retry as part of the same request;                    // 1640
      // we only want to retry once.                                                                                   // 1641
      if (shouldRestartGrain(error, retryCount)) {                                                                     // 1642
        this.resetConnection();                                                                                        // 1643
        return inMeteor(function () {                                                                                  // 1644
          _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                  // 1645
        });                                                                                                            // 1646
      } else {                                                                                                         // 1647
        throw error;                                                                                                   // 1648
      }                                                                                                                // 1649
    }                                                                                                                  // 1650
                                                                                                                       //
    return maybeRetryAfterError;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.doSessionInit = function () {                                                                        //
    function doSessionInit(request, response, requestPath) {                                                           //
      // jscs:disable disallowQuotedKeysInObjects                                                                      // 1653
      var path = requestPath || "/";                                                                                   // 1654
                                                                                                                       //
      // Check that the path is relative (ie. starts with a /).                                                        // 1656
      // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                       // 1657
      if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                         // 1658
        response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                            // 1659
        response.end("Invalid path supplied.");                                                                        // 1660
        return;                                                                                                        // 1661
      }                                                                                                                // 1662
                                                                                                                       //
      // Set the session ID.                                                                                           // 1664
      response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));   // 1665
                                                                                                                       //
      response.setHeader("Cache-Control", "no-cache, private");                                                        // 1667
                                                                                                                       //
      // Redirect to the app's root URL.                                                                               // 1669
      // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                // 1670
      //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                     // 1671
      response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                           // 1672
      response.end();                                                                                                  // 1673
    }                                                                                                                  // 1674
                                                                                                                       //
    return doSessionInit;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.makeContext = function () {                                                                          //
    function makeContext(request, response, callback) {                                                                //
      // Parses the cookies from the request, checks that the session ID is present and valid, then                    // 1677
      // synchronously calls callback() passing it the request context object which contains the                       // 1678
      // other cookies. Throws an exception if the session ID is missing or invalid. The callback                      // 1679
      // must immediately use the context in an RPC. Once the callback returns, the context object                     // 1680
      // will be torn down.                                                                                            // 1681
      //                                                                                                               // 1682
      // `makeContext()` returns the result of `callback()`.                                                           // 1683
                                                                                                                       //
      var context = {};                                                                                                // 1685
                                                                                                                       //
      if (this.hostId) {                                                                                               // 1687
        var parseResult = parseCookies(request);                                                                       // 1688
        if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                      // 1689
          throw new Meteor.Error(403, "Unauthorized");                                                                 // 1690
        }                                                                                                              // 1691
                                                                                                                       //
        if (parseResult.cookies.length > 0) {                                                                          // 1693
          context.cookies = parseResult.cookies;                                                                       // 1694
        }                                                                                                              // 1695
      } else {                                                                                                         // 1696
        // jscs:disable disallowEmptyBlocks                                                                            // 1697
        // This is an API request. Cookies are not supported.                                                          // 1698
      }                                                                                                                // 1699
                                                                                                                       //
      context.accept = parseAcceptHeader(request);                                                                     // 1701
                                                                                                                       //
      context.acceptEncoding = parseAcceptEncodingHeader(request);                                                     // 1703
                                                                                                                       //
      context.eTagPrecondition = parsePreconditionHeader(request);                                                     // 1705
                                                                                                                       //
      context.additionalHeaders = [];                                                                                  // 1707
      for (var headerName in meteorBabelHelpers.sanitizeForInObject(request.headers)) {                                // 1708
        if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                            // 1709
          context.additionalHeaders.push({                                                                             // 1710
            name: headerName,                                                                                          // 1711
            value: request.headers[headerName]                                                                         // 1712
          });                                                                                                          // 1710
        }                                                                                                              // 1714
      }                                                                                                                // 1715
                                                                                                                       //
      if (response) {                                                                                                  // 1717
        var promise = new Promise(function (resolve, reject) {                                                         // 1718
          response.resolveResponseStream = resolve;                                                                    // 1719
          response.rejectResponseStream = reject;                                                                      // 1720
        });                                                                                                            // 1721
                                                                                                                       //
        context.responseStream = new Capnp.Capability(promise, ByteStream);                                            // 1723
                                                                                                                       //
        try {                                                                                                          // 1725
          return callback(context);                                                                                    // 1726
        } finally {                                                                                                    // 1727
          context.responseStream.close();                                                                              // 1728
        }                                                                                                              // 1729
      } else {                                                                                                         // 1730
        // WebSocket -- no response object.                                                                            // 1731
        return callback(context);                                                                                      // 1732
      }                                                                                                                // 1733
    }                                                                                                                  // 1734
                                                                                                                       //
    return makeContext;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.translateResponse = function () {                                                                    //
    function translateResponse(rpcResponse, response, request) {                                                       //
      var _this9 = this;                                                                                               // 1736
                                                                                                                       //
      if (this.hostId) {                                                                                               // 1737
        if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                             // 1738
          response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                           // 1739
        }                                                                                                              // 1740
                                                                                                                       //
        var mainUrl = this.parentOrigin;                                                                               // 1742
        var grainHost = PROTOCOL + "//" + request.headers.host;                                                        // 1743
        response.setHeader("Content-Security-Policy", "frame-ancestors " + mainUrl + " " + grainHost);                 // 1744
        response.setHeader("X-Frame-Options", "ALLOW-FROM " + mainUrl);                                                // 1745
                                                                                                                       //
        // TODO(security): Add a Content-Security-Policy header which:                                                 // 1747
        // (1) Prevents the app from initiating HTTP requests to third parties.                                        // 1748
        // (2) Prevents the app from navigating the parent frame.                                                      // 1749
        // (3) Prevents the app from opening popups.                                                                   // 1750
        // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                       // 1751
        //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                      // 1752
      } else {                                                                                                         // 1753
        // This is an API request. Cookies are not supported.                                                          // 1754
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                // 1756
        response.setHeader("Vary", "Authorization");                                                                   // 1757
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                // 1759
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1760
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 // 1762
        // in a browser context. This policy should thoroughly neuter it.                                              // 1763
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1764
      }                                                                                                                // 1765
                                                                                                                       //
      if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                 // 1767
        // Add any additional prefixed/whitelisted headers to the response.                                            // 1768
        // We cannot trust that the headers in the RPC response are actually                                           // 1769
        // allowed, so we check if they are prefixed or whitelisted.                                                   // 1770
        rpcResponse.additionalHeaders.forEach(function (header) {                                                      // 1771
          if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                        // 1772
            // If header is prefixed with appHeaderPrefix,                                                             // 1773
            // or if the header name is in whitelist, set it.                                                          // 1774
            response.setHeader(header.name, header.value);                                                             // 1775
          }                                                                                                            // 1776
        });                                                                                                            // 1777
      }                                                                                                                // 1778
                                                                                                                       //
      // On first response, update the session to have hasLoaded=true                                                  // 1780
      this.setHasLoaded();                                                                                             // 1781
                                                                                                                       //
      // TODO(security): Set X-Content-Type-Options: nosniff?                                                          // 1783
                                                                                                                       //
      if ("content" in rpcResponse) {                                                                                  // 1785
        var content = rpcResponse.content;                                                                             // 1786
        var code = successCodes[content.statusCode];                                                                   // 1787
        if (!code) {                                                                                                   // 1788
          throw new Error("Unknown status code: ", content.statusCode);                                                // 1789
        }                                                                                                              // 1790
                                                                                                                       //
        if (content.mimeType) {                                                                                        // 1792
          response.setHeader("Content-Type", content.mimeType);                                                        // 1793
        }                                                                                                              // 1794
                                                                                                                       //
        if (content.encoding) {                                                                                        // 1796
          response.setHeader("Content-Encoding", content.encoding);                                                    // 1797
        }                                                                                                              // 1798
                                                                                                                       //
        if (content.language) {                                                                                        // 1800
          response.setHeader("Content-Language", content.language);                                                    // 1801
        }                                                                                                              // 1802
                                                                                                                       //
        if (content.eTag) {                                                                                            // 1804
          response.setHeader("ETag", composeETag(content.eTag));                                                       // 1805
        }                                                                                                              // 1806
                                                                                                                       //
        if ("disposition" in content && "download" in content.disposition) {                                           // 1808
          response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
        }                                                                                                              // 1811
                                                                                                                       //
        if ("stream" in content.body) {                                                                                // 1813
          if (request.method === "HEAD") {                                                                             // 1814
            content.body.stream.close();                                                                               // 1815
            response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                         // 1816
          } else if (response.socket.destroyed) {                                                                      // 1817
            // The client has already closed the stream. No additional "close" event will be                           // 1818
            // emitted. Annoyingly, we cannot rely on `response.write()` throwing an exception                         // 1819
            // in this case, so if we don't handle it specially we could end up with a                                 // 1820
            // `ResponseStream` that gets stuck waiting for a "drain" event that never arrives.                        // 1821
            content.body.stream.close();                                                                               // 1822
            response.rejectResponseStream(new Error("client disconnected"));                                           // 1823
          } else {                                                                                                     // 1824
            var _ret3 = function () {                                                                                  // 1824
              var idx = _this9.streamingResponseCounter;                                                               // 1825
              _this9.streamingResponseCounter += 1;                                                                    // 1826
              var streamHandle = content.body.stream;                                                                  // 1827
              var rawResponseStream = new ResponseStream(response, code.id, code.title, streamHandle, function () {    // 1828
                delete _this9.streamingResponses[idx];                                                                 // 1830
              });                                                                                                      // 1830
              _this9.streamingResponses[idx] = rawResponseStream;                                                      // 1831
              var responseStream = new Capnp.Capability(rawResponseStream, ByteStream);                                // 1832
              response.resolveResponseStream(responseStream);                                                          // 1833
              return {                                                                                                 // 1834
                v: { streamHandle: responseStream }                                                                    // 1834
              };                                                                                                       // 1834
            }();                                                                                                       // 1824
                                                                                                                       //
            if ((typeof _ret3 === "undefined" ? "undefined" : _typeof(_ret3)) === "object") return _ret3.v;            // 1824
          }                                                                                                            // 1835
        } else {                                                                                                       // 1836
          response.rejectResponseStream(new Error("Response content body was not a stream."));                         // 1837
                                                                                                                       //
          if ("bytes" in content.body) {                                                                               // 1840
            response.setHeader("Content-Length", content.body.bytes.length);                                           // 1841
          } else {                                                                                                     // 1842
            throw new Error("Unknown content body type.");                                                             // 1843
          }                                                                                                            // 1844
        }                                                                                                              // 1845
                                                                                                                       //
        response.writeHead(code.id, code.title);                                                                       // 1847
                                                                                                                       //
        if ("bytes" in content.body && request.method !== "HEAD") {                                                    // 1849
          response.write(content.body.bytes);                                                                          // 1850
        }                                                                                                              // 1851
                                                                                                                       //
        response.end();                                                                                                // 1853
      } else if ("noContent" in rpcResponse) {                                                                         // 1854
        var noContent = rpcResponse.noContent;                                                                         // 1855
        var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                      // 1856
        if (noContent.eTag) {                                                                                          // 1857
          response.setHeader("ETag", composeETag(noContent.eTag));                                                     // 1858
        }                                                                                                              // 1859
                                                                                                                       //
        response.writeHead(noContentCode.id, noContentCode.title);                                                     // 1861
        response.end();                                                                                                // 1862
      } else if ("preconditionFailed" in rpcResponse) {                                                                // 1863
        var preconditionFailed = rpcResponse.preconditionFailed;                                                       // 1864
        if (request.method === "GET" && "if-none-match" in request.headers) {                                          // 1865
          if (preconditionFailed.matchingETag) {                                                                       // 1866
            response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                  // 1867
          }                                                                                                            // 1868
                                                                                                                       //
          response.writeHead(304, "Not Modified");                                                                     // 1870
        } else {                                                                                                       // 1871
          response.writeHead(412, "Precondition Failed");                                                              // 1872
        }                                                                                                              // 1873
                                                                                                                       //
        response.end();                                                                                                // 1875
      } else if ("redirect" in rpcResponse) {                                                                          // 1876
        var redirect = rpcResponse.redirect;                                                                           // 1877
        var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                             // 1878
        response.writeHead(redirectCode.id, redirectCode.title, {                                                      // 1879
          "Location": encodeURI(redirect.location)                                                                     // 1880
        });                                                                                                            // 1879
        response.end();                                                                                                // 1882
      } else if ("clientError" in rpcResponse) {                                                                       // 1883
        var clientError = rpcResponse.clientError;                                                                     // 1884
        var errorCode = errorCodes[clientError.statusCode];                                                            // 1885
        if (!errorCode) {                                                                                              // 1886
          throw new Error("Unknown status code: ", clientError.statusCode);                                            // 1887
        }                                                                                                              // 1888
                                                                                                                       //
        response.writeHead(errorCode.id, errorCode.title, {                                                            // 1890
          "Content-Type": "text/html"                                                                                  // 1891
        });                                                                                                            // 1890
                                                                                                                       //
        if (request.method !== "HEAD") {                                                                               // 1894
          if (clientError.descriptionHtml) {                                                                           // 1895
            response.write(clientError.descriptionHtml);                                                               // 1896
          } else {                                                                                                     // 1897
            // TODO(someday):  Better default error page.                                                              // 1898
            response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");        // 1899
          }                                                                                                            // 1901
        }                                                                                                              // 1902
                                                                                                                       //
        response.end();                                                                                                // 1904
      } else if ("serverError" in rpcResponse) {                                                                       // 1905
        response.writeHead(500, "Internal Server Error", {                                                             // 1906
          "Content-Type": "text/html"                                                                                  // 1907
        });                                                                                                            // 1906
                                                                                                                       //
        if (request.method !== "HEAD") {                                                                               // 1910
          if (rpcResponse.serverError.descriptionHtml) {                                                               // 1911
            response.write(rpcResponse.serverError.descriptionHtml);                                                   // 1912
          } else {                                                                                                     // 1913
            // TODO(someday):  Better default error page.                                                              // 1914
            response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                           // 1915
          }                                                                                                            // 1916
        }                                                                                                              // 1917
                                                                                                                       //
        response.end();                                                                                                // 1919
      } else {                                                                                                         // 1920
        throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                // 1921
      }                                                                                                                // 1922
                                                                                                                       //
      return {};                                                                                                       // 1924
    }                                                                                                                  // 1925
                                                                                                                       //
    return translateResponse;                                                                                          //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequest = function () {                                                                        //
    function handleRequest(request, data, response, retryCount) {                                                      //
      var _this10 = this;                                                                                              // 1927
                                                                                                                       //
      return Promise.resolve(undefined).then(function () {                                                             // 1928
        return _this10.makeContext(request, response, function (context) {                                             // 1929
          // jscs:disable requireDotNotation                                                                           // 1930
          // Send the RPC.                                                                                             // 1931
          var path = request.url.slice(1); // remove leading '/'                                                       // 1932
          var session = _this10.getSession(request);                                                                   // 1933
                                                                                                                       //
          var requestContent = function () {                                                                           // 1935
            function requestContent() {                                                                                // 1935
              return {                                                                                                 // 1936
                content: data,                                                                                         // 1937
                encoding: request.headers["content-encoding"],                                                         // 1938
                mimeType: request.headers["content-type"]                                                              // 1939
              };                                                                                                       // 1936
            }                                                                                                          // 1941
                                                                                                                       //
            return requestContent;                                                                                     // 1935
          }();                                                                                                         // 1935
                                                                                                                       //
          var xmlContent = function () {                                                                               // 1943
            function xmlContent() {                                                                                    // 1943
              var type = request.headers["content-type"] || "application/xml;charset=utf-8";                           // 1944
              var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                          // 1945
              if (!match) {                                                                                            // 1946
                response.writeHead(415, "Unsupported media type.", {                                                   // 1947
                  "Content-Type": "text/plain"                                                                         // 1948
                });                                                                                                    // 1947
                response.end("expected XML request body");                                                             // 1950
                throw new Error("expected XML request body");                                                          // 1951
              }                                                                                                        // 1952
                                                                                                                       //
              var charset = match[2] || "ISO-8859-1";                                                                  // 1954
                                                                                                                       //
              var encoding = request.headers["content-encoding"];                                                      // 1956
              if (encoding && encoding !== "identity") {                                                               // 1957
                if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                     // 1958
                data = gunzipSync(data);                                                                               // 1959
              }                                                                                                        // 1960
                                                                                                                       //
              return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                             // 1962
            }                                                                                                          // 1963
                                                                                                                       //
            return xmlContent;                                                                                         // 1943
          }();                                                                                                         // 1943
                                                                                                                       //
          var propfindDepth = function () {                                                                            // 1965
            function propfindDepth() {                                                                                 // 1965
              var depth = request.headers["depth"];                                                                    // 1966
              return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                      // 1967
            }                                                                                                          // 1970
                                                                                                                       //
            return propfindDepth;                                                                                      // 1965
          }();                                                                                                         // 1965
                                                                                                                       //
          var shallow = function () {                                                                                  // 1972
            function shallow() {                                                                                       // 1972
              return request.headers["depth"] === "0";                                                                 // 1973
            }                                                                                                          // 1974
                                                                                                                       //
            return shallow;                                                                                            // 1972
          }();                                                                                                         // 1972
                                                                                                                       //
          var noOverwrite = function () {                                                                              // 1976
            function noOverwrite() {                                                                                   // 1976
              return (request.headers["overwrite"] || "").toLowerCase() === "f";                                       // 1977
            }                                                                                                          // 1978
                                                                                                                       //
            return noOverwrite;                                                                                        // 1976
          }();                                                                                                         // 1976
                                                                                                                       //
          var destination = function () {                                                                              // 1980
            function destination() {                                                                                   // 1980
              var result = request.headers["destination"];                                                             // 1981
              if (!result) throw new Error("missing destination");                                                     // 1982
              return Url.parse(result).path.slice(1); // remove leading '/'                                            // 1983
            }                                                                                                          // 1984
                                                                                                                       //
            return destination;                                                                                        // 1980
          }();                                                                                                         // 1980
                                                                                                                       //
          if (request.method === "GET" || request.method === "HEAD") {                                                 // 1986
            return session.get(path, context, request.method === "HEAD");                                              // 1987
          } else if (request.method === "POST") {                                                                      // 1988
            return session.post(path, requestContent(), context);                                                      // 1989
          } else if (request.method === "PUT") {                                                                       // 1990
            return session.put(path, requestContent(), context);                                                       // 1991
          } else if (request.method === "PATCH") {                                                                     // 1992
            return session.patch(path, requestContent(), context);                                                     // 1993
          } else if (request.method === "DELETE") {                                                                    // 1994
            return session["delete"](path, context);                                                                   // 1995
          } else if (request.method === "PROPFIND") {                                                                  // 1996
            return session.propfind(path, xmlContent(), propfindDepth(), context);                                     // 1997
          } else if (request.method === "PROPPATCH") {                                                                 // 1998
            return session.proppatch(path, xmlContent(), context);                                                     // 1999
          } else if (request.method === "MKCOL") {                                                                     // 2000
            return session.mkcol(path, requestContent(), context);                                                     // 2001
          } else if (request.method === "COPY") {                                                                      // 2002
            return session.copy(path, destination(), noOverwrite(), shallow(), context);                               // 2003
          } else if (request.method === "MOVE") {                                                                      // 2004
            return session.move(path, destination(), noOverwrite(), context);                                          // 2005
          } else if (request.method === "LOCK") {                                                                      // 2006
            return session.lock(path, xmlContent(), shallow(), context);                                               // 2007
          } else if (request.method === "UNLOCK") {                                                                    // 2008
            return session.unlock(path, request.headers["lock-token"], context);                                       // 2009
          } else if (request.method === "ACL") {                                                                       // 2010
            return session.acl(path, xmlContent(), context);                                                           // 2011
          } else if (request.method === "REPORT") {                                                                    // 2012
            return session.report(path, requestContent(), context);                                                    // 2013
          } else if (request.method === "OPTIONS") {                                                                   // 2014
            return session.options(path, context).then(function (options) {                                            // 2015
              var dav = [];                                                                                            // 2016
              if (options.davClass1) dav.push("1");                                                                    // 2017
              if (options.davClass2) dav.push("2");                                                                    // 2018
              if (options.davClass3) dav.push("3");                                                                    // 2019
              if (options.davExtensions) {                                                                             // 2020
                options.davExtensions.forEach(function (token) {                                                       // 2021
                  if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                 // 2022
                    dav.push(token);                                                                                   // 2023
                  }                                                                                                    // 2024
                });                                                                                                    // 2025
              }                                                                                                        // 2026
                                                                                                                       //
              if (dav.length > 0) {                                                                                    // 2028
                response.setHeader("DAV", dav.join(", "));                                                             // 2029
                response.setHeader("Access-Control-Expose-Headers", "DAV");                                            // 2030
              }                                                                                                        // 2031
                                                                                                                       //
              response.end();                                                                                          // 2033
              // Return no response; we already handled everything.                                                    // 2034
            }, function (err) {                                                                                        // 2035
              if (err.kjType !== "unimplemented") throw err;                                                           // 2036
              response.end();                                                                                          // 2037
              // Return no response; we already handled everything.                                                    // 2038
            });                                                                                                        // 2039
          } else {                                                                                                     // 2040
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 2042
        });                                                                                                            // 2043
      }).then(function (rpcResponse) {                                                                                 // 2044
        if (rpcResponse !== undefined) {                                                                               // 2045
          // Will be undefined for OPTIONS request.                                                                    // 2045
          return _this10.translateResponse(rpcResponse, response, request);                                            // 2046
        }                                                                                                              // 2047
      })["catch"](function (error) {                                                                                   // 2048
        return _this10.maybeRetryAfterError(error, retryCount).then(function () {                                      // 2049
          return _this10.handleRequest(request, data, response, retryCount + 1);                                       // 2050
        });                                                                                                            // 2051
      });                                                                                                              // 2052
    }                                                                                                                  // 2053
                                                                                                                       //
    return handleRequest;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function () {                                                               //
    function handleRequestStreaming(request, response, contentLength, retryCount) {                                    //
      var _this11 = this;                                                                                              // 2055
                                                                                                                       //
      return this.makeContext(request, response, function (context) {                                                  // 2056
        var path = request.url.slice(1); // remove leading '/'                                                         // 2057
        var session = _this11.getSession(request);                                                                     // 2058
                                                                                                                       //
        var mimeType = request.headers["content-type"] || "application/octet-stream";                                  // 2060
        var encoding = request.headers["content-encoding"];                                                            // 2061
                                                                                                                       //
        var requestStreamPromise = void 0;                                                                             // 2063
        if (request.method === "POST") {                                                                               // 2064
          requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                             // 2065
        } else if (request.method === "PUT") {                                                                         // 2066
          requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                              // 2067
        } else {                                                                                                       // 2068
          throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                 // 2069
        }                                                                                                              // 2070
                                                                                                                       //
        // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                  // 2072
        //   handle the case where the app doesn't actually support streaming. We could pipeline while                 // 2073
        //   also buffering the data on the side in case we need it again later, but that's kind of                    // 2074
        //   complicated. We should fix the whole protocol to make streaming the standard.                             // 2075
        return requestStreamPromise.then(function (requestStreamResult) {                                              // 2076
          var requestStream = requestStreamResult.stream;                                                              // 2077
                                                                                                                       //
          // Initialized when getResponse() returns, if the response is streaming.                                     // 2079
          var downloadStreamHandle = void 0;                                                                           // 2080
                                                                                                                       //
          // Initialized if an upload-stream method throws.                                                            // 2082
          var uploadStreamError = void 0;                                                                              // 2083
                                                                                                                       //
          // We call `getResponse()` immediately so that the app can start streaming data down even                    // 2085
          // while data is still being streamed up. This theoretically allows apps to perform                          // 2086
          // bidirectional streaming, though probably very few actually do that.                                       // 2087
          //                                                                                                           // 2088
          // Note that we need to be able to cancel `responsePromise` below, so it's important that                    // 2089
          // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                         // 2090
          // variable.                                                                                                 // 2091
          var responsePromise = requestStream.getResponse();                                                           // 2092
                                                                                                                       //
          var reportUploadStreamError = function () {                                                                  // 2094
            function reportUploadStreamError(err) {                                                                    // 2094
              // Called when an upload-stream method throws.                                                           // 2095
                                                                                                                       //
              if (!uploadStreamError) {                                                                                // 2097
                uploadStreamError = err;                                                                               // 2098
                                                                                                                       //
                // If we're still waiting on any response stuff, cancel it.                                            // 2100
                responsePromise.cancel();                                                                              // 2101
                requestStream.close();                                                                                 // 2102
                if (downloadStreamHandle) {                                                                            // 2103
                  downloadStreamHandle.close();                                                                        // 2104
                }                                                                                                      // 2105
              }                                                                                                        // 2106
            }                                                                                                          // 2107
                                                                                                                       //
            return reportUploadStreamError;                                                                            // 2094
          }();                                                                                                         // 2094
                                                                                                                       //
          // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                          // 2109
          if (contentLength !== undefined) {                                                                           // 2110
            requestStream.expectSize(contentLength)["catch"](function (err) {                                          // 2111
              // expectSize() is allowed to be unimplemented.                                                          // 2112
              if (err.kjType !== "unimplemented") {                                                                    // 2113
                reportUploadStreamError(err);                                                                          // 2114
              }                                                                                                        // 2115
            });                                                                                                        // 2116
          }                                                                                                            // 2117
                                                                                                                       //
          // Pipe the input stream to the app.                                                                         // 2119
          var writesInFlight = 0;                                                                                      // 2120
          var readingPaused = false;                                                                                   // 2121
          request.on("data", function (buf) {                                                                          // 2122
            // TODO(someday): Coalesce small writes.                                                                   // 2123
                                                                                                                       //
            if (buf.length > 4194304) {                                                                                // 2125
              // Whoa, buffer is more than 4MB. We should be splitting it. But does this actually                      // 2126
              // happen? Let's try to detect this problem before we try to do anything about it.                       // 2127
              console.log("whoa, huge upload buffer:", buf.length);                                                    // 2128
              reportUploadStreamError(new Error("upload buffer too big (bug in Sandstorm)"));                          // 2129
              destructor();                                                                                            // 2130
              return;                                                                                                  // 2131
            }                                                                                                          // 2132
                                                                                                                       //
            if (!uploadStreamError) {                                                                                  // 2134
              requestStream.write(buf).then(function () {                                                              // 2135
                writesInFlight--;                                                                                      // 2136
                if (readingPaused) {                                                                                   // 2137
                  request.resume();                                                                                    // 2138
                  readingPaused = false;                                                                               // 2139
                }                                                                                                      // 2140
              })["catch"](reportUploadStreamError);                                                                    // 2141
                                                                                                                       //
              if (writesInFlight++ > 16) {                                                                             // 2143
                request.pause();                                                                                       // 2144
                readingPaused = true;                                                                                  // 2145
              }                                                                                                        // 2146
            }                                                                                                          // 2147
          });                                                                                                          // 2148
                                                                                                                       //
          var idx = _this11.streamingRequestCounter;                                                                   // 2150
          _this11.streamingRequestCounter += 1;                                                                        // 2151
          _this11.streamingRequests[idx] = request;                                                                    // 2152
          destructor = function () {                                                                                   // 2153
            function destructor() {                                                                                    // 2153
              delete _this11.streamingRequests[idx];                                                                   // 2153
            }                                                                                                          // 2153
                                                                                                                       //
            return destructor;                                                                                         // 2153
          }();                                                                                                         // 2153
                                                                                                                       //
          request.on("end", function () {                                                                              // 2155
            if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                            // 2156
                                                                                                                       //
            // We're all done making calls to requestStream.                                                           // 2158
            requestStream.close();                                                                                     // 2159
            destructor();                                                                                              // 2160
          });                                                                                                          // 2161
                                                                                                                       //
          request.on("close", function () {                                                                            // 2163
            reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                 // 2164
            destructor();                                                                                              // 2165
          });                                                                                                          // 2166
                                                                                                                       //
          request.on("error", function (err) {                                                                         // 2168
            reportUploadStreamError(err);                                                                              // 2169
            destructor();                                                                                              // 2170
          });                                                                                                          // 2171
                                                                                                                       //
          return responsePromise.then(function (rpcResponse) {                                                         // 2173
            // Stop here if the upload stream has already failed.                                                      // 2174
            if (uploadStreamError) throw uploadStreamError;                                                            // 2175
            downloadStreamHandle = _this11.translateResponse(rpcResponse, response, request).streamHandle;             // 2176
          });                                                                                                          // 2177
        }, function (err) {                                                                                            // 2178
          if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                              // 2179
            // Hack to work around old apps using an old version of Cap'n Proto, before the                            // 2180
            // 'unimplemented' exception type was introduced. :(                                                       // 2181
            // TODO(cleanup): When we transition to API version 2, we can move this into the                           // 2182
            //   compatibility layer.                                                                                  // 2183
            err.kjType = "unimplemented";                                                                              // 2184
          }                                                                                                            // 2185
                                                                                                                       //
          if (shouldRestartGrain(err, 0)) {                                                                            // 2187
            // This is the kind of error that indicates we should retry. Note that we passed 0 for                     // 2188
            // the retry count above because we were just checking if this is a retriable error (vs.                   // 2189
            // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                  // 2190
            // the proper retry count.                                                                                 // 2191
            return _this11.maybeRetryAfterError(err, retryCount).then(function () {                                    // 2192
              return _this11.handleRequestStreaming(request, response, contentLength, retryCount + 1);                 // 2193
            });                                                                                                        // 2194
          } else if (err.kjType === "unimplemented") {                                                                 // 2195
            // Streaming is not implemented. Fall back to non-streaming version.                                       // 2196
            return readAll(request).then(function (data) {                                                             // 2197
              return _this11.handleRequest(request, data, response, 0);                                                // 2198
            });                                                                                                        // 2199
          } else {                                                                                                     // 2200
            throw err;                                                                                                 // 2201
          }                                                                                                            // 2202
        });                                                                                                            // 2203
      });                                                                                                              // 2204
    }                                                                                                                  // 2205
                                                                                                                       //
    return handleRequestStreaming;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function () {                                                                      //
    function handleWebSocket(request, socket, head, retryCount) {                                                      //
      var _this12 = this;                                                                                              // 2207
                                                                                                                       //
      return Promise.resolve(undefined).then(function () {                                                             // 2208
        return _this12.makeContext(request, undefined, function (context) {                                            // 2209
          var path = request.url.slice(1); // remove leading '/'                                                       // 2210
          var session = _this12.getSession(request);                                                                   // 2211
                                                                                                                       //
          if (!("sec-websocket-key" in request.headers)) {                                                             // 2213
            throw new Error("Missing Sec-WebSocket-Accept header.");                                                   // 2214
          }                                                                                                            // 2215
                                                                                                                       //
          var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                   // 2217
          var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                    // 2218
                                                                                                                       //
          var protocols = [];                                                                                          // 2220
          if ("sec-websocket-protocol" in request.headers) {                                                           // 2221
            protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                        // 2222
              return s.trim();                                                                                         // 2223
            });                                                                                                        // 2223
          }                                                                                                            // 2224
                                                                                                                       //
          var receiver = new WebSocketReceiver(socket);                                                                // 2226
                                                                                                                       //
          var promise = session.openWebSocket(path, context, protocols, receiver);                                     // 2228
                                                                                                                       //
          if (head.length > 0) {                                                                                       // 2230
            promise.serverStream.sendBytes(head);                                                                      // 2231
          }                                                                                                            // 2232
                                                                                                                       //
          var socketIdx = _this12.websocketCounter;                                                                    // 2234
          _this12.websockets[socketIdx] = socket;                                                                      // 2235
          _this12.websocketCounter += 1;                                                                               // 2236
          pumpWebSocket(socket, promise.serverStream, function () {                                                    // 2237
            delete _this12.websockets[socketIdx];                                                                      // 2237
          });                                                                                                          // 2237
                                                                                                                       //
          return promise.then(function (response) {                                                                    // 2239
            var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
            if (response.protocol && response.protocol.length > 0) {                                                   // 2246
              headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                 // 2247
            }                                                                                                          // 2248
                                                                                                                       //
            headers.push("");                                                                                          // 2250
            headers.push("");                                                                                          // 2251
                                                                                                                       //
            socket.write(headers.join("\r\n"));                                                                        // 2253
            receiver.go();                                                                                             // 2254
                                                                                                                       //
            // Note:  At this point errors are out of our hands.                                                       // 2256
          });                                                                                                          // 2257
        });                                                                                                            // 2258
      })["catch"](function (error) {                                                                                   // 2259
        return _this12.maybeRetryAfterError(error, retryCount).then(function () {                                      // 2260
          return _this12.handleWebSocket(request, socket, head, retryCount + 1);                                       // 2261
        });                                                                                                            // 2262
      });                                                                                                              // 2263
    }                                                                                                                  // 2264
                                                                                                                       //
    return handleWebSocket;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function () {                                                                         //
    function setHasLoaded() {                                                                                          //
      var _this13 = this;                                                                                              // 2266
                                                                                                                       //
      if (!this.hasLoaded) {                                                                                           // 2267
        (function () {                                                                                                 // 2267
          _this13.hasLoaded = true;                                                                                    // 2268
          var sessionId = _this13.sessionId;                                                                           // 2269
          inMeteor(function () {                                                                                       // 2270
            Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                        // 2271
          });                                                                                                          // 2272
        })();                                                                                                          // 2267
      }                                                                                                                // 2273
    }                                                                                                                  // 2274
                                                                                                                       //
    return setHasLoaded;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2277
  if (Net.isIPv4(address)) {                                                                                           // 2278
    var quad = address.split(".").map(function (x) {                                                                   // 2279
      return parseInt(x, 10);                                                                                          // 2279
    });                                                                                                                // 2279
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2283
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       // 2284
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2285
  } else {                                                                                                             // 2286
    // Ignore things that are neither IPv4 nor IPv6                                                                    // 2287
    return false;                                                                                                      // 2288
  }                                                                                                                    // 2289
};                                                                                                                     // 2290
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2292
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2293
  return num.toString();                                                                                               // 2297
};                                                                                                                     // 2298
                                                                                                                       //
// -----------------------------------------------------------------------------                                       // 2300
// Session cookie management                                                                                           // 2301
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2303
  // jscs:disable requireDotNotation                                                                                   // 2304
  var header = request.headers["cookie"];                                                                              // 2305
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2307
  if (header) {                                                                                                        // 2308
    var reqCookies = header.split(";");                                                                                // 2309
    for (var i in meteorBabelHelpers.sanitizeForInObject(reqCookies)) {                                                // 2310
      var reqCookie = reqCookies[i];                                                                                   // 2311
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2312
      var cookie = void 0;                                                                                             // 2313
      if (equalsPos === -1) {                                                                                          // 2314
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2315
      } else {                                                                                                         // 2316
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2317
      }                                                                                                                // 2318
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2320
        if (result.sessionId) {                                                                                        // 2321
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2322
        }                                                                                                              // 2323
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2325
      } else {                                                                                                         // 2326
        result.cookies.push(cookie);                                                                                   // 2327
      }                                                                                                                // 2328
    }                                                                                                                  // 2329
  }                                                                                                                    // 2330
                                                                                                                       //
  return result;                                                                                                       // 2332
};                                                                                                                     // 2333
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2335
  if (request.headers["if-match"]) {                                                                                   // 2336
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2337
      return { exists: null };                                                                                         // 2338
    }                                                                                                                  // 2339
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2341
    if (matches.length > 0) {                                                                                          // 2342
      return { matchesOneOf: matches };                                                                                // 2343
    }                                                                                                                  // 2344
  }                                                                                                                    // 2345
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2347
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2348
      return { doesntExist: null };                                                                                    // 2349
    }                                                                                                                  // 2350
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2352
    if (noneMatches.length > 0) {                                                                                      // 2353
      return { matchesNoneOf: noneMatches };                                                                           // 2354
    }                                                                                                                  // 2355
  }                                                                                                                    // 2356
                                                                                                                       //
  return { none: null };                                                                                               // 2358
};                                                                                                                     // 2359
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2361
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          // 2362
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         // 2363
                                                                                                                       //
  input = input.trim();                                                                                                // 2365
  var results = [];                                                                                                    // 2366
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2368
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2369
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2370
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2372
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2373
  }                                                                                                                    // 2374
                                                                                                                       //
  return results;                                                                                                      // 2376
};                                                                                                                     // 2377
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2379
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2380
  if (tag.weak) result = "W/" + result;                                                                                // 2381
  return result;                                                                                                       // 2382
};                                                                                                                     // 2383
                                                                                                                       //
var parseAcceptHeaderString = function parseAcceptHeaderString(header, field) {                                        // 2385
  var result = [];                                                                                                     // 2386
  if (header) {                                                                                                        // 2387
    var acceptList = header.split(",");                                                                                // 2388
    for (var i in meteorBabelHelpers.sanitizeForInObject(acceptList)) {                                                // 2389
      var acceptStr = acceptList[i];                                                                                   // 2390
      var tokensList = acceptStr.split(";");                                                                           // 2391
                                                                                                                       //
      var temp = {};                                                                                                   // 2393
      temp[field] = tokensList[0].trim();                                                                              // 2394
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2396
      for (var j in meteorBabelHelpers.sanitizeForInObject(tokensListRest)) {                                          // 2397
        var token = tokensListRest[j];                                                                                 // 2398
        var equalsPos = token.indexOf("=");                                                                            // 2399
        if (equalsPos) {                                                                                               // 2400
          var key = token.slice(0, equalsPos).trim();                                                                  // 2401
          var value = token.slice(equalsPos + 1).trim();                                                               // 2402
                                                                                                                       //
          if (key === "q") {                                                                                           // 2404
            temp.qValue = +value;                                                                                      // 2405
          }                                                                                                            // 2406
        }                                                                                                              // 2407
      }                                                                                                                // 2408
                                                                                                                       //
      result.push(temp);                                                                                               // 2410
    }                                                                                                                  // 2411
  }                                                                                                                    // 2412
                                                                                                                       //
  return result;                                                                                                       // 2414
};                                                                                                                     // 2415
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2417
  // jscs:disable requireDotNotation                                                                                   // 2418
  var header = request.headers["accept"];                                                                              // 2419
  return parseAcceptHeaderString(header, "mimeType");                                                                  // 2420
};                                                                                                                     // 2421
                                                                                                                       //
var parseAcceptEncodingHeader = function parseAcceptEncodingHeader(request) {                                          // 2423
  // jscs:disable requireDotNotation                                                                                   // 2424
  var header = request.headers["accept-encoding"];                                                                     // 2425
  return parseAcceptHeaderString(header, "contentCoding");                                                             // 2426
};                                                                                                                     // 2427
                                                                                                                       //
// -----------------------------------------------------------------------------                                       // 2429
// Regular HTTP request handling                                                                                       // 2430
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2432
  return new Promise(function (resolve, reject) {                                                                      // 2433
    var buffers = [];                                                                                                  // 2434
    stream.on("data", function (buf) {                                                                                 // 2435
      buffers.push(buf);                                                                                               // 2436
    });                                                                                                                // 2437
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2439
      resolve(Buffer.concat(buffers));                                                                                 // 2440
    });                                                                                                                // 2441
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2443
  });                                                                                                                  // 2444
};                                                                                                                     // 2445
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2447
  var result = [cookie.name, "=", cookie.value];                                                                       // 2448
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2450
    result.push("; Expires=");                                                                                         // 2451
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2452
  } else if ("relative" in cookie.expires) {                                                                           // 2453
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2454
  }                                                                                                                    // 2455
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2457
    result.push("; Path=" + cookie.path);                                                                              // 2458
  }                                                                                                                    // 2459
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2461
    result.push("; HttpOnly");                                                                                         // 2462
  }                                                                                                                    // 2463
                                                                                                                       //
  return result.join("");                                                                                              // 2465
};                                                                                                                     // 2466
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            // 2468
var successCodes = {                                                                                                   // 2469
  ok: { id: 200, title: "OK" },                                                                                        // 2470
  created: { id: 201, title: "Created" },                                                                              // 2471
  accepted: { id: 202, title: "Accepted" },                                                                            // 2472
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2473
};                                                                                                                     // 2469
var noContentSuccessCodes = [                                                                                          // 2475
// Indexed by shouldResetForm * 1                                                                                      // 2476
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2477
var redirectCodes = [                                                                                                  // 2480
// Indexed by switchToGet * 2 + isPermanent                                                                            // 2481
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2487
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2488
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2489
  notFound: { id: 404, title: "Not Found" },                                                                           // 2490
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2491
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2492
  conflict: { id: 409, title: "Conflict" },                                                                            // 2493
  gone: { id: 410, title: "Gone" },                                                                                    // 2494
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2495
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2496
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2497
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2498
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2499
};                                                                                                                     // 2487
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2502
  // Note: This class is used in pre-meteor.js as well as in this file.                                                // 2503
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle, idempotentCleanup) {                         // 2505
    var _this14 = this;                                                                                                // 2505
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2505
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          // 2506
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           // 2507
    //   completion for flow control, so we want write() to complete only when there is space                          // 2508
    //   available for more writes.                                                                                    // 2509
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      // 2510
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      // 2511
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      // 2512
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         // 2513
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      // 2514
    //   can lead to very excessive log spam.                                                                          // 2515
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         // 2516
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     // 2517
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       // 2518
    //   point, we again get log spam.                                                                                 // 2519
    // - If the connection closes during a write, Node never calls the completion callback at all.                     // 2520
    //   We have to listen for the "close" event.                                                                      // 2521
                                                                                                                       //
    this.response = response;                                                                                          // 2523
    this.httpCode = httpCode;                                                                                          // 2524
    this.httpStatus = httpStatus;                                                                                      // 2525
    this.upstreamHandle = upstreamHandle;                                                                              // 2526
    this.idempotentCleanup = idempotentCleanup;                                                                        // 2527
                                                                                                                       //
    this.started = false;                                                                                              // 2529
    this.ended = false; // Invariant: if `ended` is true, then `started` is also true.                                 // 2530
    this.waiting = [];                                                                                                 // 2531
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2533
      _this14.waiting.forEach(function (f) {                                                                           // 2534
        return f();                                                                                                    // 2534
      });                                                                                                              // 2534
      _this14.waiting = [];                                                                                            // 2535
    });                                                                                                                // 2536
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2538
      _this14.abort();                                                                                                 // 2538
    });                                                                                                                // 2538
  }                                                                                                                    // 2539
                                                                                                                       //
  ResponseStream.prototype.abort = function () {                                                                       // 2502
    function abort() {                                                                                                 // 2502
      this.aborted = true;                                                                                             // 2542
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    // 2544
      // an incomplete download is the client's problem, not the server's. The important thing is                      // 2545
      // to cancel the stream if it is still being generated; to that end, the next new write() call                   // 2546
      // after this point will throw.                                                                                  // 2547
      this.waiting.forEach(function (f) {                                                                              // 2548
        return f();                                                                                                    // 2548
      });                                                                                                              // 2548
      this.waiting = [];                                                                                               // 2549
                                                                                                                       //
      this.close();                                                                                                    // 2551
    }                                                                                                                  // 2552
                                                                                                                       //
    return abort;                                                                                                      // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  ResponseStream.prototype.expectSize = function () {                                                                  // 2502
    function expectSize(size) {                                                                                        // 2502
      if (!this.started) {                                                                                             // 2555
        this.started = true;                                                                                           // 2556
        this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                           // 2557
      }                                                                                                                // 2558
    }                                                                                                                  // 2559
                                                                                                                       //
    return expectSize;                                                                                                 // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  ResponseStream.prototype.write = function () {                                                                       // 2502
    function write(data) {                                                                                             // 2502
      var _this15 = this;                                                                                              // 2561
                                                                                                                       //
      if (!this.started) {                                                                                             // 2562
        this.started = true;                                                                                           // 2563
        this.response.writeHead(this.httpCode, this.httpStatus);                                                       // 2564
      }                                                                                                                // 2565
                                                                                                                       //
      if (this.aborted) {                                                                                              // 2567
        // Connection has been aborted.                                                                                // 2568
        if (this.alreadyThrew) {                                                                                       // 2569
          // We already threw an error from a previous write(). Do not throw more errors, because                      // 2570
          // older versions of sandstorm-http-bridge do not stop on the first error and will print                     // 2571
          // every error to the log, wasting space. Newer versions stop on the first failure.                          // 2572
          return;                                                                                                      // 2573
        } else {                                                                                                       // 2574
          this.alreadyThrew = true;                                                                                    // 2575
          throw new Error("client disconnected");                                                                      // 2576
        }                                                                                                              // 2577
      } else {                                                                                                         // 2578
        if (this.response.write(data)) {                                                                               // 2579
          // All written.                                                                                              // 2580
          return;                                                                                                      // 2581
        } else {                                                                                                       // 2582
          // Write buffer is full. Don't complete until it has more space.                                             // 2583
          return new Promise(function (resolve, reject) {                                                              // 2584
            _this15.waiting.push(resolve);                                                                             // 2585
          });                                                                                                          // 2586
        }                                                                                                              // 2587
      }                                                                                                                // 2588
    }                                                                                                                  // 2589
                                                                                                                       //
    return write;                                                                                                      // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  ResponseStream.prototype.done = function () {                                                                        // 2502
    function done() {                                                                                                  // 2502
      if (!this.started) {                                                                                             // 2592
        this.started = true;                                                                                           // 2593
        this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                              // 2594
      }                                                                                                                // 2595
                                                                                                                       //
      if (!this.ended) {                                                                                               // 2597
        this.ended = true;                                                                                             // 2598
        this.response.end();                                                                                           // 2599
      }                                                                                                                // 2600
                                                                                                                       //
      this.close();                                                                                                    // 2602
    }                                                                                                                  // 2603
                                                                                                                       //
    return done;                                                                                                       // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  ResponseStream.prototype.close = function () {                                                                       // 2502
    function close() {                                                                                                 // 2502
      if (this.upstreamHandle) {                                                                                       // 2606
        this.upstreamHandle.close();                                                                                   // 2607
      }                                                                                                                // 2608
                                                                                                                       //
      if (this.idempotentCleanup) {                                                                                    // 2610
        this.idempotentCleanup();                                                                                      // 2611
      }                                                                                                                // 2612
                                                                                                                       //
      // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                 // 2614
      // the only case in which we can actually report the error is when we haven't done any writes                    // 2615
      // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                         // 2616
      // implies `!this.ended`.                                                                                        // 2617
      if (!this.started) {                                                                                             // 2618
        this.started = true;                                                                                           // 2619
        this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });      // 2620
      }                                                                                                                // 2622
                                                                                                                       //
      if (!this.ended) {                                                                                               // 2624
        this.ended = true;                                                                                             // 2625
        this.response.end();                                                                                           // 2626
      }                                                                                                                // 2627
    }                                                                                                                  // 2628
                                                                                                                       //
    return close;                                                                                                      // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function () {                                                       // 2502
    function sendingDirectResponse() {                                                                                 // 2502
      // For internal front-end use: Indicates that the caller is going to fill in the response                        // 2631
      // instead. If a response has already been started, this throws an exception.                                    // 2632
      //                                                                                                               // 2633
      // This is used in particular in pre-meteor.js, when dealing with static web publishing.                         // 2634
                                                                                                                       //
      if (this.started) {                                                                                              // 2636
        throw new Error("can't sendDirectResponse() because response already started");                                // 2637
        this.response.end();                                                                                           // 2638
      } else if (this.ended) {                                                                                         // 2639
        throw new Error("can't sendDirectResponse() because response already sent");                                   // 2640
      } else {                                                                                                         // 2641
        this.started = true;                                                                                           // 2642
        this.ended = true;                                                                                             // 2643
      }                                                                                                                // 2644
    }                                                                                                                  // 2645
                                                                                                                       //
    return sendingDirectResponse;                                                                                      // 2502
  }();                                                                                                                 // 2502
                                                                                                                       //
  return ResponseStream;                                                                                               // 2502
}();                                                                                                                   // 2502
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            // 2648
var Zlib = Npm.require("zlib");                                                                                        // 2649
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2650
                                                                                                                       //
// -----------------------------------------------------------------------------                                       // 2652
// WebSocket handling                                                                                                  // 2653
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2655
  function WebSocketReceiver(socket) {                                                                                 // 2656
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2656
                                                                                                                       //
    this.socket = socket;                                                                                              // 2657
    this.queue = [];                                                                                                   // 2658
  }                                                                                                                    // 2659
                                                                                                                       //
  WebSocketReceiver.prototype.go = function () {                                                                       // 2655
    function go() {                                                                                                    // 2655
      for (var i in meteorBabelHelpers.sanitizeForInObject(this.queue)) {                                              // 2662
        this.socket.write(this.queue[i]);                                                                              // 2663
      }                                                                                                                // 2664
                                                                                                                       //
      this.queue = null;                                                                                               // 2666
    }                                                                                                                  // 2667
                                                                                                                       //
    return go;                                                                                                         // 2655
  }();                                                                                                                 // 2655
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function () {                                                                // 2655
    function sendBytes(message) {                                                                                      // 2655
      // TODO(someday):  Flow control of some sort?                                                                    // 2670
      if (this.queue === null) {                                                                                       // 2671
        this.socket.write(message);                                                                                    // 2672
      } else {                                                                                                         // 2673
        this.queue.push(message);                                                                                      // 2674
      }                                                                                                                // 2675
    }                                                                                                                  // 2676
                                                                                                                       //
    return sendBytes;                                                                                                  // 2655
  }();                                                                                                                 // 2655
                                                                                                                       //
  WebSocketReceiver.prototype.close = function () {                                                                    // 2655
    function close() {                                                                                                 // 2655
      this.socket.end();                                                                                               // 2679
    }                                                                                                                  // 2680
                                                                                                                       //
    return close;                                                                                                      // 2655
  }();                                                                                                                 // 2655
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2655
}();                                                                                                                   // 2655
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2683
  var writesInFlight = 0;                                                                                              // 2684
  var readingPaused = false;                                                                                           // 2685
  socket.on("data", function (chunk) {                                                                                 // 2686
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2687
      writesInFlight--;                                                                                                // 2688
      if (readingPaused) {                                                                                             // 2689
        socket.resume();                                                                                               // 2690
        readingPaused = false;                                                                                         // 2691
      }                                                                                                                // 2692
    })["catch"](function (err) {                                                                                       // 2693
      if (err.kjType !== "disconnected") {                                                                             // 2694
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2695
      }                                                                                                                // 2696
                                                                                                                       //
      socket.destroy();                                                                                                // 2698
    });                                                                                                                // 2699
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2701
      socket.pause();                                                                                                  // 2702
      readingPaused = true;                                                                                            // 2703
    }                                                                                                                  // 2704
  });                                                                                                                  // 2705
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2707
    rpcStream.close();                                                                                                 // 2708
  });                                                                                                                  // 2709
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2711
    destructor();                                                                                                      // 2712
  });                                                                                                                  // 2713
};                                                                                                                     // 2714
                                                                                                                       //
// =======================================================================================                             // 2716
// Debug log access                                                                                                    // 2717
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2719
  var _this16 = this;                                                                                                  // 2719
                                                                                                                       //
  check(grainId, String);                                                                                              // 2720
  var id = 0;                                                                                                          // 2721
  var grain = Grains.findOne(grainId);                                                                                 // 2722
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2723
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2724
    this.ready();                                                                                                      // 2725
    return;                                                                                                            // 2726
  }                                                                                                                    // 2727
                                                                                                                       //
  var connected = false;                                                                                               // 2729
  var _this = this;                                                                                                    // 2730
                                                                                                                       //
  var receiver = {                                                                                                     // 2732
    write: function () {                                                                                               // 2733
      function write(data) {                                                                                           // 2732
        connected = true;                                                                                              // 2734
        _this.added("grainLog", id++, { text: data.toString("utf8") });                                                // 2735
      }                                                                                                                // 2736
                                                                                                                       //
      return write;                                                                                                    // 2732
    }(),                                                                                                               // 2732
    close: function () {                                                                                               // 2738
      function close() {                                                                                               // 2732
        if (connected) {                                                                                               // 2739
          _this.added("grainLog", id++, {                                                                              // 2740
            text: "*** lost connection to grain (probably because it shut down) ***"                                   // 2741
          });                                                                                                          // 2740
        }                                                                                                              // 2743
      }                                                                                                                // 2744
                                                                                                                       //
      return close;                                                                                                    // 2732
    }()                                                                                                                // 2732
  };                                                                                                                   // 2732
                                                                                                                       //
  try {                                                                                                                // 2747
    (function () {                                                                                                     // 2747
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2748
        return supervisor.watchLog(8192, receiver);                                                                    // 2749
      })).handle;                                                                                                      // 2750
      connected = true;                                                                                                // 2751
      _this16.onStop(function () {                                                                                     // 2752
        handle.close();                                                                                                // 2753
      });                                                                                                              // 2754
    })();                                                                                                              // 2747
  } catch (err) {                                                                                                      // 2755
    if (!connected) {                                                                                                  // 2756
      this.added("grainLog", id++, {                                                                                   // 2757
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2758
      });                                                                                                              // 2757
    }                                                                                                                  // 2760
  }                                                                                                                    // 2761
                                                                                                                       //
  // Notify ready.                                                                                                     // 2763
  this.ready();                                                                                                        // 2764
});                                                                                                                    // 2765
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});var SANDSTORM_ALTHOME;module.import("/imports/server/constants.js",{"SANDSTORM_ALTHOME":function(v){SANDSTORM_ALTHOME=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
                                                                                                                       // 26
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 28
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 30
                                                                                                                       //
// Figure out what IP address to send Sandcats requests from. For machines with multiple IPs, it                       // 32
// is important to use the IP to which we're binding. However, some people set BIND_IP to 127.0.0.1                    // 33
// and put sniproxy in front of Sandstorm. In those cases, it won't work to send from BIND_IP;                         // 34
// we'll have to let the system choose.                                                                                // 35
var BIND_IP = process.env.BIND_IP.startsWith("127.") ? null : process.env.BIND_IP;                                     // 36
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 38
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 39
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 40
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 42
  var responseCallback = function responseCallback(res) {                                                              // 43
    if (res.statusCode === 200) {                                                                                      // 44
      console.log("Successfully updated sandcats IP");                                                                 // 45
    } else {                                                                                                           // 46
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 47
    }                                                                                                                  // 48
  };                                                                                                                   // 49
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 51
    console.error("Couldn't send update sandcats hostname", err);                                                      // 52
  };                                                                                                                   // 53
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 57
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 59
  var socket = dgram.createSocket("udp4");                                                                             // 60
  var secret = Random.secret(16);                                                                                      // 61
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 63
  socket.on("message", function (buf) {                                                                                // 64
    if (buf.toString() === secret) {                                                                                   // 65
      updateSandcatsIp();                                                                                              // 66
    } else {                                                                                                           // 67
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 68
    }                                                                                                                  // 69
  });                                                                                                                  // 70
                                                                                                                       //
  socket.on("error", function (err) {                                                                                  // 72
    throw err;                                                                                                         // 73
  });                                                                                                                  // 74
                                                                                                                       //
  var callback = function callback() {                                                                                 // 76
    socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                  // 77
      if (err) {                                                                                                       // 78
        console.error("Couldn't send UDP sandcats ping", err);                                                         // 79
      }                                                                                                                // 80
    });                                                                                                                // 81
                                                                                                                       //
    setTimeout(function () {                                                                                           // 83
      socket.close();                                                                                                  // 84
    }, 10 * 1000);                                                                                                     // 85
  };                                                                                                                   // 86
                                                                                                                       //
  if (BIND_IP) {                                                                                                       // 88
    socket.bind({ address: BIND_IP }, callback);                                                                       // 89
  } else {                                                                                                             // 90
    callback();                                                                                                        // 91
  }                                                                                                                    // 92
};                                                                                                                     // 93
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 96
    hostname: hostname,                                                                                                // 97
    path: path,                                                                                                        // 98
    method: "POST",                                                                                                    // 99
    agent: false,                                                                                                      // 100
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 101
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 102
    headers: {                                                                                                         // 103
      "X-Sand": "cats",                                                                                                // 104
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 105
    }                                                                                                                  // 103
  };                                                                                                                   // 96
                                                                                                                       //
  if (BIND_IP) {                                                                                                       // 109
    options.localAddress = BIND_IP;                                                                                    // 110
  }                                                                                                                    // 111
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 113
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 117
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 119
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 120
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 125
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 127
  req.write(newPostData);                                                                                              // 128
  req.end();                                                                                                           // 129
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 131
    req.on("error", errorCallback);                                                                                    // 132
  }                                                                                                                    // 133
                                                                                                                       //
  return req;                                                                                                          // 135
};                                                                                                                     // 136
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 138
  check(commonName, String);                                                                                           // 139
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  // 141
  // a synchronous as well as an asynchronous API, and the synchronous                                                 // 142
  // one blocks for a while.                                                                                           // 143
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 144
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 // 146
  // I will refrain.                                                                                                   // 147
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 148
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               // 150
  var csr = pki.createCertificationRequest();                                                                          // 151
  csr.publicKey = keys.publicKey;                                                                                      // 152
  csr.setSubject([{                                                                                                    // 153
    name: "commonName",                                                                                                // 155
    value: commonName,                                                                                                 // 156
    valueTagClass: asn1.Type.UTF8                                                                                      // 157
  }]);                                                                                                                 // 154
  csr.sign(keys.privateKey);                                                                                           // 163
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 164
  return {                                                                                                             // 165
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 166
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 167
  };                                                                                                                   // 165
};                                                                                                                     // 169
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 171
  // We use the current JS time (like UNIX timestamp but in                                                            // 172
  // milliseconds) as the key number. Note that the keyNumber is                                                       // 173
  // intended to be an opaque identifier; the only important thing is                                                  // 174
  // that it increases numerically over time. We use the current time                                                  // 175
  // just as a simplistic way to pick a filename that probably no one                                                  // 176
  // else has created yet.                                                                                             // 177
  var keyNumber = new Date().getTime();                                                                                // 178
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 179
  var csrFilename = keyFilename + ".csr";                                                                              // 180
  var responseFilename = keyFilename + ".response-json";                                                               // 181
  var withWildcard = "*." + hostname;                                                                                  // 182
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 183
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 184
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 186
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 191
    csrFilename: csrFilename,                                                                                          // 192
    keyFilename: keyFilename,                                                                                          // 193
    responseFilename: responseFilename                                                                                 // 194
  };                                                                                                                   // 191
};                                                                                                                     // 196
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 198
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 199
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 200
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 201
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 202
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 204
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 205
    };                                                                                                                 // 206
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 208
      if (res.statusCode == 200) {                                                                                     // 209
        (function () {                                                                                                 // 209
          // Save the response, chunk by chunk, then store it on disk                                                  // 210
          // for later use.                                                                                            // 211
          var responseBody = "";                                                                                       // 212
          res.on("data", function (chunk) {                                                                            // 213
            responseBody += chunk;                                                                                     // 214
          });                                                                                                          // 215
                                                                                                                       //
          res.on("end", function () {                                                                                  // 217
            // For sanity, make sure it parses as JSON, since we're                                                    // 218
            // going to need it to do that.                                                                            // 219
            try {                                                                                                      // 220
              JSON.parse(responseBody);                                                                                // 221
            } catch (e) {                                                                                              // 222
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 // 227
              // and continue with the process of saving it to disk.                                                   // 228
              responseBody = "{}";                                                                                     // 229
            }                                                                                                          // 230
                                                                                                                       //
            try {                                                                                                      // 232
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 233
            } catch (err) {                                                                                            // 234
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 239
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                // 241
            // about which keys are available.                                                                         // 242
            if (!global.sandcats) {                                                                                    // 243
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 245
              // Call the sandcats rekeying function.                                                                  // 246
              global.sandcats.rekey();                                                                                 // 247
              // That's that.                                                                                          // 248
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 249
            }                                                                                                          // 251
          });                                                                                                          // 252
        })();                                                                                                          // 209
      } else {                                                                                                         // 253
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 254
        res.on("data", function (chunk) {                                                                              // 256
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 257
        });                                                                                                            // 258
      }                                                                                                                // 259
    };                                                                                                                 // 260
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 262
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 264
      rawHostname: SANDCATS_NAME,                                                                                      // 265
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 266
    }, errorCallback, responseCallback);                                                                               // 264
  };                                                                                                                   // 268
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 270
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 271
    return renewHttpsCertificate();                                                                                    // 272
  }                                                                                                                    // 273
};                                                                                                                     // 274
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 276
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 277
  if (i < 0) {                                                                                                         // 278
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 281
    var oneMinute = 60 * 1000;                                                                                         // 282
    var oneHour = 60 * oneMinute;                                                                                      // 283
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 284
    // All Sandcats installs need dyndns updating.                                                                     // 285
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 286
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 287
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                // 288
    if (process.env.HTTPS_PORT) {                                                                                      // 289
      // Always do a HTTPS certificate update check on Sandstorm start.                                                // 290
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 291
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  // 293
      // the future.                                                                                                   // 294
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 295
    }                                                                                                                  // 297
  }                                                                                                                    // 298
};                                                                                                                     // 299
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 301
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 302
};                                                                                                                     // 303
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":["/imports/server/async-helpers.js","/imports/server/constants.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var inMeteor;module.import("/imports/server/async-helpers.js",{"inMeteor":function(v){inMeteor=v}});var staticAssetHost;module.import("/imports/server/constants.js",{"staticAssetHost":function(v){staticAssetHost=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// Set up browser policy.                                                                                              // 17
//                                                                                                                     // 18
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       // 19
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       // 20
// but inline script are enabled.                                                                                      // 21
//                                                                                                                     // 22
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          // 23
//   extra round trip on startup to fetch server settings. That seems like something that could                        // 24
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        // 25
//   is incredibly important, and Meteor's templating system (which we use to render all our                           // 26
//   HTML) already does a good job of protecting us from script injection, so right now I think                        // 27
//   we should favor avoiding the round trip.                                                                          // 28
//                                                                                                                     // 29
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        // 30
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        // 31
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         // 32
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        // 33
//   user, so maybe it's not a big deal...                                                                             // 34
                                                                                                                       //
                                                                                                                       // 36
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 38
Meteor.startup(function () {                                                                                           // 39
  var frameSetter = function frameSetter() {                                                                           // 40
    BrowserPolicy.content.disallowFrame(); // This clears all the old rules                                            // 41
    BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                       // 42
    var billingPromptUrl = globalDb.getBillingPromptUrl();                                                             // 43
    if (billingPromptUrl) {                                                                                            // 44
      BrowserPolicy.content.allowFrameOrigin(billingPromptUrl);                                                        // 45
    }                                                                                                                  // 46
  };                                                                                                                   // 47
                                                                                                                       //
  frameSetter(); // Call once on startup                                                                               // 49
  globalDb.collections.settings.find({ _id: "billingPromptUrl" }).observe({                                            // 50
    added: frameSetter,                                                                                                // 51
    changed: frameSetter,                                                                                              // 52
    removed: frameSetter                                                                                               // 53
  });                                                                                                                  // 50
});                                                                                                                    // 55
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             // 57
                                                                                                                       // 58
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 59
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 60
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 61
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 62
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 64
  var _this = this;                                                                                                    // 64
                                                                                                                       //
  if (this.userId) {                                                                                                   // 65
    if (globalDb.isQuotaEnabled()) {                                                                                   // 66
      (function () {                                                                                                   // 66
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    // 67
        //   front page.                                                                                               // 68
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      // 69
        //   back-end?                                                                                                 // 70
        var userId = _this.userId;                                                                                     // 71
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 72
          inMeteor(function () {                                                                                       // 73
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 74
          });                                                                                                          // 75
        })["catch"](function (err) {                                                                                   // 76
          if (err.kjType === "unimplemented") {                                                                        // 77
            // Compute based on sum of grain sizes instead.                                                            // 78
            var total = 0;                                                                                             // 79
            Grains.find({ userId: userId }, { fields: { size: 1 } }).forEach(function (grain) {                        // 80
              return total += grain.size || 0;                                                                         // 81
            });                                                                                                        // 81
            Meteor.users.update(userId, { $set: { storageUsage: total } });                                            // 82
          } else {                                                                                                     // 83
            console.error(err.stack);                                                                                  // 84
          }                                                                                                            // 85
        });                                                                                                            // 86
      })();                                                                                                            // 66
    }                                                                                                                  // 87
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 89
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 95
    return [];                                                                                                         // 96
  }                                                                                                                    // 97
});                                                                                                                    // 98
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 100
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         // 101
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          // 102
  // user is not logged in or is using incognito mode.                                                                 // 103
  check(sessionId, String);                                                                                            // 104
                                                                                                                       //
  // We exclude powerboxRequest because the client already has the descriptor list in packed                           // 106
  // format, and the parsed format can be kind of large.                                                               // 107
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] }, { fields: { powerboxRequest: 0 } });
});                                                                                                                    // 110
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 112
  return DevPackages.find();                                                                                           // 113
});                                                                                                                    // 114
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 116
  var _this2 = this;                                                                                                   // 116
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   // 117
  //                                                                                                                   // 118
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       // 119
  var cursor = Meteor.users.find();                                                                                    // 120
  if (cursor.count() > 0) {                                                                                            // 121
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 122
  } else {                                                                                                             // 123
    (function () {                                                                                                     // 123
      var handle = cursor.observeChanges({                                                                             // 124
        added: function () {                                                                                           // 125
          function added(id) {                                                                                         // 125
            _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                  // 126
            handle.stop();                                                                                             // 127
            handle = null;                                                                                             // 128
          }                                                                                                            // 129
                                                                                                                       //
          return added;                                                                                                // 125
        }()                                                                                                            // 125
      });                                                                                                              // 124
      _this2.onStop(function () {                                                                                      // 131
        if (handle) handle.stop();                                                                                     // 132
      });                                                                                                              // 133
    })();                                                                                                              // 123
  }                                                                                                                    // 134
                                                                                                                       //
  this.ready();                                                                                                        // 136
});                                                                                                                    // 137
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 139
  var _this3 = this;                                                                                                   // 139
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         // 140
  // form:                                                                                                             // 141
  //                                                                                                                   // 142
  // - id: (String) same as the User._id of an identity this user has referred                                         // 143
  // - name: (String) the profile.name from that identity                                                              // 144
  // - completed: (Boolean) if this referral is complete                                                               // 145
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      // 147
  if (!this.userId) {                                                                                                  // 148
    return [];                                                                                                         // 149
  }                                                                                                                    // 150
                                                                                                                       //
  // Implementation note:                                                                                              // 152
  //                                                                                                                   // 153
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     // 154
  // the (2) completed: true case.                                                                                     // 155
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     // 157
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 158
    referredBy: this.userId,                                                                                           // 159
    "profile.name": { $exists: true }                                                                                  // 160
  }, {                                                                                                                 // 158
    fields: {                                                                                                          // 162
      _id: 1,                                                                                                          // 163
      referredBy: 1,                                                                                                   // 164
      "profile.name": 1                                                                                                // 165
    }                                                                                                                  // 162
  });                                                                                                                  // 161
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 168
    // The added function gets called with the id of Bob when Alice refers Bob.                                        // 169
    added: function () {                                                                                               // 170
      function added(id, fields) {                                                                                     // 170
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                             // 171
      }                                                                                                                // 172
                                                                                                                       //
      return added;                                                                                                    // 170
    }(),                                                                                                               // 170
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      // 173
    // this will get more complicated once we support sending completed referrals to the client.                       // 174
    removed: function () {                                                                                             // 175
      function removed(id) {                                                                                           // 175
        _this3.removed("referralInfo", id);                                                                            // 176
      }                                                                                                                // 177
                                                                                                                       //
      return removed;                                                                                                  // 175
    }(),                                                                                                               // 175
    // The modified function gets called when Bob's profile.name changed.                                              // 178
    modified: function () {                                                                                            // 179
      function modified(id, fields) {                                                                                  // 179
        _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                          // 180
      }                                                                                                                // 181
                                                                                                                       //
      return modified;                                                                                                 // 179
    }()                                                                                                                // 179
  });                                                                                                                  // 168
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               // 184
  //                                                                                                                   // 185
  // - Do a query for the current list of completed identities.                                                        // 186
  //                                                                                                                   // 187
  // - Every time we see a new such identity, we create a query that watches that one identity in                      // 188
  //   case its profile.name changes.                                                                                  // 189
  //                                                                                                                   // 190
  // - Also watch the first query, since the list of completed identities might change.                                // 191
  var handleForProfileNameByIdentityId = {};                                                                           // 192
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 193
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 194
      stopWatchingIdentity(identityId);                                                                                // 195
    });                                                                                                                // 196
  };                                                                                                                   // 197
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 199
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 200
    if (handleForProfileName) {                                                                                        // 201
      _this3.removed("referralInfo", identityId);                                                                      // 202
      handleForProfileName.stop();                                                                                     // 203
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                // 204
      delete handleForProfileNameByIdentityId[identityId];                                                             // 205
    }                                                                                                                  // 206
  };                                                                                                                   // 207
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 209
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 210
    if (handleForProfileName) {                                                                                        // 211
      return;                                                                                                          // 212
    }                                                                                                                  // 213
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 215
      _id: identityId                                                                                                  // 216
    }, {                                                                                                               // 215
      fields: {                                                                                                        // 218
        "profile.name": 1                                                                                              // 219
      }                                                                                                                // 218
    }).observeChanges({                                                                                                // 217
      added: function () {                                                                                             // 222
        function added(id, fields) {                                                                                   // 222
          _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                            // 223
        }                                                                                                              // 224
                                                                                                                       //
        return added;                                                                                                  // 222
      }(),                                                                                                             // 222
                                                                                                                       //
      changed: function () {                                                                                           // 226
        function changed(id, fields) {                                                                                 // 226
          _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                          // 227
        }                                                                                                              // 228
                                                                                                                       //
        return changed;                                                                                                // 226
      }(),                                                                                                             // 226
                                                                                                                       //
      removed: function () {                                                                                           // 230
        function removed(id) {                                                                                         // 230
          stopWatchingIdentity(id);                                                                                    // 231
        }                                                                                                              // 232
                                                                                                                       //
        return removed;                                                                                                // 230
      }()                                                                                                              // 230
    });                                                                                                                // 221
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 235
  };                                                                                                                   // 236
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 238
    _id: this.userId,                                                                                                  // 239
    referredIdentityIds: { $exists: true }                                                                             // 240
  }, {                                                                                                                 // 238
    fields: {                                                                                                          // 242
      referredIdentityIds: true                                                                                        // 243
    }                                                                                                                  // 242
  }).observeChanges({                                                                                                  // 241
    // `added` gets called when a user gets their first completed referral.                                            // 246
    added: function () {                                                                                               // 247
      function added(id, fields) {                                                                                     // 247
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 248
          // Unconditionally mark these as successful referrals and start watching.                                    // 249
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 250
        }                                                                                                              // 252
      }                                                                                                                // 253
                                                                                                                       //
      return added;                                                                                                    // 247
    }(),                                                                                                               // 247
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              // 254
    // referral becomes complete.                                                                                      // 255
    changed: function () {                                                                                             // 256
      function changed(id, fields) {                                                                                   // 256
        // Two major tasks.                                                                                            // 257
        //                                                                                                             // 258
        // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                           // 259
        //                                                                                                             // 260
        // 2. Look for identityIds to subscribe to.                                                                    // 261
                                                                                                                       //
        // Task 1. Unsubscribe where needed.                                                                           // 263
        var referredIdentityIdsAsObject = {};                                                                          // 264
        fields.referredIdentityIds.forEach(function (i) {                                                              // 265
          referredIdentityIdsAsObject[i] = true;                                                                       // 265
        });                                                                                                            // 265
                                                                                                                       //
        Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                  // 267
          // If the handle doesn't show up in the new list of referredIdentityIds, then remove                         // 268
          // info from the client & stop it on the server & make it null.                                              // 269
          var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                     // 270
          if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                // 271
            stopWatchingIdentity(identityId);                                                                          // 272
          }                                                                                                            // 273
        });                                                                                                            // 274
                                                                                                                       //
        // Task 2. Subscribe where needed.                                                                             // 276
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 277
          // The watch... function will avoid double-creating subscriptions, so this is safe.                          // 278
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 279
        }                                                                                                              // 280
      }                                                                                                                // 281
                                                                                                                       //
      return changed;                                                                                                  // 256
    }(),                                                                                                               // 256
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          // 282
    removed: function () {                                                                                             // 283
      function removed() {                                                                                             // 283
        // Remove all data from client; stop all handles.                                                              // 284
        stopWatchingAllIdentities();                                                                                   // 285
      }                                                                                                                // 286
                                                                                                                       //
      return removed;                                                                                                  // 283
    }()                                                                                                                // 283
  });                                                                                                                  // 245
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    // 289
  this.onStop(function () {                                                                                            // 290
    stopWatchingAllIdentities();                                                                                       // 291
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 292
    completedIdentityIdsHandle.stop();                                                                                 // 293
  });                                                                                                                  // 294
                                                                                                                       //
  this.ready();                                                                                                        // 296
});                                                                                                                    // 297
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 299
  var _this4 = this;                                                                                                   // 299
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 300
  var anonCount = 0;                                                                                                   // 301
  var counter = 0;                                                                                                     // 302
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 304
    name = name.trim();                                                                                                // 305
    if (name === "") {                                                                                                 // 306
      ++anonCount;                                                                                                     // 307
    } else {                                                                                                           // 308
      _this4.added("backers", counter++, { name: name });                                                              // 309
    }                                                                                                                  // 310
  });                                                                                                                  // 311
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    // 313
  --anonCount;                                                                                                         // 314
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 316
                                                                                                                       //
  this.ready();                                                                                                        // 318
});                                                                                                                    // 319
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           // 17
// users of the Sandstorm server).                                                                                     // 18
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function () {                                                                                          // 26
    function useSignupKey(key) {                                                                                       // 26
      check(key, String);                                                                                              // 27
                                                                                                                       //
      if (!this.userId) {                                                                                              // 29
        throw new Meteor.Error(403, "Must be signed in.");                                                             // 30
      }                                                                                                                // 31
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 33
      if (user.signupKey) {                                                                                            // 34
        // Don't waste it.                                                                                             // 35
        return;                                                                                                        // 36
      }                                                                                                                // 37
                                                                                                                       //
      if (isDemoUser()) {                                                                                              // 39
        throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");           // 40
      }                                                                                                                // 42
                                                                                                                       //
      if (!user.loginIdentities) {                                                                                     // 44
        // Don't consume signup key as identity user.                                                                  // 45
        return;                                                                                                        // 46
      }                                                                                                                // 47
                                                                                                                       //
      var keyInfo = SignupKeys.findOne(key);                                                                           // 49
      if (!keyInfo || keyInfo.used) {                                                                                  // 50
        throw new Meteor.Error(403, "Invalid key or already used.");                                                   // 51
      }                                                                                                                // 52
                                                                                                                       //
      if (isSignedUp() && user.payments && user.payments.id) {                                                         // 54
        // This user is already signed up with a payment account. Possibly, they signed up before                      // 55
        // using their invite, and then went back and clicked on the invite. As a result they                          // 56
        // probably now have two payment accounts. Mark this invite as used but also add a special                     // 57
        // flag so we can find it later and cancel the dupe payment account. Record who tried to                       // 58
        // use it so that we can transfer credits over if needed.                                                      // 59
        SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                     // 60
        return;                                                                                                        // 61
      }                                                                                                                // 62
                                                                                                                       //
      var userFields = {                                                                                               // 64
        signupKey: key,                                                                                                // 65
        signupNote: keyInfo.note                                                                                       // 66
      };                                                                                                               // 64
      if (keyInfo.email) {                                                                                             // 68
        userFields.signupEmail = keyInfo.email;                                                                        // 69
      }                                                                                                                // 70
                                                                                                                       //
      if ("quota" in keyInfo) {                                                                                        // 72
        userFields.quota = keyInfo.quota;                                                                              // 73
      }                                                                                                                // 74
                                                                                                                       //
      if (keyInfo.plan) {                                                                                              // 76
        userFields.plan = keyInfo.plan;                                                                                // 77
      }                                                                                                                // 78
                                                                                                                       //
      if (keyInfo.payments) {                                                                                          // 80
        userFields["payments.id"] = keyInfo.payments.id;                                                               // 81
      }                                                                                                                // 82
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: userFields });                                                          // 84
      SignupKeys.update(key, { $set: { used: true } });                                                                // 85
    }                                                                                                                  // 86
                                                                                                                       //
    return useSignupKey;                                                                                               // 26
  }()                                                                                                                  // 26
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"standalone-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/standalone-server.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
Meteor.publish("standaloneDomain", function (domain) {                                                                 // 17
  check(domain, String);                                                                                               // 18
                                                                                                                       //
  return globalDb.collections.standaloneDomains.find({ _id: domain });                                                 // 20
});                                                                                                                    // 21
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         // 17
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    // 25
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    // If the only thing that happened is some trailing slashes got removed, then don't reset OAuth                    // 29
    // providers.                                                                                                      // 30
    var resetOAuth = true;                                                                                             // 31
    if (baseUrlRow.value.replace(/[/]*$/, "") === ROOT_URL) {                                                          // 32
      console.log("Not resetting OAuth because old ROOT_URL and new ROOT_URL differ only by trailing slashes.");       // 33
      resetOAuth = false;                                                                                              // 34
    }                                                                                                                  // 35
                                                                                                                       //
    if (resetOAuth) {                                                                                                  // 37
      console.log("resetting oauth");                                                                                  // 38
      Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                               // 39
        if (!!setting.value) {                                                                                         // 40
          Settings.update({ _id: setting._id }, { $set: { value: false,                                                // 41
              automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                       // 43
        }                                                                                                              // 44
      });                                                                                                              // 45
    }                                                                                                                  // 46
                                                                                                                       //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 48
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 49
  }                                                                                                                    // 50
});                                                                                                                    // 51
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  // 27
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         // 33
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   // 36
  // during the requested time period.                                                                                 // 37
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   // 44
  // the requested time period.                                                                                        // 45
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         // 48
  // contains records of type `user` and `appDemoUser`, indicating                                                     // 49
  // the number of those types of accounts that were created and                                                       // 50
  // then auto-expired through the demo mode's auto-account-expiry.                                                    // 51
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           // 57
  // fact in DeleteStats with type: "grain".                                                                           // 58
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in meteorBabelHelpers.sanitizeForInObject(apps)) {                                                    // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         // 81
    // have to fetch a list of grainIds first.                                                                         // 82
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        // 83
    //   already denormalized for the specific case of apps that don't have icons, but the data                        // 84
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        // 85
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         // 86
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     // 87
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          // 88
    //   revealed to the user.                                                                                         // 89
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   // 126
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var postStats = function postStats(record) {                                                                         // 168
    HTTP.post("https://alpha-api.sandstorm.io/data", {                                                                 // 169
      data: record,                                                                                                    // 170
      headers: {                                                                                                       // 171
        Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                           // 172
        "Content-Type": "application/json"                                                                             // 173
      }                                                                                                                // 171
    });                                                                                                                // 169
  };                                                                                                                   // 176
                                                                                                                       //
  var now = new Date();                                                                                                // 178
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 186
    timestamp: now,                                                                                                    // 187
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 188
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 189
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 190
    forever: computeStats(new Date(0)),                                                                                // 191
    plans: planStats                                                                                                   // 192
  };                                                                                                                   // 186
  record.computeTime = Date.now() - now;                                                                               // 194
  if (global.BlackrockPayments && global.BlackrockPayments.getTotalCharges) {                                          // 195
    // This only exists under Blackrock                                                                                // 196
    record.totalCharges = global.BlackrockPayments.getTotalCharges();                                                  // 197
  }                                                                                                                    // 198
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 200
  var age = ActivityStats.find().count();                                                                              // 201
  // The stats page which the user agreed we can send actually displays the whole history                              // 202
  // of the server, but we're only sending stats from the last day. Let's also throw in the                            // 203
  // length of said history. This is still strictly less information than what the user said                           // 204
  // we're allowed to send.                                                                                            // 205
  record.serverAge = age;                                                                                              // 206
                                                                                                                       //
  if (age > 3) {                                                                                                       // 208
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 209
                                                                                                                       //
    if (!reportSetting) {                                                                                              // 211
      // Setting not set yet, send out notifications and set it to false                                               // 212
      globalDb.sendAdminNotification("reportStats", "/admin/stats");                                                   // 213
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 214
    } else if (reportSetting.value === true) {                                                                         // 215
      postStats(record);                                                                                               // 216
    }                                                                                                                  // 217
  }                                                                                                                    // 218
}                                                                                                                      // 219
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 221
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            // 222
  // (Only on the first replica to avoid conflicts.)                                                                   // 223
  Meteor.setTimeout(function () {                                                                                      // 224
    Meteor.setInterval(function () {                                                                                   // 225
      recordStats();                                                                                                   // 226
    }, DAY_MS);                                                                                                        // 227
                                                                                                                       //
    recordStats();                                                                                                     // 229
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 230
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 232
    if (StatsTokens.find().count() === 0) {                                                                            // 233
      StatsTokens.remove({});                                                                                          // 234
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 235
    }                                                                                                                  // 236
  });                                                                                                                  // 237
}                                                                                                                      // 238
                                                                                                                       //
Meteor.methods({                                                                                                       // 240
  regenerateStatsToken: function () {                                                                                  // 241
    function regenerateStatsToken() {                                                                                  // 241
      if (!isAdmin()) {                                                                                                // 242
        throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                             // 243
      }                                                                                                                // 244
                                                                                                                       //
      StatsTokens.remove({});                                                                                          // 246
      var token = StatsTokens.insert({ _id: Random.id(22) });                                                          // 247
      return token._id;                                                                                                // 248
    }                                                                                                                  // 249
                                                                                                                       //
    return regenerateStatsToken;                                                                                       // 241
  }()                                                                                                                  // 241
});                                                                                                                    // 240
                                                                                                                       //
Router.map(function () {                                                                                               // 252
  this.route("fetchStats", {                                                                                           // 253
    where: "server",                                                                                                   // 254
    path: "/fetchStats/:tokenId",                                                                                      // 255
    action: function () {                                                                                              // 256
      function action() {                                                                                              // 256
        var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                 // 257
                                                                                                                       //
        if (!token) {                                                                                                  // 259
          this.response.writeHead(404, {                                                                               // 260
            "Content-Type": "text/plain"                                                                               // 261
          });                                                                                                          // 260
          this.response.write("Token not found");                                                                      // 263
          return this.response.end();                                                                                  // 264
        }                                                                                                              // 265
                                                                                                                       //
        try {                                                                                                          // 267
          var stats = ActivityStats.find().fetch();                                                                    // 268
          var statsString = JSON.stringify(stats);                                                                     // 269
                                                                                                                       //
          this.response.writeHead(200, {                                                                               // 271
            "Content-Type": "application/json"                                                                         // 272
          });                                                                                                          // 271
          this.response.write(statsString);                                                                            // 274
        } catch (error) {                                                                                              // 275
          console.error(error.stack);                                                                                  // 276
          this.response.writeHead(500, {                                                                               // 277
            "Content-Type": "text/plain"                                                                               // 278
          });                                                                                                          // 277
          this.response.write(error.stack);                                                                            // 280
        }                                                                                                              // 281
                                                                                                                       //
        return this.response.end();                                                                                    // 283
      }                                                                                                                // 284
                                                                                                                       //
      return action;                                                                                                   // 256
    }()                                                                                                                // 256
  });                                                                                                                  // 253
});                                                                                                                    // 286
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// TODO(someday): split out fields by locus                                                                            // 17
// isEnabled is available on both client and server                                                                    // 18
// getLoginId is only used on server                                                                                   // 19
// initiateLogin and loginTemplate are only used on client                                                             // 20
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 22
  var setting = Settings.findOne({ _id: name });                                                                       // 23
  return setting && !!setting.value;                                                                                   // 24
}                                                                                                                      // 25
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 27
  isEnabled: function () {                                                                                             // 28
    function isEnabled() {                                                                                             // 28
      return serviceEnabled("github");                                                                                 // 29
    }                                                                                                                  // 30
                                                                                                                       //
    return isEnabled;                                                                                                  // 28
  }(),                                                                                                                 // 28
                                                                                                                       //
  getLoginId: function () {                                                                                            // 32
    function getLoginId(identity) {                                                                                    // 32
      return identity.services.github.username;                                                                        // 33
    }                                                                                                                  // 34
                                                                                                                       //
    return getLoginId;                                                                                                 // 32
  }(),                                                                                                                 // 32
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 36
    function initiateLogin(loginId) {                                                                                  // 36
      Meteor.loginWithGithub();                                                                                        // 37
      return { oneClick: true };                                                                                       // 38
    }                                                                                                                  // 39
                                                                                                                       //
    return initiateLogin;                                                                                              // 36
  }(),                                                                                                                 // 36
                                                                                                                       //
  loginTemplate: {                                                                                                     // 41
    name: "oauthLoginButton",                                                                                          // 42
    priority: 1,                                                                                                       // 43
    data: {                                                                                                            // 44
      method: "loginWithGithub",                                                                                       // 45
      name: "github",                                                                                                  // 46
      displayName: "GitHub",                                                                                           // 47
      linkingNewIdentity: false                                                                                        // 48
    }                                                                                                                  // 44
  }                                                                                                                    // 41
};                                                                                                                     // 27
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 53
  isEnabled: function () {                                                                                             // 54
    function isEnabled() {                                                                                             // 54
      return serviceEnabled("google");                                                                                 // 55
    }                                                                                                                  // 56
                                                                                                                       //
    return isEnabled;                                                                                                  // 54
  }(),                                                                                                                 // 54
                                                                                                                       //
  getLoginId: function () {                                                                                            // 58
    function getLoginId(identity) {                                                                                    // 58
      return identity.services.google.email;                                                                           // 59
    }                                                                                                                  // 60
                                                                                                                       //
    return getLoginId;                                                                                                 // 58
  }(),                                                                                                                 // 58
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 62
    function initiateLogin(loginId) {                                                                                  // 62
      Meteor.loginWithGoogle({ loginHint: loginId });                                                                  // 63
      return { oneClick: true };                                                                                       // 64
    }                                                                                                                  // 65
                                                                                                                       //
    return initiateLogin;                                                                                              // 62
  }(),                                                                                                                 // 62
                                                                                                                       //
  loginTemplate: {                                                                                                     // 67
    name: "oauthLoginButton",                                                                                          // 68
    priority: 2,                                                                                                       // 69
    data: {                                                                                                            // 70
      method: "loginWithGoogle",                                                                                       // 71
      name: "google",                                                                                                  // 72
      displayName: "Google",                                                                                           // 73
      linkingNewIdentity: false                                                                                        // 74
    }                                                                                                                  // 70
  }                                                                                                                    // 67
};                                                                                                                     // 53
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 79
  isEnabled: function () {                                                                                             // 80
    function isEnabled() {                                                                                             // 80
      return serviceEnabled("emailToken");                                                                             // 81
    }                                                                                                                  // 82
                                                                                                                       //
    return isEnabled;                                                                                                  // 80
  }(),                                                                                                                 // 80
                                                                                                                       //
  getLoginId: function () {                                                                                            // 84
    function getLoginId(identity) {                                                                                    // 84
      return identity.services.email.email;                                                                            // 85
    }                                                                                                                  // 86
                                                                                                                       //
    return getLoginId;                                                                                                 // 84
  }(),                                                                                                                 // 84
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 88
    function initiateLogin(loginId) {                                                                                  // 88
      return { form: true };                                                                                           // 89
    }                                                                                                                  // 90
                                                                                                                       //
    return initiateLogin;                                                                                              // 88
  }(),                                                                                                                 // 88
                                                                                                                       //
  loginTemplate: {                                                                                                     // 92
    name: "emailLoginForm",                                                                                            // 93
    priority: 10                                                                                                       // 94
  }                                                                                                                    // 92
};                                                                                                                     // 79
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 98
  isEnabled: function () {                                                                                             // 99
    function isEnabled() {                                                                                             // 99
      return serviceEnabled("ldap");                                                                                   // 100
    }                                                                                                                  // 101
                                                                                                                       //
    return isEnabled;                                                                                                  // 99
  }(),                                                                                                                 // 99
                                                                                                                       //
  getLoginId: function () {                                                                                            // 103
    function getLoginId(identity) {                                                                                    // 103
      return identity.services.ldap.username;                                                                          // 104
    }                                                                                                                  // 105
                                                                                                                       //
    return getLoginId;                                                                                                 // 103
  }(),                                                                                                                 // 103
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 107
    function initiateLogin(loginId) {                                                                                  // 107
      return { form: true };                                                                                           // 108
    }                                                                                                                  // 109
                                                                                                                       //
    return initiateLogin;                                                                                              // 107
  }(),                                                                                                                 // 107
                                                                                                                       //
  loginTemplate: {                                                                                                     // 111
    name: "ldapLoginForm",                                                                                             // 112
    priority: 21 }                                                                                                     // 113
};                                                                                                                     // 98
                                                                                                                       //
Accounts.identityServices.saml = {                                                                                     // 117
  isEnabled: function () {                                                                                             // 118
    function isEnabled() {                                                                                             // 118
      return serviceEnabled("saml");                                                                                   // 119
    }                                                                                                                  // 120
                                                                                                                       //
    return isEnabled;                                                                                                  // 118
  }(),                                                                                                                 // 118
                                                                                                                       //
  getLoginId: function () {                                                                                            // 122
    function getLoginId(identity) {                                                                                    // 122
      return identity.services.saml.id;                                                                                // 123
    }                                                                                                                  // 124
                                                                                                                       //
    return getLoginId;                                                                                                 // 122
  }(),                                                                                                                 // 122
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 126
    function initiateLogin(loginId) {                                                                                  // 126
      Meteor.loginWithSaml();                                                                                          // 127
      return { oneClick: true };                                                                                       // 128
    }                                                                                                                  // 129
                                                                                                                       //
    return initiateLogin;                                                                                              // 126
  }(),                                                                                                                 // 126
                                                                                                                       //
  loginTemplate: {                                                                                                     // 131
    name: "samlLoginForm",                                                                                             // 132
    priority: 20 }                                                                                                     // 133
};                                                                                                                     // 117
                                                                                                                       //
Accounts.identityServices.demo = {                                                                                     // 137
  isEnabled: function () {                                                                                             // 138
    function isEnabled() {                                                                                             // 138
      return false; // You can never authenticate as a demo user.                                                      // 139
    }                                                                                                                  // 140
                                                                                                                       //
    return isEnabled;                                                                                                  // 138
  }(),                                                                                                                 // 138
                                                                                                                       //
  getLoginId: function () {                                                                                            // 142
    function getLoginId(identity) {                                                                                    // 142
      return identity._id;                                                                                             // 143
    }                                                                                                                  // 144
                                                                                                                       //
    return getLoginId;                                                                                                 // 142
  }(),                                                                                                                 // 142
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 146
    function initiateLogin(loginId) {                                                                                  // 146
      return { demoCannotLogin: true };                                                                                // 147
    }                                                                                                                  // 148
                                                                                                                       //
    return initiateLogin;                                                                                              // 146
  }(),                                                                                                                 // 146
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 150
};                                                                                                                     // 137
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function () {                                                                                             // 18
    function isEnabled() {                                                                                             // 18
      return globalDb.allowDevAccounts();                                                                              // 19
    }                                                                                                                  // 20
                                                                                                                       //
    return isEnabled;                                                                                                  // 18
  }(),                                                                                                                 // 18
                                                                                                                       //
  getLoginId: function () {                                                                                            // 22
    function getLoginId(identity) {                                                                                    // 22
      return identity.services.dev.name;                                                                               // 23
    }                                                                                                                  // 24
                                                                                                                       //
    return getLoginId;                                                                                                 // 22
  }(),                                                                                                                 // 22
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 26
    function initiateLogin(loginId) {                                                                                  // 26
      loginDevAccount(loginId);                                                                                        // 27
      return { oneClick: true };                                                                                       // 28
    }                                                                                                                  // 29
                                                                                                                       //
    return initiateLogin;                                                                                              // 26
  }(),                                                                                                                 // 26
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        // 18
  // potential.                                                                                                        // 19
  //                                                                                                                   // 20
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             // 21
                                                                                                                       //
  markActivityReadByOwner: function () {                                                                               // 23
    function markActivityReadByOwner(grainId) {                                                                        // 23
      check(grainId, String);                                                                                          // 24
      check(this.userId, String);                                                                                      // 25
                                                                                                                       //
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                // 27
    }                                                                                                                  // 29
                                                                                                                       //
    return markActivityReadByOwner;                                                                                    // 23
  }(),                                                                                                                 // 23
                                                                                                                       //
  markActivityRead: function () {                                                                                      // 31
    function markActivityRead(grainId, identityId) {                                                                   // 31
      check(grainId, String);                                                                                          // 32
      check(identityId, String);                                                                                       // 33
                                                                                                                       //
      if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                        // 35
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 36
      }                                                                                                                // 37
                                                                                                                       //
      ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
    }                                                                                                                  // 41
                                                                                                                       //
    return markActivityRead;                                                                                           // 31
  }(),                                                                                                                 // 31
                                                                                                                       //
  moveGrainsToTrash: function () {                                                                                     // 43
    function moveGrainsToTrash(grainIds) {                                                                             // 43
      var _this = this;                                                                                                // 43
                                                                                                                       //
      check(grainIds, [String]);                                                                                       // 44
                                                                                                                       //
      if (this.userId) {                                                                                               // 46
        Grains.update({ userId: { $eq: this.userId },                                                                  // 47
          _id: { $in: grainIds },                                                                                      // 48
          trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                          // 49
                                                                                                                       //
        var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                               // 53
                                                                                                                       //
        ApiTokens.update({ grainId: { $in: grainIds },                                                                 // 55
          "owner.user.identityId": { $in: identityIds },                                                               // 56
          trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                        // 57
                                                                                                                       //
        if (!this.isSimulation) {                                                                                      // 61
          var grainsOwned = Grains.find({                                                                              // 62
            userId: { $eq: this.userId },                                                                              // 63
            _id: { $in: grainIds }                                                                                     // 64
          }, { fields: { _id: 1 } });                                                                                  // 62
                                                                                                                       //
          grainsOwned.forEach(function (grain) {                                                                       // 67
            Sessions.remove({ grainId: grain._id });                                                                   // 68
            try {                                                                                                      // 69
              _this.connection.sandstormBackend.shutdownGrain(grain._id, _this.userId).await();                        // 70
            } catch (err) {                                                                                            // 71
              console.error("Failed to shutdown trashed grain", grain._id, err);                                       // 72
            }                                                                                                          // 73
          });                                                                                                          // 74
        }                                                                                                              // 75
      }                                                                                                                // 76
    }                                                                                                                  // 77
                                                                                                                       //
    return moveGrainsToTrash;                                                                                          // 43
  }(),                                                                                                                 // 43
                                                                                                                       //
  moveGrainsOutOfTrash: function () {                                                                                  // 79
    function moveGrainsOutOfTrash(grainIds) {                                                                          // 79
      check(grainIds, [String]);                                                                                       // 80
                                                                                                                       //
      if (this.userId) {                                                                                               // 82
        Grains.update({ userId: { $eq: this.userId },                                                                  // 83
          _id: { $in: grainIds },                                                                                      // 84
          trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                  // 85
                                                                                                                       //
        var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                               // 89
                                                                                                                       //
        ApiTokens.update({ grainId: { $in: grainIds },                                                                 // 91
          "owner.user.identityId": { $in: identityIds },                                                               // 92
          "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                              // 93
      }                                                                                                                // 96
    }                                                                                                                  // 97
                                                                                                                       //
    return moveGrainsOutOfTrash;                                                                                       // 79
  }(),                                                                                                                 // 79
                                                                                                                       //
  deleteGrain: function () {                                                                                           // 99
    function deleteGrain(grainId) {                                                                                    // 99
      check(grainId, String);                                                                                          // 100
                                                                                                                       //
      if (this.userId) {                                                                                               // 102
        var grainsQuery = {                                                                                            // 103
          _id: grainId,                                                                                                // 104
          userId: this.userId,                                                                                         // 105
          trashed: { $exists: true }                                                                                   // 106
        };                                                                                                             // 103
                                                                                                                       //
        var numDeleted = 0;                                                                                            // 109
        if (this.isSimulation) {                                                                                       // 110
          numDeleted = Grains.remove(grainsQuery);                                                                     // 111
        } else {                                                                                                       // 112
          numDeleted = globalDb.deleteGrains(grainsQuery, globalBackend, isDemoUser() ? "demoGrain" : "grain");        // 113
        }                                                                                                              // 115
                                                                                                                       //
        // Usually we don't automatically remove user-owned tokens that have become invalid,                           // 117
        // because if we did their owner might become confused as to why they have mysteriously                        // 118
        // disappeared. In this particular case, however, for tokens held by the grain owner,                          // 119
        // there should be no confusion. Indeed, it would be more confusing *not* to remove these                      // 120
        // tokens, because then the grain could still show up in the trash bin as a "shared with me"                   // 121
        // grain after the owner clicks "delete permanently".                                                          // 122
        //                                                                                                             // 123
        // Note that these tokens may be visible to other accounts if there are identities shared                      // 124
        // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                      // 125
        // case too.                                                                                                   // 126
        var apiTokensQuery = {                                                                                         // 127
          grainId: grainId,                                                                                            // 128
          "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                             // 129
          "trashed": { $exists: true }                                                                                 // 130
        };                                                                                                             // 127
                                                                                                                       //
        if (numDeleted > 0) {                                                                                          // 133
          if (this.isSimulation) {                                                                                     // 134
            ApiTokens.remove(apiTokensQuery);                                                                          // 135
          } else {                                                                                                     // 136
            globalDb.removeApiTokens(apiTokensQuery);                                                                  // 137
          }                                                                                                            // 138
        }                                                                                                              // 139
      }                                                                                                                // 140
    }                                                                                                                  // 141
                                                                                                                       //
    return deleteGrain;                                                                                                // 99
  }(),                                                                                                                 // 99
                                                                                                                       //
  forgetGrain: function () {                                                                                           // 143
    function forgetGrain(grainId, identityId) {                                                                        // 143
      check(grainId, String);                                                                                          // 144
      check(identityId, String);                                                                                       // 145
                                                                                                                       //
      if (!this.userId) {                                                                                              // 147
        throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                           // 148
      }                                                                                                                // 149
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 151
        throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                          // 152
      }                                                                                                                // 153
                                                                                                                       //
      var query = {                                                                                                    // 155
        grainId: grainId,                                                                                              // 156
        "owner.user.identityId": identityId,                                                                           // 157
        "trashed": { $exists: true }                                                                                   // 158
      };                                                                                                               // 155
                                                                                                                       //
      if (this.isSimulation) {                                                                                         // 161
        ApiTokens.remove(query);                                                                                       // 162
      } else {                                                                                                         // 163
        globalDb.removeApiTokens(query);                                                                               // 164
      }                                                                                                                // 165
    }                                                                                                                  // 166
                                                                                                                       //
    return forgetGrain;                                                                                                // 143
  }()                                                                                                                  // 143
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
isSafeDemoAppUrl = function () {                                                                                       // 17
    function isSafeDemoAppUrl(url) {                                                                                   // 17
        // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)               // 18
        // and we allow specifying a sandstorm.io URL.                                                                 // 19
        return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
    }                                                                                                                  // 25
                                                                                                                       //
    return isSafeDemoAppUrl;                                                                                           // 17
}();                                                                                                                   // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 // 20
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function () {                                                                            // 35
          function createMockGithubUser() {                                                                            // 35
            Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            // 39
                                                                                                                       //
          return createMockGithubUser;                                                                                 // 35
        }(),                                                                                                           // 35
                                                                                                                       //
        clearMockGithubUser: function () {                                                                             // 41
          function clearMockGithubUser() {                                                                             // 41
            clearUser("Py8fwsaryQNGBuiXb");                                                                            // 42
          }                                                                                                            // 43
                                                                                                                       //
          return clearMockGithubUser;                                                                                  // 41
        }(),                                                                                                           // 41
                                                                                                                       //
        createMockGoogleUser: function () {                                                                            // 45
          function createMockGoogleUser() {                                                                            // 45
            Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            // 49
                                                                                                                       //
          return createMockGoogleUser;                                                                                 // 45
        }(),                                                                                                           // 45
                                                                                                                       //
        clearMockGoogleUser: function () {                                                                             // 51
          function clearMockGoogleUser() {                                                                             // 51
            clearUser("6WJcRo2gg2Ysuxsok");                                                                            // 52
          }                                                                                                            // 53
                                                                                                                       //
          return clearMockGoogleUser;                                                                                  // 51
        }(),                                                                                                           // 51
                                                                                                                       //
        fetchAppIndexTest: function () {                                                                               // 55
          function fetchAppIndexTest() {                                                                               // 55
            globalDb.collections.appIndex.remove({});                                                                  // 56
            SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                       // 57
          }                                                                                                            // 58
                                                                                                                       //
          return fetchAppIndexTest;                                                                                    // 55
        }()                                                                                                            // 55
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 60
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 62
    Meteor.call("createMockGithubUser", function (err) {                                                               // 63
      if (err) {                                                                                                       // 64
        console.log(err);                                                                                              // 65
      }                                                                                                                // 66
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 68
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 69
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 70
      window.location.reload();                                                                                        // 71
    });                                                                                                                // 72
  };                                                                                                                   // 73
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 75
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 76
      if (err) {                                                                                                       // 77
        console.log(err);                                                                                              // 78
      }                                                                                                                // 79
    });                                                                                                                // 80
  };                                                                                                                   // 81
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 83
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 84
      if (err) {                                                                                                       // 85
        console.log(err);                                                                                              // 86
      }                                                                                                                // 87
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 89
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 90
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 91
      window.location.reload();                                                                                        // 92
    });                                                                                                                // 93
  };                                                                                                                   // 94
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 96
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 97
      if (err) {                                                                                                       // 98
        console.log(err);                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 101
  };                                                                                                                   // 102
}                                                                                                                      // 103
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/accounts/email-token/token-server.js");
require("./server/accounts/identity/identity-server.js");
require("./server/accounts/ldap/ldap-server.js");
require("./server/accounts/saml/saml-server.js");
require("./server/accounts/accounts-server.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/account-suspension.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/contacts-server.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/standalone-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
