(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file defines the database schema.                                                                              // 17
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         // 19
// query it makes, so you can see if it's doing queries too often, etc.                                                // 20
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      // 29
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            // 36
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           // 39
// so that we can be extra certain that all mutations must go through methods.                                         // 40
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              // 42
// The users collection is special and can be accessed through `Meteor.users`.                                         // 43
// See https://docs.meteor.com/#/full/meteor_users.                                                                    // 44
//                                                                                                                     // 45
// There are two distinct types of entries in the users collection: identities and accounts. An                        // 46
// identity contains personal profile information and typically includes some intrinsic method for                     // 47
// authenticating as the owner of that information.                                                                    // 48
//                                                                                                                     // 49
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           // 50
// Each account can have multiple identities linked to it. To log in as an account you must first                      // 51
// authenticate as one of its linked identities.                                                                       // 52
//                                                                                                                     // 53
// Every user contains the following fields:                                                                           // 54
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         // 55
//        stable SHA-256 ID of this identity, hex-encoded.                                                             // 56
//   createdAt: Date when this entry was added to the collection.                                                      // 57
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                // 58
//   services: Object containing login data used by Meteor authentication services.                                    // 59
//   expires: Date when this user should be deleted. Only present for demo users.                                      // 60
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        // 61
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   // 62
//                     rather than as a Date object. We should fix that.                                               // 63
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     // 64
//              link. This field contains the app ID of the app that the user started out demoing.                     // 65
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      // 66
//              being a demo user.                                                                                     // 67
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       // 68
//              can be suspended. After some amount of time, the user will be completely deleted                       // 69
//              and removed from the DB.                                                                               // 70
//              It is an object with fields:                                                                           // 71
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        // 72
//                  chance to still login and reverse the suspension/deletion.                                         // 73
//                admin: The userId of the admin who suspended the account.                                            // 74
//                timestamp: Date object. When the suspension occurred.                                                // 75
//                willDelete: Boolean. If true, this account will be deleted after some time.                          // 76
//                                                                                                                     // 77
// Identity users additionally contain the following fields:                                                           // 78
//   profile: Object containing the data that will be shared with users and grains that come into                      // 79
//            contact with this identity. Includes the following fields:                                               // 80
//       service: String containing the name of this identity's authentication method.                                 // 81
//       name: String containing the chosen display name of the identity.                                              // 82
//       handle: String containing the identity's preferred handle.                                                    // 83
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          // 84
//                an identicon will be used.                                                                           // 85
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      // 86
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          // 87
//   referredBy: ID of the Account that referred this Identity.                                                        // 88
//                                                                                                                     // 89
// Account users additionally contain the following fields:                                                            // 90
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       // 91
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             // 92
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      // 93
//                       a separate array here so that we can use a Mongo index to enforce the                         // 94
//                       invariant that an identity only be a login identity for a single account.                     // 95
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   // 96
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        // 97
//                 to do this checking automatically.                                                                  // 98
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  // 99
//   signupKey: If this is an invited user, then this field contains their signup key.                                 // 100
//   signupNote: If the user was invited through a link, then this field contains the note that the                    // 101
//               inviter admin attached to the key.                                                                    // 102
//   signupEmail: If the user was invited by email, then this field contains the email address that                    // 103
//                the invite was sent to.                                                                              // 104
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    // 105
//                       terms of service.                                                                             // 106
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       // 107
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       // 108
//              module writes data here; we merely read it. Missing fields should be treated as                        // 109
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           // 110
//              TODO(cleanup): Use for referral bonus too.                                                             // 111
//   storageUsage: Number of bytes this user is currently storing.                                                     // 112
//   payments: Object defined by payments module, if loaded.                                                           // 113
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 // 114
//   accessRequests: Object containing the following fields; used to limit spam.                                       // 115
//       count: Number of "request access" emails during sent during the current interval.                             // 116
//       resetOn: Date when the count should be reset.                                                                 // 117
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              // 118
//                        stop writing new referredBy values onto Identities for this account.                         // 119
//   referredCompleteDate: The Date at which the completed referral occurred.                                          // 120
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        // 121
//                        reliably determining which Identity's names are safe to display.                             // 122
//   experiments: Object where each field is an experiment that the user is in, and each value                         // 123
//           is the parameters for that experiment. Typically, the value simply names which                            // 124
//           experiment group which the user is in, where "control" is one group. If an experiment                     // 125
//           is not listed, then the user should not be considered at all for the purpose of that                      // 126
//           experiment. Each experiment may define a point in time where users not already in the                     // 127
//           experiment may be added to it and assigned to a group (for example, at user creation                      // 128
//           time). Current experiments:                                                                               // 129
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         // 130
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       // 131
//               test group will see a plan selection dialog and asked to make an explitic choice                      // 132
//               (possibly "free") before they can create grains (but not when opening someone                         // 133
//               else's shared grain). The goal of the experiment is to determine whether this                         // 134
//               prompt scares users away -- and also whether it increases paid signups.                               // 135
//       freeGrainLimit: Value is "control" or or a number indicating the grain limit that the                         // 136
//               user should receive when on the "free" plan, e.g. "Infinity".                                         // 137
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       // 138
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              // 139
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 141
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 142
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 143
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 145
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 146
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 147
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 148
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   // 150
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 151
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 153
// Packages which are installed or downloading.                                                                        // 154
//                                                                                                                     // 155
// Each contains:                                                                                                      // 156
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    // 157
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   // 158
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                // 159
//       >1 = download byte count.                                                                                     // 160
//   error:  If status is "failed", error message string.                                                              // 161
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          // 162
//   appId:  If status is "ready", the application ID string.  Packages representing different                         // 163
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         // 164
//       and can cryptographically verify that a package belongs to a particular app ID.                               // 165
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        // 166
//       collector should at some point check whether there are any other references and, if not,                      // 167
//       delete the package.                                                                                           // 168
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         // 169
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    // 170
//     even if it has no users.                                                                                        // 171
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           // 172
//     packager.                                                                                                       // 173
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 175
// List of packages currently made available via the dev tools running on the local machine.                           // 176
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     // 177
// on the local machine to publish an under-development app to this server. That should only ever                      // 178
// happen on developers' desktop machines.                                                                             // 179
//                                                                                                                     // 180
// While a dev package is published, it automatically appears as installed by every user of the                        // 181
// server, and it overrides all packages with the same application ID. If any instances of those                       // 182
// packages are currently open, they are killed and reset on publish.                                                  // 183
//                                                                                                                     // 184
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     // 185
// are again killed and refreshed.                                                                                     // 186
//                                                                                                                     // 187
// Each contains:                                                                                                      // 188
//   _id:  The package ID string (as with Packages._id).                                                               // 189
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  // 190
//   timestamp:  Time when the package was last updated. If this changes while the package is                          // 191
//     published, all running instances are reset. This is used e.g. to reset the app each time                        // 192
//     changes are made to the source code.                                                                            // 193
//   manifest:  The app's manifest, as with Packages.manifest.                                                         // 194
//   mountProc: True if the supervisor should mount /proc.                                                             // 195
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 197
// List of actions that each user has installed which create new grains.  Each app may install                         // 198
// some number of actions (usually, one).                                                                              // 199
//                                                                                                                     // 200
// Each contains:                                                                                                      // 201
//   _id:  random                                                                                                      // 202
//   userId:  Account ID of the user who has installed this action.                                                    // 203
//   packageId:  Package used to run this action.                                                                      // 204
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 205
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 // 206
//       that clients can access it without subscribing to the Packages collection.                                    // 207
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 208
//       searchability.                                                                                                // 209
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               // 210
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     // 211
//       `{defaultText: "New Spreadsheet"}`.                                                                           // 212
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        // 213
//   command:  Manifest.Command to run this action (see package.capnp).                                                // 214
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 216
// Grains belonging to users.                                                                                          // 217
//                                                                                                                     // 218
// Each contains:                                                                                                      // 219
//   _id:  random                                                                                                      // 220
//   packageId:  _id of the package of which this grain is an instance.                                                // 221
//   packageSalt: If present, a random string that will used in session ID generation. This field                      // 222
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            // 223
//       clients with active sessions.                                                                                 // 224
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 225
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 226
//       searchability.                                                                                                // 227
//   userId: The _id of the account that owns this grain.                                                              // 228
//   identityId: The identity with which the owning account prefers to open this grain.                                // 229
//   title:  Human-readable string title, as chosen by the user.                                                       // 230
//   lastUsed:  Date when the grain was last used by a user.                                                           // 231
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    // 232
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    // 233
//                   time a session to this grain was opened.                                                          // 234
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       // 235
//            this date, the grain will be automatically deleted.                                                      // 236
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        // 237
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    // 238
//              of querying.                                                                                           // 239
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        // 240
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        // 241
//   size: On-disk size of the grain in bytes.                                                                         // 242
//                                                                                                                     // 243
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     // 244
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      // 245
// is implemented.                                                                                                     // 246
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     // 247
//       web publishing. This field is initialized when first requested by the app.                                    // 248
                                                                                                                       //
Grains.ensureIndexOnServer("cachedViewInfo.matchRequests.tags.id", { sparse: 1 });                                     // 250
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 252
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    // 253
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             // 254
// collection.                                                                                                         // 255
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 257
// Edges in the social graph.                                                                                          // 258
//                                                                                                                     // 259
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         // 260
// will show up in her user-picker UI for actions like share-by-identity.                                              // 261
//                                                                                                                     // 262
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        // 263
// Bob's.                                                                                                              // 264
//                                                                                                                     // 265
// Each contains:                                                                                                      // 266
//   _id: random                                                                                                       // 267
//   ownerId: The accountId of the user account who owns this contact.                                                 // 268
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        // 269
//            the contact to the owner.                                                                                // 270
//   created: Date when this contact was created.                                                                      // 271
//   identityId: The `_id` of the user whose contact info this contains.                                               // 272
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 274
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    // 275
//                                                                                                                     // 276
// Each contains:                                                                                                      // 277
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     // 278
//       client, and the grain's `packageSalt`.                                                                        // 279
//   grainId:  _id of the grain to which this session is connected.                                                    // 280
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     // 281
//       '*' in WILDCARD_HOST.                                                                                         // 282
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         // 283
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      // 284
//       have the same `tabId` as the outer session.                                                                   // 285
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        // 286
//       period.                                                                                                       // 287
//   userId:  Account ID of the user who owns this session.                                                            // 288
//   identityId:  Identity ID of the user who owns this session.                                                       // 289
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      // 290
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         // 291
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     // 292
//       are present.                                                                                                  // 293
//   powerboxView: Information about a server-initiated powerbox interaction taking place in this                      // 294
//       session. When the client sees a `powerboxView` appear on the session, it opens the                            // 295
//       powerbox popup according to the contents. This field is an object containing one of:                          // 296
//     offer: A capability is being offered to the user by the app. This is an object containing:                      // 297
//       token: For a non-UiView capability, the API token that can be used to restore this                            // 298
//           capability.                                                                                               // 299
//       uiView: A UiView capability. This object contains one of:                                                     // 300
//         tokenId: The _id of an ApiToken belonging to the current user.                                              // 301
//         token: A full webkey token which can be opened by an anonymous user.                                        // 302
//     fulfill: A capability is being offered which fulfills the active powerbox request. This                         // 303
//         is an object with members:                                                                                  // 304
//       token: The SturdyRef of the fulfilling capability. This token can only be used in a call                      // 305
//           to claimRequest() by the requesting                                                                       // 306
//           grain.                                                                                                    // 307
//       descriptor: Packed-base64 PowerboxDescriptor for the capability.                                              // 308
//   powerboxRequest: If present, this session is a powerbox request session. Object containing:                       // 309
//     descriptors: Array of PowerboxDescriptors representing the request.                                             // 310
//     requestingSession: Session ID of the session initiating the request.                                            // 311
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     // 312
//       until newSession is called on the UiView.                                                                     // 313
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        // 314
//       until newSession is called on the UiView.                                                                     // 315
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   // 316
//       request                                                                                                       // 317
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 319
// Invite keys which may be used by users to get access to Sandstorm.                                                  // 320
//                                                                                                                     // 321
// Each contains:                                                                                                      // 322
//   _id:  random                                                                                                      // 323
//   used:  Boolean indicating whether this key has already been consumed.                                             // 324
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          // 325
//   email: If this key was sent as an email invite, the email address to which it was sent.                           // 326
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 328
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  // 329
//                                                                                                                     // 330
// Each contains:                                                                                                      // 331
//   timestamp: Date when measurements were taken.                                                                     // 332
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   // 333
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           // 334
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           // 335
//                                                                                                                     // 336
// Each of daily, weekly, and monthly contains:                                                                        // 337
//   activeUsers: The number of unique users who have used a grain on the server in the time                           // 338
//       interval. Only counts logged-in users.                                                                        // 339
//   demoUsers: Demo users.                                                                                            // 340
//   appDemoUsers: Users that came in through "app demo".                                                              // 341
//   activeGrains: The number of unique grains that have been used in the time interval.                               // 342
//   apps: An object indexed by app ID recording, for each app:                                                        // 343
//       owners: Number of unique owners of this app (counting only grains that still exist).                          // 344
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    // 345
//         only grains that still exist).                                                                              // 346
//       grains: Number of active grains of this app (that still exist).                                               // 347
//       deleted: Number of non-demo grains of this app that were deleted.                                             // 348
//       demoed: Number of demo grains created and expired.                                                            // 349
//       appDemoUsers: Number of app demos initiated with this app.                                                    // 350
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 352
// Contains records of objects that were deleted, for stat-keeping purposes.                                           // 353
//                                                                                                                     // 354
// Each contains:                                                                                                      // 355
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             // 356
//   lastActive: Date of the user's or grain's last activity.                                                          // 357
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     // 358
//     arrived to demo. For others, undefined.                                                                         // 359
//   experiments: The experiments the user (or owner of the grain) was in. See user.experiments.                       // 360
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 362
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       // 363
// a token when they create a backup file (either by uploading it, or by backing up one of their                       // 364
// grains) and may use the token to read the file (either to download it, or to restore a new                          // 365
// grain from it).                                                                                                     // 366
//                                                                                                                     // 367
// Each contains:                                                                                                      // 368
//   _id:       The unguessable token string.                                                                          // 369
//   name:      Suggested filename.                                                                                    // 370
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        // 371
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 373
// Access tokens for APIs exported by apps.                                                                            // 374
//                                                                                                                     // 375
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      // 376
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      // 377
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           // 378
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         // 379
// `MainView`) -- the fields of type `Data` are API tokens.                                                            // 380
//                                                                                                                     // 381
// Each contains:                                                                                                      // 382
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           // 383
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      // 384
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       // 385
//              That is, the UiView's newSession() method will intersect the requested permissions                     // 386
//              with this identity's permissions before forwarding on to the underlying app. If                        // 387
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     // 388
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        // 389
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     // 390
//              this is NOT the identity against which the `requiredPermissions` parameter of                          // 391
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   // 392
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    // 393
//              that created the token.                                                                                // 394
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         // 395
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    // 396
//              permissions will be intersected with those held by `identityId` when the view is                       // 397
//              opened.                                                                                                // 398
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    // 399
//              anonymous rather than as directly associated with `identityId`. This has no effect                     // 400
//              on the permissions granted.                                                                            // 401
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      // 402
//              the app or its supervisor (whereas without this it strictly represents UiView).                        // 403
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      // 404
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             // 405
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               // 406
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    // 407
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    // 408
//              containing exactly one of the following fields:                                                        // 409
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    // 410
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           // 411
//                           `Notifications` collection.                                                               // 412
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      // 413
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      // 414
//                  database when that happens. This field contains the boolean true to signify that                   // 415
//                  it has been set.                                                                                   // 416
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     // 417
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           // 418
//                      value is an object containing the fields `id` and `services`. `id` is the                      // 419
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             // 420
//                      powerbox query for matching verified emails. `services` is a                                   // 421
//                      list of names of identity providers that are trusted to verify addresses.                      // 422
//                      If `services` is omitted or falsy, all configured identity providers are                       // 423
//                      trusted. Note that a malicious user could specify invalid names in the                         // 424
//                      list; they should be ignored.                                                                  // 425
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               // 426
//                      An object containing `verifierId`, `tabId`, and `address`.                                     // 427
//       identity: An Identity capability. The field is the identity ID.                                               // 428
//   parentToken: If present, then this token represents exactly the capability represented by                         // 429
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    // 430
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       // 431
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       // 432
//              is set to the identity that shared the view, and `accountId` is set to the account                     // 433
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             // 434
//              `parentToken` is present.                                                                              // 435
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          // 436
//              revocation. This should be displayed when visualizing incoming capabilities to                         // 437
//              the grain identified by `grainId`.                                                                     // 438
//   created:   Date when this token was created.                                                                      // 439
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    // 440
//              become un-revoked in the future.                                                                       // 441
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     // 442
//              this date, the token will be automatically deleted.                                                    // 443
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        // 444
//              so treat this token the same as "trashed". It is denormalized out of Users for                         // 445
//              ease of querying.                                                                                      // 446
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     // 447
//   lastUsed:  Optional Date when this token was last used.                                                           // 448
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             // 449
//              as passed to the `save()` call that created this token. If not present, treat                          // 450
//              as `webkey` (the default for `ApiTokenOwner`).                                                         // 451
//   expiresIfUnused:                                                                                                  // 452
//              Optional Date after which the token, if it has not been used yet, expires.                             // 453
//              This field should be cleared on a token's first use.                                                   // 454
//   requirements: List of conditions which must hold for this token to be considered valid.                           // 455
//              Semantically, this list specifies the powers which were *used* to originally                           // 456
//              create the token. If any condition in the list becomes untrue, then the token must                     // 457
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         // 458
//              through it must also become revoked. Each item is the JSON serialization of the                        // 459
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         // 460
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          // 461
//              cleaned up when the token is.                                                                          // 462
//                                                                                                                     // 463
// It is important to note that a token's owner and provider are independent from each other. To                       // 464
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    // 465
//                                                                                                                     // 466
// struct ApiToken {                                                                                                   // 467
//   owner :ApiTokenOwner;                                                                                             // 468
//   provider :union {                                                                                                 // 469
//     grain :group {                                                                                                  // 470
//       grainId :Text;                                                                                                // 471
//       union {                                                                                                       // 472
//         uiView :group {                                                                                             // 473
//           identityId :Text;                                                                                         // 474
//           roleAssignment :RoleAssignment;                                                                           // 475
//           forSharing :Bool;                                                                                         // 476
//         }                                                                                                           // 477
//         objectId :SupervisorObjectId;                                                                               // 478
//       }                                                                                                             // 479
//     }                                                                                                               // 480
//     frontendRef :union {                                                                                            // 481
//       notificationHandle :Text;                                                                                     // 482
//       ipNetwork :Bool;                                                                                              // 483
//       ipInterface :Bool;                                                                                            // 484
//       emailVerifier :group {                                                                                        // 485
//         id :Text;                                                                                                   // 486
//         services :List(String);                                                                                     // 487
//       }                                                                                                             // 488
//       verifiedEmail :group {                                                                                        // 489
//         verifierId :Text;                                                                                           // 490
//         tabId :Text;                                                                                                // 491
//         address :Text;                                                                                              // 492
//       }                                                                                                             // 493
//       identity :Text;                                                                                               // 494
//     }                                                                                                               // 495
//     child :group {                                                                                                  // 496
//       parentToken :Text;                                                                                            // 497
//       union {                                                                                                       // 498
//         uiView :group {                                                                                             // 499
//           grainId :Text;                                                                                            // 500
//           identityId :Text;                                                                                         // 501
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        // 502
//         }                                                                                                           // 503
//         other :Void;                                                                                                // 504
//       }                                                                                                             // 505
//     }                                                                                                               // 506
//   }                                                                                                                 // 507
//   requirements: List(Supervisor.MembraneRequirement);                                                               // 508
//   ...                                                                                                               // 509
// }                                                                                                                   // 510
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 512
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 513
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 514
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 516
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    // 517
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      // 518
// to probe an API host without authentication to determine capabilities such as DAV protocols                         // 519
// supported, before authenticating to perform real requests. An app can specify these properties                      // 520
// when creating an offerTemplate.                                                                                     // 521
//                                                                                                                     // 522
// Each contains:                                                                                                      // 523
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             // 524
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     // 525
//                 up when ApiTokens are deleted.                                                                      // 526
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          // 527
//                 This is an object containing fields:                                                                // 528
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             // 529
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 // 530
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        // 531
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      // 532
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          // 533
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          // 534
//                 fields:                                                                                             // 535
//     type:       Content-Type.                                                                                       // 536
//     language:   Content-Language.                                                                                   // 537
//     encoding:   Content-Encoding.                                                                                   // 538
//     body:       Entity-body as a string or buffer.                                                                  // 539
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 541
// Notifications for a user.                                                                                           // 542
//                                                                                                                     // 543
// Each contains:                                                                                                      // 544
//   _id:          random                                                                                              // 545
//   grainId:      The grain originating this notification, if any.                                                    // 546
//   userId:       Account ID of the user receiving the notification.                                                  // 547
//   text:         The JSON-ified LocalizedText to display in the notification.                                        // 548
//   isUnread:     Boolean indicating if this notification is unread.                                                  // 549
//   timestamp:    Date when this notification was last updated                                                        // 550
//   eventType:    If this notification is due to an activity event, this is the numeric index                         // 551
//                 of the event type on the grain's ViewInfo.                                                          // 552
//   count:        The number of times this exact event has repeated. Identical events are                             // 553
//                 aggregated by incrementing the count.                                                               // 554
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      // 555
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               // 556
//                 initiatingIdentity is present, the notification is not from a user.                                 // 557
//   path:         Path inside the grain to which the user should be directed if they click on                         // 558
//                 the notification.                                                                                   // 559
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             // 560
//                 ApiToken referencing the `OngoingNotification` capability.                                          // 561
//   admin:        If present, this is a notification intended for an admin.                                           // 562
//     action:     If present, this is a (string) link that the notification should direct the                         // 563
//                 admin to.                                                                                           // 564
//     type:       The type of notification -- currently can only be "reportStats".                                    // 565
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     // 566
//                 as keys.                                                                                            // 567
//     $appId:     The appId that has an outstanding update.                                                           // 568
//       packageId: The packageId that it will update to.                                                              // 569
//       name: The name of the app. (appTitle from package.manifest)                                                   // 570
//       version: The app's version number. (appVersion from package.manifest)                                         // 571
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           // 572
//   referral:     If this boolean field is true, then treat this notification as a referral                           // 573
//                 notification. This causes text to be ignored, since we need custom logic.                           // 574
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      // 575
//                 a one-time notification only to Oasis users who existed when the bonus program                      // 576
//                 was implemented.                                                                                    // 577
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 579
// Activity events to which a user is subscribed.                                                                      // 580
//                                                                                                                     // 581
// Each contains:                                                                                                      // 582
//   _id:          random                                                                                              // 583
//   identityId:   Who is subscribed.                                                                                  // 584
//   grainId:      Grain to which subscription applies.                                                                // 585
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       // 586
//                 whole grain.                                                                                        // 587
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         // 588
//                 This allows is useful to express:                                                                   // 589
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  // 590
//                 - The owner of a grain does not want notifications (normally, they are                              // 591
//                   implicitly subscribed).                                                                           // 592
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      // 593
//                   which they comment, so they mute the grain.                                                       // 594
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 596
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 597
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 599
// Access tokens for the Stats collection                                                                              // 600
//                                                                                                                     // 601
// These tokens are used for accessing the ActivityStats collection remotely                                           // 602
// (ie. from a dashboard webapp)                                                                                       // 603
//                                                                                                                     // 604
// Each contains:                                                                                                      // 605
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  // 606
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 608
// Miscellaneous configuration and other settings                                                                      // 609
//                                                                                                                     // 610
// This table is currently only used for persisting BASE_URL from one session to the next,                             // 611
// but in general any miscellaneous settings should go in here                                                         // 612
//                                                                                                                     // 613
// Each contains:                                                                                                      // 614
//   _id:       The name of the setting. eg. "BASE_URL"                                                                // 615
//   value:     The value of the setting.                                                                              // 616
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 618
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         // 619
// route. This collection differs from misc in that any admin user can update it through the admin                     // 620
// interface.                                                                                                          // 621
//                                                                                                                     // 622
// Each contains:                                                                                                      // 623
//   _id:       The name of the setting. eg. "smtpConfig"                                                              // 624
//   value:     The value of the setting.                                                                              // 625
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     // 626
//                       so, it will also write an object to this field indicating why the reset was                   // 627
//                       needed. That object can have the following variants:                                          // 628
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      // 629
//                           with the old BASE_URL.                                                                    // 630
//   preinstalledApps: A list of objects:                                                                              // 631
//     appId: The Packages.appId of the app to install                                                                 // 632
//     status: packageId                                                                                               // 633
//     packageId: The Packages._id of the app to install                                                               // 634
//                                                                                                                     // 635
//   potentially other fields that are unique to the setting                                                           // 636
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 638
// This table tracks which migrations we have applied to this instance.                                                // 639
// It contains a single entry:                                                                                         // 640
//   _id:       "migrations_applied"                                                                                   // 641
//   value:     The number of migrations this instance has successfully completed.                                     // 642
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 644
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            // 645
// support relatively small assets: under 1MB each.                                                                    // 646
//                                                                                                                     // 647
// Each contains:                                                                                                      // 648
//   _id:       Random ID; will be used in the URL.                                                                    // 649
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            // 650
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              // 651
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    // 652
//   content:   The asset content (byte buffer).                                                                       // 653
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    // 654
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        // 655
//       to catch leaked assets, although it's probably not a big deal in practice.                                    // 656
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 658
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         // 659
// profile picture.                                                                                                    // 660
//                                                                                                                     // 661
// Each contains:                                                                                                      // 662
//   _id:       Random ID.                                                                                             // 663
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 // 664
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          // 665
//           userId: Account ID of user whose picture shall be replaced.                                               // 666
//           identityId: Which of the user's identities shall be updated.                                              // 667
//   expires:   Time when this token will go away if unused.                                                           // 668
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 670
// Subscription plans, which determine quota.                                                                          // 671
//                                                                                                                     // 672
// Each contains:                                                                                                      // 673
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                // 674
//   storage: Number of bytes this user is allowed to store.                                                           // 675
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          // 676
//   computeLabel: Label to display to the user describing this plan's compute units.                                  // 677
//   grains: Total number of grains this user can create (often `Infinity`).                                           // 678
//   price: Price per month in US cents.                                                                               // 679
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           // 680
//       allowed to switch away.                                                                                       // 681
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      // 682
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 684
// A mirror of the data from the App Market index                                                                      // 685
//                                                                                                                     // 686
// Each contains:                                                                                                      // 687
//   _id: the appId of the app                                                                                         // 688
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    // 689
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 691
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     // 692
// by that user is installed, as well as if the keybase profile is requested and not already                           // 693
// present for some reason.                                                                                            // 694
//                                                                                                                     // 695
// Each contains:                                                                                                      // 696
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   // 697
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    // 698
//   handle: Keybase handle.                                                                                           // 699
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      // 700
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         // 701
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          // 702
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     // 703
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     // 704
//     server is currently actively checking this proof). Note that if a check fails due to network                    // 705
//     errors, the status goes back to "unverified".                                                                   // 706
//                                                                                                                     // 707
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          // 708
//       for now and we just trust Keybase.                                                                            // 709
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 711
// OBSOLETE: This was used to implement the Sandstorm for Work paywall, which has been removed.                        // 712
//   Collection object still defined because it could have old data in it, for servers that used                       // 713
//   to have a feature key.                                                                                            // 714
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 716
// Responsible for storing information about setup sessions.  Contains a single document with three                    // 717
// keys:                                                                                                               // 718
//                                                                                                                     // 719
//   _id: "current-session"                                                                                            // 720
//   creationDate: Date object indicating when this session was created.                                               // 721
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              // 722
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 724
// Responsible for very short-lived queueing of desktop notification information.                                      // 725
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        // 726
// odd in that it is intended primarily for edge-triggered communications, but                                         // 727
// Meteor's collections aren't really designed to support that organization.                                           // 728
// Fields for each :                                                                                                   // 729
//                                                                                                                     // 730
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            // 731
//   creationDate: Date object. indicating when this notification was posted.                                          // 732
//   userId: String. Account id to which this notification was published.                                              // 733
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   // 734
//                            notification is activated.                                                               // 735
//   appActivity: Object with fields:                                                                                  // 736
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          // 737
//           present, it will have one of the following shapes:                                                        // 738
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      // 739
//       {                                                                                                             // 740
//         identityId: String  The user's identity ID.                                                                 // 741
//         name: String        The user's display name.                                                                // 742
//         avatarUrl: String   The URL for the user's profile picture.                                                 // 743
//       },                                                                                                            // 744
//     grainId: String,      Which grain this action took place on                                                     // 745
//     path: String,         The path of the notification.                                                             // 746
//     body: Util.LocalizedText,  The main body of the activity event.                                                 // 747
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 // 748
//                                     { defaultText: "added a comment" }                                              // 749
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions);                                  // 751
// A standalone domain that points to a single share link. These domains act a little different                        // 752
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     // 753
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         // 754
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    // 755
// login.                                                                                                              // 756
// Fields for each :                                                                                                   // 757
//                                                                                                                     // 758
//   _id: String. The domain name to use.                                                                              // 759
//   token: String. _id of a sharing token (it must be a webkey).                                                      // 760
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 762
  Meteor.publish("credentials", function () {                                                                          // 763
    // Data needed for isSignedUp() and isAdmin() to work.                                                             // 764
                                                                                                                       //
    if (this.userId) {                                                                                                 // 766
      var db = this.connection.sandstormDb;                                                                            // 767
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 771
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), db.collections.plans.find()];              // 772
    } else {                                                                                                           // 775
      return [];                                                                                                       // 776
    }                                                                                                                  // 777
  });                                                                                                                  // 778
}                                                                                                                      // 779
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 781
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 782
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 783
};                                                                                                                     // 784
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 786
  // This function returns an object of the form:                                                                      // 787
  //                                                                                                                   // 788
  // - {grains: 0, storage: 0}                                                                                         // 789
  //                                                                                                                   // 790
  // which are extra resources this account gets as part of participating in the referral                              // 791
  // program. (Storage is measured in bytes, as usual for plans.)                                                      // 792
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        // 794
  //   payments-specific) and aggregating into `planBonus`.                                                            // 795
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              // 797
  var isPaid = user.plan && user.plan !== "free";                                                                      // 798
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 800
  if (isPaid) {                                                                                                        // 801
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 802
    return { grains: 0,                                                                                                // 803
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 804
  } else {                                                                                                             // 807
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 808
    var bonus = {                                                                                                      // 809
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 810
    };                                                                                                                 // 809
    if (successfulReferralsCount > 0) {                                                                                // 814
      bonus.grains = Infinity;                                                                                         // 815
    } else {                                                                                                           // 816
      bonus.grains = 0;                                                                                                // 817
    }                                                                                                                  // 818
                                                                                                                       //
    return bonus;                                                                                                      // 820
  }                                                                                                                    // 821
};                                                                                                                     // 822
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 824
  // Returns true if the user is the administrator.                                                                    // 825
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 827
  if (user && user.isAdmin) {                                                                                          // 828
    return true;                                                                                                       // 829
  } else {                                                                                                             // 830
    return false;                                                                                                      // 831
  }                                                                                                                    // 832
};                                                                                                                     // 833
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 835
  // Returns true if the user's id is the administrator.                                                               // 836
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 838
  if (user && user.isAdmin) {                                                                                          // 839
    return true;                                                                                                       // 840
  } else {                                                                                                             // 841
    return false;                                                                                                      // 842
  }                                                                                                                    // 843
};                                                                                                                     // 844
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 846
  if (!token.requirements) {                                                                                           // 847
    return;                                                                                                            // 848
  }                                                                                                                    // 849
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 851
    return "userIsAdmin" in requirement;                                                                               // 852
  });                                                                                                                  // 853
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 855
    return;                                                                                                            // 856
  }                                                                                                                    // 857
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 859
    return;                                                                                                            // 860
  }                                                                                                                    // 861
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 863
};                                                                                                                     // 864
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 866
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 868
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 869
}                                                                                                                      // 870
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 872
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           // 873
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    // 875
  // comparison logic ignores port numbers.                                                                            // 876
  var prefix = wildcardHost[0];                                                                                        // 877
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 878
  var hostSansPort = host.split(":")[0];                                                                               // 879
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 884
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 885
      return id;                                                                                                       // 886
    }                                                                                                                  // 887
  }                                                                                                                    // 888
                                                                                                                       //
  return null;                                                                                                         // 890
};                                                                                                                     // 891
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 893
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 894
};                                                                                                                     // 895
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 897
  if (hostId) {                                                                                                        // 898
    var split = hostId.split("-");                                                                                     // 899
    if (split[0] === "api") return split[1] || "*";                                                                    // 900
  }                                                                                                                    // 901
                                                                                                                       //
  return false;                                                                                                        // 903
};                                                                                                                     // 904
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 906
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 907
};                                                                                                                     // 908
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 910
if (Meteor.isServer) {                                                                                                 // 911
  (function () {                                                                                                       // 911
    var Crypto = Npm.require("crypto");                                                                                // 912
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 913
      // Given an API token, compute the host ID that must be used when requesting this token.                         // 914
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      // 916
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     // 917
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     // 918
      // any bugs which would allow someone who knows only the hostname to access the app API.                         // 919
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 920
    };                                                                                                                 // 921
  })();                                                                                                                // 911
} else {                                                                                                               // 922
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 923
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 924
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 926
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 927
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 928
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 929
    return SHA256("x" + token).slice(0, 32);                                                                           // 930
  };                                                                                                                   // 931
}                                                                                                                      // 932
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 934
  return "api-" + apiHostIdHashForToken(token);                                                                        // 935
};                                                                                                                     // 936
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 938
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 939
};                                                                                                                     // 940
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 942
  (function () {                                                                                                       // 942
    var Url = Npm.require("url");                                                                                      // 943
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 944
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      // 945
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    // 946
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                // 947
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   // 948
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              // 949
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 // 951
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 952
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 954
      if (dotPos < 0) {                                                                                                // 955
        return protocol + "//*";                                                                                       // 956
      } else {                                                                                                         // 957
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 958
      }                                                                                                                // 959
    };                                                                                                                 // 960
  })();                                                                                                                // 942
}                                                                                                                      // 961
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 963
  // quotaManager is an object with the following method:                                                              // 964
  //   updateUserQuota: It is provided two arguments                                                                   // 965
  //     db: This SandstormDb object                                                                                   // 966
  //     user: A collections.users account object                                                                      // 967
  //   and returns a quota object:                                                                                     // 968
  //     storage: A number (can be Infinity)                                                                           // 969
  //     compute: A number (can be Infinity)                                                                           // 970
  //     grains: A number (can be Infinity)                                                                            // 971
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 973
  this.collections = {                                                                                                 // 974
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    // 975
    // collection globals directly.                                                                                    // 976
    //                                                                                                                 // 977
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      // 978
    //   direct access to the collections.                                                                             // 979
    users: Meteor.users,                                                                                               // 980
                                                                                                                       //
    packages: Packages,                                                                                                // 982
    devPackages: DevPackages,                                                                                          // 983
    userActions: UserActions,                                                                                          // 984
    grains: Grains,                                                                                                    // 985
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 986
    contacts: Contacts,                                                                                                // 987
    sessions: Sessions,                                                                                                // 988
    signupKeys: SignupKeys,                                                                                            // 989
    activityStats: ActivityStats,                                                                                      // 990
    deleteStats: DeleteStats,                                                                                          // 991
    fileTokens: FileTokens,                                                                                            // 992
    apiTokens: ApiTokens,                                                                                              // 993
    apiHosts: ApiHosts,                                                                                                // 994
    notifications: Notifications,                                                                                      // 995
    activitySubscriptions: ActivitySubscriptions,                                                                      // 996
    statsTokens: StatsTokens,                                                                                          // 997
    misc: Misc,                                                                                                        // 998
    settings: Settings,                                                                                                // 999
    migrations: Migrations,                                                                                            // 1000
    staticAssets: StaticAssets,                                                                                        // 1001
    assetUploadTokens: AssetUploadTokens,                                                                              // 1002
    plans: Plans,                                                                                                      // 1003
    appIndex: AppIndex,                                                                                                // 1004
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1005
    setupSession: SetupSession,                                                                                        // 1006
    desktopNotifications: DesktopNotifications,                                                                        // 1007
    standaloneDomains: StandaloneDomains                                                                               // 1008
  };                                                                                                                   // 974
};                                                                                                                     // 1010
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           // 1012
//   objects created in SandstormDb's constructor rather than globals.                                                 // 1013
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1015
  isAdmin: isAdmin,                                                                                                    // 1016
  isAdminById: isAdminById,                                                                                            // 1017
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1018
  matchWildcardHost: matchWildcardHost,                                                                                // 1019
  makeWildcardHost: makeWildcardHost,                                                                                  // 1020
  isApiHostId: isApiHostId,                                                                                            // 1021
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1022
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1023
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1024
  makeApiHost: makeApiHost,                                                                                            // 1025
  allowDevAccounts: function () {                                                                                      // 1026
    function allowDevAccounts() {                                                                                      // 1015
      var setting = this.collections.settings.findOne({ _id: "devAccounts" });                                         // 1027
      if (setting) {                                                                                                   // 1028
        return setting.value;                                                                                          // 1029
      } else {                                                                                                         // 1030
        return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;             // 1031
      }                                                                                                                // 1033
    }                                                                                                                  // 1034
                                                                                                                       //
    return allowDevAccounts;                                                                                           // 1015
  }(),                                                                                                                 // 1015
                                                                                                                       //
                                                                                                                       //
  roleAssignmentPattern: {                                                                                             // 1036
    none: Match.Optional(null),                                                                                        // 1037
    allAccess: Match.Optional(null),                                                                                   // 1038
    roleId: Match.Optional(Match.Integer),                                                                             // 1039
    addPermissions: Match.Optional([Boolean]),                                                                         // 1040
    removePermissions: Match.Optional([Boolean])                                                                       // 1041
  },                                                                                                                   // 1036
                                                                                                                       //
  isDemoUser: function () {                                                                                            // 1044
    function isDemoUser() {                                                                                            // 1015
      // Returns true if this is a demo user.                                                                          // 1045
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 1047
      if (user && user.expires) {                                                                                      // 1048
        return true;                                                                                                   // 1049
      } else {                                                                                                         // 1050
        return false;                                                                                                  // 1051
      }                                                                                                                // 1052
    }                                                                                                                  // 1053
                                                                                                                       //
    return isDemoUser;                                                                                                 // 1015
  }(),                                                                                                                 // 1015
  isSignedUp: function () {                                                                                            // 1055
    function isSignedUp() {                                                                                            // 1015
      var user = Meteor.user();                                                                                        // 1056
      return this.isAccountSignedUp(user);                                                                             // 1057
    }                                                                                                                  // 1058
                                                                                                                       //
    return isSignedUp;                                                                                                 // 1015
  }(),                                                                                                                 // 1015
  isAccountSignedUp: function () {                                                                                     // 1060
    function isAccountSignedUp(user) {                                                                                 // 1015
      // Returns true if the user has presented an invite key.                                                         // 1061
                                                                                                                       //
      if (!user) return false; // not signed in                                                                        // 1063
                                                                                                                       //
      if (!user.loginIdentities) return false; // not an account                                                       // 1065
                                                                                                                       //
      if (user.expires) return false; // demo user.                                                                    // 1067
                                                                                                                       //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                               // 1069
                                                                                                                       //
      if (user.signupKey) return true; // user is invited                                                              // 1071
                                                                                                                       //
      if (this.isUserInOrganization(user)) return true;                                                                // 1073
                                                                                                                       //
      return false;                                                                                                    // 1075
    }                                                                                                                  // 1076
                                                                                                                       //
    return isAccountSignedUp;                                                                                          // 1015
  }(),                                                                                                                 // 1015
  isSignedUpOrDemo: function () {                                                                                      // 1078
    function isSignedUpOrDemo() {                                                                                      // 1015
      var user = Meteor.user();                                                                                        // 1079
      return this.isAccountSignedUpOrDemo(user);                                                                       // 1080
    }                                                                                                                  // 1081
                                                                                                                       //
    return isSignedUpOrDemo;                                                                                           // 1015
  }(),                                                                                                                 // 1015
  isAccountSignedUpOrDemo: function () {                                                                               // 1083
    function isAccountSignedUpOrDemo(user) {                                                                           // 1015
      if (!user) return false; // not signed in                                                                        // 1084
                                                                                                                       //
      if (!user.loginIdentities) return false; // not an account                                                       // 1086
                                                                                                                       //
      if (user.expires) return true; // demo user.                                                                     // 1088
                                                                                                                       //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                               // 1090
                                                                                                                       //
      if (user.signupKey) return true; // user is invited                                                              // 1092
                                                                                                                       //
      if (this.isUserInOrganization(user)) return true;                                                                // 1094
                                                                                                                       //
      return false;                                                                                                    // 1096
    }                                                                                                                  // 1097
                                                                                                                       //
    return isAccountSignedUpOrDemo;                                                                                    // 1015
  }(),                                                                                                                 // 1015
  isIdentityInOrganization: function () {                                                                              // 1099
    function isIdentityInOrganization(identity) {                                                                      // 1015
      if (!identity || !identity.services) {                                                                           // 1100
        return false;                                                                                                  // 1101
      }                                                                                                                // 1102
                                                                                                                       //
      var orgMembership = this.getOrganizationMembership();                                                            // 1104
      var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                       // 1105
      var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                         // 1106
      var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                // 1107
      var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                  // 1108
      var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                             // 1109
      var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                             // 1110
      if (emailEnabled && emailDomain && identity.services.email) {                                                    // 1111
        if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                            // 1112
          return true;                                                                                                 // 1113
        }                                                                                                              // 1114
      } else if (ldapEnabled && identity.services.ldap) {                                                              // 1115
        return true;                                                                                                   // 1116
      } else if (samlEnabled && identity.services.saml) {                                                              // 1117
        return true;                                                                                                   // 1118
      } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {           // 1119
        if (identity.services.google.hd.toLowerCase() === googleDomain) {                                              // 1120
          return true;                                                                                                 // 1121
        }                                                                                                              // 1122
      }                                                                                                                // 1123
                                                                                                                       //
      return false;                                                                                                    // 1125
    }                                                                                                                  // 1126
                                                                                                                       //
    return isIdentityInOrganization;                                                                                   // 1015
  }(),                                                                                                                 // 1015
  isUserInOrganization: function () {                                                                                  // 1128
    function isUserInOrganization(user) {                                                                              // 1015
      for (var i = 0; i < user.loginIdentities.length; i++) {                                                          // 1129
        var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                      // 1130
        if (this.isIdentityInOrganization(identity)) {                                                                 // 1131
          return true;                                                                                                 // 1132
        }                                                                                                              // 1133
      }                                                                                                                // 1134
                                                                                                                       //
      return false;                                                                                                    // 1136
    }                                                                                                                  // 1137
                                                                                                                       //
    return isUserInOrganization;                                                                                       // 1015
  }()                                                                                                                  // 1015
});                                                                                                                    // 1015
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1140
  (function () {                                                                                                       // 1140
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1141
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1143
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1144
      var _this2 = this;                                                                                               // 1144
                                                                                                                       //
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           // 1145
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1147
        // Clean up ApiHosts for webkey tokens.                                                                        // 1148
        if (token.hasApiHost) {                                                                                        // 1149
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1150
          _this2.collections.apiHosts.remove({ hash2: hash2 });                                                        // 1151
        }                                                                                                              // 1152
      });                                                                                                              // 1153
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1155
    };                                                                                                                 // 1156
  })();                                                                                                                // 1140
}                                                                                                                      // 1157
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            // 1159
// appears all over the codebase.                                                                                      // 1160
var httpProtocol = void 0;                                                                                             // 1161
if (Meteor.isServer) {                                                                                                 // 1162
  var _Url = Npm.require("url");                                                                                       // 1163
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1164
} else {                                                                                                               // 1165
  httpProtocol = window.location.protocol;                                                                             // 1166
}                                                                                                                      // 1167
                                                                                                                       //
// =======================================================================================                             // 1169
// Below this point are newly-written or refactored functions.                                                         // 1170
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1172
  getUser: function () {                                                                                               // 1173
    function getUser(userId) {                                                                                         // 1172
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1174
      if (userId) {                                                                                                    // 1175
        return Meteor.users.findOne(userId);                                                                           // 1176
      }                                                                                                                // 1177
    }                                                                                                                  // 1178
                                                                                                                       //
    return getUser;                                                                                                    // 1172
  }(),                                                                                                                 // 1172
  getIdentity: function () {                                                                                           // 1180
    function getIdentity(identityId) {                                                                                 // 1172
      check(identityId, String);                                                                                       // 1181
      var identity = Meteor.users.findOne({ _id: identityId });                                                        // 1182
      if (identity) {                                                                                                  // 1183
        SandstormDb.fillInProfileDefaults(identity);                                                                   // 1184
        SandstormDb.fillInIntrinsicName(identity);                                                                     // 1185
        SandstormDb.fillInPictureUrl(identity);                                                                        // 1186
        return identity;                                                                                               // 1187
      }                                                                                                                // 1188
    }                                                                                                                  // 1189
                                                                                                                       //
    return getIdentity;                                                                                                // 1172
  }(),                                                                                                                 // 1172
  userHasIdentity: function () {                                                                                       // 1191
    function userHasIdentity(userId, identityId) {                                                                     // 1172
      check(userId, String);                                                                                           // 1192
      check(identityId, String);                                                                                       // 1193
                                                                                                                       //
      if (userId === identityId) return true;                                                                          // 1195
                                                                                                                       //
      var user = Meteor.users.findOne(userId);                                                                         // 1197
      return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                           // 1198
    }                                                                                                                  // 1199
                                                                                                                       //
    return userHasIdentity;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  userGrains: function () {                                                                                            // 1201
    function userGrains(userId, options) {                                                                             // 1172
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1202
      check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
      var query = { userId: userId };                                                                                  // 1206
      if (options && options.includeTrashOnly) {                                                                       // 1207
        query.trashed = { $exists: true };                                                                             // 1208
      } else if (options && options.includeTrash) {                                                                    // 1209
        // Keep query as-is.                                                                                           // 1210
      } else {                                                                                                         // 1211
        query.trashed = { $exists: false };                                                                            // 1212
      }                                                                                                                // 1213
                                                                                                                       //
      return this.collections.grains.find(query);                                                                      // 1215
    }                                                                                                                  // 1216
                                                                                                                       //
    return userGrains;                                                                                                 // 1172
  }(),                                                                                                                 // 1172
  currentUserGrains: function () {                                                                                     // 1218
    function currentUserGrains(options) {                                                                              // 1172
      return this.userGrains(Meteor.userId(), options);                                                                // 1219
    }                                                                                                                  // 1220
                                                                                                                       //
    return currentUserGrains;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getGrain: function () {                                                                                              // 1222
    function getGrain(grainId) {                                                                                       // 1172
      check(grainId, String);                                                                                          // 1223
      return this.collections.grains.findOne(grainId);                                                                 // 1224
    }                                                                                                                  // 1225
                                                                                                                       //
    return getGrain;                                                                                                   // 1172
  }(),                                                                                                                 // 1172
  userApiTokens: function () {                                                                                         // 1227
    function userApiTokens(userId, trashed) {                                                                          // 1172
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1228
      check(trashed, Match.OneOf(Boolean, undefined, null));                                                           // 1229
      var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                          // 1230
      return this.collections.apiTokens.find({                                                                         // 1231
        "owner.user.identityId": { $in: identityIds },                                                                 // 1232
        trashed: { $exists: !!trashed }                                                                                // 1233
      });                                                                                                              // 1231
    }                                                                                                                  // 1235
                                                                                                                       //
    return userApiTokens;                                                                                              // 1172
  }(),                                                                                                                 // 1172
  currentUserApiTokens: function () {                                                                                  // 1237
    function currentUserApiTokens(trashed) {                                                                           // 1172
      return this.userApiTokens(Meteor.userId(), trashed);                                                             // 1238
    }                                                                                                                  // 1239
                                                                                                                       //
    return currentUserApiTokens;                                                                                       // 1172
  }(),                                                                                                                 // 1172
  userActions: function () {                                                                                           // 1241
    function userActions(user) {                                                                                       // 1172
      return this.collections.userActions.find({ userId: user });                                                      // 1242
    }                                                                                                                  // 1243
                                                                                                                       //
    return userActions;                                                                                                // 1172
  }(),                                                                                                                 // 1172
  currentUserActions: function () {                                                                                    // 1245
    function currentUserActions() {                                                                                    // 1172
      return this.userActions(Meteor.userId());                                                                        // 1246
    }                                                                                                                  // 1247
                                                                                                                       //
    return currentUserActions;                                                                                         // 1172
  }(),                                                                                                                 // 1172
  iconSrcForPackage: function () {                                                                                     // 1249
    function iconSrcForPackage(pkg, usage) {                                                                           // 1172
      return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));           // 1250
    }                                                                                                                  // 1251
                                                                                                                       //
    return iconSrcForPackage;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getDenormalizedGrainInfo: function () {                                                                              // 1253
    function getDenormalizedGrainInfo(grainId) {                                                                       // 1172
      var grain = this.getGrain(grainId);                                                                              // 1254
      var pkg = this.collections.packages.findOne(grain.packageId);                                                    // 1255
                                                                                                                       //
      if (!pkg) {                                                                                                      // 1257
        pkg = this.collections.devPackages.findOne(grain.packageId);                                                   // 1258
      }                                                                                                                // 1259
                                                                                                                       //
      var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                              // 1261
      var grainInfo = { appTitle: appTitle };                                                                          // 1262
                                                                                                                       //
      if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                               // 1264
        var icons = pkg.manifest.metadata.icons;                                                                       // 1265
        var icon = icons.grain || icons.appGrid;                                                                       // 1266
        if (icon) {                                                                                                    // 1267
          grainInfo.icon = icon;                                                                                       // 1268
        }                                                                                                              // 1269
      }                                                                                                                // 1270
                                                                                                                       //
      // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                    // 1272
      if (!grainInfo.icon && pkg) {                                                                                    // 1273
        grainInfo.appId = pkg.appId;                                                                                   // 1274
      }                                                                                                                // 1275
                                                                                                                       //
      return grainInfo;                                                                                                // 1277
    }                                                                                                                  // 1278
                                                                                                                       //
    return getDenormalizedGrainInfo;                                                                                   // 1172
  }(),                                                                                                                 // 1172
  getPlan: function () {                                                                                               // 1280
    function getPlan(id, user) {                                                                                       // 1172
      check(id, String);                                                                                               // 1281
                                                                                                                       //
      // `user`, if provided, is the user observing the plan. This matters only for checking if the                    // 1283
      // user is in an experiment.                                                                                     // 1284
                                                                                                                       //
      var plan = this.collections.plans.findOne(id);                                                                   // 1286
      if (!plan) {                                                                                                     // 1287
        throw new Error("no such plan: " + id);                                                                        // 1288
      }                                                                                                                // 1289
                                                                                                                       //
      if (plan._id === "free") {                                                                                       // 1291
        user = user || Meteor.user();                                                                                  // 1292
        if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                         // 1293
          plan.grains = user.experiments.freeGrainLimit;                                                               // 1295
        }                                                                                                              // 1296
      }                                                                                                                // 1297
                                                                                                                       //
      return plan;                                                                                                     // 1299
    }                                                                                                                  // 1300
                                                                                                                       //
    return getPlan;                                                                                                    // 1172
  }(),                                                                                                                 // 1172
  listPlans: function () {                                                                                             // 1302
    function listPlans(user) {                                                                                         // 1172
      user = user || Meteor.user();                                                                                    // 1303
      if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                           // 1304
        return this.collections.plans.find({}, { sort: { price: 1 } }).map(function (plan) {                           // 1306
          if (plan._id === "free") {                                                                                   // 1308
            plan.grains = user.experiments.freeGrainLimit;                                                             // 1309
          }                                                                                                            // 1310
                                                                                                                       //
          return plan;                                                                                                 // 1312
        });                                                                                                            // 1313
      } else {                                                                                                         // 1314
        return this.collections.plans.find({}, { sort: { price: 1 } }).fetch();                                        // 1315
      }                                                                                                                // 1316
    }                                                                                                                  // 1317
                                                                                                                       //
    return listPlans;                                                                                                  // 1172
  }(),                                                                                                                 // 1172
  getMyPlan: function () {                                                                                             // 1319
    function getMyPlan() {                                                                                             // 1172
      var user = Meteor.user();                                                                                        // 1320
      return user && this.collections.plans.findOne(user.plan || "free");                                              // 1321
    }                                                                                                                  // 1322
                                                                                                                       //
    return getMyPlan;                                                                                                  // 1172
  }(),                                                                                                                 // 1172
  getMyReferralBonus: function () {                                                                                    // 1324
    function getMyReferralBonus(user) {                                                                                // 1172
      // This function is called from the server and from the client, similar to getMyPlan().                          // 1325
      //                                                                                                               // 1326
      // The parameter may be omitted in which case the current user is assumed.                                       // 1327
                                                                                                                       //
      return calculateReferralBonus(user || Meteor.user());                                                            // 1329
    }                                                                                                                  // 1330
                                                                                                                       //
    return getMyReferralBonus;                                                                                         // 1172
  }(),                                                                                                                 // 1172
  getMyUsage: function () {                                                                                            // 1332
    function getMyUsage(user) {                                                                                        // 1172
      user = user || Meteor.user();                                                                                    // 1333
      if (user && (Meteor.isServer || user.pseudoUsage)) {                                                             // 1334
        if (Meteor.isClient) {                                                                                         // 1335
          // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                     // 1336
          // not reactive.                                                                                             // 1337
          return user.pseudoUsage;                                                                                     // 1338
        } else {                                                                                                       // 1339
          return {                                                                                                     // 1340
            grains: this.collections.grains.find({ userId: user._id }).count(),                                        // 1341
            storage: user.storageUsage || 0,                                                                           // 1342
            compute: 0 };                                                                                              // 1343
        }                                                                                                              // 1345
      } else {                                                                                                         // 1346
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1347
      }                                                                                                                // 1348
    }                                                                                                                  // 1349
                                                                                                                       //
    return getMyUsage;                                                                                                 // 1172
  }(),                                                                                                                 // 1172
  isUninvitedFreeUser: function () {                                                                                   // 1351
    function isUninvitedFreeUser() {                                                                                   // 1172
      if (!Meteor.settings["public"].allowUninvited) return false;                                                     // 1352
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 1354
      return user && !user.expires && (!user.plan || user.plan === "free");                                            // 1355
    }                                                                                                                  // 1356
                                                                                                                       //
    return isUninvitedFreeUser;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  getSetting: function () {                                                                                            // 1358
    function getSetting(name) {                                                                                        // 1172
      var setting = this.collections.settings.findOne(name);                                                           // 1359
      return setting && setting.value;                                                                                 // 1360
    }                                                                                                                  // 1361
                                                                                                                       //
    return getSetting;                                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getSettingWithFallback: function () {                                                                                // 1363
    function getSettingWithFallback(name, fallbackValue) {                                                             // 1172
      var value = this.getSetting(name);                                                                               // 1364
      if (value === undefined) {                                                                                       // 1365
        return fallbackValue;                                                                                          // 1366
      }                                                                                                                // 1367
                                                                                                                       //
      return value;                                                                                                    // 1369
    }                                                                                                                  // 1370
                                                                                                                       //
    return getSettingWithFallback;                                                                                     // 1172
  }(),                                                                                                                 // 1172
  addUserActions: function () {                                                                                        // 1372
    function addUserActions(userId, packageId, simulation) {                                                           // 1172
      check(userId, String);                                                                                           // 1373
      check(packageId, String);                                                                                        // 1374
                                                                                                                       //
      var pack = this.collections.packages.findOne({ _id: packageId });                                                // 1376
      if (pack) {                                                                                                      // 1377
        // Remove old versions.                                                                                        // 1378
        var numRemoved = this.collections.userActions.remove({ userId: userId, appId: pack.appId });                   // 1379
                                                                                                                       //
        // Install new.                                                                                                // 1381
        var actions = pack.manifest.actions;                                                                           // 1382
        for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                               // 1383
          var action = actions[i];                                                                                     // 1384
          if ("none" in action.input) {                                                                                // 1385
            var userAction = {                                                                                         // 1386
              userId: userId,                                                                                          // 1387
              packageId: pack._id,                                                                                     // 1388
              appId: pack.appId,                                                                                       // 1389
              appTitle: pack.manifest.appTitle,                                                                        // 1390
              appMarketingVersion: pack.manifest.appMarketingVersion,                                                  // 1391
              appVersion: pack.manifest.appVersion,                                                                    // 1392
              title: action.title,                                                                                     // 1393
              nounPhrase: action.nounPhrase,                                                                           // 1394
              command: action.command                                                                                  // 1395
            };                                                                                                         // 1386
            this.collections.userActions.insert(userAction);                                                           // 1397
          } else {                                                                                                     // 1398
            // TODO(someday):  Implement actions with capability inputs.                                               // 1399
          }                                                                                                            // 1400
        }                                                                                                              // 1401
                                                                                                                       //
        if (numRemoved > 0 && !simulation) {                                                                           // 1403
          this.deleteUnusedPackages(pack.appId);                                                                       // 1404
        }                                                                                                              // 1405
      }                                                                                                                // 1406
    }                                                                                                                  // 1407
                                                                                                                       //
    return addUserActions;                                                                                             // 1172
  }(),                                                                                                                 // 1172
  sendAdminNotification: function () {                                                                                 // 1409
    function sendAdminNotification(type, action) {                                                                     // 1172
      Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                           // 1410
        Notifications.insert({                                                                                         // 1411
          admin: { action: action, type: type },                                                                       // 1412
          userId: user._id,                                                                                            // 1413
          timestamp: new Date(),                                                                                       // 1414
          isUnread: true                                                                                               // 1415
        });                                                                                                            // 1411
      });                                                                                                              // 1417
    }                                                                                                                  // 1418
                                                                                                                       //
    return sendAdminNotification;                                                                                      // 1172
  }(),                                                                                                                 // 1172
  getKeybaseProfile: function () {                                                                                     // 1420
    function getKeybaseProfile(keyFingerprint) {                                                                       // 1172
      return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                           // 1421
    }                                                                                                                  // 1422
                                                                                                                       //
    return getKeybaseProfile;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getServerTitle: function () {                                                                                        // 1424
    function getServerTitle() {                                                                                        // 1172
      var setting = this.collections.settings.findOne({ _id: "serverTitle" });                                         // 1425
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1426
    }                                                                                                                  // 1427
                                                                                                                       //
    return getServerTitle;                                                                                             // 1172
  }(),                                                                                                                 // 1172
  getSmtpConfig: function () {                                                                                         // 1429
    function getSmtpConfig() {                                                                                         // 1172
      var setting = this.collections.settings.findOne({ _id: "smtpConfig" });                                          // 1430
      return setting ? setting.value : undefined; // undefined if subscription is not ready.                           // 1431
    }                                                                                                                  // 1432
                                                                                                                       //
    return getSmtpConfig;                                                                                              // 1172
  }(),                                                                                                                 // 1172
  getReturnAddress: function () {                                                                                      // 1434
    function getReturnAddress() {                                                                                      // 1172
      var config = this.getSmtpConfig();                                                                               // 1435
      return config && config.returnAddress || ""; // empty if subscription is not ready.                              // 1436
    }                                                                                                                  // 1437
                                                                                                                       //
    return getReturnAddress;                                                                                           // 1172
  }(),                                                                                                                 // 1172
  getReturnAddressWithDisplayName: function () {                                                                       // 1439
    function getReturnAddressWithDisplayName(identityId) {                                                             // 1172
      check(identityId, String);                                                                                       // 1440
      var identity = this.getIdentity(identityId);                                                                     // 1441
      var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                // 1442
                                                                                                                       //
      // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                          // 1444
      // we could escape such characters with a backslash, but that does not seem to help here.                        // 1445
      var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                         // 1446
                                                                                                                       //
      return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                // 1448
    }                                                                                                                  // 1449
                                                                                                                       //
    return getReturnAddressWithDisplayName;                                                                            // 1172
  }(),                                                                                                                 // 1172
  getPrimaryEmail: function () {                                                                                       // 1451
    function getPrimaryEmail(accountId, identityId) {                                                                  // 1172
      check(accountId, String);                                                                                        // 1452
      check(identityId, String);                                                                                       // 1453
                                                                                                                       //
      var identity = this.getIdentity(identityId);                                                                     // 1455
      var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                      // 1456
      var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                           // 1457
      var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                           // 1458
      if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                          // 1459
        return accountPrimaryEmailAddress;                                                                             // 1460
      } else if (senderPrimaryEmail) {                                                                                 // 1461
        return senderPrimaryEmail.email;                                                                               // 1462
      } else {                                                                                                         // 1463
        return null;                                                                                                   // 1464
      }                                                                                                                // 1465
    }                                                                                                                  // 1466
                                                                                                                       //
    return getPrimaryEmail;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  incrementDailySentMailCount: function () {                                                                           // 1468
    function incrementDailySentMailCount(accountId) {                                                                  // 1172
      check(accountId, String);                                                                                        // 1469
                                                                                                                       //
      var DAILY_LIMIT = 50;                                                                                            // 1471
      var result = Meteor.users.findAndModify({                                                                        // 1472
        query: { _id: accountId },                                                                                     // 1473
        update: {                                                                                                      // 1474
          $inc: {                                                                                                      // 1475
            dailySentMailCount: 1                                                                                      // 1476
          }                                                                                                            // 1475
        },                                                                                                             // 1474
        fields: { dailySentMailCount: 1 }                                                                              // 1479
      });                                                                                                              // 1472
                                                                                                                       //
      if (!result.ok) {                                                                                                // 1482
        throw new Error("Couldn't update daily sent mail count.");                                                     // 1483
      }                                                                                                                // 1484
                                                                                                                       //
      var user = result.value;                                                                                         // 1486
      if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                    // 1487
        throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
      }                                                                                                                // 1492
    }                                                                                                                  // 1493
                                                                                                                       //
    return incrementDailySentMailCount;                                                                                // 1172
  }(),                                                                                                                 // 1172
  getLdapUrl: function () {                                                                                            // 1495
    function getLdapUrl() {                                                                                            // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapUrl" });                                             // 1496
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1497
    }                                                                                                                  // 1498
                                                                                                                       //
    return getLdapUrl;                                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getLdapBase: function () {                                                                                           // 1500
    function getLdapBase() {                                                                                           // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapBase" });                                            // 1501
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1502
    }                                                                                                                  // 1503
                                                                                                                       //
    return getLdapBase;                                                                                                // 1172
  }(),                                                                                                                 // 1172
  getLdapDnPattern: function () {                                                                                      // 1505
    function getLdapDnPattern() {                                                                                      // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapDnPattern" });                                       // 1506
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1507
    }                                                                                                                  // 1508
                                                                                                                       //
    return getLdapDnPattern;                                                                                           // 1172
  }(),                                                                                                                 // 1172
  getLdapSearchUsername: function () {                                                                                 // 1510
    function getLdapSearchUsername() {                                                                                 // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapSearchUsername" });                                  // 1511
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1512
    }                                                                                                                  // 1513
                                                                                                                       //
    return getLdapSearchUsername;                                                                                      // 1172
  }(),                                                                                                                 // 1172
  getLdapNameField: function () {                                                                                      // 1515
    function getLdapNameField() {                                                                                      // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapNameField" });                                       // 1516
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1517
    }                                                                                                                  // 1518
                                                                                                                       //
    return getLdapNameField;                                                                                           // 1172
  }(),                                                                                                                 // 1172
  getLdapEmailField: function () {                                                                                     // 1520
    function getLdapEmailField() {                                                                                     // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapEmailField" });                                      // 1521
      return setting ? setting.value : "mail";                                                                         // 1522
      // default to "mail". This setting was added later, and so could potentially be unset.                           // 1523
    }                                                                                                                  // 1524
                                                                                                                       //
    return getLdapEmailField;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getLdapExplicitDnSelected: function () {                                                                             // 1526
    function getLdapExplicitDnSelected() {                                                                             // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapExplicitDnSelected" });                              // 1527
      return setting && setting.value;                                                                                 // 1528
    }                                                                                                                  // 1529
                                                                                                                       //
    return getLdapExplicitDnSelected;                                                                                  // 1172
  }(),                                                                                                                 // 1172
  getLdapFilter: function () {                                                                                         // 1531
    function getLdapFilter() {                                                                                         // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapFilter" });                                          // 1532
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1533
    }                                                                                                                  // 1534
                                                                                                                       //
    return getLdapFilter;                                                                                              // 1172
  }(),                                                                                                                 // 1172
  getLdapSearchBindDn: function () {                                                                                   // 1536
    function getLdapSearchBindDn() {                                                                                   // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapSearchBindDn" });                                    // 1537
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1538
    }                                                                                                                  // 1539
                                                                                                                       //
    return getLdapSearchBindDn;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  getLdapSearchBindPassword: function () {                                                                             // 1541
    function getLdapSearchBindPassword() {                                                                             // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapSearchBindPassword" });                              // 1542
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1543
    }                                                                                                                  // 1544
                                                                                                                       //
    return getLdapSearchBindPassword;                                                                                  // 1172
  }(),                                                                                                                 // 1172
  getLdapCaCert: function () {                                                                                         // 1546
    function getLdapCaCert() {                                                                                         // 1172
      var setting = this.collections.settings.findOne({ _id: "ldapCaCert" });                                          // 1547
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1548
    }                                                                                                                  // 1549
                                                                                                                       //
    return getLdapCaCert;                                                                                              // 1172
  }(),                                                                                                                 // 1172
  getOrganizationMembership: function () {                                                                             // 1551
    function getOrganizationMembership() {                                                                             // 1172
      var setting = this.collections.settings.findOne({ _id: "organizationMembership" });                              // 1552
      return setting && setting.value;                                                                                 // 1553
    }                                                                                                                  // 1554
                                                                                                                       //
    return getOrganizationMembership;                                                                                  // 1172
  }(),                                                                                                                 // 1172
  getOrganizationEmailEnabled: function () {                                                                           // 1556
    function getOrganizationEmailEnabled() {                                                                           // 1172
      var membership = this.getOrganizationMembership();                                                               // 1557
      return membership && membership.emailToken && membership.emailToken.enabled;                                     // 1558
    }                                                                                                                  // 1559
                                                                                                                       //
    return getOrganizationEmailEnabled;                                                                                // 1172
  }(),                                                                                                                 // 1172
  getOrganizationEmailDomain: function () {                                                                            // 1561
    function getOrganizationEmailDomain() {                                                                            // 1172
      var membership = this.getOrganizationMembership();                                                               // 1562
      return membership && membership.emailToken && membership.emailToken.domain;                                      // 1563
    }                                                                                                                  // 1564
                                                                                                                       //
    return getOrganizationEmailDomain;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getOrganizationGoogleEnabled: function () {                                                                          // 1566
    function getOrganizationGoogleEnabled() {                                                                          // 1172
      var membership = this.getOrganizationMembership();                                                               // 1567
      return membership && membership.google && membership.google.enabled;                                             // 1568
    }                                                                                                                  // 1569
                                                                                                                       //
    return getOrganizationGoogleEnabled;                                                                               // 1172
  }(),                                                                                                                 // 1172
  getOrganizationGoogleDomain: function () {                                                                           // 1571
    function getOrganizationGoogleDomain() {                                                                           // 1172
      var membership = this.getOrganizationMembership();                                                               // 1572
      return membership && membership.google && membership.google.domain;                                              // 1573
    }                                                                                                                  // 1574
                                                                                                                       //
    return getOrganizationGoogleDomain;                                                                                // 1172
  }(),                                                                                                                 // 1172
  getOrganizationLdapEnabled: function () {                                                                            // 1576
    function getOrganizationLdapEnabled() {                                                                            // 1172
      var membership = this.getOrganizationMembership();                                                               // 1577
      return membership && membership.ldap && membership.ldap.enabled;                                                 // 1578
    }                                                                                                                  // 1579
                                                                                                                       //
    return getOrganizationLdapEnabled;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getOrganizationSamlEnabled: function () {                                                                            // 1581
    function getOrganizationSamlEnabled() {                                                                            // 1172
      var membership = this.getOrganizationMembership();                                                               // 1582
      return membership && membership.saml && membership.saml.enabled;                                                 // 1583
    }                                                                                                                  // 1584
                                                                                                                       //
    return getOrganizationSamlEnabled;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getOrganizationDisallowGuests: function () {                                                                         // 1586
    function getOrganizationDisallowGuests() {                                                                         // 1172
      return this.getOrganizationDisallowGuestsRaw();                                                                  // 1587
    }                                                                                                                  // 1588
                                                                                                                       //
    return getOrganizationDisallowGuests;                                                                              // 1172
  }(),                                                                                                                 // 1172
  getOrganizationDisallowGuestsRaw: function () {                                                                      // 1590
    function getOrganizationDisallowGuestsRaw() {                                                                      // 1172
      var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                // 1591
      return setting && setting.value && setting.value.disallowGuests;                                                 // 1592
    }                                                                                                                  // 1593
                                                                                                                       //
    return getOrganizationDisallowGuestsRaw;                                                                           // 1172
  }(),                                                                                                                 // 1172
  getOrganizationShareContacts: function () {                                                                          // 1595
    function getOrganizationShareContacts() {                                                                          // 1172
      return this.getOrganizationShareContactsRaw();                                                                   // 1596
    }                                                                                                                  // 1597
                                                                                                                       //
    return getOrganizationShareContacts;                                                                               // 1172
  }(),                                                                                                                 // 1172
  getOrganizationShareContactsRaw: function () {                                                                       // 1599
    function getOrganizationShareContactsRaw() {                                                                       // 1172
      var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                // 1600
      if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                   // 1601
        // default to true if undefined                                                                                // 1602
        return true;                                                                                                   // 1603
      } else {                                                                                                         // 1604
        return setting.value.shareContacts;                                                                            // 1605
      }                                                                                                                // 1606
    }                                                                                                                  // 1607
                                                                                                                       //
    return getOrganizationShareContactsRaw;                                                                            // 1172
  }(),                                                                                                                 // 1172
  getSamlEntryPoint: function () {                                                                                     // 1609
    function getSamlEntryPoint() {                                                                                     // 1172
      var setting = this.collections.settings.findOne({ _id: "samlEntryPoint" });                                      // 1610
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1611
    }                                                                                                                  // 1612
                                                                                                                       //
    return getSamlEntryPoint;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getSamlLogout: function () {                                                                                         // 1614
    function getSamlLogout() {                                                                                         // 1172
      var setting = this.collections.settings.findOne({ _id: "samlLogout" });                                          // 1615
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1616
    }                                                                                                                  // 1617
                                                                                                                       //
    return getSamlLogout;                                                                                              // 1172
  }(),                                                                                                                 // 1172
  getSamlPublicCert: function () {                                                                                     // 1619
    function getSamlPublicCert() {                                                                                     // 1172
      var setting = this.collections.settings.findOne({ _id: "samlPublicCert" });                                      // 1620
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1621
    }                                                                                                                  // 1622
                                                                                                                       //
    return getSamlPublicCert;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  getSamlEntityId: function () {                                                                                       // 1624
    function getSamlEntityId() {                                                                                       // 1172
      var setting = this.collections.settings.findOne({ _id: "samlEntityId" });                                        // 1625
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1626
    }                                                                                                                  // 1627
                                                                                                                       //
    return getSamlEntityId;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  userHasSamlLoginIdentity: function () {                                                                              // 1629
    function userHasSamlLoginIdentity() {                                                                              // 1172
      var user = Meteor.user();                                                                                        // 1630
      if (!user.loginIdentities) {                                                                                     // 1631
        return false;                                                                                                  // 1632
      }                                                                                                                // 1633
                                                                                                                       //
      var hasSaml = false;                                                                                             // 1635
      user.loginIdentities.forEach(function (identity) {                                                               // 1636
        if (Meteor.users.findOne({ _id: identity.id }).services.saml) {                                                // 1637
          hasSaml = true;                                                                                              // 1638
        }                                                                                                              // 1639
      });                                                                                                              // 1640
                                                                                                                       //
      return hasSaml;                                                                                                  // 1642
    }                                                                                                                  // 1643
                                                                                                                       //
    return userHasSamlLoginIdentity;                                                                                   // 1172
  }(),                                                                                                                 // 1172
  getActivitySubscriptions: function () {                                                                              // 1645
    function getActivitySubscriptions(grainId, threadPath) {                                                           // 1172
      return this.collections.activitySubscriptions.find({                                                             // 1646
        grainId: grainId,                                                                                              // 1647
        threadPath: threadPath || { $exists: false }                                                                   // 1648
      }, {                                                                                                             // 1646
        fields: { identityId: 1, mute: 1, _id: 0 }                                                                     // 1650
      }).fetch();                                                                                                      // 1649
    }                                                                                                                  // 1652
                                                                                                                       //
    return getActivitySubscriptions;                                                                                   // 1172
  }(),                                                                                                                 // 1172
  subscribeToActivity: function () {                                                                                   // 1654
    function subscribeToActivity(identityId, grainId, threadPath) {                                                    // 1172
      // Subscribe the given identity to activity events with the given grainId and (optional)                         // 1655
      // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                      // 1656
      // case do nothing.                                                                                              // 1657
                                                                                                                       //
      var record = { identityId: identityId, grainId: grainId };                                                       // 1659
      if (threadPath) {                                                                                                // 1660
        record.threadPath = threadPath;                                                                                // 1661
      }                                                                                                                // 1662
                                                                                                                       //
      // The $set here is redundant since an upsert automatically initializes a new record to contain                  // 1664
      // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                    // 1665
      // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                  // 1666
      // What a wonderful query language.                                                                              // 1667
      this.collections.activitySubscriptions.upsert(record, { $set: record });                                         // 1668
    }                                                                                                                  // 1669
                                                                                                                       //
    return subscribeToActivity;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  muteActivity: function () {                                                                                          // 1671
    function muteActivity(identityId, grainId, threadPath) {                                                           // 1172
      // Mute notifications for the given identity originating from the given grainId and                              // 1672
      // (optional) threadPath.                                                                                        // 1673
                                                                                                                       //
      var record = { identityId: identityId, grainId: grainId };                                                       // 1675
      if (threadPath) {                                                                                                // 1676
        record.threadPath = threadPath;                                                                                // 1677
      }                                                                                                                // 1678
                                                                                                                       //
      this.collections.activitySubscriptions.upsert(record, { $set: { mute: true } });                                 // 1680
    }                                                                                                                  // 1681
                                                                                                                       //
    return muteActivity;                                                                                               // 1172
  }(),                                                                                                                 // 1172
  updateAppIndex: function () {                                                                                        // 1683
    function updateAppIndex() {                                                                                        // 1172
      var _this3 = this;                                                                                               // 1683
                                                                                                                       //
      var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                  // 1684
      var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                              // 1685
      if (!appUpdatesEnabled) {                                                                                        // 1686
        // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                     // 1687
        // timer that triggers this call.                                                                              // 1688
        return;                                                                                                        // 1689
      }                                                                                                                // 1690
                                                                                                                       //
      var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                               // 1692
      var appIndex = this.collections.appIndex;                                                                        // 1693
      var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                      // 1694
      var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                        // 1695
      // We make sure to get all preinstalled appIds, even ones that are currently                                     // 1696
      // downloading/failed.                                                                                           // 1697
      data.apps.forEach(function (app) {                                                                               // 1698
        app._id = app.appId;                                                                                           // 1699
                                                                                                                       //
        var oldApp = appIndex.findOne({ _id: app.appId });                                                             // 1701
        app.hasSentNotifications = false;                                                                              // 1702
        appIndex.upsert({ _id: app._id }, app);                                                                        // 1703
        var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                             // 1704
        if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
          var pack = _this3.collections.packages.findOne({ _id: app.packageId });                                      // 1708
          var url = appIndexUrl + "/packages/" + app.packageId;                                                        // 1709
          if (pack) {                                                                                                  // 1710
            if (pack.status === "ready") {                                                                             // 1711
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1712
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1713
              } else {                                                                                                 // 1715
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                if (isAppPreinstalled) {                                                                               // 1718
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1719
                }                                                                                                      // 1720
              }                                                                                                        // 1721
            } else {                                                                                                   // 1722
              var result = _this3.collections.packages.findAndModify({                                                 // 1723
                query: { _id: app.packageId },                                                                         // 1724
                update: { $set: { isAutoUpdated: true } }                                                              // 1725
              });                                                                                                      // 1723
                                                                                                                       //
              if (!result.ok) {                                                                                        // 1728
                return;                                                                                                // 1729
              }                                                                                                        // 1730
                                                                                                                       //
              var newPack = result.value;                                                                              // 1732
              if (newPack.status === "ready") {                                                                        // 1733
                // The package was marked as ready before we applied isAutoUpdated=true. We should send                // 1734
                // notifications ourselves to be sure there's no timing issue (sending more than one is                // 1735
                // fine, since it will de-dupe).                                                                       // 1736
                if (pack.appId && pack.appId !== app.appId) {                                                          // 1737
                  console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));    // 1738
                } else {                                                                                               // 1740
                  _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                  if (isAppPreinstalled) {                                                                             // 1743
                    _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                          // 1744
                  }                                                                                                    // 1745
                }                                                                                                      // 1746
              } else if (newPack.status === "failed") {                                                                // 1747
                // If the package has failed, retry it                                                                 // 1748
                _this3.startInstall(app.packageId, url, true, true);                                                   // 1749
              }                                                                                                        // 1750
            }                                                                                                          // 1751
          } else {                                                                                                     // 1752
            _this3.startInstall(app.packageId, url, false, true);                                                      // 1753
          }                                                                                                            // 1754
        }                                                                                                              // 1755
      });                                                                                                              // 1756
    }                                                                                                                  // 1757
                                                                                                                       //
    return updateAppIndex;                                                                                             // 1172
  }(),                                                                                                                 // 1172
  isPackagePreinstalled: function () {                                                                                 // 1759
    function isPackagePreinstalled(packageId) {                                                                        // 1172
      return this.collections.settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;  // 1760
    }                                                                                                                  // 1761
                                                                                                                       //
    return isPackagePreinstalled;                                                                                      // 1172
  }(),                                                                                                                 // 1172
  getAppIdForPreinstalledPackage: function () {                                                                        // 1763
    function getAppIdForPreinstalledPackage(packageId) {                                                               // 1172
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
      // value.$ causes mongo to transform the result and only return the first matching element in                    // 1766
      // the array                                                                                                     // 1767
      return setting && setting.value && setting.value[0] && setting.value[0].appId;                                   // 1768
    }                                                                                                                  // 1769
                                                                                                                       //
    return getAppIdForPreinstalledPackage;                                                                             // 1172
  }(),                                                                                                                 // 1172
  getPackageIdForPreinstalledApp: function () {                                                                        // 1771
    function getPackageIdForPreinstalledApp(appId) {                                                                   // 1172
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });
      // value.$ causes mongo to transform the result and only return the first matching element in                    // 1774
      // the array                                                                                                     // 1775
      return setting && setting.value && setting.value[0] && setting.value[0].packageId;                               // 1776
    }                                                                                                                  // 1777
                                                                                                                       //
    return getPackageIdForPreinstalledApp;                                                                             // 1172
  }(),                                                                                                                 // 1172
  getReadyPreinstalledAppIds: function () {                                                                            // 1779
    function getReadyPreinstalledAppIds() {                                                                            // 1172
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1780
      var ret = setting && setting.value || [];                                                                        // 1781
      return _.chain(ret).filter(function (app) {                                                                      // 1782
        return app.status === "ready";                                                                                 // 1783
      }).map(function (app) {                                                                                          // 1783
        return app.appId;                                                                                              // 1784
      }).value();                                                                                                      // 1784
    }                                                                                                                  // 1786
                                                                                                                       //
    return getReadyPreinstalledAppIds;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getAllPreinstalledAppIds: function () {                                                                              // 1788
    function getAllPreinstalledAppIds() {                                                                              // 1172
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1789
      var ret = setting && setting.value || [];                                                                        // 1790
      return _.map(ret, function (app) {                                                                               // 1791
        return app.appId;                                                                                              // 1791
      });                                                                                                              // 1791
    }                                                                                                                  // 1792
                                                                                                                       //
    return getAllPreinstalledAppIds;                                                                                   // 1172
  }(),                                                                                                                 // 1172
  preinstallAppsForUser: function () {                                                                                 // 1794
    function preinstallAppsForUser(userId) {                                                                           // 1172
      var _this4 = this;                                                                                               // 1794
                                                                                                                       //
      var appIds = this.getReadyPreinstalledAppIds();                                                                  // 1795
      appIds.forEach(function (appId) {                                                                                // 1796
        try {                                                                                                          // 1797
          _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                 // 1798
        } catch (e) {                                                                                                  // 1799
          console.error("failed to install app for user:", e);                                                         // 1800
        }                                                                                                              // 1801
      });                                                                                                              // 1802
    }                                                                                                                  // 1803
                                                                                                                       //
    return preinstallAppsForUser;                                                                                      // 1172
  }(),                                                                                                                 // 1172
  setPreinstallAppAsDownloading: function () {                                                                         // 1805
    function setPreinstallAppAsDownloading(appId, packageId) {                                                         // 1172
      this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
    }                                                                                                                  // 1809
                                                                                                                       //
    return setPreinstallAppAsDownloading;                                                                              // 1172
  }(),                                                                                                                 // 1172
  setPreinstallAppAsReady: function () {                                                                               // 1811
    function setPreinstallAppAsReady(appId, packageId) {                                                               // 1172
      // This function both sets the appId as ready and updates the packageId for the given appId                      // 1812
      // Setting the packageId is especially useful in installer.js, as it always ensures the                          // 1813
      // latest installed package will be set as ready.                                                                // 1814
      this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
    }                                                                                                                  // 1818
                                                                                                                       //
    return setPreinstallAppAsReady;                                                                                    // 1172
  }(),                                                                                                                 // 1172
  ensureAppPreinstall: function () {                                                                                   // 1820
    function ensureAppPreinstall(appId, packageId) {                                                                   // 1172
      check(appId, String);                                                                                            // 1821
      var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                               // 1822
      var pack = this.collections.packages.findOne({ _id: packageId });                                                // 1823
      var url = appIndexUrl + "/packages/" + packageId;                                                                // 1824
      if (pack && pack.status === "ready") {                                                                           // 1825
        this.setPreinstallAppAsReady(appId, packageId);                                                                // 1826
      } else if (pack && pack.status === "failed") {                                                                   // 1827
        this.setPreinstallAppAsDownloading(appId, packageId);                                                          // 1828
        this.startInstall(packageId, url, true, false);                                                                // 1829
      } else {                                                                                                         // 1830
        this.setPreinstallAppAsDownloading(appId, packageId);                                                          // 1831
        this.startInstall(packageId, url, false, false);                                                               // 1832
      }                                                                                                                // 1833
    }                                                                                                                  // 1834
                                                                                                                       //
    return ensureAppPreinstall;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  setPreinstalledApps: function () {                                                                                   // 1836
    function setPreinstalledApps(appAndPackageIds) {                                                                   // 1172
      var _this5 = this;                                                                                               // 1836
                                                                                                                       //
      // appAndPackageIds: A List[Object] where each element has fields:                                               // 1837
      //     appId: The Packages.appId of the app to install                                                           // 1838
      //     packageId: The Packages._id of the app to install                                                         // 1839
      check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                 // 1840
                                                                                                                       //
      // Start by clearing out the setting. We'll push appIds one by one to it                                         // 1842
      this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                          // 1843
          value: appAndPackageIds.map(function (data) {                                                                // 1844
            return {                                                                                                   // 1845
              appId: data.appId,                                                                                       // 1846
              status: "notReady",                                                                                      // 1847
              packageId: data.packageId                                                                                // 1848
            };                                                                                                         // 1845
          })                                                                                                           // 1850
        } });                                                                                                          // 1843
      appAndPackageIds.forEach(function (data) {                                                                       // 1852
        _this5.ensureAppPreinstall(data.appId, data.packageId);                                                        // 1853
      });                                                                                                              // 1854
    }                                                                                                                  // 1855
                                                                                                                       //
    return setPreinstalledApps;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  getProductivitySuiteAppIds: function () {                                                                            // 1857
    function getProductivitySuiteAppIds() {                                                                            // 1172
      return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                        // 1858
      "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                              // 1860
      "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                           // 1861
      "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                         // 1862
    }                                                                                                                  // 1864
                                                                                                                       //
    return getProductivitySuiteAppIds;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  getSystemSuiteAppIds: function () {                                                                                  // 1866
    function getSystemSuiteAppIds() {                                                                                  // 1172
      return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                 // 1867
    }                                                                                                                  // 1870
                                                                                                                       //
    return getSystemSuiteAppIds;                                                                                       // 1172
  }(),                                                                                                                 // 1172
  isPreinstalledAppsReady: function () {                                                                               // 1872
    function isPreinstalledAppsReady() {                                                                               // 1172
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1873
      if (!setting || !setting.value) {                                                                                // 1874
        return true;                                                                                                   // 1875
      }                                                                                                                // 1876
                                                                                                                       //
      var packageIds = _.pluck(setting.value, "packageId");                                                            // 1878
      var readyApps = this.collections.packages.find({                                                                 // 1879
        _id: {                                                                                                         // 1880
          $in: packageIds                                                                                              // 1881
        },                                                                                                             // 1880
        status: "ready"                                                                                                // 1883
      });                                                                                                              // 1879
      return readyApps.count() === packageIds.length;                                                                  // 1885
    }                                                                                                                  // 1886
                                                                                                                       //
    return isPreinstalledAppsReady;                                                                                    // 1172
  }(),                                                                                                                 // 1172
  getBillingPromptUrl: function () {                                                                                   // 1888
    function getBillingPromptUrl() {                                                                                   // 1172
      var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                    // 1889
      return setting && setting.value;                                                                                 // 1890
    }                                                                                                                  // 1891
                                                                                                                       //
    return getBillingPromptUrl;                                                                                        // 1172
  }(),                                                                                                                 // 1172
  isReferralEnabled: function () {                                                                                     // 1893
    function isReferralEnabled() {                                                                                     // 1172
      // This function is a bit weird, in that we've transitioned from                                                 // 1894
      // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                  // 1895
      // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                // 1896
      return Meteor.settings["public"].quotaEnabled;                                                                   // 1897
    }                                                                                                                  // 1898
                                                                                                                       //
    return isReferralEnabled;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  isHideAboutEnabled: function () {                                                                                    // 1900
    function isHideAboutEnabled() {                                                                                    // 1172
      var setting = this.collections.settings.findOne({ _id: "whiteLabelHideAbout" });                                 // 1901
      return setting && setting.value;                                                                                 // 1902
    }                                                                                                                  // 1903
                                                                                                                       //
    return isHideAboutEnabled;                                                                                         // 1172
  }(),                                                                                                                 // 1172
  isQuotaEnabled: function () {                                                                                        // 1905
    function isQuotaEnabled() {                                                                                        // 1172
      if (Meteor.settings["public"].quotaEnabled) return true;                                                         // 1906
                                                                                                                       //
      var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                        // 1908
      return setting && setting.value;                                                                                 // 1909
    }                                                                                                                  // 1910
                                                                                                                       //
    return isQuotaEnabled;                                                                                             // 1172
  }(),                                                                                                                 // 1172
  isQuotaLdapEnabled: function () {                                                                                    // 1912
    function isQuotaLdapEnabled() {                                                                                    // 1172
      var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                    // 1913
      return setting && setting.value;                                                                                 // 1914
    }                                                                                                                  // 1915
                                                                                                                       //
    return isQuotaLdapEnabled;                                                                                         // 1172
  }(),                                                                                                                 // 1172
  updateUserQuota: function () {                                                                                       // 1917
    function updateUserQuota(user) {                                                                                   // 1172
      if (this.quotaManager) {                                                                                         // 1918
        return this.quotaManager.updateUserQuota(this, user);                                                          // 1919
      }                                                                                                                // 1920
    }                                                                                                                  // 1921
                                                                                                                       //
    return updateUserQuota;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  getUserQuota: function () {                                                                                          // 1923
    function getUserQuota(user) {                                                                                      // 1172
      if (this.isQuotaLdapEnabled()) {                                                                                 // 1924
        return this.quotaManager.updateUserQuota(this, user);                                                          // 1925
      } else {                                                                                                         // 1926
        var plan = this.getPlan(user.plan || "free", user);                                                            // 1927
        var referralBonus = calculateReferralBonus(user);                                                              // 1928
        var bonus = user.planBonus || {};                                                                              // 1929
        var userQuota = {                                                                                              // 1930
          storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                        // 1931
          grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                            // 1932
          compute: plan.compute + (bonus.compute || 0)                                                                 // 1933
        };                                                                                                             // 1930
        return userQuota;                                                                                              // 1935
      }                                                                                                                // 1936
    }                                                                                                                  // 1937
                                                                                                                       //
    return getUserQuota;                                                                                               // 1172
  }(),                                                                                                                 // 1172
  isUserOverQuota: function () {                                                                                       // 1939
    function isUserOverQuota(user) {                                                                                   // 1172
      // Return false if user has quota space remaining, true if it is full. When this returns true,                   // 1940
      // we will not allow the user to create new grains, though they may be able to open existing ones                // 1941
      // which may still increase their storage usage.                                                                 // 1942
      //                                                                                                               // 1943
      // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                              // 1944
                                                                                                                       //
      if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                        // 1946
                                                                                                                       //
      var plan = this.getUserQuota(user);                                                                              // 1948
      if (plan.grains < Infinity) {                                                                                    // 1949
        var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: plan.grains }).count();
        if (count >= plan.grains) return "outOfGrains";                                                                // 1952
      }                                                                                                                // 1953
                                                                                                                       //
      return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                         // 1955
    }                                                                                                                  // 1956
                                                                                                                       //
    return isUserOverQuota;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  isUserExcessivelyOverQuota: function () {                                                                            // 1958
    function isUserExcessivelyOverQuota(user) {                                                                        // 1172
      // Return true if user is so far over quota that we should prevent their existing grains from                    // 1959
      // running at all.                                                                                               // 1960
      //                                                                                                               // 1961
      // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                              // 1962
                                                                                                                       //
      if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                        // 1964
                                                                                                                       //
      var quota = this.getUserQuota(user);                                                                             // 1966
                                                                                                                       //
      // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                         // 1968
      if (quota.grains < Infinity) {                                                                                   // 1969
        var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: quota.grains * 2 }).count();
        if (count >= quota.grains * 2) return "outOfGrains";                                                           // 1972
      }                                                                                                                // 1973
                                                                                                                       //
      return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                 // 1975
    }                                                                                                                  // 1976
                                                                                                                       //
    return isUserExcessivelyOverQuota;                                                                                 // 1172
  }(),                                                                                                                 // 1172
  suspendIdentity: function () {                                                                                       // 1978
    function suspendIdentity(userId, suspension) {                                                                     // 1172
      check(userId, String);                                                                                           // 1979
      check(suspension, {                                                                                              // 1980
        timestamp: Date,                                                                                               // 1981
        admin: Match.Optional(String),                                                                                 // 1982
        voluntary: Match.Optional(Boolean)                                                                             // 1983
      });                                                                                                              // 1980
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                             // 1986
      this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
    }                                                                                                                  // 1989
                                                                                                                       //
    return suspendIdentity;                                                                                            // 1172
  }(),                                                                                                                 // 1172
  unsuspendIdentity: function () {                                                                                     // 1991
    function unsuspendIdentity(userId) {                                                                               // 1172
      check(userId, String);                                                                                           // 1992
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                    // 1994
      this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
    }                                                                                                                  // 1997
                                                                                                                       //
    return unsuspendIdentity;                                                                                          // 1172
  }(),                                                                                                                 // 1172
  suspendAccount: function () {                                                                                        // 1999
    function suspendAccount(userId, byAdminUserId, willDelete) {                                                       // 1172
      var _this6 = this;                                                                                               // 1999
                                                                                                                       //
      check(userId, String);                                                                                           // 2000
      check(byAdminUserId, Match.OneOf(String, null, undefined));                                                      // 2001
      check(willDelete, Boolean);                                                                                      // 2002
                                                                                                                       //
      var user = this.collections.users.findOne({ _id: userId });                                                      // 2004
      var suspension = {                                                                                               // 2005
        timestamp: new Date(),                                                                                         // 2006
        willDelete: willDelete || false                                                                                // 2007
      };                                                                                                               // 2005
      if (byAdminUserId) {                                                                                             // 2009
        suspension.admin = byAdminUserId;                                                                              // 2010
      } else {                                                                                                         // 2011
        suspension.voluntary = true;                                                                                   // 2012
      }                                                                                                                // 2013
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                             // 2015
      this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });              // 2016
                                                                                                                       //
      delete suspension.willDelete;                                                                                    // 2018
      // Only mark the parent account for deletion. This makes the query simpler later.                                // 2019
                                                                                                                       //
      user.loginIdentities.forEach(function (identity) {                                                               // 2021
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2022
      });                                                                                                              // 2023
      user.nonloginIdentities.forEach(function (identity) {                                                            // 2024
        if (_this6.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
          // Only suspend non-login identities that are unique to this account.                                        // 2029
          _this6.suspendIdentity(identity.id, suspension);                                                             // 2030
        }                                                                                                              // 2031
      });                                                                                                              // 2032
                                                                                                                       //
      // Force logout this user                                                                                        // 2034
      this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                // 2035
      if (user && user.loginIdentities) {                                                                              // 2037
        user.loginIdentities.forEach(function (identity) {                                                             // 2038
          Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                 // 2039
        });                                                                                                            // 2040
      }                                                                                                                // 2041
    }                                                                                                                  // 2042
                                                                                                                       //
    return suspendAccount;                                                                                             // 1172
  }(),                                                                                                                 // 1172
  unsuspendAccount: function () {                                                                                      // 2044
    function unsuspendAccount(userId) {                                                                                // 1172
      var _this7 = this;                                                                                               // 2044
                                                                                                                       //
      check(userId, String);                                                                                           // 2045
                                                                                                                       //
      var user = this.collections.users.findOne({ _id: userId });                                                      // 2047
      this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                    // 2048
      this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });               // 2049
                                                                                                                       //
      user.loginIdentities.forEach(function (identity) {                                                               // 2051
        _this7.unsuspendIdentity(identity.id);                                                                         // 2052
      });                                                                                                              // 2053
                                                                                                                       //
      user.nonloginIdentities.forEach(function (identity) {                                                            // 2055
        _this7.unsuspendIdentity(identity.id);                                                                         // 2056
      });                                                                                                              // 2057
    }                                                                                                                  // 2058
                                                                                                                       //
    return unsuspendAccount;                                                                                           // 1172
  }(),                                                                                                                 // 1172
  deletePendingAccounts: function () {                                                                                 // 2060
    function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                                              // 1172
      var _this8 = this;                                                                                               // 2060
                                                                                                                       //
      check(deletionCoolingOffTime, Number);                                                                           // 2061
                                                                                                                       //
      var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                   // 2063
      this.collections.users.find({                                                                                    // 2064
        "suspended.willDelete": true,                                                                                  // 2065
        "suspended.timestamp": { $lt: queryDate }                                                                      // 2066
      }).forEach(function (user) {                                                                                     // 2064
        if (cb) cb(_this8, user);                                                                                      // 2068
        _this8.deleteAccount(user._id, backend);                                                                       // 2069
      });                                                                                                              // 2070
    }                                                                                                                  // 2071
                                                                                                                       //
    return deletePendingAccounts;                                                                                      // 1172
  }(),                                                                                                                 // 1172
                                                                                                                       //
                                                                                                                       //
  hostIsStandalone: function () {                                                                                      // 2073
    function hostIsStandalone(hostname) {                                                                              // 2073
      check(hostname, String);                                                                                         // 2074
                                                                                                                       //
      return !!this.collections.standaloneDomains.findOne({ _id: hostname });                                          // 2076
    }                                                                                                                  // 2077
                                                                                                                       //
    return hostIsStandalone;                                                                                           // 2073
  }()                                                                                                                  // 2073
});                                                                                                                    // 1172
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2080
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     // 2081
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   // 2082
  // and seems to be a de facto standard, for example:                                                                 // 2083
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  // 2084
  return key.replace(".", "\uFF0E").replace("$", "\uFF04");                                                            // 2085
};                                                                                                                     // 2086
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2088
  // This function takes a Package object from Mongo and returns an                                                    // 2089
  // app title.                                                                                                        // 2090
  var manifest = packageObj.manifest;                                                                                  // 2091
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2092
  var action = manifest.actions[0];                                                                                    // 2093
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2094
  return appName;                                                                                                      // 2096
};                                                                                                                     // 2097
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2099
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               // 2100
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  // 2101
  //   derive the app title from the action title.                                                                     // 2102
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        // 2103
  if (!name) {                                                                                                         // 2104
    return "(unnamed)";                                                                                                // 2105
  }                                                                                                                    // 2106
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2108
    name = name.slice(4);                                                                                              // 2109
  }                                                                                                                    // 2110
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2112
    name = "Hacker CMS";                                                                                               // 2113
  } else {                                                                                                             // 2114
    var space = name.indexOf(" ");                                                                                     // 2115
    if (space > 0) {                                                                                                   // 2116
      name = name.slice(0, space);                                                                                     // 2117
    }                                                                                                                  // 2118
  }                                                                                                                    // 2119
                                                                                                                       //
  return name;                                                                                                         // 2121
};                                                                                                                     // 2122
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2124
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2128
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2130
  // A hack to deal with legacy apps not including fields in their manifests.                                          // 2131
  // I look forward to the day I can remove most of this code.                                                         // 2132
  // Attempt to figure out the appropriate noun that this action will create.                                          // 2133
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            // 2134
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2135
  // Otherwise, try to guess one from the structure of the action title field                                          // 2136
  if (action.title && action.title.defaultText) {                                                                      // 2137
    var text = action.title.defaultText;                                                                               // 2138
    // Strip a leading "New "                                                                                          // 2139
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2140
      var candidate = text.slice(4);                                                                                   // 2141
      // Strip a leading appname too, if provided                                                                      // 2142
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2143
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2144
        // Unless that leaves you with no noun, in which case, use "grain"                                             // 2145
        if (newCandidate.length > 0) {                                                                                 // 2146
          return newCandidate.toLowerCase();                                                                           // 2147
        } else {                                                                                                       // 2148
          return "grain";                                                                                              // 2149
        }                                                                                                              // 2150
      }                                                                                                                // 2151
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2153
    }                                                                                                                  // 2154
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        // 2155
    // the package soon.                                                                                               // 2156
    return text;                                                                                                       // 2157
  } else {                                                                                                             // 2158
    return "grain";                                                                                                    // 2159
  }                                                                                                                    // 2160
};                                                                                                                     // 2161
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          // 2163
// Largely things that deal with backwards-compatibility.                                                              // 2164
_.extend(SandstormDb, {                                                                                                // 2165
  appNameFromActionName: appNameFromActionName,                                                                        // 2166
  appNameFromPackage: appNameFromPackage,                                                                              // 2167
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2168
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2169
});                                                                                                                    // 2165
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2172
  (function () {                                                                                                       // 2172
    var Crypto = Npm.require("crypto");                                                                                // 2173
    var ContentType = Npm.require("content-type");                                                                     // 2174
    var Zlib = Npm.require("zlib");                                                                                    // 2175
    var Url = Npm.require("url");                                                                                      // 2176
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2178
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2180
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        // 2181
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         // 2182
      // The sequence looks like:                                                                                      // 2183
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             // 2184
      //                                                                                                               // 2185
      // We use this to determine how we'll stagger periodic events performed by this replica.                         // 2186
      // Notice that this allows us to compute a stagger which is independent of the number of                         // 2187
      // front-end replicas present; we can add more replicas to the end without affecting how the                     // 2188
      // earlier ones schedule their events.                                                                           // 2189
      var denom = 1;                                                                                                   // 2190
      while (denom <= n) {                                                                                             // 2191
        denom <<= 1;                                                                                                   // 2191
      }var num = n * 2 - denom + 1;                                                                                    // 2191
      return num / denom;                                                                                              // 2193
    };                                                                                                                 // 2194
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2196
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2198
      // Register a database cleanup function than should run periodically, roughly once every                         // 2199
      // interval of the given length.                                                                                 // 2200
      //                                                                                                               // 2201
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      // 2202
      // scaled appropriately on the assumption that more data is being generated demanding more                       // 2203
      // frequent cleanups.                                                                                            // 2204
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2206
      check(callback, Function);                                                                                       // 2207
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2209
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2210
      }                                                                                                                // 2212
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      // 2214
      // the schedule is independent of the exact startup time.                                                        // 2215
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2216
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       // 2218
      // same data at the same time.                                                                                   // 2219
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2220
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           // 2222
      if (first > intervalMs) first -= intervalMs;                                                                     // 2223
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2225
        callback();                                                                                                    // 2226
        Meteor.setInterval(callback, intervalMs);                                                                      // 2227
      }, first);                                                                                                       // 2228
    };                                                                                                                 // 2229
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          // 2231
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2232
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2234
      return Match.Where(function (buf) {                                                                              // 2235
        check(buf, Buffer);                                                                                            // 2236
        return buf.length < limit;                                                                                     // 2237
      });                                                                                                              // 2238
    };                                                                                                                 // 2239
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2241
      check(s, String);                                                                                                // 2242
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2243
    });                                                                                                                // 2244
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                              // 2246
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     // 2247
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  // 2248
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2250
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2251
        metadata.encoding = "gzip";                                                                                    // 2252
      }                                                                                                                // 2253
                                                                                                                       //
      check(metadata, {                                                                                                // 2255
        mimeType: String,                                                                                              // 2256
        encoding: Match.Optional("gzip")                                                                               // 2257
      });                                                                                                              // 2255
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2259
                                                                                                                       //
      // Validate content type.                                                                                        // 2261
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2262
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2264
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2265
      hasher.update(content);                                                                                          // 2266
      var hash = hasher.digest("base64");                                                                              // 2267
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2269
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2270
        update: { $inc: { refcount: 1 } },                                                                             // 2271
        fields: { _id: 1, refcount: 1 }                                                                                // 2272
      });                                                                                                              // 2269
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2275
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2276
      }                                                                                                                // 2277
                                                                                                                       //
      var existing = result.value;                                                                                     // 2279
      if (existing) {                                                                                                  // 2280
        return existing._id;                                                                                           // 2281
      }                                                                                                                // 2282
                                                                                                                       //
      return this.collections.staticAssets.insert(_.extend({                                                           // 2284
        hash: hash,                                                                                                    // 2285
        content: content,                                                                                              // 2286
        refcount: 1                                                                                                    // 2287
      }, metadata));                                                                                                   // 2284
    };                                                                                                                 // 2289
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2291
      // Increment the refcount on an existing static asset. Returns the asset on success.                             // 2292
      // If the asset does not exist, returns a falsey value.                                                          // 2293
      //                                                                                                               // 2294
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      // 2295
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     // 2296
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       // 2297
                                                                                                                       //
      check(id, String);                                                                                               // 2299
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2301
        query: { hash: hash },                                                                                         // 2302
        update: { $inc: { refcount: 1 } },                                                                             // 2303
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2304
      });                                                                                                              // 2301
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2307
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2308
      }                                                                                                                // 2309
                                                                                                                       //
      var existing = result.value;                                                                                     // 2311
      return existing;                                                                                                 // 2312
    };                                                                                                                 // 2313
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2315
      // Decrement refcount on a static asset and delete if it has reached zero.                                       // 2316
      //                                                                                                               // 2317
      // You must call this AFTER removing the reference from the DB, in case of failure between                       // 2318
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     // 2319
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       // 2320
                                                                                                                       //
      check(id, String);                                                                                               // 2322
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2324
        query: { _id: id },                                                                                            // 2325
        update: { $inc: { refcount: -1 } },                                                                            // 2326
        fields: { _id: 1, refcount: 1 },                                                                               // 2327
        "new": true                                                                                                    // 2328
      });                                                                                                              // 2324
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2331
        throw new Error("Couldn't unref static asset " + id);                                                          // 2332
      }                                                                                                                // 2333
                                                                                                                       //
      var existing = result.value;                                                                                     // 2335
      if (!existing) {                                                                                                 // 2336
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2337
      } else if (existing.refcount <= 0) {                                                                             // 2338
        this.collections.staticAssets.remove({ _id: existing._id });                                                   // 2339
      }                                                                                                                // 2340
    };                                                                                                                 // 2341
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2343
      // Get a static asset's mimeType, encoding, and raw content.                                                     // 2344
                                                                                                                       //
      check(id, String);                                                                                               // 2346
                                                                                                                       //
      var asset = this.collections.staticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });
      if (asset) {                                                                                                     // 2349
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      // 2350
        //   here.                                                                                                     // 2351
        asset.content = new Buffer(asset.content);                                                                     // 2352
      }                                                                                                                // 2353
                                                                                                                       //
      return asset;                                                                                                    // 2355
    };                                                                                                                 // 2356
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2358
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return this.collections.assetUploadTokens.insert({                                                               // 2364
        purpose: purpose,                                                                                              // 2365
        expires: new Date(Date.now() + 300000) });                                                                     // 2366
    };                                                                                                                 // 2368
                                                                                                                       //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2370
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       // 2371
      // returned. If no matching upload exists, returns undefined.                                                    // 2372
                                                                                                                       //
      check(id, String);                                                                                               // 2374
                                                                                                                       //
      var result = this.collections.assetUploadTokens.findAndModify({                                                  // 2376
        query: { _id: id },                                                                                            // 2377
        remove: true                                                                                                   // 2378
      });                                                                                                              // 2376
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2381
        throw new Error("Failed to remove asset upload token");                                                        // 2382
      }                                                                                                                // 2383
                                                                                                                       //
      var upload = result.value;                                                                                       // 2385
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2387
        return undefined; // already expired                                                                           // 2388
      } else {                                                                                                         // 2389
        return upload.purpose;                                                                                         // 2390
      }                                                                                                                // 2391
    };                                                                                                                 // 2392
                                                                                                                       //
    SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                   // 2394
      this.collections.assetUploadTokens.remove({ expires: { $lt: Date.now() } });                                     // 2395
    };                                                                                                                 // 2396
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   // 2398
    var Future = Npm.require("fibers/future");                                                                         // 2399
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2400
      var result = new Future();                                                                                       // 2401
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2402
      return result;                                                                                                   // 2403
    };                                                                                                                 // 2404
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2406
      return promiseToFuture(promise).wait();                                                                          // 2407
    };                                                                                                                 // 2408
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2410
      var _this9 = this;                                                                                               // 2410
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         // 2411
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2413
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2415
      this.collections.grains.find(query).forEach(function (grain) {                                                   // 2416
        var user = Meteor.users.findOne(grain.userId);                                                                 // 2417
                                                                                                                       //
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2419
        numDeleted += _this9.collections.grains.remove({ _id: grain._id });                                            // 2420
        _this9.removeApiTokens({                                                                                       // 2421
          grainId: grain._id,                                                                                          // 2422
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2423
        });                                                                                                            // 2421
                                                                                                                       //
        _this9.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2429
                                                                                                                       //
        _this9.collections.activitySubscriptions.remove({ grainId: grain._id });                                       // 2431
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2433
          var record = {                                                                                               // 2434
            type: "grain", // Demo grains can never get here!                                                          // 2435
            lastActive: grain.lastUsed,                                                                                // 2436
            appId: grain.appId                                                                                         // 2437
          };                                                                                                           // 2434
          if (user && user.experiments) {                                                                              // 2439
            record.experiments = user.experiments;                                                                     // 2440
          }                                                                                                            // 2441
                                                                                                                       //
          _this9.collections.deleteStats.insert(record);                                                               // 2443
        }                                                                                                              // 2444
                                                                                                                       //
        _this9.deleteUnusedPackages(grain.appId);                                                                      // 2446
                                                                                                                       //
        if (grain.size) {                                                                                              // 2448
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2449
        }                                                                                                              // 2450
      });                                                                                                              // 2451
      return numDeleted;                                                                                               // 2452
    };                                                                                                                 // 2453
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2455
      check(grainId, String);                                                                                          // 2456
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2457
      check(identityId, String);                                                                                       // 2458
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2460
      if (!grain) {                                                                                                    // 2461
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2462
      }                                                                                                                // 2463
                                                                                                                       //
      var title = grain.title;                                                                                         // 2465
      if (grain.userId !== accountId) {                                                                                // 2466
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2467
          grainId: grainId,                                                                                            // 2468
          "owner.user.identityId": identityId                                                                          // 2469
        }, {                                                                                                           // 2467
          sort: {                                                                                                      // 2471
            lastUsed: -1                                                                                               // 2472
          }                                                                                                            // 2471
        });                                                                                                            // 2470
        if (sharerToken) {                                                                                             // 2475
          title = sharerToken.owner.user.title;                                                                        // 2476
        } else {                                                                                                       // 2477
          title = "shared grain";                                                                                      // 2478
        }                                                                                                              // 2479
      }                                                                                                                // 2480
                                                                                                                       //
      return title;                                                                                                    // 2482
    };                                                                                                                 // 2483
                                                                                                                       //
    var packageCache = {};                                                                                             // 2485
    // Package info is immutable. Let's cache to save on mongo queries.                                                // 2486
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2488
      // Get the given package record. Since package info is immutable, cache the data in the server                   // 2489
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       // 2490
      // lot.                                                                                                          // 2491
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2493
        return packageCache[packageId];                                                                                // 2494
      }                                                                                                                // 2495
                                                                                                                       //
      var pkg = this.collections.packages.findOne(packageId);                                                          // 2497
      if (pkg && pkg.status === "ready") {                                                                             // 2498
        packageCache[packageId] = pkg;                                                                                 // 2499
      }                                                                                                                // 2500
                                                                                                                       //
      return pkg;                                                                                                      // 2502
    };                                                                                                                 // 2503
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2505
      var _this10 = this;                                                                                              // 2505
                                                                                                                       //
      check(appId, String);                                                                                            // 2506
      this.collections.packages.find({ appId: appId }).forEach(function (pkg) {                                        // 2507
        // Mark package for possible deletion;                                                                         // 2508
        _this10.collections.packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });     // 2509
      });                                                                                                              // 2510
    };                                                                                                                 // 2511
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this11 = this;                                                                                              // 2514
                                                                                                                       //
      var actions = this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2517
        var userId = action.userId;                                                                                    // 2518
        var updater = {                                                                                                // 2519
          timestamp: new Date(),                                                                                       // 2520
          isUnread: true                                                                                               // 2521
        };                                                                                                             // 2519
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2523
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    // 2525
        // field inside of an object to update                                                                         // 2526
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2527
          marketingVersion: marketingVersion,                                                                          // 2528
          packageId: packageId,                                                                                        // 2529
          name: name,                                                                                                  // 2530
          version: versionNumber                                                                                       // 2531
        };                                                                                                             // 2527
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   // 2534
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       // 2535
        if (_this11.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     // 2539
          _this11.collections.notifications.insert(inserter);                                                          // 2540
        }                                                                                                              // 2541
      });                                                                                                              // 2542
                                                                                                                       //
      this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                      // 2544
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  // 2546
      // package, we need to clean it up                                                                               // 2547
      this.deleteUnusedPackages(appId);                                                                                // 2548
    };                                                                                                                 // 2549
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                        // 2551
      this.collections.notifications.upsert({                                                                          // 2552
        userId: userId,                                                                                                // 2553
        referral: true                                                                                                 // 2554
      }, {                                                                                                             // 2552
        userId: userId,                                                                                                // 2556
        referral: true,                                                                                                // 2557
        timestamp: new Date(),                                                                                         // 2558
        isUnread: true                                                                                                 // 2559
      });                                                                                                              // 2555
    };                                                                                                                 // 2561
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2563
      check(appId, String);                                                                                            // 2564
      check(version, Match.Integer);                                                                                   // 2565
      check(packageId, String);                                                                                        // 2566
                                                                                                                       //
      var selector = {                                                                                                 // 2568
        userId: Meteor.userId(),                                                                                       // 2569
        appId: appId,                                                                                                  // 2570
        appVersion: { $lte: version },                                                                                 // 2571
        packageId: { $ne: packageId }                                                                                  // 2572
      };                                                                                                               // 2568
                                                                                                                       //
      this.collections.grains.find(selector).forEach(function (grain) {                                                // 2575
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2576
      });                                                                                                              // 2577
                                                                                                                       //
      this.collections.grains.update(selector, {                                                                       // 2579
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2580
      }, { multi: true });                                                                                             // 2579
    };                                                                                                                 // 2582
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2584
      // Mark package for possible installation.                                                                       // 2585
                                                                                                                       //
      var fields = {                                                                                                   // 2587
        status: "download",                                                                                            // 2588
        progress: 0,                                                                                                   // 2589
        url: url,                                                                                                      // 2590
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2591
      };                                                                                                               // 2587
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2594
        this.collections.packages.update({ _id: packageId, status: "failed" }, { $set: fields });                      // 2595
      } else {                                                                                                         // 2596
        try {                                                                                                          // 2597
          fields._id = packageId;                                                                                      // 2598
          this.collections.packages.insert(fields);                                                                    // 2599
        } catch (err) {                                                                                                // 2600
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2601
        }                                                                                                              // 2602
      }                                                                                                                // 2603
    };                                                                                                                 // 2604
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2606
      check(keyFingerprint, String);                                                                                   // 2607
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2608
    });                                                                                                                // 2609
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2611
      var _this12 = this;                                                                                              // 2611
                                                                                                                       //
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   // 2612
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2614
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2616
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2621
      }, function (err, keybaseResponse) {                                                                             // 2620
        if (err) {                                                                                                     // 2623
          console.log("keybase lookup error:", err.stack);                                                             // 2624
          return;                                                                                                      // 2625
        }                                                                                                              // 2626
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2628
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2629
          return;                                                                                                      // 2630
        }                                                                                                              // 2631
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2633
                                                                                                                       //
        if (profile) {                                                                                                 // 2635
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       // 2636
          var record = {                                                                                               // 2637
            displayName: (profile.profile || {}).full_name,                                                            // 2638
            handle: (profile.basics || {}).username,                                                                   // 2639
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2640
          };                                                                                                           // 2637
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        // 2642
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2644
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    // 2645
            // this would filter.)                                                                                     // 2646
            for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                         // 2647
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    // 2648
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        // 2649
              // return any objects anyway).                                                                           // 2650
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2651
                delete proof[field];                                                                                   // 2652
              }                                                                                                        // 2653
            }                                                                                                          // 2654
                                                                                                                       //
            // Indicate not verified.                                                                                  // 2656
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    // 2657
            //   Keybase node-based CLI.                                                                               // 2658
            proof.status = "unverified";                                                                               // 2659
          });                                                                                                          // 2660
                                                                                                                       //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });              // 2662
        } else {                                                                                                       // 2663
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    // 2664
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    // 2665
          // from Keybase.                                                                                             // 2666
          //                                                                                                           // 2667
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     // 2668
          //   but at present we don't have the ability to verify proofs.                                              // 2669
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2672
      });                                                                                                              // 2673
    };                                                                                                                 // 2674
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2676
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        // 2677
                                                                                                                       //
      check(identityId, String);                                                                                       // 2679
      var account = this.collections.users.findOne({ "loginIdentities.id": identityId });                              // 2680
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({ userId: account._id }) && !this.collections.apiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({ ownerId: account._id })) {
        this.collections.users.remove({ _id: account._id });                                                           // 2689
        backend.deleteUser(account._id);                                                                               // 2690
      }                                                                                                                // 2691
    };                                                                                                                 // 2692
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2694
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2695
      var db = this.connection.sandstormDb;                                                                            // 2696
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2698
      if (cursor.count() === 0) {                                                                                      // 2699
        // Fire off async update.                                                                                      // 2700
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2701
      }                                                                                                                // 2702
                                                                                                                       //
      return cursor;                                                                                                   // 2704
    });                                                                                                                // 2705
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2707
      check(appId, String);                                                                                            // 2708
      var db = this.connection.sandstormDb;                                                                            // 2709
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2710
      return cursor;                                                                                                   // 2711
    });                                                                                                                // 2712
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2714
      var _this13 = this;                                                                                              // 2714
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         // 2715
      // 1. referenced by one of their userActions                                                                     // 2716
      // 2. referenced by one of their grains                                                                          // 2717
      var db = this.connection.sandstormDb;                                                                            // 2718
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      // 2720
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    // 2721
      // to reactively remove a package from the client side when it is removed on the server, or                      // 2722
      // when the client stops using it, because the worst case is the client has a small amount                       // 2723
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        // 2724
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    // 2725
      // stuff, we push the package info to the client, and then we never update it.                                   // 2726
      //                                                                                                               // 2727
      // Alternatively, we could subscribe to each individual package query, but this would waste                      // 2728
      // lots of server-side resources watching for events that will never happen or don't matter.                     // 2729
      var hasPackage = {};                                                                                             // 2730
      var refPackage = function refPackage(packageId) {                                                                // 2731
        // Ignore dev apps.                                                                                            // 2732
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2733
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2735
          hasPackage[packageId] = true;                                                                                // 2736
          var pkg = db.getPackage(packageId);                                                                          // 2737
          if (pkg) {                                                                                                   // 2738
            _this13.added("packages", packageId, pkg);                                                                 // 2739
          } else {                                                                                                     // 2740
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2741
          }                                                                                                            // 2743
        }                                                                                                              // 2744
      };                                                                                                               // 2745
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             // 2747
      var actions = db.userActions(this.userId);                                                                       // 2748
      var actionsHandle = actions.observe({                                                                            // 2749
        added: function () {                                                                                           // 2750
          function added(newAction) {                                                                                  // 2749
            refPackage(newAction.packageId);                                                                           // 2751
          }                                                                                                            // 2752
                                                                                                                       //
          return added;                                                                                                // 2749
        }(),                                                                                                           // 2749
        changed: function () {                                                                                         // 2754
          function changed(newAction, oldAction) {                                                                     // 2749
            refPackage(newAction.packageId);                                                                           // 2755
          }                                                                                                            // 2756
                                                                                                                       //
          return changed;                                                                                              // 2749
        }()                                                                                                            // 2749
      });                                                                                                              // 2749
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     // 2759
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2760
      var grainsHandle = grains.observe({                                                                              // 2761
        added: function () {                                                                                           // 2762
          function added(newGrain) {                                                                                   // 2761
            // Watch out: DevApp grains can lack a packageId.                                                          // 2763
            if (newGrain.packageId) {                                                                                  // 2764
              refPackage(newGrain.packageId);                                                                          // 2765
            }                                                                                                          // 2766
          }                                                                                                            // 2767
                                                                                                                       //
          return added;                                                                                                // 2761
        }(),                                                                                                           // 2761
        changed: function () {                                                                                         // 2769
          function changed(newGrain, oldGrain) {                                                                       // 2761
            // Watch out: DevApp grains can lack a packageId.                                                          // 2770
            if (newGrain.packageId) {                                                                                  // 2771
              refPackage(newGrain.packageId);                                                                          // 2772
            }                                                                                                          // 2773
          }                                                                                                            // 2774
                                                                                                                       //
          return changed;                                                                                              // 2761
        }()                                                                                                            // 2761
      });                                                                                                              // 2761
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2777
        actionsHandle.stop();                                                                                          // 2778
        grainsHandle.stop();                                                                                           // 2779
      });                                                                                                              // 2780
                                                                                                                       //
      this.ready();                                                                                                    // 2782
    });                                                                                                                // 2783
  })();                                                                                                                // 2172
}                                                                                                                      // 2784
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2786
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2787
    check(identityId, String);                                                                                         // 2788
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2790
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2791
    Meteor.users.remove({ _id: identityId });                                                                          // 2792
  };                                                                                                                   // 2793
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2795
    check(userId, String);                                                                                             // 2796
                                                                                                                       //
    var _this = this;                                                                                                  // 2798
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2799
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2800
    this.collections.userActions.remove({ userId: userId });                                                           // 2801
    this.collections.notifications.remove({ userId: userId });                                                         // 2802
    user.loginIdentities.forEach(function (identity) {                                                                 // 2803
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               // 2808
        _this.deleteIdentity(identity.id);                                                                             // 2809
      }                                                                                                                // 2810
    });                                                                                                                // 2811
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2812
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               // 2817
        _this.deleteIdentity(identity.id);                                                                             // 2818
      }                                                                                                                // 2819
    });                                                                                                                // 2820
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2821
    backend.deleteUser(userId);                                                                                        // 2822
    Meteor.users.remove({ _id: userId });                                                                              // 2823
  };                                                                                                                   // 2824
}                                                                                                                      // 2825
                                                                                                                       //
Meteor.methods({                                                                                                       // 2827
  addUserActions: function () {                                                                                        // 2828
    function addUserActions(packageId) {                                                                               // 2827
      check(packageId, String);                                                                                        // 2829
      if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                     // 2830
        throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                       // 2831
      }                                                                                                                // 2832
                                                                                                                       //
      if (this.isSimulation) {                                                                                         // 2834
        // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                    // 2835
        //   a proper DB object to use.                                                                                // 2836
        new SandstormDb().addUserActions(this.userId, packageId, true);                                                // 2837
      } else {                                                                                                         // 2838
        this.connection.sandstormDb.addUserActions(this.userId, packageId);                                            // 2839
      }                                                                                                                // 2840
    }                                                                                                                  // 2841
                                                                                                                       //
    return addUserActions;                                                                                             // 2827
  }(),                                                                                                                 // 2827
  removeUserAction: function () {                                                                                      // 2843
    function removeUserAction(actionId) {                                                                              // 2827
      check(actionId, String);                                                                                         // 2844
      if (this.isSimulation) {                                                                                         // 2845
        UserActions.remove({ _id: actionId });                                                                         // 2846
      } else {                                                                                                         // 2847
        if (this.userId) {                                                                                             // 2848
          var result = this.connection.sandstormDb.collections.userActions.findAndModify({                             // 2849
            query: { _id: actionId, userId: this.userId },                                                             // 2850
            remove: true                                                                                               // 2851
          });                                                                                                          // 2849
                                                                                                                       //
          if (!result.ok) {                                                                                            // 2854
            throw new Error("Couldn't remove user action " + actionId);                                                // 2855
          }                                                                                                            // 2856
                                                                                                                       //
          var action = result.value;                                                                                   // 2858
          if (action) {                                                                                                // 2859
            this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                            // 2860
          }                                                                                                            // 2861
        }                                                                                                              // 2862
      }                                                                                                                // 2863
    }                                                                                                                  // 2864
                                                                                                                       //
    return removeUserAction;                                                                                           // 2827
  }()                                                                                                                  // 2827
});                                                                                                                    // 2827
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       // 22
    // has a given identity linked. Automatically stops the subscription if the user loses the                         // 23
    // identity. Returns a boolean indicating whether the user initially has the identity.                             // 24
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function () {                                                // 47
            function removed() {                                                                                       // 47
              publishHandler.stop();                                                                                   // 47
            }                                                                                                          // 47
                                                                                                                       //
            return removed;                                                                                            // 47
          }() });                                                                                                      // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                // 95
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          // 122
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 // 123
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       // 125
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   // 126
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      // 127
      // anyway to be safe.                                                                                            // 128
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     // 135
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            // 156
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              // 161
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         // 165
  // on the same account.                                                                                              // 166
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   // 172
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            // 180
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              // 256
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        // 266
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
    if (email) {                                                                                                       // 268
      return [{ email: email, primary: true }];                                                                        // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        // 279
  // addresses.                                                                                                        // 280
                                                                                                                       //
  check(email, String);                                                                                                // 282
                                                                                                                       //
  // For LDAP, the field containing the e-mail address is configurable...                                              // 284
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, ldapQuery, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 // 295
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   // 315
  // account. Always returns the most recently added login identity first.                                             // 316
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   // 325
  // Each entry in the array is an object of the form:                                                                 // 326
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    // 327
  //                                                                                                                   // 328
  // At most one entry in the result has `primary = true`.                                                             // 329
  //                                                                                                                   // 330
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         // 331
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         // 332
  //   on SandstormDb.                                                                                                 // 333
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 340
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
                                                                                                                       //
  var result = [];                                                                                                     // 354
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({ email: email,                                                                                        // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail });                                                                         // 358
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({ email: email, verified: false });                                                                  // 362
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               // 365
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function () {                                                                       // 373
  function addContact(ownerId, identityId) {                                                                           // 373
    check(ownerId, String);                                                                                            // 374
    check(identityId, String);                                                                                         // 375
    var profile = this.getIdentity(identityId).profile;                                                                // 376
    this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                   // 377
      ownerId: ownerId,                                                                                                // 378
      petname: profile && profile.name,                                                                                // 379
      created: new Date(),                                                                                             // 380
      identityId: identityId                                                                                           // 381
    });                                                                                                                // 377
  }                                                                                                                    // 383
                                                                                                                       //
  return addContact;                                                                                                   // 373
}();                                                                                                                   // 373
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
